<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: PN boys and girls band
// Purpose of file: language API
// ----------------------------------------------------------------------------

/**
 * Load language files for the current language
 * 
 * @return void
 */
function pnLangLoad()
{
    // See if a language update is required
    $newlang = pnVarCleanFromInput('newlang');
    if (!empty($newlang)) {
        $lang = $newlang;
        pnSessionSetVar('lang', $newlang);
    } else {
        $detectlang = pnConfigGetVar('language_detect');
        $defaultlang = pnConfigGetVar('language');
         
        switch ($detectlang) {  
            case 1: // Detect Browser Language
		        $cnvlanguage=cnvlanguagelist();
                $currentlang="";
         	    $langs = split ('[,;]',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
         	    foreach ($langs as $lang) {
                    print "check lang".$cnvlanguage[$lang];
         	  	    if (file_exists('language/' . pnVarPrepForOS($cnvlanguage[$lang]) . '/global.php')) {
         	  	        $currentlang=$cnvlanguage[$lang];
         	  	        break;
         	  	    }
         	    }
                if ($currentlang=="")
         	        $currentlang=$defaultlang;
         	  	    print $currentlang;
         	  	    break;
            default:
                $currentlang=$defaultlang; 
        }
        $lang = pnSessionGetVar('lang');
    } 
    // Load global language defines
    if (isset ($lang) && file_exists('language/' . pnVarPrepForOS($lang) . '/global.php')) {
        $currentlang = $lang;
    } else {
        $currentlang = pnConfigGetVar('language');
        pnSessionSetVar('lang', $currentlang);
    } 
    include 'language/' . pnVarPrepForOS($currentlang) . '/global.php';
	
	// load the languge language file
	if (file_exists('language/' . pnVarPrepForOS($currentlang) . '/languages.php')) {
		include 'language/' . pnVarPrepForOS($currentlang) . '/languages.php';
	}
}

// Make common language selection dropdown (from Tim Litwiller)
// =======================================
   function lang_dropdown($echoed=1, $currentlang='user')
   {
      if($currentlang == 'user') $currentlang = pnUserGetLang();
      $output = "<select name=\"language\" class=\"pn-text\">";
      $lang = languagelist();
      $output .= "<option value=\"\">"._ALL.'</option>';
      $handle = opendir('language');
      while ($f = readdir($handle))
      {
         if (is_dir("language/$f") && @$lang[$f])
         {
            $langlist[$f] = $lang[$f];
         }
      }
      asort($langlist);
      foreach ($langlist as $k=>$v)
      {
         $output .= '<option value="'.$k.'"';
         if ( $currentlang == $k)
         {
            $output .= ' selected';
         }
         $output .= '>'. pnVarPrepForDisplay($v) . '</option> ';
      }
      $output .= "</select>";

	  if($echoed) {
		echo $output;
	  } else {
		return $output;
	  }
   }

// Loads the required language file for module (from Patrick Kellum <webmaster@ctarl-ctarl.com>)
// ===========================================
   function modules_get_language($script = 'global')
   {

      $currentlang = pnSessionGetVar('lang');
      $language = pnConfigGetVar('language');

      if (file_exists("modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($currentlang)."/$script.php")) {
         @include "modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($currentlang)."/$script.php";
      }
      elseif (!empty($language)) {
         if (file_exists("modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($language)."/$script.php")) {
            @include "modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($language)."/$script.php";
         }
      } else {
         @include "modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/eng/$script.php";
      }
      return;
   }

// Loads the required manual for module
// ===========================================
   function modules_get_manual()
   {

      $currentlang = pnSessionGetVar('lang');
      $language = pnConfigGetVar('language');

      if (file_exists("modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($currentlang)."/manual.html")) {
         $GLOBALS['hlpfile'] = "modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($currentlang)."/manual.html";
      }
      elseif (!empty($language)) {
         if (file_exists("modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($language)."/manual.html")) {
            $GLOBALS['hlpfile'] = "modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/".pnVarPrepForOS($language)."/manual.html";
         }
      } else {
         $GLOBALS['hlpfile'] = "modules/".pnVarPrepForOS($GLOBALS['ModName'])."/lang/eng/manual.html";
      }
      return ;
   }

// Loads the required language file for themes (from Patrick Kellum <webmaster@ctarl-ctarl.com>)
// ===========================================
   function themes_get_language($script = 'global')
   {

      $currentlang = pnSessionGetVar('lang');
      $language = pnConfigGetVar('language');
      $Default_Theme = pnConfigGetVar('Default_Theme');

// modification multisites .71 mouzaia
// added the WHERE_IS_PERSO possibilities.
// is it good ?
// die( $currentlang . '-' . $language .'-'.$Default_Theme);

      if (file_exists($file='themes/' . pnVarPrepForOS($GLOBALS['thename']) . '/lang/' . pnVarPrepForOS($currentlang) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      elseif (file_exists($file='themes/' . pnVarPrepForOS($GLOBALS['thename']) . '/lang/' . pnVarPrepForOS($language) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      if (file_exists($file=WHERE_IS_PERSO.'themes/' . pnVarPrepForOS($GLOBALS['thename']) . '/lang/' . pnVarPrepForOS($currentlang) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      elseif (file_exists($file=WHERE_IS_PERSO.'themes/' . pnVarPrepForOS($GLOBALS['thename']) . '/lang/' . pnVarPrepForOS($language) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      elseif (file_exists($file='themes/' . pnVarPrepForOS($Default_Theme) . '/lang/' . pnVarPrepForOS($currentlang) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      elseif (file_exists($file='themes/' . pnVarPrepForOS($Default_Theme) . '/lang/' . pnVarPrepForOS($language) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      elseif (file_exists($file=WHERE_IS_PERSO.'themes/' . pnVarPrepForOS($Default_Theme) . '/lang/' . pnVarPrepForOS($currentlang) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
      elseif (file_exists($file=WHERE_IS_PERSO.'themes/' . pnVarPrepForOS($Default_Theme) . '/lang/' . pnVarPrepForOS($language) . '/' . pnVarPrepForOS($script) . '.php'))
         @include $file;
   }

// list of all availabe languages (from Patrick Kellum <webmaster@ctarl-ctarl.com>)
// ==============================
   function languagelist()
   {
      // Need to ensure this is loaded for language defines
      pnBlockLoad('Core', 'thelang');
//    All entries use ISO 639-2/T
      $lang['ara'] = _LANGUAGE_ARA; // Arabic
      $lang['bul'] = _LANGUAGE_BUL; // Bulgarian
      $lang['zho'] = _LANGUAGE_ZHO; // Chinese
      $lang['cat'] = _LANGUAGE_CAT; // Catalan
      $lang['ces'] = _LANGUAGE_CES; // Czech
      $lang['hrv'] = _LANGUAGE_HRV; // Croatian  HRV
      $lang['cro'] = _LANGUAGE_CRO; // Croatian  CRO
      $lang['dan'] = _LANGUAGE_DAN; // Danish
      $lang['nld'] = _LANGUAGE_NLD; // Dutch
      $lang['eng'] = _LANGUAGE_ENG; // English
      $lang['epo'] = _LANGUAGE_EPO; // Esperanto
      $lang['est'] = _LANGUAGE_EST; // Estonian
      $lang['fin'] = _LANGUAGE_FIN; // Finnish
      $lang['fra'] = _LANGUAGE_FRA; // French
      $lang['deu'] = _LANGUAGE_DEU; // German
      $lang['ell'] = _LANGUAGE_ELL; // Greek, Modern (1453-)
      $lang['heb'] = _LANGUAGE_HEB; // Hebrew
      $lang['hun'] = _LANGUAGE_HUN; // Hungarian
      $lang['isl'] = _LANGUAGE_ISL; // Icelandic
      $lang['ind'] = _LANGUAGE_IND; // Indonesian
      $lang['ita'] = _LANGUAGE_ITA; // Italian
      $lang['jpn'] = _LANGUAGE_JPN; // Japanese
      $lang['kor'] = _LANGUAGE_KOR; // Korean
      $lang['lav'] = _LANGUAGE_LAV; // Latvian
      $lang['lit'] = _LANGUAGE_LIT; // Lithuanian
      $lang['mas'] = _LANGUAGE_MAS; // Malay
      $lang['mkd'] = _LANGUAGE_MKD; // Macedonian
      $lang['nor'] = _LANGUAGE_NOR; // Norwegian
      $lang['pol'] = _LANGUAGE_POL; // Polish
      $lang['por'] = _LANGUAGE_POR; // Portuguese
      $lang['ron'] = _LANGUAGE_RON; // Romanian
      $lang['rus'] = _LANGUAGE_RUS; // Russian
      $lang['slv'] = _LANGUAGE_SLV; // Slovenian
      $lang['spa'] = _LANGUAGE_SPA; // Spanish
      $lang['swe'] = _LANGUAGE_SWE; // Swedish
      $lang['tha'] = _LANGUAGE_THA; // Thai
      $lang['tur'] = _LANGUAGE_TUR; // Turkish
      $lang['ukr'] = _LANGUAGE_UKR; // Ukrainian
      $lang['yid'] = _LANGUAGE_YID; // Yiddish
//    Non-ISO entries are written as x_[language name]
      $lang['x_all'] = _ALL; // all languages
      $lang['x_brazilian_portuguese'] = _LANGUAGE_X_BRAZILIAN_PORTUGUESE; // Brazilian Portuguese
      $lang['x_klingon'] = _LANGUAGE_X_KLINGON; // Klingon
      $lang['x_rus_koi8r'] = _LANGUAGE_X_RUS_KOI8R; // Russian KOI8-R
//    end of list
      return $lang;
   }

   function rsslanguagelist()
   {
    $rsslang['af'] = "Afrikaans";
    $rsslang['sq'] = "Albanian";
    $rsslang['ar-bh'] = "Arabic (Bahrain)";
    $rsslang['eu'] = "Basque";
    $rsslang['be'] = "Belarusian";
    $rsslang['bg'] = "Bulgarian";
    $rsslang['ca'] = "Catalan";
    $rsslang['zh-cn'] = 'Chinese (Simplified)';
    $rsslang['zh-tw'] = 'Chinese (Traditional)';
    $rsslang['hr'] = 'Croatian';
    $rsslang['cs'] = 'Czech';
    $rsslang['da'] = 'Danish';
    $rsslang['nl'] = 'Dutch';
    $rsslang['nl-be'] = 'Dutch (Belgium)';
    $rsslang['nl-nl'] = 'Dutch (Netherlands)';
    $rsslang['en'] = 'English';
    $rsslang['en-au'] = 'English (Australia)';
    $rsslang['en-bz'] = 'English (Belize)';
    $rsslang['en-ca'] = 'English (Canada)';
    $rsslang['en-ie'] = 'English (Ireland)';
    $rsslang['en-jm'] = 'English (Jamaica)';
    $rsslang['en-nz'] = 'English (New Zealand)';
    $rsslang['en-ph'] = 'English (Phillipines)';
    $rsslang['en-za'] = 'English (South Africa)';
    $rsslang['en-tt'] = 'English (Trinidad)';
    $rsslang['en-gb'] = 'English (United Kingdom)';
    $rsslang['en-us'] = 'English (United States)';
    $rsslang['en-zw'] = 'English (Zimbabwe)';
    $rsslang['fo'] = 'Faeroese';
    $rsslang['fi'] = 'Finnish';
    $rsslang['fr'] = 'French';
    $rsslang['fr-be'] = 'French (Belgium)';
    $rsslang['fr-ca'] = 'French (Canada)';
    $rsslang['fr-fr'] = 'French (France)';
    $rsslang['fr-lu'] = 'French (Luxembourg)';
    $rsslang['fr-mc'] = 'French (Monaco)';
    $rsslang['fr-ch'] = 'French (Switzerland)';
    $rsslang['gl'] = 'Galician';
    $rsslang['gd'] = 'Gaelic';
    $rsslang['de'] = 'German';
    $rsslang['de-at'] = 'German (Austria)';
    $rsslang['de-de'] = 'German (Germany)';
    $rsslang['de-li'] = 'German (Liechtenstein)';
    $rsslang['de-lu'] = 'German (Luxembourg)';
    $rsslang['de-ch'] = 'German (Switzerland)';
    $rsslang['el'] = 'Greek';
    $rsslang['hu'] = 'Hungarian';
    $rsslang['is'] = 'Icelandic';
    $rsslang['in'] = 'Indonesian';
    $rsslang['ga'] = 'Irish';
    $rsslang['it'] = 'Italian';
    $rsslang['it-it'] = 'Italian (Italy)';
    $rsslang['it-ch'] = 'Italian (Switzerland)';
    $rsslang['ja'] = 'Japanese';
    $rsslang['ko'] = 'Korean';
    $rsslang['mk'] = 'Macedonian';
    $rsslang['no'] = 'Norwegian';
    $rsslang['pl'] = 'Polish';
    $rsslang['pt'] = 'Portuguese';
    $rsslang['pt-br'] = 'Portuguese (Brazil)';
    $rsslang['pt-pt'] = 'Portuguese (Portugal)';
    $rsslang['ro'] = 'Romanian';
    $rsslang['ro-mo'] = 'Romanian (Moldova)';
    $rsslang['ro-ro'] = 'Romanian (Romania)';
    $rsslang['ru'] = 'Russian';
    $rsslang['KOI8-R'] = 'Russian KOI8-R';
    $rsslang['ru-mo'] = 'Russian (Moldova)';
    $rsslang['ru-ru'] = 'Russian (Russia)';
    $rsslang['sr'] = 'Serbian';
    $rsslang['sk'] = 'Slovak';
    $rsslang['sl'] = 'Slovenian';
    $rsslang['es'] = 'Spanish';
    $rsslang['es-ar'] = 'Spanish (Argentina)';
    $rsslang['es-bo'] = 'Spanish (Bolivia)';
    $rsslang['es-cl'] = 'Spanish (Chile)';
    $rsslang['es-co'] = 'Spanish (Colombia)';
    $rsslang['es-cr'] = 'Spanish (Costa Rica)';
    $rsslang['es-do'] = 'Spanish (Dominican Republic)';
    $rsslang['es-ec'] = 'Spanish (Ecuador)';
    $rsslang['es-sv'] = 'Spanish (El Salvador)';
    $rsslang['es-gt'] = 'Spanish (Guatemala)';
    $rsslang['es-hn'] = 'Spanish (Honduras)';
    $rsslang['es-mx'] = 'Spanish (Mexico)';
    $rsslang['es-ni'] = 'Spanish (Nicaragua)';
    $rsslang['es-pa'] = 'Spanish (Panama)';
    $rsslang['es-py'] = 'Spanish (Paraguay)';
    $rsslang['es-pe'] = 'Spanish (Peru)';
    $rsslang['es-pr'] = 'Spanish (Puerto Rico)';
    $rsslang['es-es'] = 'Spanish (Spain)';
    $rsslang['es-uy'] = 'Spanish (Uruguay)';
    $rsslang['es-ve'] = 'Spanish (Venezuela)';
    $rsslang['sv'] = 'Swedish';
    $rsslang['sv-fi'] = 'Swedish (Finland)';
    $rsslang['sv-se'] = 'Swedish (Sweden)';
    $rsslang['th'] = 'Thai';
    $rsslang['tr'] = 'Turkish';
    $rsslang['uk'] = 'Ukranian';
    $rsslang['ar'] = 'Arabic';
    $rsslang['ar-ae'] = 'Arabic (United Arab Emirates)';
    $rsslang['ar-bh'] = 'Arabic (Bahrain)';
    $rsslang['ar-dz'] = 'Arabic (Algeria)';
    $rsslang['ar-eg'] = 'Arabic (Egypt)';
    $rsslang['ar-iq'] = 'Arabic (Iraq)';
    $rsslang['ar-jo'] = 'Arabic (Jordan)';
    $rsslang['ar-kw'] = 'Arabic (Kuwait)';
    $rsslang['ar-lb'] = 'Arabic (Lebanon)';
    $rsslang['ar-ly'] = 'Arabic (Libya)';
    $rsslang['ar-ma'] = 'Arabic (Morocco)';
    $rsslang['ar-mr'] = 'Arabic (Mauritania)';
    $rsslang['ar-om'] = 'Arabic (Oman)';
    $rsslang['ar-qa'] = 'Arabic (Qatar)';
    $rsslang['ar-sa'] = 'Arabic (Saudi Arabia)';
    $rsslang['ar-sd'] = 'Arabic (Sudan)';
    $rsslang['ar-so'] = 'Arabic (Somalia)';
    $rsslang['ar-sy'] = 'Arabic (Syria)';
    $rsslang['ar-tn'] = 'Arabic (Tunisia)';
    $rsslang['ar-ye'] = 'Arabic (Yemen)';
    $rsslang['ar-km'] = 'Arabic (Comoros)';
    $rsslang['ar-dj'] = 'Arabic (Djibouti)';
    asort($rsslang);
    return $rsslang;
}

/**
 * Language list for auto detection of browser language
 */
function cnvlanguagelist()
{
    $cnvlang['af'] = "eng";
    $cnvlang['sq'] = "eng";
    $cnvlang['ar-bh'] = "ara";
    $cnvlang['eu'] = "eng";
    $cnvlang['be'] = "eng";
    $cnvlang['bg'] = "bul";
    $cnvlang['ca'] = "eng";
    $cnvlang['zh-cn'] = 'zho';
    $cnvlang['zh-tw'] = 'zho';
    $cnvlang['hr'] = 'cro';
    $cnvlang['cs'] = 'ces';
    $cnvlang['da'] = 'dan';
    $cnvlang['nl'] = 'nld';
    $cnvlang['nl-be'] = 'nld';
    $cnvlang['nl-nl'] = 'nld';
    $cnvlang['en'] = 'eng';
    $cnvlang['en-au'] = 'eng';
    $cnvlang['en-bz'] = 'eng';
    $cnvlang['en-ca'] = 'eng';
    $cnvlang['en-ie'] = 'eng';
    $cnvlang['en-jm'] = 'eng';
    $cnvlang['en-nz'] = 'eng';
    $cnvlang['en-ph'] = 'eng';
    $cnvlang['en-za'] = 'eng';
    $cnvlang['en-tt'] = 'eng';
    $cnvlang['en-gb'] = 'eng';
    $cnvlang['en-us'] = 'eng';
    $cnvlang['en-zw'] = 'eng';
    $cnvlang['fo'] = 'eng';
    $cnvlang['fi'] = 'fin';
    $cnvlang['fr'] = 'fra';
    $cnvlang['fr-be'] = 'fra';
    $cnvlang['fr-ca'] = 'fra';
    $cnvlang['fr-fr'] = 'fra';
    $cnvlang['fr-lu'] = 'fra';
    $cnvlang['fr-mc'] = 'fra';
    $cnvlang['fr-ch'] = 'fra';
    $cnvlang['gl'] = 'eng';
    $cnvlang['gd'] = 'eng';
    $cnvlang['de'] = 'deu';
    $cnvlang['de-at'] = 'deu';
    $cnvlang['de-de'] = 'deu';
    $cnvlang['de-li'] = 'deu';
    $cnvlang['de-lu'] = 'deu';
    $cnvlang['de-ch'] = 'deu';
    $cnvlang['el'] = 'ell';
    $cnvlang['hu'] = 'hun';
    $cnvlang['is'] = 'isl';
    $cnvlang['in'] = 'ind';
    $cnvlang['ga'] = 'eng';
    $cnvlang['it'] = 'ita';
    $cnvlang['it-it'] = 'ita';
    $cnvlang['it-ch'] = 'ita';
    $cnvlang['ja'] = 'jpn';
    $cnvlang['ko'] = 'kor';
    $cnvlang['mk'] = 'mkd';
    $cnvlang['no'] = 'nor';
    $cnvlang['pl'] = 'pol';
    $cnvlang['pt'] = 'por';
    $cnvlang['pt-br'] = 'por';
    $cnvlang['pt-pt'] = 'por';
    $cnvlang['ro'] = 'ron';
    $cnvlang['ro-mo'] = 'ron';
    $cnvlang['ro-ro'] = 'ron';
    $cnvlang['ru'] = 'rus';
    $cnvlang['KOI8-R'] = 'rus';
    $cnvlang['ru-mo'] = 'rus';
    $cnvlang['ru-ru'] = 'rus';
    $cnvlang['sr'] = 'eng';
    $cnvlang['sk'] = 'slv';
    $cnvlang['sl'] = 'slv';
    $cnvlang['es'] = 'spa';
    $cnvlang['es-ar'] = 'spa';
    $cnvlang['es-bo'] = 'spa';
    $cnvlang['es-cl'] = 'spa';
    $cnvlang['es-co'] = 'spa';
    $cnvlang['es-cr'] = 'spa';
    $cnvlang['es-do'] = 'spa';
    $cnvlang['es-ec'] = 'spa';
    $cnvlang['es-sv'] = 'spa';
    $cnvlang['es-gt'] = 'spa';
    $cnvlang['es-hn'] = 'spa';
    $cnvlang['es-mx'] = 'spa';
    $cnvlang['es-ni'] = 'spa';
    $cnvlang['es-pa'] = 'spa';
    $cnvlang['es-py'] = 'spa';
    $cnvlang['es-pe'] = 'spa';
    $cnvlang['es-pr'] = 'spa';
    $cnvlang['es-es'] = 'spa';
    $cnvlang['es-uy'] = 'spa';
    $cnvlang['es-ve'] = 'spa';
    $cnvlang['sv'] = 'swe';
    $cnvlang['sv-fi'] = 'swe';
    $cnvlang['sv-se'] = 'swe';
    $cnvlang['th'] = 'tha';
    $cnvlang['tr'] = 'tur';
    $cnvlang['uk'] = 'ukr';
    $cnvlang['ar'] = 'ara';
    $cnvlang['ar-ae'] = 'ara';
    $cnvlang['ar-bh'] = 'ara';
    $cnvlang['ar-dz'] = 'ara';
    $cnvlang['ar-eg'] = 'ara';
    $cnvlang['ar-iq'] = 'ara';
    $cnvlang['ar-jo'] = 'ara';
    $cnvlang['ar-kw'] = 'ara';
    $cnvlang['ar-lb'] = 'ara';
    $cnvlang['ar-ly'] = 'ara';
    $cnvlang['ar-ma'] = 'ara';
    $cnvlang['ar-mr'] = 'ara';
    $cnvlang['ar-om'] = 'ara';
    $cnvlang['ar-qa'] = 'ara';
    $cnvlang['ar-sa'] = 'ara';
    $cnvlang['ar-sd'] = 'ara';
    $cnvlang['ar-so'] = 'ara';
    $cnvlang['ar-sy'] = 'ara';
    $cnvlang['ar-tn'] = 'ara';
    $cnvlang['ar-ye'] = 'ara';
    $cnvlang['ar-km'] = 'ara';
    $cnvlang['ar-dj'] = 'ara';
    asort($cnvlang);
    return $cnvlang;
}

   function jslanguagelist()
   {
//    All entries use ISO 639-2/T
      $jslang['ara'] = 'en'; // Arabic
      $jslang['bul'] = 'en'; // Bulgarian
      $jslang['zho'] = 'gb'; // Chinese-GB
      $jslang['cat'] = 'en'; // Catalan
      $jslang['ces'] = 'cz'; // Czech
      $jslang['hrv'] = 'en'; // Croatian  HRV
      $jslang['cro'] = 'en'; // Croatian  CRO
      $jslang['dan'] = 'da'; // Danish
      $jslang['nld'] = 'nl'; // Dutch
      $jslang['eng'] = 'en'; // English
      $jslang['epo'] = 'en'; // Esperanto
      $jslang['est'] = 'es'; // Estonian
      $jslang['fin'] = 'fi'; // Finnish
      $jslang['fra'] = 'fr'; // French
      $jslang['deu'] = 'de'; // German
      $jslang['ell'] = 'en'; // Greek, Modern (1453-)
      $jslang['heb'] = 'he'; // Hebrew
      $jslang['hun'] = 'hu'; // Hungarian
      $jslang['isl'] = 'en'; // Icelandic
      $jslang['ind'] = 'en'; // Indonesian
      $jslang['ita'] = 'it'; // Italian
      $jslang['jpn'] = 'ja-utf8'; // Japanese
      $jslang['kor'] = 'en'; // Korean
      $jslang['lav'] = 'lv'; // Latvian
      $jslang['lit'] = 'lt'; // Lithuanian
      $jslang['mas'] = 'en'; // Malay
      $jslang['mkd'] = 'en'; // Macedonian
      $jslang['nor'] = 'no'; // Norwegian
      $jslang['pol'] = 'pl'; // Polish
      $jslang['por'] = 'pt_br'; // Portuguese
      $jslang['ron'] = 'ro'; // Romanian
      $jslang['rus'] = 'ru'; // Russian
      $jslang['slv'] = 'en'; // Slovenian
      $jslang['spa'] = 'en'; // Spanish
      $jslang['swe'] = 'se'; // Swedish
      $jslang['tha'] = 'en'; // Thai
      $jslang['tur'] = 'en'; // Turkish
      $jslang['ukr'] = 'en'; // Ukrainian
      $jslang['vie'] = 'vn'; // Vietnam
      $jslang['yid'] = 'en'; // Yiddish
//    Non-ISO entries are written as x_[language name]
      $jslang['x_all'] = 'en'; // all languages
      $jslang['x_brazilian_portuguese'] = 'en'; // Brazilian Portuguese
      $jslang['x_klingon'] = 'en'; // Klingon
      $jslang['x_rus_koi8r'] = 'en'; // Russian KOI8-R
//    end of list
      return $jslang;
   }

// format a time/date according to current language settings (from Volodymyr Metenchuk <voll@yahoo.com>)

// Timezone Function by Fred B (fredb86)
function ml_ftime($datefmt, $timestamp = -1){

    if ($timestamp < 0){
        $timestamp = time();
    }
    $day_of_week_short = explode(' ', _DAY_OF_WEEK_SHORT);
    $month_short = explode(' ', _MONTH_SHORT);
    $day_of_week_long = explode(' ', _DAY_OF_WEEK_LONG);
    $month_long = explode(' ', _MONTH_LONG);

      $ml_date = ereg_replace('%a',$day_of_week_short[(int) strftime('%w',$timestamp)],$datefmt);
      $ml_date = ereg_replace('%A',$day_of_week_long[(int) strftime('%w',$timestamp)],$ml_date);
      $ml_date = ereg_replace('%b',$month_short[(int) strftime('%m',$timestamp)-1],$ml_date);
      $ml_date = ereg_replace('%B',$month_long[(int)strftime ('%m',$timestamp)-1],$ml_date);

    if(pnUserLoggedIn()) {
        $thezone = pnUserGetVar('timezone_offset');
    } else {
        $thezone = pnConfigGetVar('timezone_offset');
    }

    $timezone_all = explode(' ', _TIMEZONES);
    $offset_all = explode(' ', _TZOFFSETS);

    $indexofzone=0;
    for ($i=0; $i<sizeof($offset_all); $i++){
        if ($offset_all[$i] == $thezone){
           $indexofzone=$i;
        }
    }
    $ml_date = ereg_replace('%Z',$timezone_all [$indexofzone],$ml_date);
    return strftime($ml_date,$timestamp);
}


// get current language
// ====================
   function language_current($action='get',$new_language='')
   {
      static $language='';
      switch ($action)
      {
         case 'get':
            return $language;
         case 'set':
            $language = $new_language;
            break;
         default:
            die("language_current($action,$new_language)");
      }
   }

// build language sql clause for ml
// ================================
   function language_sql($table, $prefix='',$sql='WHERE')
   {
    $language = language_current();
    if ($language=='')
       return '';
    else
       return " $sql " . $pntable["{$table}_column"]["{$prefix}language"] . "='$language'";
   }

// get a language name
// ===================
function language_name($language) {
    static $name=array();
    if (!count($name)) {
        $name = languagelist();
    }
    return $name[$language];
}
?>