<?php
// $Id: pnAPI.php,v 1.20 2004/09/23 06:33:06 timax Exp $
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file: The MD-Pro API
// ----------------------------------------------------------------------------
/*        Allows MD-Pro to work with register_globals set to off
 *        Patch for php 4.2.x or greater
 */
if (ini_get('register_globals') != 1) {
    if (phpversion() >= "4.2.0") $supers = array('_REQUEST', '_ENV', '_SERVER', '_SESSION', '_FILES');
    else $supers = array('HTTP_POST_VARS', 'HTTP_GET_VARS', 'HTTP_COOKIE_VARS', 'GLOBALS', 'HTTP_SESSION_VARS', 'HTTP_SERVER_VARS', 'HTTP_ENV_VARS');
    foreach($supers as $__s) if ((isset($$__s) == true) && (is_array($$__s) == true)) extract($$__s, EXTR_OVERWRITE);
    unset($supers);
}
// Yes/no integer
define('_PNYES', 1);
define('_PNNO', 0);
// State of modules
define('_PNMODULE_STATE_UNINITIALISED', 1);
define('_PNMODULE_STATE_INACTIVE', 2);
define('_PNMODULE_STATE_ACTIVE', 3);
define('_PNMODULE_STATE_MISSING', 4);
define('_PNMODULE_STATE_UPGRADED', 5);
// 'All' and 'unregistered' for user and group permissions
define('_PNPERMS_ALL', '-1');
define('_PNPERMS_UNREGISTERED', '0');
// Core version informations - should be upgraded on each release
define('_PN_VERSION_NUM', "1.0.7");
define('_PN_VERSION_ID', "MD-Pro");
define('_PN_VERSION_SUB', "Giotto");
// Fake module for config vars
define('_PN_CONFIG_MODULE', '/PNConfig');

/**
 * get all configuration variable into $pnconfig
 * will        be removed on .8
 *
 * @param none $
 * @returns true|false
 * @return none
 */
function pnConfigInit()
{
    global $pnconfig;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $table = $pntable['module_vars'];
    $columns = &$pntable['module_vars_column'];

    /*
         * Make        query and go
         */
    $query = "SELECT $columns[name],$columns[value]
                  FROM $table
                  WHERE $columns[modname]='" . pnVarPrepForStore(_PN_CONFIG_MODULE) . "'";
    $dbresult = $dbconn->Execute($query);
    if ($dbconn->ErrorNo() != 0) return false;
    if ($dbresult->EOF) {
        $dbresult->Close();
        return false;
    } while (!$dbresult->EOF) {
        list($k, $v) = $dbresult->fields;
        $dbresult->MoveNext();
        if (($k != 'dbtype') && ($k != 'dbhost') && ($k != 'dbuname') && ($k != 'dbpass') && ($k != 'dbname') && ($k != 'system') && ($k != 'prefix') && ($k != 'encoded')) {
            $v = @unserialize($v);
            $pnconfig[$k] = $v;
        }
    }
    $dbresult->Close();
    return true;
}

/**
 * get a configuration variable
 *
 * @param name $ the name        of the variable
 * @returns data
 * @return value of        the        variable, or false on failure
 */
function pnConfigGetVar($name)
{
    global $pnconfig;
    if (isset($GLOBALS['pnconfig'][$name])) $result = $GLOBALS['pnconfig'][$name];
    else {
        // Fetch base data
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $table = $pntable['module_vars'];
        $columns = &$pntable['module_vars_column'];
        // Make query and go
        $query = "SELECT $columns[value]
                  FROM $table
                  WHERE $columns[modname]='" . pnVarPrepForStore(_PN_CONFIG_MODULE) . "' AND $columns[name]='" . pnVarPrepForStore($name) . "'";
        $dbresult = $dbconn->Execute($query);
        // In any case of error return false
        if ($dbconn->ErrorNo() != 0) return false;
        if ($dbresult->EOF) {
            $dbresult->Close();
            return false;
        }
        // Get data
        list ($result) = $dbresult->fields;
        $result = unserialize($result);
        // Some caching
        $GLOBALS['pnconfig'][$name] = $result;
        $dbresult->Close();
    }
    return $result;
}

/**
 * set a configuration variable
 *
 * @param name $ the name        of the variable
 * @param value $ the        value of the variable
 * @returns bool
 * @return true on success,        false on failure
 */
function pnConfigSetVar($name, $value)
{
    // The database parameter are not allowed to change
    $not_allowed = array('', 'dbtype', 'dbhost', 'dbuname', 'dbpass', 'dbname', 'system', 'prefix', 'encoded');
    if (in_array($name, $not_allowed)) return false;
    // Test on missing record
    $must_insert = true;
    global $pnconfig;
    $dbtype = $pnconfig['dbtype'];
    $dbname = $pnconfig['prefix'];
    if (array_key_exists($name, $GLOBALS['pnconfig'])) {
        $must_insert = false;
        if ($GLOBALS['pnconfig'][$name] == $value) return true;
    }
    // Fetch base data
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $table = $pntable['module_vars'];
    $columns = &$pntable['module_vars_column'];

    if ($dbtype == 'oci8') {
        if ($must_insert) {
            // Insert
            $sequence = substr_replace($pntable['module_vars'], '', 0, strlen($dbname) + 1) . '_sq';
            $new_id = $dbconn->GenId($sequence);
            $query = "INSERT INTO $table ($columns[id],$columns[modname], $columns[name],$columns[value])
					  VALUES ($new_id,'" . pnVarPrepForStore(_PN_CONFIG_MODULE) . "','" . pnVarPrepForStore($name) . "',empty_clob())";
            $result = $dbconn->Execute($query);
            $dbconn->updateClob($table, $columns[value], pnVarPrepForStore(serialize($value)), "$columns[id]=" . $new_id);
        } else {
            // Update
            $dbconn->updateClob($table, $columns[value], pnVarPrepForStore(serialize($value)), "$columns[modname]='" . pnVarPrepForStore(_PN_CONFIG_MODULE) . "' AND $columns[name] = '" . pnVarPrepForStore($name) . "'");
        }
    } else {
        if ($must_insert) {
            // Insert
            $query = "INSERT INTO $table ($columns[modname], $columns[name],$columns[value])
					  VALUES ('" . pnVarPrepForStore(_PN_CONFIG_MODULE) . "','" . pnVarPrepForStore($name) . "','" . pnVarPrepForStore(serialize($value)) . "')";
        } else {
            // Update
            $query = "UPDATE $table
					  SET	 $columns[value]='" . pnVarPrepForStore(serialize($value)) . "'
					  WHERE	 $columns[modname]='" . pnVarPrepForStore(_PN_CONFIG_MODULE) . "' AND $columns[name]='" . pnVarPrepForStore($name) . "'";
        }
        $dbconn->Execute($query);
    }
    if ($dbconn->ErrorNo() != 0) return false;
    // Update my vars
    $GLOBALS['pnconfig'][$name] = $value;
    return true;
}
// Serg was here... Show me that guy who wrote this!
function pnConfigDelVar($name)
{
    return false;
}

/*
	Initialise MD-Pro
	Carries out a number of initialisation tasks to get MD-Pro up and running.
	@returns void
*/
function pnInit()
{
    // proper error_repoting
    // E_ALL for development
    // error_reporting(E_ALL);
    // without warnings and notices for release
    error_reporting(E_ALL &~E_NOTICE &~E_WARNING);
    // Hack for some weird PHP systems that should have the LC_* constants defined, but don't
    if (!defined('LC_TIME')) define('LC_TIME', 'LC_TIME');
    // ADODB configuration
    define('ADODB_DIR', 'pnadodb');
    include 'pnadodb/adodb.inc.php';
    // Temporary fix for hacking the hlpfile global || TODO - remove with pre-0.71 code
    global $hlpfile;
    $hlpfile = '';
    // Initialise and load configuration
    global $pnconfig, $pndebug;
    $pnconfig = array();
    include 'config/md-config.php';
    // Initialise and load phpSniff (WindMeUp 2003/05/09)
    require_once('includes/classes/phpSniff.class.php');
    // Possible to use this classes instead of our timer function for page load
    // require_once('/quots/classes/phpTimer.class.php');
    // initialize some vars
    global $client;
    if (!isset($UA)) $UA = '';
    if (!isset($cc)) $cc = '';
    if (!isset($dl)) $dl = '';
    if (!isset($am)) $am = '';
    $sniffer_settings = array('check_cookies' => $cc, 'default_language' => $dl, 'allow_masquerading' => $am);
    $client = new phpSniff($UA, $sniffer_settings);
    // Set up multisites
    @define('WHERE_IS_PERSO', '');
    // Initialise and load pntables
    global $pntable;
    $pntable = array();
    // if a multisite has its own pntables.
    if (file_exists(WHERE_IS_PERSO . 'pntables.php')) include WHERE_IS_PERSO . 'pntables.php';
    else include 'pntables.php';
    // Decode encoded DB parameters
    if ($pnconfig['encoded']) {
        $pnconfig['dbuname'] = base64_decode($pnconfig['dbuname']);
        $pnconfig['dbpass'] = base64_decode($pnconfig['dbpass']);
        $pnconfig['encoded'] = 0;
    }
    // Connect to database
    if (!pnDBInit()) die('Database initialisation failed');
    // debugger if required
    if ($pndebug['debug']) {
        include_once 'includes/lensdebug.inc.php';
        global $dbg, $debug_sqlcalls;
        $dbg = new LensDebug();
        $debug_sqlcalls = 0;
    }
    // Build up old config array
    pnConfigInit();
    // Set compression on if desired
    if (pnConfigGetVar('UseCompression') == 1) ob_start("ob_gzhandler");
    // Other includes
    include 'includes/pnSession.php';
    include 'includes/pnUser.php';
    // include 'includes/envRender.php';
    // Start session
    if (!pnSessionSetup()) die('Session setup failed');
    if (!pnSessionInit()) die('Session initialisation failed');
    
    // Load and initialize AutoTheme
    $atdir = "modules/AutoTheme/";
    include_once($atdir . "includes/atAPI.php");
    atAPIInit($atdir);
    
    include 'includes/security.php';

    /**
     * **** Try new langAPI from 1.1 ***************************
     * // See if a language update is required
     * $newlang = pnVarCleanFromInput('newlang');
     * if (!empty($newlang)) {
     * $lang = $newlang;
     * pnSessionSetVar('lang', $newlang);
     * } else $lang = pnSessionGetVar('lang');
     *
     * include 'modules/NS-Languages/api.php';
     * // Load global language defines
     * if (isset ($lang) && file_exists('language/'.pnVarPrepForOS($lang).'/global.php')) {
     * $currentlang = $lang;
     * } else {
     * $detectlang = pnConfigGetVar('language_detect');
     * $defaultlang = pnConfigGetVar('language');
     *
     * $cnvlanguage=cnvlanguagelist();
     * switch ($detectlang) {
     * case 1:
     * // Detect Browser Language
     * $currentlang="";
     * $langs = split ('[,;]',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
     * foreach ($langs as $lang) {
     * if (file_exists('language/' . pnVarPrepForOS($cnvlanguage[$lang]) . '/global.php')) {
     * $currentlang=$cnvlanguage[$lang];
     * break;
     * }
     * }
     * if ($currentlang=="") $currentlang=$defaultlang;
     * print $currentlang;
     * break;
     * default:
     * $currentlang=$defaultlang;
     * }
     * pnSessionSetVar('lang', $currentlang);
     * }
     * include 'language/'.pnVarPrepForOS($currentlang).'/global.php';
     */
    include_once 'includes/langAPI.php';
    pnLangLoad();
    // Cross-Site Scripting attack defense - Sent by larsneo
    // some syntax checking against injected javascript
    $pnAntiCrackerMode = pnConfigGetVar('pnAntiCracker');
    if ($pnAntiCrackerMode == 1) pnSecureInput();
    // Banner system DO WE NEED IT HERE ???
    include 'includes/pnBanners.php';
    // Other other includes
    include 'includes/advblocks.php';
    include 'includes/pnHTML.php';
    include 'includes/pnMod.php';
    include 'includes/queryutil.php';
    include 'includes/xhtml.php';
    include 'includes/oldfuncs.php';
   
    if (pnModAvailable('Stats')) include 'includes/counter.php';
    // Is module pnRender installed? 2003/10/22 WindMeUp
    if (pnModAvailable('pnRender')) include_once 'includes/pnRender.class.php';
    // Handle referer
    if ((pnConfigGetVar('httpref') == 1) && (pnModAvailable('Referers'))) {
        include 'referer.php';
        httpreferer();
    }
    return true;
}

// Serg: VERY FUNNY FUNCTION!
function pninclude_once($file)
{
    include_once($file);
}

function pnDBInit()
{
    // Get database parameters
    $dbtype = $GLOBALS['pnconfig']['dbtype'];
    $dbhost = $GLOBALS['pnconfig']['dbhost'];
    $dbname = $GLOBALS['pnconfig']['dbname'];
    $dbuname = $GLOBALS['pnconfig']['dbuname'];
    $dbpass = $GLOBALS['pnconfig']['dbpass'];
    // Database connection is a global (for now)
    global $dbconn;
    // Start connection
    $dbconn = ADONewConnection($dbtype);
    $dbh = $dbconn->Connect($dbhost, $dbuname, $dbpass, $dbname);
    if (!$dbh) die("<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n
		<html>\n
		<head>\n
			<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">\n
			<title>MD-Pro powered Website</title>\n
		</head>\n
		<body>\n
			<center>\n
				<h1>Problem in Database Connection</h1>\n<br /><br />\n
				<h5>This Website is powered by MD-Pro</h5>\n
				<a href=\"http://www.maxdev.com\" target=\"_blank\"><img src=\"images/powered/mdpro.gif\" border=\"0\" alt=\"Web site powered by MD-Pro\" hspace=\"10\" /></a> <a href=\"http://php.weblogs.com/ADODB\" target=\"_blank\"><img src=\"images/powered/adodb.gif\" alt=\"ADODB database library\" border=\"0\" hspace=\"10\" /></a><a href=\"http://www.php.net\" target=\"_blank\"><img src=\"images/powered/php2.gif\" alt=\"PHP Scripting Language\" border=\"0\" hspace=\"10\" /></a><br>\n<h5>Although this site is running the MD-Pro software<br />it has no other connection to the MD-Pro Developers.<br />Please refrain from sending messages about this site or its content<br />to the MD-Pro team, the end will result in an ignored e-mail.</h5>\n
			</center>\n
		</body>\n
		</html>");
    global $ADODB_FETCH_MODE;
    $ADODB_FETCH_MODE = ADODB_FETCH_NUM;
    // force oracle to a consistent date format for comparison methods later on
    if ($dbtype == 'oci8') $dbconn->Execute("alter session set NLS_DATE_FORMAT = 'YYYY-MM-DD HH24:MI:SS'");
    return true;
}

/**
 * ****** Trying Call-By-Reference
 * /**
 * get a list of database connections
 *
 * @returns array
 * @return array of        database connections
 *
 * function pnDBGetConn() {
 * global $dbconn;
 * return array($dbconn);
 * }
 *
 * /**
 * get a list of database tables
 * @returns array
 * @return array of        database tables
 *
 * function pnDBGetTables() {
 * global $pntable;
 * return $pntable;
 * }
 */

/**
 * get a list of database connections
 *
 * @author Eric Barr
 * @author Roger Raymond
 * @return array array of database connections
 */
function &pnDBGetConn($pass_by_reference = null)
{
    // If the function was called with pass_by_reference set to true
    // return a reference to the dbconn object
    if ($pass_by_reference) return $GLOBALS['dbconn'];
    else return array($GLOBALS['dbconn']);
}

/**
 * get a list of database tables
 *
 * @author Eric Barr
 * @author Roger Raymond
 * @return array array of database tables
 */
function &pnDBGetTables()
{
    return $GLOBALS['pntable'];
}

/**
 * clean user input
 * <br>
 * Gets        a global variable, cleaning        it up to try to        ensure that
 * hack        attacks        don't work
 *
 * @param var $ name of variable to get
 * @param  $ ...
 * @returns string/array
 * @return prepared variable if        only one variable passed
 * in, otherwise an        array of prepared variables
 */
function pnVarCleanFromInput()
{
    $search = array('|</?\s*SCRIPT.*?>|si',
        '|</?\s*FRAME.*?>|si',
        '|</?\s*OBJECT.*?>|si',
        '|</?\s*META.*?>|si',
        '|</?\s*APPLET.*?>|si',
        '|</?\s*LINK.*?>|si',
        '|</?\s*IFRAME.*?>|si',
        '|STYLE\s*=\s*"[^"]*"|si');

    $resarray = array();
    foreach (func_get_args() as $var) {
        // Get var
        global $$var;
        if (empty($var)) return;
        $ourvar = $$var;
        if (!isset($ourvar)) {
            array_push($resarray, null);
            continue;
        }
        if (empty($ourvar)) {
            array_push($resarray, $ourvar);
            continue;
        }
        // Clean var
        if (get_magic_quotes_gpc()) pnStripslashes($ourvar);
        if (!pnSecAuthAction(0, '::', '::', ACCESS_ADMIN)) $ourvar = preg_replace($search, array(''), $ourvar);
        // Add to result array
        array_push($resarray, $ourvar);
    }
    // Return vars
    if (func_num_args() == 1) return $resarray[0];
    else return $resarray;
}

/**
 * strip slashes
 *
 * stripslashes        on multidimensional        arrays.
 * Used        in conjunction with        pnVarCleanFromInput
 *
 * @access private
 * @param any $ variables        or arrays to be        stripslashed
 */
function pnStripslashes(&$value)
{
    if (!is_array($value)) $value = stripslashes($value);
    else array_walk($value, 'pnStripslashes');
}

/**
 * ready user output
 * <br>
 * Gets        a variable,        cleaning it        up such        that the text is
 * shown exactly as        expected
 *
 * @param var $ variable to prepare
 * @param  $ ...
 * @returns string/array
 * @return prepared variable if        only one variable passed
 * in, otherwise an        array of prepared variables
 */
function pnVarPrepForDisplay()
{
    // This        search and replace finds the text 'x@y'        and        replaces
    // it with HTML        entities, this provides        protection against
    // email harvesters
    static $search = array('/(.)@(.)/se');
    static $replace = array('"&#".sprintf("%03d", ord("\\1")) . ";&#064;&#" . sprintf("%03d", ord("\\2")) . ";";');

    $resarray = array();
    foreach (func_get_args() as $ourvar) {
        // Prepare var
        $ourvar = htmlspecialchars($ourvar);
        $ourvar = preg_replace($search, $replace, $ourvar);
        // Add to array
        array_push($resarray, $ourvar);
    }
    // Return vars
    if (func_num_args() == 1) return $resarray[0];
    else return $resarray;
}

/**
 * ready HTML output
 * <br>
 * Gets        a variable,        cleaning it        up such        that the text is
 * shown exactly as        expected, except for allowed HTML tags which
 * are allowed through
 *
 * @param var $ variable to prepare
 * @param  $ ...
 * @returns string/array
 * @return prepared variable if        only one variable passed
 * in, otherwise an        array of prepared variables
 */
function pnVarPrepHTMLDisplay()
{
    // This search and replace finds the text 'x@y' and replaces
    // it with HTML entities, this provides protection against
    // email harvesters
    // Note that the use of \024 and \022 are needed to ensure that
    // this does not break HTML tags that might be around either
    // the username or the domain name
    static $search = array('/([^\024])@([^\022])/se');
    static $replace = array('"&#" . sprintf("%03d", ord("\\1")) . ";&#064;&#" . sprintf("%03d", ord("\\2")) . ";";');

    static $allowedhtml;
    if (!isset($allowedhtml)) {
        $allowedhtml = array();
        foreach(pnConfigGetVar('AllowableHTML') as $k => $v) {
            switch ($v) {
                case 0: break;
                case 1: $allowedhtml[] = "|<(/?$k)\s*/?>|i";
                    break;
                case 2: $allowedhtml[] = "|<(/?$k(\s+.*?)?)>|i";
                    break;
            }
        }
    }
    $resarray = array();
    foreach (func_get_args() as $ourvar) {
        // Preparse var to mark the HTML that we want
        $ourvar = preg_replace($allowedhtml, "\022\\1\024", $ourvar);
        // Prepare var
        $ourvar = htmlspecialchars($ourvar);
        $ourvar = preg_replace($search, $replace, $ourvar);
        // Fix the HTML that we want
        $ourvar = preg_replace('/\022([^\024]*)\024/e', "'<'.strtr('\\1', array('&gt;'=> '>',
							   '&lt;' => '<',  '&quot;' => '\"', '&amp;' => '&')) . '>';", $ourvar);
        // Fix entities if required
        if (pnConfigGetVar('htmlentities')) {
            $ourvar = preg_replace('/&amp;([a-z#0-9]+);/i', "&\\1;", $ourvar);
            $ourvar = preg_replace('/&amp;nbsp;/', '&nbsp;', $ourvar);
        }
        // Add to array
        array_push($resarray, $ourvar);
    }
    // Return vars
    if (func_num_args() == 1) return $resarray[0];
    else return $resarray;
}

/**
 * ready databse output
 * <br>
 * Gets        a variable,        cleaning it        up such        that the text is
 * stored in a database        exactly        as expected
 *
 * @param var $ variable to prepare
 * @param  $ ...
 * @returns string/array
 * @return prepared variable if        only one variable passed
 * in, otherwise an        array of prepared variables
 */
function pnVarPrepForStore()
{
    // function modified for Oracle compatibility
    global $pndebug, $dbg, $pnconfig;
    @include_once 'config/md-config.php';
    $dbtype = $pnconfig['dbtype'];

    $resarray = array();
    foreach (func_get_args() as $ourvar) {
        // Prepare var
        if (!get_magic_quotes_runtime()) {
            if (strcmp($dbtype, 'oci8') == 0) $ourvar = ereg_replace("'", "''", $ourvar);
            else $ourvar = addslashes($ourvar);
        }
        array_push($resarray, $ourvar);
    }
    // Return vars
    if (func_num_args() == 1) return $resarray[0];
    else return $resarray;
}

/**
 * ready operating system output
 * <br>
 * Gets        a variable,        cleaning it        up such        that any attempts
 * to access files outside of the scope        of the MD-Pro
 * system is not allowed
 *
 * @param var $ variable to prepare
 * @param  $ ...
 * @returns string/array
 * @return prepared variable if        only one variable passed
 * in, otherwise an        array of prepared variables
 */
function pnVarPrepForOS()
{
    static $search = array('!\.\./!si', '!^.*://!si', '!/!si', '!\\\\!si');
    static $replace = array('', '', '_', '_');

    $resarray = array();
    foreach (func_get_args() as $ourvar) {
        // Parse out bad things
        $ourvar = preg_replace($search, $replace, $ourvar);
        // Prepare var
        if (!get_magic_quotes_runtime()) {
            if (strcmp($dbtype, 'oci8') == 0) $ourvar = ereg_replace("'", "''", $ourvar);
            else $ourvar = addslashes($ourvar);
        }
        array_push($resarray, $ourvar);
    }
    if (func_num_args() == 1) return $resarray[0];
    else return $resarray;
}

/**
 * remove censored words
 */
function pnVarCensor()
{
    static $docensor;
    if (!isset($docensor)) $docensor = pnConfigGetVar('CensorMode');

    static $search = array();
    if (empty($search)) {
        $repsearch = array('/o/i', '/e/i', '/a/i', '/i/i');
        $repreplace = array('0', '3', '@', '1');
        $censoredwords = pnConfigGetVar('CensorList');
        foreach ($censoredwords as $censoredword) {
            // Simple word
            $search[] = "/\b$censoredword\b/i";
            // Common replacements
            $mungedword = preg_replace($repsearch, $repreplace, $censoredword);
            if ($mungedword != $censoredword) $search[] = "/\b$mungedword\b/";
        }
    }
    $replace = pnConfigGetVar('CensorReplace');
    $resarray = array();
    foreach (func_get_args() as $ourvar) {
        if ($docensor) $ourvar = preg_replace($search, $replace, $ourvar);
        array_push($resarray, $ourvar);
    }
    if (func_num_args() == 1) return $resarray[0];
    else return $resarray;
}

/**
 * validate        a user variable
 *
 * @access public
 * @author Damien Bonvillain
 * @author Gregor J. Rothfuss
 * @since 1.23 - 2002/02/01
 * @param var $ the variable to validate
 * @param type $ the type        of the validation to perform
 * @param args $ optional        array with validation-specific settings
 * @returns bool
 * @return true if the validation was successful, false        otherwise
 */
function pnVarValidate($var, $type, $args = 0)
{
    switch ($type) {
        case 'email':
            // all characters must be 7 bit ascii
            $length = strlen($var);
            $idx = 0;
            while ($length--) {
                $c = $var[$idx++];
                if (ord($c) > 127) return false;
            }
            $regexp = '/^(?:[^\s\000-\037\177\(\)<>@,;:\\"\[\]]\.?)+@(?:[^\s\000-\037\177\(\)<>@,;:\\\"\[\]]\.?)+\.[a-z]{2,6}$/Ui';
            if (preg_match($regexp, $var)) return true;
            else return false;
            break;

        case 'url':
            // all characters must be 7 bit ascii
            $length = strlen($var);
            $idx = 0;
            while ($length--) {
                $c = $var[$idx++];
                if (ord($c) > 127) return false;
            }
            $regexp = '/^([!\$\046-\073=\077-\132_\141-\172~]|(?:%[a-f0-9]{2}))+$/i';
            if (!preg_match($regexp, $var)) return false;
            $url_array = @parse_url($var);
            if (empty($url_array)) return false;
            else return !empty($url_array['scheme']);
            break;
    }
}

/**
 * check an        assertion
 * <br>
 * Check an        assertion to ensure        that it        is valid.  If not, then        die
 *
 * @param assertion $ the        assertion
 * @param filename $ the filename        the        assertion occurs in
 * @param line $ the line        number the assertion occurs        in
 */
function pnAssert($assertion, $file = 'Unknown', $line = 'Unknown', $msg = '')
{
    if ($assertion) return;
    // Assertion failed - log it
    if (!empty($msg)) die("Assertion failed in $file at line $line - $msg");
    else die("Assertion failed in $file at line $line");
}

/**
 * get status message from previous        operation
 * <br>
 * Obtains any status message, and also        destroys
 * it from the session to prevent duplication
 *
 * @returns string
 * @return the status message
 */
function pnGetStatusMsg()
{
    $msg = pnSessionGetVar('statusmsg');
    pnSessionDelVar('statusmsg');
    $errmsg = pnSessionGetVar('errormsg');
    pnSessionDelVar('errormsg');
    // Error message overrides status message
    if (!empty($errmsg)) return $errmsg;
    return $msg;
}

function pnThemeLoad($thistheme)
{
    static $loaded = 0;
    if ($loaded) return true;
    // Lots of nasty globals for back-compatability with older themes
    global $bgcolor1;
    global $bgcolor2;
    global $bgcolor3;
    global $bgcolor4;
    global $bgcolor5;
    global $sepcolor;
    global $textcolor1;
    global $textcolor2;
    global $postnuke_theme;
    global $thename;

    if (defined(WHERE_IS_PERSO) and file_exists(WHERE_IS_PERSO . "themes/$thistheme/theme.php")) include WHERE_IS_PERSO . "themes/$thistheme/theme.php";
    else include "themes/$thistheme/theme.php";
    // end of modification
    $loaded = 1;
    return true;
}

function pnThemeGetVar($name)
{
    global $$name;
    if (isset($$name)) return $$name;
}

/**
 * get base        URI        for        MD-Pro
 *
 * @returns string
 * @return base URI        for        MD-Pro
 */
function pnGetBaseURI()
{
    global $HTTP_SERVER_VARS;
    // Get the name of this URI
    // Start of with REQUEST_URI
    if (isset($HTTP_SERVER_VARS['REQUEST_URI'])) $path = $HTTP_SERVER_VARS['REQUEST_URI'];
    else $path = getenv('REQUEST_URI');
    if ((empty($path)) || (substr($path, -1, 1) == '/')) {
        // REQUEST_URI was empty or        pointed        to a path
        // Try looking at PATH_INFO
        $path = getenv('PATH_INFO');
        if (empty($path)) {
            // No luck there either, try SCRIPT_NAME
            if (isset($HTTP_SERVER_VARS['SCRIPT_NAME'])) $path = $HTTP_SERVER_VARS['SCRIPT_NAME'];
            else $path = getenv('SCRIPT_NAME');
        }
    }
    $path = preg_replace('/[#\?].*/', '', $path);
    $path = dirname($path);
    if (preg_match('!^[/\\\]*$!', $path)) $path = '';
    return $path;
}

/**
 * get base        URL        for        MD-Pro
 *
 * @returns string
 * @return base URL        for        MD-Pro
 */
function pnGetBaseURL()
{
    global $HTTP_SERVER_VARS;

    if (empty($HTTP_SERVER_VARS['HTTP_HOST'])) $server = getenv('HTTP_HOST');
    else $server = $HTTP_SERVER_VARS['HTTP_HOST'];
    // IIS sets HTTPS=off
    if (isset($HTTP_SERVER_VARS['HTTPS']) && $HTTP_SERVER_VARS['HTTPS'] != 'off') $proto = 'https://';
    else $proto = 'http://';

    $path = pnGetBaseURI();
    return "$proto$server$path/";
}

/**
 * Carry out a redirect
 *
 * @param the $ URL to redirect to
 * @returns void
 */
function pnRedirect($redirecturl)
{
    session_write_close();
    if (preg_match('!^http!', $redirecturl)) {
        // Absolute URL - simple redirect
        Header("Location: $redirecturl");
        return true;
    } else {
        // Removing leading slashes from redirect url
        $redirecturl = preg_replace('!^/*!', '', $redirecturl);
        // Get base URL
        $baseurl = pnGetBaseURL();
        Header("Location: $baseurl$redirecturl");
    }
}

/**
 * check to        see        if this        is a local referral
 *
 * @returns bool
 * @return true if locally referred, false if not
 */
function pnLocalReferer()
{
    if (empty($HTTP_SERVER_VARS['HTTP_HOST'])) $server = getenv('HTTP_HOST');
    else $server = $HTTP_SERVER_VARS['HTTP_HOST'];

    if (empty($HTTP_SERVER_VARS['HTTP_REFERER'])) $referer = getenv('HTTP_REFERER');
    else $referer = $HTTP_SERVER_VARS['HTTP_REFERER'];

    if (empty($referer) || preg_match("!^http://$server/!", $referer)) return true;
    else return false;
}
// Hack - we need this for themes, but will get rid of it soon
if (!function_exists('GetUserTime')) {
    function GetUserTime($time)
    {
        if (pnUserLoggedIn()) $time += (pnUserGetVar('timezone_offset') - pnConfigGetVar('timezone_offset')) * 3600;
        return $time;
    }
}

/**
 * send        an email
 *
 * @param to $ - recipient of        the        email
 * @param subject $ -        title of the email
 * @param message $ -        body of        the        email
 * @param headers $ -        extra headers for the email
 * @param debug $ - if 1, echo mail content
 * @returns bool
 * @return true if the email was sent, false if        not
 */
function pnMail($to, $subject, $message, $headers, $debug = 0)
{
    // Language translations
    switch (pnUserGetLang()) {
        case 'rus':
            if (!empty($headers)) $headers .= "\n";
            $headers .= "Content-Type: text/plain; charset=koi8-r";
            $subject = convert_cyr_string($subject, "w", "k");
            $message = convert_cyr_string($message, "w", "k");
            $headers = convert_cyr_string($headers, "w", "k");
            break;
    }
    // Debug
    if ($debug) {
        echo "Mail To: " . $to . "<br>";
        echo "Mail Subject: " . $subject . "<br>";
        echo "Mail Message: " . $message . "<br>";
        echo "Mail Headers: " . $headers . "<br>";
    }
    // Mail message
    // do not display error messages [class007]
    $return = @mail($to, $subject, $message, $headers);
    return $return;
}

/* Protects better diverse attempts of Cross-Site Scripting
   attacks, thanks to webmedic, Timax, larsneo.
 */

function pnSecureInput()
{
    /*      Lets validate the current php version and set globals
	        accordingly.
	        Do not change this value unless you know what you are
	        doing you have been warned!
	 */
    /* Serg was here: what a s**t ??? */
    if (phpversion() >= "4.2.0") {
        $HTTP_GET_VARS = $_GET;
        $HTTP_POST_VARS = $_POST;
        $HTTP_COOKIE_VARS = $_COOKIE;
    } else {
        global $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_COOKIE_VARS;
    }
    // Cross-Site Scripting attack defense - Sent by larsneo
    // some syntax checking against injected javascript
    // extended by Neo
    if (count($HTTP_GET_VARS) > 0) {
        // Lets now sanitize the GET vars
        foreach ($HTTP_GET_VARS as $secvalue) {
            if (!is_array($secvalue)) {
                if ((eregi("<[^>]*script*\"?[^>]*>", $secvalue)) ||
                        (eregi(".*[[:space:]](or|and)[[:space:]].*(=|like).*", $secvalue)) ||
                        (eregi("<[^>]*object*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*iframe*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*applet*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*meta*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*style*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*form*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*window.*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*alert*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*img*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*document.*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*cookie*\"?[^>]*>", $secvalue)) ||
                        (eregi("\"", $secvalue))) {
                    pnMailHackAttempt(__FILE__, __LINE__, 'MD Security Alert', 'Intrusion detection.');
                    Header("Location: index.php");
                }
            }
        }
    }
    // Sanitize the POST vars
    if (count($HTTP_POST_VARS) > 0) {
        foreach ($HTTP_POST_VARS as $secvalue) {
            if (!is_array($secvalue)) {
                if ((eregi("<[^>]*script*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*object*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*iframe*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*applet*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*window.*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*alert*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*document.*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*cookie*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*meta*\"?[^>]*>", $secvalue))) {
                    pnMailHackAttempt(__FILE__, __LINE__, 'MD Security Alert', 'Intrusion detection.');
                    Header("Location: index.php");
                }
            }
        }
    }
    // Sanitize the COOKIE vars
    if (count($HTTP_COOKIE_VARS) > 0) {
        foreach ($HTTP_COOKIE_VARS as $secvalue) {
            if (!is_array($secvalue)) {
                if ((eregi("<[^>]*script*\"?[^>]*>", $secvalue)) ||
                        (eregi(".*[[:space:]](or|and)[[:space:]].*(=|like).*", $secvalue)) ||
                        (eregi("<[^>]*object*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*iframe*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*applet*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*meta*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*style*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*form*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*window.*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*alert*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*document.*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*cookie*\"?[^>]*>", $secvalue)) ||
                        (eregi("<[^>]*img*\"?[^>]*>", $secvalue))) {
                    pnMailHackAttempt(__FILE__, __LINE__, 'MD Security Alert', 'Intrusion detection.');
                    Header("Location: index.php");
                }
            }
        }
    }
}
// Function that compares the current php version on the system with the target one
// Deprecate function reverting to php detecion function
function pnPhpVersionCheck($vercheck)
{
    $minver = str_replace(".", "", $vercheck);
    $curver = str_replace(".", "", phpversion());
    return ($curver >= $minver);
}

function pnMailHackAttempt($detecting_file = "(no filename available)",
    $detecting_line = "(no line number available)",
    $hack_type = "(no type given)",
    $message = "(no message given)")
{
    // Backwards compatibility fix with php 4.0.x and 4.1.x or greater Neo
    if (phpversion() >= "4.2.0") {
        $_pv = $_POST;
        $_gv = $_GET;
        $_rv = $_REQUEST;
        $_sv = $_SERVER;
        $_ev = $_ENV;
        $_cv = $_COOKIE;
        $_fv = $_FILES;
        $_snv = $_SESSION;
    } else {
        global $HTTP_POST_VARS, $HTTP_GET_VARS, $HTTP_SERVER_VARS, $HTTP_ENV_VARS, $HTTP_COOKIE_VARS, $HTTP_POST_FILES, $HTTP_SESSION_VARS;
        $_pv = $HTTP_POST_VARS;
        $_gv = $HTTP_GET_VARS;
        $_rv = array();
        $_sv = $HTTP_SERVER_VARS;
        $_ev = $HTTP_ENV_VARS;
        $_cv = $HTTP_COOKIE_VARS;
        $_fv = $HTTP_POST_FILES;
        $_snv = $HTTP_SESSION_VARS;
    }
    $output = "Attention site admin of " . pnConfigGetVar('sitename') . ",\n";
    $output .= "On " . ml_ftime(_DATEBRIEF, (GetUserTime(time())));
    $output .= " at " . ml_ftime(_TIMEBRIEF, (GetUserTime(time())));
    $output .= " the MD-Pro code has detected that somebody tried to"
     . " send information to your site that may have been intended"
     . " as a hack. Do not panic, it may be harmless: maybe this"
     . " detection was triggered by something you did! Anyway, it"
     . " was detected and blocked. \n";
    $output .= "The suspicious activity was recognized in $detecting_file "
     . "on line $detecting_line, and is of the type $hack_type. \n";
    $output .= "Additional information given by the code which detected this: " . $message;
    $output .= "\n\nBelow you will find a lot of information obtained about "
     . "this attempt, that may help you to find  what happened and "
     . "maybe who did it.\n\n";

    $output .= "\n=====================================\n";
    $output .= "Information about this user:\n";
    $output .= "=====================================\n";

    if (!pnUserLoggedIn()) $output .= "This person is not logged in.\n";
    else {
        $output .= "MD-Pro username:  " . pnUserGetVar('uname') . "\n"
         . "Registered email of this MD-Pro user: " . pnUserGetVar('email') . "\n"
         . "Registered real name of this MD-Pro user: " . pnUserGetVar('name') . "\n";
    }

    $output .= "IP numbers: [note: when you are dealing with a real cracker "
     . "these IP numbers might not be from the actual computer he is "
     . "working on]"
     . "\n\t IP according to HTTP_CLIENT_IP: " . getenv('HTTP_CLIENT_IP')
     . "\n\t IP according to REMOTE_ADDR: " . getenv('REMOTE_ADDR')
     . "\n\t IP according to GetHostByName(\$REMOTE_ADDR): " . GetHostByName($REMOTE_ADDR)
     . "\n\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_REQUEST array\n";
    $output .= "=====================================\n";

    while (list($key, $value) = each ($_rv)) $output .= "REQUEST * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_GET array\n";
    $output .= "This is about variables that may have been ";
    $output .= "in the URL string or in a 'GET' type form.\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_gv)) $output .= "GET * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_POST array\n";
    $output .= "This is about visible and invisible form elements.\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_pv)) $output .= "POST * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Browser information\n";
    $output .= "=====================================\n";

    global $HTTP_USER_AGENT;
    $output .= "HTTP_USER_AGENT: " . $HTTP_USER_AGENT . "\n";

    $browser = (array) get_browser();
    while (list ($key, $value) = each ($browser)) $output .= "BROWSER * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_SERVER array\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_sv)) $output .= "SERVER * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_ENV array\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_ev)) $output .= "ENV * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_COOKIE array\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_cv)) $output .= "COOKIE * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_FILES array\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_fv)) $output .= "FILES * $key : $value\n";

    $output .= "\n=====================================\n";
    $output .= "Information in the \$_SESSION array\n";
    $output .= "This is session info. The variables\n";
    $output .= "  starting with PNSV are MD-Pro SessionVariables.\n";
    $output .= "=====================================\n";

    while (list ($key, $value) = each ($_snv)) $output .= "SESSION * $key : $value\n";

    $headers = "From: your own MD-Pro site [" . pnConfigGetVar('sitename') . "]\n" . "X-Priority: 1 (Highest)\n";
    pnMail(pnConfigGetVar('adminmail'), 'Attempted hack on your site? (type: ' . $hack_type . ')', $output, $headers);
    return;
}

?>
