<?php 
// $Id: pnHTML.php,v 1.9 2004/10/06 05:48:54 timax Exp $
// ---------------------------------------------------------------------
// pnMerchant HTML library
// Copyright (C) 2003  Sergey Alexandrov serg@eire.ws
// http://www.eire.ws
// ---------------------------------------------------------------------
// LICENSE

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// ---------------------------------------------------------------------
// Original author of file: Sergey Alexandrov
// Purpose of file: pnMerchant HTML library
// ---------------------------------------------------------------------


/* DEFINITIONS */
define('_PNH_KEEPOUTPUT', false);
define('_PNH_RETURNOUTPUT', true);
define('_PNH_VERBATIMINPUT', false);
define('_PNH_PARSEINPUT', true);
// function pnbannerdisplay() {}
class pnHTML {
    var $pageheader;
    var $output;
    var $echoed;
    var $clean;
    var $tabindex;
    var $uploadform;

    function pnHTML()
    {
        $this->pageheader = array ();
        $this->output = '';
        $this->echoed = _PNH_KEEPOUTPUT;
        $this->clean = _PNH_PARSEINPUT;
        $this->tabindex = 0;
        $this->uploadform = 0;
    } 

    /* Cleanup argument and leave only digits and % sign */
    /* Useful for cleanup arguments passed to form functions */
    function OnlyDigits($invar)
    {
        return ereg_replace('([^0-9%])*', '', $invar);
    } 

    function VarCleanup($invar, $forcecheck = true)
    {
        if ($this->clean or $forcecheck) {
            $invar = htmlspecialchars($invar);
            $invar = str_replace('&amp;', '&', $invar); // WindMeUp-@ngelspike added to fix &amp; in url
            /* Mess with email address */
            if (ereg("@", $invar)) {
                $tmp = '';
                for ($i = 0;$i < strlen($invar);$i++) $tmp .= "&#" . sprintf("%03d", ord($invar[$i])) . ";";
                $invar = $tmp;
            } //;
        } 
        return $invar;
    } 

    function GetOutputMode()
    {
        return $this->echoed;
    } 

    function SetOutputMode($mode)
    {
        $curmode = $this->echoed;
        $this->echoed = $mode &1;
        return $curmode;
    } 

    function GetInputMode()
    {
        return $this->clean;
    } 

    function SetInputMode($mode)
    {
        $curmode = $this->clean;
        $this->clean = $mode &1;
        return $curmode;
    } 

    function UploadMode()
    {
        return ($this->uploadform = 1);
    } 

    function GetOutput()
    {
        // return join("\n",$this->pageheader)."\n".$this->output;
        return implode("\n", $this->pageheader) . "\n" . $this->output;
    } 

    function PrintPage()
    {
        foreach ($this->pageheader as $row) Header($row);
        echo $this->output;
    } 

    function StartPage($class = '')
    {
        ob_start();
//        echo "\r<!-- StartPage --><div class=\"page\">\r"; // changed by @ngelspike to eliminate a not needed table; old code was '<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td valign="top">';
        include_once('header.php');

//        echo "\r<!-- StartPage --><div class=\"page\">\r"; // changed by @ngelspike to eliminate a not needed table; old code was '<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td valign="top">';
        $content = ob_get_contents();
        ob_end_clean();

        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function EndPage()
    {
        global $index;
        if (pnVarCleanFromInput('module')) $index = 0;
        else $index = 1;

        ob_start();

//        echo "\r<!-- EndPage --></div>\r"; // changed by @ngelspike; old code was '</td></tr></table>';
        include_once('footer.php');

        $content = ob_get_contents();
        ob_end_clean();

        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function Pager($from = 1, $total, $urltemplate, $perpage = 10)
    {
        if (!$from) $from = 1;
        if (!$perpage) $perpage = 10;
        if ($total <= $perpage) return;
        $pagerout = &new pnHTML(); 
        // Show startnum link
        if ($from != 1) {
            $url = preg_replace('/%%/', 1, $urltemplate);
            $pagerout->URL($url, '<<');
        } else $pagerout->Text('<<');
        $pagerout->Text(' '); 
        // Show following items
        $pagenum = 1;

        for ($curnum = 1; $curnum <= $total; $curnum += $perpage) {
            if (($from < $curnum) || ($from > ($curnum + $perpage - 1))) {
                // Not on this page - show link
                $url = preg_replace('/%%/', $curnum, $urltemplate);
                $pagerout->URL($url, $pagenum);
                $pagerout->Text(' ');
            } else $pagerout->Text($pagenum . ' ');
            $pagenum++;
        } 
        if (($curnum >= $perpage + 1) && ($from < $curnum - $perpage)) {
            $url = preg_replace('/%%/', $curnum - $perpage, $urltemplate);
            $pagerout->URL($url, '>>');
        } else $pagerout->Text('>>');

        if ($this->echoed) {
            $pagerout->SetOutputMode(_PNH_RETURNOUTPUT);
            return $pagerout->PrintPage();
        } else $this->output .= $pagerout->GetOutput();
    } 

    /* Redirect to anywhere, wait time in sec, default is 3 sec*/
    function Redirect($url, $waittime = 3)
    {
        $waittime *= 1000;
        $runcode = "\r<!-- Redirect -->\n<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\nsetTimeout(\"document.location.href=" . $url . $this->OnlyDigits($waittime) . "\") -->\n</script>\n"; //'<script language="JavaScript" type="text/javascript"> <!-- setTimeout("document.location.href=\''.$url.'\'","'.$this->OnlyDigits($waittime).'") --></script>';
        if ($this->echoed) return $runcode;
        else $this->pageheader[] = $runcode;
    } 

    function ConfirmAction($confirm_text, $confirm_url, $cancel_text, $cancel_url, $arg = array ())
    {
        $confirmout = &new pnHTML();
        $confirmout->FormStart($confirm_url);
        $confirmout->Text($confirm_text);
        $confirmout->Linebreak(2);
        // $arg = array('confirm' => 1, 'authid' =>pnSecGenAuthKey(), 'confirmation' => 1);
        $arg['confirm'] = 1;
        $arg['authid'] = pnSecGenAuthKey();
        $arg['confirmation'] = 1;
        $confirmout->FormHidden($arg);
        $confirmout->FormSubmit(_CONFIRM);
        $confirmout->Text(' ');
        $confirmout->FormButton($cancel_text, $cancel_url);
        $confirmout->FormEnd();
        $confirmout->SetOutputMode(_PNH_RETURNOUTPUT);
        if ($this->echoed) return $confirmout->PrintPage();
        else $this->output .= $confirmout->GetOutput();
    } 

    function Text($text)
    {
        if ($this->echoed) return $this->VarCleanup($text, false);
        else $this->output .= $this->VarCleanup($text, false);
    } 

    function Title($text)
    {
        $title = $title = "\r<!-- Title -->\n<div style=\"text-align: center;\"><span class=\"pn-title\">" . $this->VarCleanup($text, false) . "</span></div><br />\n"; // '<center><font class="pn-title">'.$this->VarCleanup($text,false).'</font></center><br />';
        if ($this->echoed) return $title;
        else $this->output .= $title;
    } 

    function BoldText($text)
    {
        $boldtext = '<strong>' . $this->VarCleanup($text, false) . '</strong>';
        if ($this->echoed) return $boldtext;
        else $this->output .= $boldtext;
    } 

    function TextHTML($text)
    {
        if ($this->echoed) return (($this->clean) ? pnVarPrepHTMLDisplay($text) : $text);
        else $this->output .= (($this->clean) ? pnVarPrepHTMLDisplay($text) : $text);
    } 

    function Linebreak($num = 1)
    {
        if ($this->echoed) return str_repeat("<br />\n", $num);
        else $this->output .= str_repeat("<br />\n", $num);
    } 

    function HorizontalRule($num = 1)
    {
        if ($this->echoed) return str_repeat("<hr />\n", $num);
        else $this->output .= str_repeat("<hr />\n", $num);
    } 

    function URL($url, $text)
    {
        if (empty ($url)) return;
        if (ereg('@', $url)) $content = '<!-- URL --><a href="mailto:' . $url . '">';
        else $content = '<!-- URL --><a href="' . $url . '">';
        $content .= $this->VarCleanup($text, false);
        // if (($text!='<<') AND ($text!='>>')) {      // fixed by Barone
        if (!(ereg('<<', $text)) AND !(ereg('>>', $text))) { // give it a try  WindMeUp
            $content = str_replace('&', '&amp;', $content) . '</a>'; // fixed by @ngelspike
        } 
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function TableStart($title = '', $pageheaders = array(), $border = 0, $width = '100%', $cellpadding = 0, $cellspacing = 0)
    { 
        // Wrap the user table in our own invisible table to make the title sit properly
        $content = "\r<!-- TableStart -->\r";
        $content .= '<table border="' . $border . '"' . ((empty ($width)) ? '' : ' width="' . $width . '"') . ' cellpadding="' . $cellpadding . '" cellspacing="' . $cellspacing . "\">\n";

        
        if (!empty ($title)) {
            $title = $this->VarCleanup($title, false);
            $content .= "\t<tr><th align=\"center\">$title</th></tr>\n";
        } 
        $content .= "\t<tr><td>\n";
        $content .= '<table border="' . $this->VarCleanup($border) . '" width="100%" cellpadding="0" cellspacing="0">' . "\n"; //'<table border="' .$this->VarCleanup($border). '" width="100%" cellpadding="0" cellspacing="0">'."\n";

        if (!empty ($pageheaders)) {
            $content .= "\n\t<tr>";
            foreach ($pageheaders as $head) {
                if (empty ($head)) $head = '&nbsp;';
                $head = $this->VarCleanup($head, false);
                $content .= "\t<th>" . $head . '</th>';
            } 
            $content .= "\t</tr>\n";
        } 
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function TableRowStart($align = 'center', $valign = 'middle')
    {
        $content = "\r\t<!-- TableRowStart -->\n";
        $content .= "\t<tr align=\"" . $align . "\" valign=\"" . $valign . "\">\n";
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function TableColStart($colspan = 1, $align = 'center', $valign = 'middle', $rowspan = 1, $width = '', $height = '')
    {
        // fixed by Serg-@ngelspike to prevent the rowspan="" invalid output
        $style = (!empty($width) ? " width: $width;" : "") . (!empty($height) ? " height: $height;" : ""); // added by @ngelspike for strict code output compliance
        $content = "\r\t\t<!-- TableColStart -->\n";
        $content .= "\t\t<td colspan=\"$colspan\" " . (!empty($rowspan) ? " rowspan=\"$rowspan\"" : "") . " align=\"$align\" valign=\"$valign\" " . (!empty($style) ? " style=\"$style\"" : "") . ">"; // modified by @ngelspike for strict code output compliance old code was: $content .= "\t\t<td colspan=\"$colspan\" ".(!empty($rowspan) ? " rowspan=\"$rowspan\"" : "")." align=\"$align\" valign=\"$valign\" ".(!empty($width) ? " width=\"$width\"" : "").(!empty($height) ? " height=\"$height\"" : "").">";
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function TableColEnd()
    {
        if ($this->echoed) return "\n\t\t<!-- TableColEnd --></td>\n";
        else $this->output .= "\n\t\t<!-- TableColEnd --></td>\n";
    } 

    function TableRowEnd()
    {
        if ($this->echoed) return "\r\t<!-- TableRowEnd --></tr>\n";
        else $this->output .= "\r\t<!-- TableRowEnd --></tr>\n";
    } 

    function TableEnd()
    {
        if ($this->echoed) return "\r<!-- TableEnd --></table>\n</td></tr></table>\n";
        else $this->output .= "\r<!-- TableEnd --></table>\n</td></tr></table>\n";
    } 

    function TableAddRow($row, $align = 'center', $valign = 'middle')
    {
        if (empty ($row)) return;
        $content = "\r\t<!-- TableAddRow --><tr align=\"$align\" valign=\"$valign\">\n"; 
        // test to see if we are using the latest array style
        if (is_array($row[0])) {
            // new style
            foreach ($row as $rowitem) {
                if (!isset($rowitem['content'])) $rowitem['content'] = '&nbsp;';
                $rowitem['content'] = $this->VarCleanup($rowitem['content'], false);
                $style = ((!empty($rowitem['width'])) ? "" : "width: " . $rowitem['width'] . ";"/* : ""*/) . ((!empty($rowitem['height'])) ? "" : "height: " . $rowitem['height'] . ";"/* : ""*/); // added by @ngelspike for strict code output compliance
                $content .= "\t\t<td"
                 . ((empty ($rowitem['align'])) ? '' : ' align="' . $rowitem['align'] . '"')
                 . ((empty ($rowitem['valign'])) ? '' : ' valign="' . $rowitem['valign'] . '"')
                 . (!empty($style) ? " style=\"$style\"" : "")
                // .((empty ($rowitem['width'])) ? '' : ' width="'.$rowitem['width'].'"')
                // .((empty ($rowitem['height'])) ? '' : ' height="'.$rowitem['height'].'"')
                 . ((empty ($rowitem['class'])) ? '' : ' class="' . $rowitem['class'] . '"')
                 . '>' . $rowitem['content'] . '</td>' . "\n";
            } 
        } else {
            // old style
            foreach ($row as $rowitem) {
                if (!isset($rowitem)) $rowitem = '&nbsp;';
                $rowitem = $this->VarCleanup($rowitem, false);
                $content .= "\t\t<td>" . $rowitem . '</td>' . "\n";
            } 
        } 
        $content .= "\t</tr>\n";
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormStart($action, $method = 'post', $name = '', $events = '')
    {
        $content = "\r<!-- FormStart -->\n<form "
         . 'action="' . $this->VarCleanup($action) . '"'
         . 'method="' . $method . '"'
         . 'name="' . $name . '"';
        if ($events != '') $content .= ' ' . $events;
        $content .= ' enctype="' . ((empty ($this->uploadform)) ? 'application/x-www-form-urlencoded' : 'multipart/form-data') . '">';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormEnd()
    {
        if ($this->echoed) return "\n</form>\n";
        else $this->output .= "\n</form>\n";
    } 

    function FormSubmit($label = _SUBMIT, $accesskey = '', $events = '')
    {
        $this->tabindex++;
        $content = '<input type="submit" value="' . $this->VarCleanup($label) . '" align="middle"'
         . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ((empty ($events)) ? '' : ' ' . $events)
         . ' tabindex="' . $this->tabindex . '" />';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormButton($label = _SUBMIT, $onclickgo = '', $accesskey = '')
    {
        $this->tabindex++;
        $content = '<input type="button" value="' . $this->VarCleanup($label) . '" align="middle"'
         . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ((empty ($onclickgo)) ? '' : ' onClick="javascript:document.location.href=\'' . $this->VarCleanup($onclickgo) . '\'"')
         . ' tabindex="' . $this->tabindex . '" />';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormText($fieldname, $contents = '', $size = 10, $maxlength = 64, $password = false, $accesskey = '')
    {
        if (empty ($fieldname)) return;
        $this->tabindex++;
        $content = '<input type="' . (($password) ? 'password' : 'text') . '" name="' . $this->VarCleanup($fieldname) . '"'
         . ' id="' . $this->VarCleanup($fieldname) . '" value="' . $this->VarCleanup($contents) . '" size="' . $this->OnlyDigits($size) . '"'
         . ' maxlength="' . $this->OnlyDigits($maxlength) . '"' . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ' tabindex="' . $this->tabindex . '" />';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    /* wrap is deprecated, leave argument for compatibility */
    function FormTextArea($fieldname, $contents = '', $rows = 6, $cols = 40, $wrap = 'soft', $accesskey = '')
    {
        if (empty ($fieldname)) return;
        $this->tabindex++;
        $content = '<textarea name="' . $this->VarCleanup($fieldname) . '" id="' . $this->VarCleanup($fieldname) . '"'
         . ' rows="' . $this->OnlyDigits($rows) . '" cols="' . $this->OnlyDigits($cols) . '"'
         . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ' tabindex="' . $this->tabindex . '">' . $this->VarCleanup($contents) . '</textarea>';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormHidden($fieldname, $value = '')
    {
        if (empty ($fieldname)) return;
        if (is_array($fieldname)) {
            $content = '';
            foreach ($fieldname as $n => $v) {
                $content .= '<input type="hidden" name="' . $this->VarCleanup($n) . '" id="' . $this->VarCleanup($n) . '"'
                 . ' value="' . $this->VarCleanup($v) . '" />';
            } 
        } else {
            $content = '<input type="hidden" name="' . $this->VarCleanup($fieldname) . '" id="' . $this->VarCleanup($fieldname) . '"'
             . ' value="' . $this->VarCleanup($value) . '" />';
        } 
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormSelectMultiple($fieldname, $data, $multiple = 0, $size = 1, $selected = '', $accesskey = '', $events = '')
    {
        if (empty ($fieldname)) return;
        $this->tabindex++; 
        // Set up selected if required
        if (!empty($selected)) {
            for ($i = 0; !empty($data[$i]); $i++) {
                if ($data[$i]['id'] == $selected) $data[$i]['selected'] = 1;
            } 
        } 

        $c = count($data);
        if ($c < $size) $size = $c;
        $content = '<select name="' . $this->VarCleanup($fieldname) . '" id="' . $this->VarCleanup($fieldname) . '"'
         . ' size="' . $this->OnlyDigits($size) . '"' . (($multiple == 1) ? ' multiple="multiple"' : '')
         . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ' tabindex="' . $this->tabindex . '"';
        if ($events != '') $content .= ' ' . strtolower($events);
        $content .= '>';

        foreach ($data as $datum) {
            $content .= '<option value="' . $this->VarCleanup($datum['id']) . '"' . ((empty ($datum['selected'])) ? '' : ' selected="selected"') . '>'
             . $this->VarCleanup($datum['name']) . '</option>';
        } 
        $content .= '</select>';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormCheckbox($fieldname, $checked = false, $value = '1', $type = 'checkbox', $accesskey = '', $events = '')
    {
        if (empty ($fieldname)) return;
        $this->tabindex++;
        $content = '<input type="' . (($type == 'checkbox') ? 'checkbox' : 'radio') . '" name="' . $this->VarCleanup($fieldname) . '"'
         . ' id="' . $this->VarCleanup($fieldname) . '" value="' . $this->VarCleanup($value) . '"'
         . (($checked) ? ' checked="checked"' : '')
         . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ((empty ($events)) ? '' : ' ' . $this->VarCleanup($events) . '')
         . ' tabindex="' . $this->tabindex . '" />';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function FormFile($fieldname, $size = 25, $maxsize = 2097152, $accesskey = '')
    {
        if (empty ($fieldname)) return;
        $this->tabindex++;
        $content = '<input type="hidden" name="MAX_FILE_SIZE" value="' . $this->OnlyDigits($maxsize) . '" />';
        $content .= '<input type="file" name="' . $this->VarCleanup($fieldname) . '" id="' . $this->VarCleanup($fieldname) . '"'
         . ' size="' . $this->OnlyDigits($size) . '"' . ((empty ($accesskey)) ? '' : ' accesskey="' . $this->VarCleanup($accesskey) . '"')
         . ' tabindex="' . $this->tabindex . '" />';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 
    // $scriptname must include full path to JS-file
    function ScriptInclude($scriptname, $scriptlang = 'javascript')
    {
        if (empty ($scriptname)) return;
        $content = '<script language="' . $scriptlang . '">';
        $fp = fopen($scriptname, 'r');
        do {
            $row = ltrim(fgets($fp, 1000));
            if (substr($row, 0, 2) != '//') {
                $content .= $row;
            } 
        } while (!feof($fp));
        fclose($fp);
        $content .= '</script>';
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    /**
     * Manipulating the complete output, expands it with some RteMulti-setups and -scripts
     * ONLY TO USE WITH RTE - NOTHING ELSE !!
     */
    function ManipulatePage($what = "")
    {
        global $module;
        // $what is needed for Encompass. This is the original outstream-object
        if ($what == "") {
            // $output = pnModAPIFunc('rtemulti',
            $output = pnModAPIFunc('RteMulti',
                'user',
                'getinfo',
                array('original' => $this->output,
                    'modname' => pnVarPrepForOS($module)));
        } else {
            // $output = pnModAPIFunc('rtemulti',
            $output = pnModAPIFunc('RteMulti',
                'user',
                'getinfo',
                array('original' => $what,
                    'modname' => pnVarPrepForOS($module)));
//            echo pnVarPrepForDisplay($output);
        } 
//return;
        if ($this->GetOutputMode() == _PNH_RETURNOUTPUT) {
            return $output;
        } else {
            $this->output = $output;
        } 
    } 

    /**
     * added by
     * 
     * @ngelspike to handle divs layout
     * (x)html standard attributes as options - align attribute is deprecated
     * 
     * to consider adding standard events:
     * onclick, ondblclick, onkeypress, onkeyup, onmousedown, onmousemove, onmouseout, onmouseover, onmouseup
     * 
     * syntax need to be checked
     */
    function DivStart ($id, $class, $style, $dir, $lang, $title)
    {
        $content = "\r<!-- DivStart -->\n<div " . (!empty($id) ? " id=\"$id\"" : "") . (!empty($class) ? " class=\"$class\"" : "") . (!empty($style) ? " style=\"$style\"" : "") . (!empty($dir) ? " dir=\"$dir\"" : "") . (!empty($lang) ? " lang=\"$lang\"" : "") . (!empty($titile) ? " title=\"$title\"" : "") . ">";
        if ($this->echoed) return $content;
        else $this->output .= $content;
    } 

    function DivEnd ()
    {
        if ($this->echoed) return "\n<!-- DivEnd --></div>\n";
        else $this->output .= "\n<!-- DivEnd --></div>\n";
    } 
     
    function adminmenu ()
    {
	$content = '<a href="admin.php">'._ADMINTITLE.'</a>';
	  if ($this->echoed) return $content;
        else $this->output .= $content;
    } 
} 

?>