<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author: Patrick Kellum
// Purpose: Search comments
// ----------------------------------------------------------------------
// sjah: 03-10-2004 removed tables for css layout

$search_modules[] = array(
    'title' => 'Comments',
    'func_search' => 'search_comments',
    'func_opt' => 'search_comments_opt'
);

function search_comments_opt() {
    global
        $bgcolor2,
        $tblcolor3,
        $info;

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (pnSecAuthAction(0, 'AddStory::', "$info[aid]:$info[cattitle]:$info[sid]", ACCESS_COMMENT)) {
        $output->Text("<div style=\"background: $bgcolor2; border-bottom:1px solid $tblcolor3;\">\n");
        $output->Text("    <input type=\"checkbox\" name=\"active_comments\" id=\"active_comments\" value=\"1\" checked>&nbsp;"._SEARCH_COMMENTS."\n");
        $output->Text("</div>\n");
    }

    return $output->GetOutput();
}

function search_comments() {

        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($active_comments,
         $startnum,
         $total,
         $bool,
         $q) = pnVarCleanFromInput('active_comments',
                                   'startnum',
                                   'total',
                                   'bool',
                                   'q');

    if(empty($active_comments)) {
        return;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (!isset($startnum) || !is_numeric($startnum)) {
        $startnum = 1;
    }
    if (isset($total) && !is_numeric($total)) {
        unset($total);
    }

    $w = search_split_query($q);
    $flag = false;
    $column = &$pntable['comments_column'];
    $query = "SELECT $column[subject] as subject, $column[tid] as tid, ";
    $query .= "$column[sid] as sid, $column[pid] as pid FROM $pntable[comments] WHERE ";
    foreach($w as $word) {
        if($flag) {
            switch($bool) {
                case 'AND' :
                    $query .= ' AND ';
                    break;
                case 'OR' :
                default :
                    $query .= ' OR ';
                    break;
            }
        }
        $query .= '(';
        $query .= "$column[subject] LIKE '$word' OR ";
//modified for Oracle compatibility
                switch ($dbtype){
                        case "oci8":
                                $query .= "contains($column[comment],'$word',1)>0 ";
                                break;
                        default:
        $query .= "$column[comment] LIKE '$word'";
                                breaK;
                }
        $query .= ')';
        $flag = true;
    }
    $query .= " ORDER BY $column[subject]";

    if (empty($total)) {
        $countres = $dbconn->Execute($query);
        $total = $countres->PO_RecordCount();
        $countres->Close();
    }

        // for RTE call use other max. rows. I think 100 hits are enough
        if($active_comments == 2) {
            $result = $dbconn->SelectLimit($query, 100, $startnum-1);
        } else {
            $result = $dbconn->SelectLimit($query, 10, $startnum-1);
        }

    if(!$result->EOF) {
                // if call from RTE then set smaller font size because of iframe
                if($active_comments == 2) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("<font size=2>");
                $output->SetInputMode(_PNH_PARSEINPUT);
                }

//        $output->Text('<font class="pn-normal">' . _COMMENTS . ': ' . $total . ' ' . _SEARCHRESULTS . '</font>');
        $output->Text(_COMMENTS . ': ' . $total . ' ' . _SEARCHRESULTS);
        $output->SetInputMode(_PNH_VERBATIMINPUT);

        $url = "modules.php?op=modload&name=Search&file=index&action=search&active_comments=1&bool=$bool&q=$q";

        $output->Text("<ul>");
        while(!$result->EOF) {
            $row = $result->GetRowAssoc(false);
            if ($row[pid] != 0) {
                // comment with parent posting
                $output->Text("<li><a class=\"pn-normal\" href=\"modules.php?op=modload&name=NS-Comments&file=index&req=showreply&tid=$row[tid]&sid=$row[sid]&pid=$row[pid]\">$row[subject]</a></li>");
            } else {
                // comment without parent posting
                $output->Text("<li><a class=\"pn-normal\" href=\"modules.php?op=modload&name=NS-Comments&file=index&tid=$row[tid]&sid=$row[sid]#$row[tid]\">$row[subject]</a></li>");
            }
            $result->MoveNext();
        }
        $output->Text("</ul>");
//        $output->Linebreak(4);

        // Munge URL for template
        $urltemplate = $url . "&startnum=%%&total=$total";
                // for RTE call use other max. rows. I think 100 hits are enough
                if($active_comments == 2) {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               100);
                } else {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               10);
                }

                // .... and close smaller font size for RTE call
                if($active_comments == 2) {
                $output->Text("</font>");
                }
    } else {
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('<font class="pn-normal">'._SEARCH_NO_COMMENTS.'</font>');
        $output->SetInputMode(_PNH_PARSEINPUT);
    }
    $output->Linebreak(3);

    return $output->GetOutput();
}
?>