<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// Filename: includes/search/downloads.php
// Original Author: Patrick Kellum
// Purpose: Search downloads
// ----------------------------------------------------------------------
// Download plugin: adam_baum, based on Patrick Kellum's reviews plugin.
// ----------------------------------------------------------------------
// sjah: 03-10-2004 removed tables for css layout

$search_modules[] = array(
    'title' => 'Downloads',
    'func_search' => 'search_downloads',
    'func_opt' => 'search_downloads_opt'
);
function search_downloads_opt() {
    global
        $bgcolor2,
        $tblcolor3;

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (pnSecAuthAction(0, 'Downloads::', '::', ACCESS_READ)) {
	    $output->Text("<div style=\"background: $bgcolor2; border-bottom:1px solid $tblcolor3;\">\n");
        $output->Text("    <input type=\"checkbox\" name=\"active_downloads\" id=\"active_downloads\" value=\"1\" checked>&nbsp;<label for=\"active_downloads\">"._SEARCH_DOWNLOADS."</label>\n");
        $output->Text("</div>\n");
    }

    return $output->GetOutput();
}

function search_downloads() {

        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($q,
         $active_downloads,
         $bool,
         $startnum,
         $total) = pnVarCleanFromInput('q',
                                       'active_downloads',
                                       'bool',
                                       'startnum',
                                       'total');

    if(empty($active_downloads)) {
        return;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $output = new pnHTML();

    if (!isset($startnum)) {
        $startnum = 1;
    }

    $w = search_split_query($q);
    $flag = false;
    // fifers: have to explicitly name the columns so that if the underlying DB column names change, the code to access them doesn't.  We use the column names in assoc array later...
    $column = &$pntable['downloads_downloads_column'];
    $query = "SELECT $column[lid] as lid, $column[title] as title, $column[totalvotes] as totalvotes, $column[hits] as hits, $column[name] as name, $column[description] as description FROM $pntable[downloads_downloads] WHERE \n";

    foreach($w as $word) {
        if($flag) {
            switch($bool) {
                case 'AND' :
                    $query .= ' AND ';
                    break;
                case 'OR' :
                default :
                    $query .= ' OR ';
                    break;
            }
        }
        $query .= '(';
        // downloads
//modified for Oracle compatibility
                switch ($dbtype){
                        case "oci8":
                                $query .= "contains($column[description],'$word',1)>0 OR \n";
                                break;
                        default:
        $query .= "$column[description] LIKE '$word' OR \n";
                                break;
                }
        $query .= "$column[submitter] LIKE '$word' OR \n";
        $query .= "$column[name] LIKE '$word' OR \n";
        $query .= "$column[homepage] LIKE '$word' \n";
        $query .= ')';
        $flag = true;
    }
    $query .= " ORDER BY $column[lid]";

    if (empty($total)) {
        $countres = $dbconn->Execute($query);
        $total = $countres->PO_RecordCount();
        $countres->Close();
    }

        // for RTE call use other max. rows. I think 100 hits are enough
        if($active_downloads == 2) {
            $result = $dbconn->SelectLimit($query, 100, $startnum-1);
        } else {
            $result = $dbconn->SelectLimit($query, 10, $startnum-1);
        }

    if(!$result->EOF) {
                // if call from RTE then set smaller font size because of iframe
                if($active_downloads == 2) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("<font size=2>");
                $output->SetInputMode(_PNH_PARSEINPUT);
                }
        $output->Text(_DOWNLOADS . ': ' . $total . ' ' . _SEARCHRESULTS);
        $output->SetInputMode(_PNH_VERBATIMINPUT);

        $url = "modules.php?op=modload&name=Search&file=index&action=search&active_downloads=1&bool=$bool&q=$q";

        $output->Text("<ul>");

        while(!$result->EOF) {
            $row = $result->GetRowAssoc(false);
                        if($active_downloads != 2) {
                    $output->Text("<li><a class=\"pn-normal\" href=\"modules.php?op=modload&name=Downloads&file=index&req=getit&lid=$row[lid]\">$row[title]</a> <font class=\"pn-normal\">(votes: $row[totalvotes] - hits: $row[hits])</font><br>Uploader: $row[name]<br>$row[description]</li>");
                        } else {
                    $output->Text("<li><a href=\"#\" onclick=\"top.document.forms[0].elements['LinkUrl'].value='modules.php?op=modload&name=Downloads&file=index&req=getit&lid=$row[lid]'\">$row[title]</a> <font class=\"pn-normal\">(votes: $row[totalvotes] - hits: $row[hits])</font><br>Uploader: $row[name]<br>".substr($row[description],0,80)."...</li>");
                        }
            $result->MoveNext();
        }
        $output->Text("</ul>");
//        $output->Linebreak(4);

        // Mung URL for template
        $urltemplate = $url . "&startnum=%%&total=$total";
                // for RTE call use other max. rows. I think 100 hits are enough
                if($active_downloads == 2) {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               100);
                } else {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               10);
                }
                // .... and close smaller font size for RTE call
                if($active_downloads == 2) {
                $output->Text("</font>");
                }
    } else {
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('<font class="pn-normal">'._SEARCH_NO_DOWNLOADS.'</font>');
        $output->SetInputMode(_PNH_PARSEINPUT);
    }
    $output->Linebreak();

    return $output->GetOutput();
}
?>