<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// Copyright (c) 2001 by Patrick Kellum (webmaster@ctarl-ctarl.com)
// http://www.ctarl-ctarl.com
//
// ----------------------------------------------------------------------
// adam_baum: faq.php based on Patrick Kellum's reviews.php search plugin
//           purpose: search the faq database.
// sjah: 03-10-2004 removed tables for css layout

$search_modules[] = array(
    'title' => 'FAQS',
    'func_search' => 'search_faqs',
    'func_opt' => 'search_faqs_opt'
);
function search_faqs_opt() {
    global
        $bgcolor2,
        $tblcolor3;

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (pnSecAuthAction(0, 'FAQ::', '::', ACCESS_READ)) {
	    $output->Text("<div style=\"background: $bgcolor2; border-bottom:1px solid $tblcolor3;\">\n");
        $output->Text("    <input type=\"checkbox\" name=\"active_faqs\" id=\"active_faqs\" value=\"1\" checked>&nbsp;<label for=\"active_faqs\">"._SEARCH_FAQS."</label>\n");
        $output->Text("</div>\n");
    }

    return $output->GetOutput();
}

function search_faqs() {

        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($q,
         $bool,
         $startnum,
         $total,
         $active_faqs) = pnVarCleanFromInput('q',
                                             'bool',
                                             'startnum',
                                             'total',
                                             'active_faqs');

    if (empty($active_faqs)) {
        return;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (!isset($startnum) || !is_numeric($startnum)) {
        $startnum = 1;
    }
    if (isset($total) && !is_numeric($total)) {
        unset($total);
    }

    $w = search_split_query($q);
    $flag = false;
    $column = &$pntable['faqanswer_column'];
    $faqcatcol = &$pntable['faqcategories_column'];
//modified for Oracle compatibility
        switch ($dbtype){
                case "oci8":
                        $query = "SELECT $column[id_cat] as id_cat, $column[question] as question, $column[answer] as answer
              FROM $pntable[faqanswer] , $pntable[faqcategories] WHERE $column[id_cat] (+) =$faqcatcol[id_cat] AND \n";
                        break;
                default:
    $query = "SELECT $column[id_cat] as id_cat, $column[question] as question, $column[answer] as answer
              FROM $pntable[faqanswer] LEFT JOIN $pntable[faqcategories] ON $column[id_cat]=$faqcatcol[id_cat]
              WHERE \n";
                        break;
        }
    foreach($w as $word) {
        if($flag) {
            switch($bool) {
                case 'AND' :
                    $query .= ' AND ';
                    break;
                case 'OR' :
                default :
                    $query .= ' OR ';
                    break;
            }
        }
        $query .= '(';
        // faqs
                switch ($dbtype){
                        case "oci8":
                                $query .= "contains($column[question],'$word',1)>0 OR \n";
                                $query .= "contains($column[answer],'$word',2)>0 \n";
                                break;
                        default:
        $query .= "$column[question] LIKE '$word' OR \n";
        $query .= "$column[answer] LIKE '$word'\n";
                        break;
                }
        $query .= ')';
        $flag = true;
    }
    if (pnConfigGetVar('multilingual') == 1) {
           $query .= " AND ($faqcatcol[flanguage]='" . pnVarPrepForStore(pnUserGetLang()) . "' OR $faqcatcol[flanguage]='' OR $faqcatcol[flanguage] IS NULL)";
    }
    $query .= " ORDER BY $column[id]";

    if (empty($total)) {
        $total = 0;
        $countres = $dbconn->Execute($query);
        while(!$countres->EOF) {
            $row = $countres->GetRowAssoc(false);
            if (pnSecAuthAction(0,"FAQ::","$row[categories]::$row[id_cat]",ACCESS_READ)) {
                $total++;
            }
            $countres->MoveNext();
        }
    }

        // for RTE call use other max. rows. I think 100 hits are enough
        if($active_faqs == 2) {
            $result = $dbconn->SelectLimit($query, 100, $startnum-1);
        } else {
            $result = $dbconn->SelectLimit($query, 10, $startnum-1);
        }

    if (!$result->EOF) {
                // if call from RTE then set smaller font size because of iframe
                if($active_faqs == 2) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("<font size=2>");
//                $output->SetInputMode(_PNH_PARSEINPUT);
                }
        $output->Text('<font class="pn-normal">'. _FAQ . ': ' . $total . ' ' . _SEARCHRESULTS . '</font>');
        $output->SetInputMode(_PNH_VERBATIMINPUT);

        $url = "modules.php?op=modload&name=Search&file=index&action=search&active_faqs=1&bool=$bool&q=$q";

        $output->Text("<ul>");

        while(!$result->EOF) {
            $row = $result->GetRowAssoc(false);
            if (pnSecAuthAction(0,"FAQ::","$row[categories]::$row[id_cat]",ACCESS_READ)) {
                $output->Text("<li><a class=\"pn-normal\" href=\"modules.php?op=modload&name=FAQ&file=index&myfaq=yes&id_cat=$row[id_cat]\">$row[question]</a><br>Answer: ".nl2br($row[answer])."</li>");
            }
            $result->MoveNext();
        }
        $output->Text('</ul>');
//        $output->Linebreak(4);

        // Munge URL for template
        $urltemplate = $url . "&startnum=%%&total=$total";
                // for RTE call use other max. rows. I think 100 hits are enough
                if($active_faqs == 2) {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               100);
                } else {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               10);
                }

                // .... and close smaller font size for RTE call
                if($active_faqs == 2) {
                $output->Text("</font>");
                }
    } else {
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('<font class="pn-normal">'._SEARCH_NO_FAQS.'</font>');
        $output->SetInputMode(_PNH_PARSEINPUT);
    }
    $output->Linebreak(3);

    return $output->GetOutput();
}
?>