<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author: Patrick Kellum
// Purpose: Search reviews
// ----------------------------------------------------------------------
// sjah: 03-10-2004 removed tables for css layout

$search_modules[] = array(
    'title' => 'Reviews',
    'func_search' => 'search_reviews',
    'func_opt' => 'search_reviews_opt'
);

function search_reviews_opt() {
    global
        $bgcolor2,
        $tblcolor3;

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (pnSecAuthAction(0, 'Reviews::', '::', ACCESS_READ)){
	    $output->Text("<div style=\"background: $bgcolor2; border-bottom:1px solid $tblcolor3;\">\n");
        $output->Text("    <input type=\"checkbox\" name=\"active_reviews\" id=\"active_reviews\" value=\"1\" checked>&nbsp;<label for=\"active_reviews\">"._SEARCH_REVIEWS."</label>\n");
        $output->Text("</div>\n");
    }

    return $output->GetOutput();
}

function search_reviews() {

        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($active_reviews,
         $startnum,
         $total,
         $bool,
         $q) = pnVarCleanFromInput('active_reviews',
                                   'startnum',
                                   'total',
                                   'bool',
                                   'q');

    if(empty($active_reviews)) {
        return;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (!isset($startnum) || !is_numeric($startnum)) {
        $startnum = 1;
    }
    if (isset($total) && !is_numeric($total)) {
        unset($total);
    }

    $w = search_split_query($q);
    $flag = false;

    $revcol = &$pntable['reviews_column'];
    $comcol = &$pntable['reviews_comments_column'];
//modified for Oracle compatibility
        switch ($dbtype){
                case "oci8":
                        $query = "SELECT DISTINCT $revcol[id] as id, $revcol[title] as title, $revcol[score] as score, $revcol[hits] as hits, $revcol[reviewer] as reviewer, $revcol[date] AS fdate
              FROM $pntable[reviews], $pntable[reviews_comments] WHERE $comcol[rid] (+)=$revcol[id] AND \n";
                        break;
                default:
    $query = "SELECT DISTINCT $revcol[id] as id, $revcol[title] as title, $revcol[score] as score, $revcol[hits] as hits, $revcol[reviewer] as reviewer, $revcol[date] AS fdate
              FROM $pntable[reviews] LEFT JOIN $pntable[reviews_comments] ON $comcol[rid]=$revcol[id]
              WHERE \n";
                break;
        }
    foreach($w as $word) {
        if($flag) {
            switch($bool) {
                case 'AND' :
                    $query .= ' AND ';
                    break;
                case 'OR' :
                default :
                    $query .= ' OR ';
                    break;
            }
        }
        $query .= '(';
        // reviews
        $query .= "$revcol[title] LIKE '$word' OR \n";
                switch ($dbtype){
                        case "oci8":
                                $query .= "contains($revcol[text],'$word',1)>0 OR \n";
                                break;
                        default:
        $query .= "$revcol[text] LIKE '$word' OR \n";
                                break;
                }
        $query .= "$revcol[reviewer] LIKE '$word' OR \n";
        $query .= "$revcol[cover] LIKE '$word' OR \n";
        $query .= "$revcol[url] LIKE '$word' OR \n";
        $query .= "$revcol[url_title] LIKE '$word' OR \n";
        // reviews_comments
                switch ($dbtype){
                        case "oci8":
                                $query .= "contains($comcol[comments],'$word',2)>0 \n";
                                break;
                        default:
        $query .= "$comcol[comments] LIKE '$word'\n";
                                break;
                }
        $query .= ')';
        $flag = true;
    }
    if (pnConfigGetVar('multilingual') == 1) {
           $query .= " AND ($revcol[rlanguage]='" . pnVarPrepForStore(pnUserGetLang()) . "' OR $revcol[rlanguage] IS NULL)";
    }
    $query .= " ORDER BY $revcol[date]";

    // get the total count with permissions!
    if (empty($total)) {
        $total = 0;
        $countres = $dbconn->Execute($query);
        while(!$countres->EOF) {
            $row = $countres->GetRowAssoc(false);
            if (pnSecAuthAction(0,"Reviews::","$row[title]::$row[id]",ACCESS_READ)) {
                $total++;
            }
            $countres->MoveNext();
        }
    }

        // for RTE call use other max. rows. I think 100 hits are enough
        if($active_reviews == 2) {
            $result = $dbconn->SelectLimit($query, 100, $startnum-1);
        } else {
            $result = $dbconn->SelectLimit($query, 10, $startnum-1);
        }

    if(!$result->EOF) {
                // if call from RTE then set smaller font size because of iframe
                if($active_reviews == 2) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("<font size=2>");
//                $output->SetInputMode(_PNH_PARSEINPUT);
                }
        $output->Text('<font class="pn-normal">' . _REVIEWS . ': ' . $total . ' ' . _SEARCHRESULTS . '</font>');

        $url = "modules.php?op=modload&name=Search&file=index&action=search&active_reviews=1&bool=$bool&q=$q";

        $output->Text("<ul>");
        while(!$result->EOF) {
            $row = $result->GetRowAssoc(false);
            $row['fdate'] = ml_ftime(_DATELONG,$result->UnixTimeStamp($row['fdate']));
            if (pnSecAuthAction(0,"Reviews::","$row[title]::$row[id]",ACCESS_READ)) {
                    $output->Text("<li><a class=\"pn-normal\" href=\"modules.php?op=modload&name=Reviews&file=index&req=showcontent&id=$row[id]\">$row[title]</a> <font class=\"pn-sub\">(score: $row[score] - hits: $row[hits])</font><br>$row[reviewer]<br>$row[fdate]</li>");
                        } else {
                    $output->Text("<li><a href=\"#\" onclick=\"top.document.forms[0].elements['LinkUrl'].value='modules.php?op=modload&name=Reviews&file=index&req=showcontent&id=$row[id]'\">$row[title]</a> <font class=\"pn-sub\">(score: $row[score] - hits: $row[hits])</font><br>$row[reviewer]<br>$row[fdate]</li>");
                        }
            $result->MoveNext();
        }
        $output->Text("</ul>");

        // Munge URL for template
        $urltemplate = $url . "&startnum=%%&total=$total";
                // for RTE call use other max. rows. I think 100 hits are enough
                if($active_reviews == 2) {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               100);
                } else {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               10);
                }

                // .... and close smaller font size for RTE call
                if($active_reviews == 2) {
                $output->Text("</font>");
                }
    } else {
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('<font class="pn-normal">'._SEARCH_NO_REVIEWS.'</font>');
        $output->SetInputMode(_PNH_PARSEINPUT);
    }
    $output->Linebreak(3);

    return $output->GetOutput();
}
?>