<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Filename: modules/Search/stories.php
// Original Author: Patrick Kellum
// Purpose: Search reviews/users/stories/topics
//
// Last change:  WindMeUp 2003/01/27
// modification: new switch: search_stories = 2, is a special for RTE to search&insert contents-URL
//               needed, because the output is different from standard
// -----------------------------------------------------------------------
// sjah: 03-10-2004 removed tables for css layout

$search_modules[] = array(
    'title' => 'Stories',
    'func_search' => 'search_stories',
    'func_opt' => 'search_stories_opt'
);
function search_stories_opt() {
    global
        $bgcolor2,
        $tblcolor3,
        $info;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("<div style=\"background: $bgcolor2; border-bottom:1px solid $tblcolor3;\">\n");

    if (pnSecAuthAction(0, 'AddStory::', "$info[aid]:$info[cattitle]:$info[sid]", ACCESS_READ)) {
	    $output->Text("    <div style=\"background: $bgcolor2;\">\n");
        $output->Text("        <input type=\"checkbox\" name=\"active_stories\" id=\"active_stories\" value=\"1\" checked>&nbsp;<label for=\"active_stories\">"._SEARCH_STORIES_TOPICS."</label>\n");
        $output->Text("    </div>\n");
        $output->Text("    <div style=\"margin: 10px 0px 0px 30px;\">\n");
        $output->Text("        <b><label for=\"stories_topics[]\">"._TOPIC."</label>:</b><br /><select name=\"stories_topics[]\" id=\"stories_topics[]\" multiple><option value=\"\" selected>"._SRCHALLTOPICS."</option>\n");
        
    $column = &$pntable['topics_column'];
    $result = $dbconn->Execute("SELECT $column[topicid] as topicid, $column[topictext] as topictext, $column[topicname] as topicname
                              FROM $pntable[topics]
                              ORDER BY $column[topictext]");

    while(!$result->EOF) {
        $row = $result->GetRowAssoc(false);
        if (pnSecAuthAction(0, 'Topics::Topic', "$row[topicname]::$row[topicid]", ACCESS_READ)){
        if(strlen($row['topictext']) > 23) {
            $row['topictext'] = substr($row['topictext'],0,20) . '...';
        }
        $output->Text("<option value=\"$row[topicid]\">$row[topictext]</option>");
                }
        $result->MoveNext();
    }
    $output->Text("</select>\n</div>");
// categories
    $output->Text("     <div style=\"margin: 10px 0px 0px 30px;\">\n");
    $output->Text("          <b><label for=\"stories_cat[]\">"._CATEGORY."</label>:</b><br /><select name=\"stories_cat[]\" id=\"stories_cat[]\" multiple><option value=\"\" selected>"._ALLCATEGORIES."</option>");
    $column = &$pntable['stories_cat_column'];
    $result = $dbconn->Execute("SELECT $column[catid] as catid, $column[title] as title
                              FROM $pntable[stories_cat]
                              ORDER BY $column[title]");

    while(!$result->EOF) {
        $row = $result->GetRowAssoc(false);
        if (pnSecAuthAction(0, 'AddStory::', ":$row[title]:", ACCESS_READ)) {
                if(strlen($row['title']) > 23) {
                    $row['title'] = substr($row['title'],0,20) . '...';
                }
                $output->Text("<option value=\"$row[catid]\">$row[title]</option>");
        }
        $result->MoveNext();
    }
    $output->Text("</select>\n</div>\n");

// author
    $output->Text("    <div style=\"margin: 10px 0px 0px 30px;\">\n");
    $output->Text("         <b><label for=\"stories_author\">"._AUTHOR."</label>:</b><br /><input type=\"text\" name=\"stories_author\" id=\"stories_author\" size=\"20\" maxlength=\"255\">\n");
    $output->Text("    </div><br /><br />\n");    
    }
    $output->Text("</div>\n");
    return $output->GetOutput();
}
function search_stories() {

        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($startnum,
         $active_stories,
         $total,
         $stories_topics,
         $stories_cat,
         $stories_author,
         $q,
         $bool) = pnVarCleanFromInput('startnum',
                                      'active_stories',
                                      'total',
                                      'stories_topics',
                                      'stories_cat',
                                      'stories_author',
                                      'q',
                                      'bool');

    if(!isset($active_stories) || !$active_stories) {
        return;
    }

    $output = new pnHTML();

    if (!isset($startnum) || !is_numeric($startnum)) {
        $startnum = 1;
    }
    if (isset($total) && !is_numeric($total)) {
            unset ($total);
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    if (empty($bool)) {
        $bool = 'OR';
    }

    $flag = false;

    $storcol = &$pntable['stories_column'];
    $stcatcol = &$pntable['stories_cat_column'];
    $topcol = &$pntable['topics_column'];
    $query = "";
//modified for Oracle compatibility
        switch ($dbtype){
                case "oci8":
                    $query1 = "SELECT $storcol[sid] as sid,
                     $topcol[topicid] as topicid,
                     $topcol[topicname] as topicname,
                     $topcol[topictext] as topictext,
                     $storcol[catid] as catid,
                     $storcol[time] AS fdate,
                     $storcol[title] AS story_title,
                     $storcol[aid] AS aid,
                     $stcatcol[title] AS cat_title
                                FROM $pntable[stories], $pntable[stories_cat], $pntable[topics]
                                WHERE $storcol[catid] =$stcatcol[catid] (+) AND
                                $storcol[topic] =$topcol[topicid] AND ";
                        break;
                default:
    $query1 = "SELECT $storcol[sid] as sid,
                     $topcol[topicid] as topicid,
                     $topcol[topicname] as topicname,
                     $topcol[topictext] as topictext,
                     $storcol[catid] as catid,
                     $storcol[time] AS fdate,
                     $storcol[title] AS story_title,
                     $storcol[aid] AS aid,
                     $stcatcol[title] AS cat_title
               FROM $pntable[stories]
               LEFT JOIN $pntable[stories_cat] ON ($storcol[catid]=$stcatcol[catid])
               LEFT JOIN $pntable[topics] ON ($storcol[topic]=$topcol[topicid])
               WHERE ";
                        break;
        }
    // hack to get this to work, but much better than what we had before
    //$query .= " 1 = 1 ";
// words
    $w = search_split_query($q);
    if (isset($w)) {
        foreach($w as $word) {
            if($flag) {
                switch($bool) {
                    case 'AND' :
                        $query .= ' AND ';
                        break;
                    case 'OR' :
                    default :
                        $query .= ' OR ';
                        break;
                }
            }
            $query .= '(';
            $query .= "$storcol[title] LIKE '$word' OR ";
                        switch ($dbtype){
                                case "oci8":
                                        $query .= "contains($storcol[hometext],'$word',1)>0 OR ";
                                        $query .= "contains($storcol[bodytext],'$word',2)>0 OR ";
                                        $query .= "$storcol[comments] LIKE '$word' OR ";
                                        $query .= "$storcol[informant] LIKE '$word' OR ";
                                        $query .= "contains($storcol[notes],'$word',3)>0 ";
                                        break;
                                default:
            $query .= "$storcol[hometext] LIKE '".pnVarPrepForStore($word)."' OR ";
            $query .= "$storcol[bodytext] LIKE '".pnVarPrepForStore($word)."' OR ";
            //$query .= "$storcol[comments] LIKE '".pnVarPrepForStore($word)."' OR ";
            $query .= "$storcol[informant] LIKE '".pnVarPrepForStore($word)."' OR ";
            $query .= "$storcol[notes] LIKE '".pnVarPrepForStore($word)."'";
                                        break;
                        }
            $query .= ')';
            $flag = true;
            $no_flag = false;
        }
    } else {
     $no_flag = true;
    }
// topics
    if(isset($stories_topics) && (!empty($stories_topics))) {
        $flag = false;
        $start_flag = false;
            // dont set AND/OR if nothing is in front
            foreach($stories_topics as $v) {
              if (empty($v)) continue;
                if ( (!$no_flag) and (!$start_flag) ) {
                  $query .= " AND (";
                  $start_flag = true;
                }
              if ($flag) $query .= " OR ";
              $query .= "$storcol[topic]='".pnVarPrepForStore($v)."'";
              $flag = true;
            }
          if ( (!$no_flag) and ($start_flag) ) {
              $query .= ") ";
              $no_flag = false;
          }
    }
// categories
if (!is_array($stories_cat)) $stories_cat[0] = '';
    if(isset($stories_cat[0]) &&(!empty($stories_cat[0]))) {
          if (!$no_flag) {
            $query .= " AND (";
          }
        $flag = false;
        foreach($stories_cat as $v) {
              if($flag) {
                  $query .= " OR ";
              }
            $query .= "$stcatcol[catid]='".pnVarPrepForStore($v)."'";
            $flag = true;
        }
          if (!$no_flag) {
              $query .= ") ";
              $no_flag = false;
          }
    }
// authors
    if(isset($stories_author) && $stories_author != "") {
          if (!$no_flag) {
            $query .= " AND (";
          }
        $query .= "$storcol[informant]='".pnVarPrepForStore($stories_author)."'";

        $result = $dbconn->Execute("SELECT {$pntable['users_column']['uid']} as pn_uid FROM $pntable[users] WHERE {$pntable['users_column']['uname']} LIKE '%".pnVarPrepForStore($stories_author)."%' OR {$pntable['users_column']['name']} LIKE '%".pnVarPrepForStore($stories_author)."%'");
         while(!$result->EOF) {
             $row = $result->GetRowAssoc(false);
             $query .= " OR $storcol[aid]=$row[pn_uid]";
             $result->MoveNext();
         }
          if (!$no_flag) {
              $query .= ") ";
              $no_flag = false;
          }
    }
    else
    {
        $stories_author = '';
    }

    if (pnConfigGetVar('multilingual') == 1) {
           if (!empty($query)) $query .= " AND";
//modified for Oracle compatibility
//           $query .= " ($storcol[alanguage]='" . pnVarPrepForStore(pnUserGetLang()) . "' OR $storcol[alanguage]='')";
           $query .= " ($storcol[alanguage]='" . pnVarPrepForStore(pnUserGetLang()) . "' OR $storcol[alanguage]='' OR $storcol[alanguage] IS NULL)";
    }
    if (empty($query)) $query = "1";
    $query .= " ORDER BY $storcol[time] DESC";
    $query = $query1.$query;

    if (empty($total)) {
   // echo $query;
           $total = 0;
        $countres = $dbconn->Execute($query);
        //$total = $countres->PO_RecordCount();
        while(!$countres->EOF) {
                $row = $countres->GetRowAssoc(false);
                if (pnSecAuthAction(0, 'Stories::Story', "$row[aid]:$row[cat_title]:$row[sid]", ACCESS_READ) && pnSecAuthAction(0, 'Topics::Topic', "$row[topicname]::$row[topicid]", ACCESS_READ)) {
                        $total++;
                }
                $countres->MoveNext();
                // $countres->Close();
        }
    }

        // for RTE call use other max. rows. I think 100 hits are enough
        if($active_stories == 2) {
            $result = $dbconn->SelectLimit($query, 100, $startnum-1);
        } else {
            $result = $dbconn->SelectLimit($query, 10, $startnum-1);
        }

    if(!$result->EOF) {
                // if call from RTE then set smaller font size because of iframe
                if($active_stories == 2) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("<font size=2>");
                $output->SetInputMode(_PNH_PARSEINPUT);
                }

        $output->Text(_STORIES_TOPICS . ': ' . $total . ' ' . _SEARCHRESULTS);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        // Rebuild the search string from previous information
        $url = "modules.php?op=modload&amp;name=Search&amp;file=index&amp;action=search&amp;active_stories=1&amp;stories_author=".$stories_author;
        if (isset($stories_cat) && $stories_cat) {
            foreach($stories_cat as $v) {
                $url .= "&amp;stories_cat%5B%5D=$v";
            }
        }
        if (isset($stories_topics) && $stories_topics){
            foreach($stories_topics as $v) {
                $url .= ("&amp;stories_topics%5B%5D=$v");
            }
        }
        $url .= "&amp;bool=".$bool;
        if (isset($q)) {
            $url .= "&amp;q=".$q;
        }

        $output->Text("<ul>");

        while(!$result->EOF) {
            $row = $result->GetRowAssoc(false);
                    $row['fdate'] = ml_ftime(_DATELONG,$result->UnixTimeStamp($row['fdate']));
            $output->Text("<li>");
            if (!empty($row['topicid'])) {
                // If active_stories==2 --> we came from RTE and send back URL for insert into content
                                if($active_stories != 2) {
                                        $output->Text("<b><a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=Search&amp;file=index&amp;action=search&amp;active_stories=1&amp;stories_topics[0]=".$row['topicid']."\">".$row['topictext']."</a></b> - ");
                                } else {
                                        $output->Text("<b>".$row['topictext']."</b> - ");
                                }
            }
            if (!empty($row['catid'])) {
                                if($active_stories != 2) {
                        $output->Text("<a href=\"index.php?catid=".$row['catid']."\">".$row['cat_title']."</a>: ");
                                } else {
//                        $output->Text("<a href=\"#\" onClick=\"top.document.forms[0].elements['LinkUrl'].value='index.php?catid=".$row['catid']."'\">".$row['cat_title']."</a>: ");
                        $output->Text("<a href=\"#\" onClick=\"top.document.getElementById('f_href').value='index.php?catid=".$row['catid']."'\">".$row['cat_title']."</a>: ");
                                }
			}

            if ($row['story_title'] == '') {
                $row['story_title'] = 'No Title';
            }

           if($active_stories != 2) {
                    $output->Text('<i><a class="pn-normal" href="modules.php?op=modload&amp;name=News&amp;file=article&amp;sid='.$row['sid'].'">'. pnVarPrepHTMLDisplay($row['story_title']) . '</a></i> - ' .$row['fdate']."</li>");
           } else {
//                    $output->Text("<i><a href=\"#\" onClick=\"top.document.forms[0].elements['LinkUrl'].value='modules.php?op=modload&amp;name=News&amp;file=article&sid=".$row['sid']."'\">". pnVarPrepHTMLDisplay($row['story_title']) . "</a></i> - " .$row['fdate']."</li>");
                    $output->Text("<i><a href=\"#\" onClick=\"top.document.getElementById('f_href').value='modules.php?op=modload&amp;name=News&amp;file=article&sid=".$row['sid']."'\">". pnVarPrepHTMLDisplay($row['story_title']) . "</a></i> - " .$row['fdate']."</li>");
           }
           ;
           $result->MoveNext();
        }
        $output->Text("</ul>");
//        $output->Linebreak(4);

        // Munge URL for template
        $urltemplate = $url . "&amp;startnum=%%&amp;total=$total";
                // for RTE call use other max. rows. I think 100 hits are enough
                if($active_stories == 2) {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               100);
                } else {
                $output->Pager($startnum,
                               $total,
                               $urltemplate,
                               10);
                }
    } else {
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('<font class="pn-normal">'._SEARCH_NO_STORIES_TOPICS.'</font>');
        $output->SetInputMode(_PNH_PARSEINPUT);
    }
    $output->Linebreak();

        // .... and close smaller font size for RTE call
        if($active_stories == 2) {
        $output->Text("</font>");
        }
    return $output->GetOutput();
}
?>