<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file:
// Purpose of file:
// ----------------------------------------------------------------------------

/**
 * MD-Pro Install Script.
 *
 * This script will set the database up, and do the basic configurations of the script.
 * Once this script has run, please delete this file from your root directory.
 * There is a security risk if you keep this file around.
 *
----------------------------------------------------------
 * ChangeLog
 * 8/11/2002      Brian Lindner   Added PHPNuke 4.2 - 6.0 Upgrade scripts
 * 6/11/2003      WindMeUp        Add log-file for installation
 * 3/07/2004 TiMax        Add upgrade from MD 1.0.6 to MD 1.0.7
 */
//error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

if (phpversion() >= "4.2.0") {
if ( ini_get('register_globals') != 1 ) {

$supers = array('_REQUEST',
                                '_ENV',
                                '_SERVER',
                                '_POST',
                                '_GET',
                                '_COOKIE',
                                '_SESSION',
                                '_FILES',
                                '_GLOBALS' );

        foreach( $supers as $__s) {
            if ( ( isset( $$__s ) ) && ( is_array( $$__s ) == true )) {
                extract( $$__s, EXTR_OVERWRITE );
            }
        }
unset($supers);
}
} else {

if ( ini_get('register_globals') != 1 ) {

$supers = array('HTTP_POST_VARS',
                                'HTTP_GET_VARS',
                                'HTTP_COOKIE_VARS',
                                'GLOBALS',
                                'HTTP_SESSION_VARS',
                                'HTTP_REQUEST_VARS',
                        'HTTP_SERVER_VARS',
                        'HTTP_ENV_VARS' );

        foreach( $supers as $__s) {
            if ( is_array( $$__s ) == true ) {
                extract( $$__s, EXTR_OVERWRITE );
            }
        }
        unset($supers);
    }
}


@set_time_limit(0);

// functions for the db abstraction layer
define('ADODB_DIR', 'pnadodb');
require_once ("pnadodb/adodb.inc.php");

ini_set('register_globals', 'On');
if (isset($alanguage)) {
        $currentlang = $alanguage;
}

if(!isset($prefix)) {
        include_once 'config/md-config.php';

        $prefix = $pnconfig['prefix'];
        $dbtype = $pnconfig['dbtype'];
       // $dbtabletype = $pnconfig['dbtabletype'];
        $dbhost = $pnconfig['dbhost'];
        $dbuname = $pnconfig['dbuname'];
        $dbpass = $pnconfig['dbpass'];
        $dbname = $pnconfig['dbname'];
        $system = $pnconfig['system'];
        $encoded = $pnconfig['encoded'];
}

// GRAB the upgrade version

if (!empty($encoded)) {
        // Decode username and password
        $dbuname = base64_decode($dbuname);
        $dbpass = base64_decode($dbpass);
}

$pnconfig['prefix'] = $prefix;
global $op;
// database tables information
include_once 'pntables.php';

// functions for multilanguage support
include_once 'install/language.php';

installer_get_language();

// functions to modify config.php
include_once 'install/modify_config.php';

// functions for upgrades
include_once 'install/upgrade.php';

// functions for new installs
include_once 'install/newinstall.php';

// functions for rendering the gui
include_once 'install/gui.php';

// functions for accessing the db
include_once 'install/db.php';

// functions for various checks
include_once 'install/check.php';

// functions for API calls
include_once 'includes/pnAPI.php';

// functions for Module calls
include_once 'includes/pnMod.php';

// print the page header, include style sheets
print_header($op);

/*  This starts the switch statement that filters through the form options.
* the @ is in front of $op to suppress error messages if $op is unset and E_ALL
* is on */
switch(@$op) {

    case "CHM_check":
         print_CHM_check();
         break;

    case "Submit":
         print_submit();
         break;

    case "Change Info":
         print_change_info();
         break;

    case "New Install":
         print_new_install();
         break;

    case "Start":
         if(!isset($dbmake)) {
            $dbmake = false;
         }
         make_db($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, $dbmake);
         print_start();
         break;

    case "Continue":
         print_continue($upgrade);
         break;

    case "Set Login":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
                 // Log-file entry: Selection from previous step !!
                 do_upgrade_log(_ADMIN_LOGIN.": ".$aid."\n".
                                           _ADMIN_NAME.": ".$name."\n".
                                           _ADMIN_PASS.": ******\n".
                                           _ADMIN_EMAIL.": ".$email."\n".
                                           _ROOTPATH.": ".$root_path."\n".
                                           _ENROOTPATH.": ".$pnrootpath."\n".
                                           _ENV_UPLOAD_URL.": ".$upload_path."\n".
                                           _ENV_PAGES_UPLOAD_URL.": ".$pages_upload_path."\n".
                                           _ADMIN_URL.": ".$url."\n",_INPUT_DATA_1,"Step9");

         input_data($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, $aid, $name, $pwd, $repeatpwd, $email, $url, $upgrade);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp

                 // Log-file entry: Selection from previous step !!
                 do_upgrade_log("config files OK");

         print_set_login($upgrade);
         break;

    case "Select Language":
         print_select_language();
         break;

    case "Set Language":
         $currentlang = $alanguage;
         print_default();
         break;

    case "Finish":
         print_finish();
         break;

    case "Finish Upgrade":
         print_finish_upgrade();
         break;

    case "Upgrade":
         print_upgrade();
         break;

    case "Check":
        do_check_php($loginit);
        do_check_chmod($loginit);
        break;
// Brian Lindner:  BEGIN UPGRADE AREA CALLS!!!
    case "Envolution 1.1.0":
    case "Envolution 1.1.5":
    case "Envolution 1.2":
    case "Envolution 1.2.5":
    case "PostNuke .714":
    case "PostNuke .721":
    case "PostNuke .723":
    case "PostNuke .726":
    case "MD-pro alpha":
    case "MD-pro 1.0.6":

         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
//         do_loadconfig_default($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '.72');
//         echo "Test: ".pnModGetVar('subjects','pagespath');
                 print_config_upgrade($op);
         break;
    case "envoUpgrade 1.1.0":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
         //update_sub_config(true); // write sub-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");
         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype,$themeengine,1,$envoblocks,$encompass,$filemanager,$subjects, '1.1.0');
         print_set_login_upgrade($op);
         break;
    case "envoUpgrade 1.1.5":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
         //update_sub_config(true); // write sub-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");
         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype,$themeengine,1,$envoblocks,$encompass,$filemanager,$subjects, '1.1.5');
         print_set_login_upgrade($op);
         break;
    case "envoUpgrade 1.2":
                 $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
         //update_sub_config(true); // write sub-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");
         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype,$themeengine,1,$envoblocks,$encompass,$filemanager,$subjects, '1.2');
         print_set_login_upgrade($op);
         break;
        case "envoUpgrade 1.2.5":
                 $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
         //update_sub_config(true); // write sub-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");
         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype,$themeengine,1,$envoblocks,$encompass,$filemanager,$subjects, '1.2.5');
         print_set_login_upgrade($op);
         break;
    case "PNUpgrade .714":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
                 // Log-file entry: Selection from previous step !!
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
         //update_sub_config(true); // write sub-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");

         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_postnuke($dbhost,$dbuname,$dbpass,$dbname,$prefix,$dbtype,$themeengine,$adminlite,$envoblocks=0,$encompass=0,$filemanager,$subjects, '.714');
         //print_start($op);
         print_set_login_upgrade($op);
         break;
    case "PNUpgrade .721":
    case "PNUpgrade .723":
    case "PNUpgrade .726":
    global $envoblocks, $encompass;
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");

         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_postnuke($dbhost,$dbuname,$dbpass,$dbname,$prefix,$dbtype,$themeengine,$adminlite,$envoblocks=0,$encompass=0,$filemanager,$subjects, '.72');
         //print_start($op);
         print_set_login_upgrade($op);
         break;
        case "mdUpgrade alpha":
                 $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
         update_rte_config(true); // write rte-config.php - WindMeUp
         //update_sub_config(true); // write sub-config.php - WindMeUp
                 do_upgrade_log(_SET_POSTNUKE.": ".pnConfigGetVar('Version_ID')." ".pnConfigGetVar('Version_Num')." ".pnConfigGetVar('Version_Sub')."\n".
                                           _SET_NEWTHEME2.": ".doYesNo($themeengine)."\n".
                                           _SET_ADMINLITE2.":".doYesNo($adminlite)."\n".
                                           _SET_ENVOBLOCKS2.": ".doYesNo($envoblocks)."\n".
                                           _SET_ENCOMPASS2.": ".doYesNo($encompass)."\n".
                                           _SET_FILEMANAGER2.": ".doYesNo($filemanager)."\n".
                                           _SET_SUBJECTS2.": ".doYesNo($subjects)."\n");
         $mods = pnModGetUserMods();
         foreach ($mods as $mods) {
                    do_upgrade_log(_INSTALLEDMODULE.": ".$mods['directory']." ".$mods['version']." [".$mods['description']."]\n");
         }
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype,1,1,0,0,1,1, 'MD alpha');
         print_set_login_upgrade($op);
         break;
                case "PHPNuke 4.2":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '4.2');
         print_start($op);
         break;
           case "PHPNuke 4.3":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '4.3');
         print_start($op);
         break;
           case "PHPNuke 4.4":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '4.4');
         print_start($op);
         break;
                case "PHPNuke 5.0":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.0');
         print_start($op);
         break;
                case "PHPNuke 5.1":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.1');
         print_start($op);
         break;
                case "PHPNuke 5.2":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.2');
         print_start($op);
         break;
                case "PHPNuke 5.3":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.3');
         print_start($op);
         break;
                case "PHPNuke 5.31":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.31');
         print_start($op);
         break;
                case "PHPNuke 5.4":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.4');
         print_start($op);
         break;
                case "PHPNuke 5.5":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.5');
         print_start($op);
         break;
                case "PHPNuke 5.6":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.6');
         print_start($op);
         break;
                case "PHPNuke 6.0":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '6.0');
         print_start($op);
         break;
         case "mdUpgrade 1.0.6":
                 $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);

         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype,1,1,0,0,1,1, 'MD 1.0.6');
         print_set_login_upgrade($op);
         break;



// END UPGRADE AREA CALLS


    default:
         print_select_language($op);
         break;
}

// print the footer, and closing tags
print_footer($op);

function doYesNo($what) {

if($what) {
   return (_YES);
} else {
   return (_NO);
}
}

function do_upgrade_log($string,$description="",$step="none") {

        $filename = 'config/install_log.txt';

        if (!file_exists($filename)) {
            print "The file $filename does not exist. Try to create it.";
            //$tempf = tempnam("config/", "log");
                   $logf = fopen("config/install_log.txt", "w");
                if (is_writable($filename)) {
                        fwrite($logf, $string."\n".$step.": ".$description."\n");
                } else {
                        die (_INSTALL_LOG_ERROR);
                }
        } else {
                if (is_writable($filename)) {
                switch($step) {
                    case "Step1":
                    case "Init":
                                $logf = fopen("config/install_log.txt", "w");
                                //break;

                        default:
                                $logf = fopen("config/install_log.txt", "a");
                                //break;
                }
                } else die (_INSTALL_LOG_ERROR);

                if (is_writable($filename)) {
                        if($step == "none") {
                                fwrite($logf, $string.": ".$description."\n");
                        } else {
                                fwrite($logf, $string."\n\n".$step.": ".$description."\n");
                        }
                } else {
                        die (_INSTALL_LOG_ERROR);
                }
        }
        fclose($logf);

}

?>
