<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// $Id: pn714.php,v 1.2 2004/07/01 22:08:15 timax Exp $
// Upgrade from PostNuke .714 and .72 to Envolution 1.0
//
// Note that this is upgrade script uses ADODB instead
// of raw mysql
//
// Adapted by xaplo from Postnuke.
//
// Log:
// - Make upgradable from .72
// - Clean code
// - New function (in update_functions) SaveConfigValue

global $dbconn, $pntable, $prefix;

include_once("install/Encompass.php");

// Save / upgrade module vars
SaveConfigValue('/PNConfig','allowuserdelete',0,0);
SaveConfigValue('/PNConfig','senddeleteemail',0,0);
SaveConfigValue('/PNConfig','sendaddemail',0,0);
SaveConfigValue('/PNConfig','allowuserpass',0,0);
SaveConfigValue('/PNConfig','blkusrreg',0,0);
SaveConfigValue('/PNConfig','senduserpass',0,0);
SaveConfigValue('/PNConfig','pncuaver','1.2',1);
SaveConfigValue('/PNConfig','pncuaadvreg',0,0);
SaveConfigValue('/PNConfig','Default_Theme','Envolved',1);
SaveConfigValue('/PNConfig','Version_ID','Envolution',1);
SaveConfigValue('/PNConfig','Version_Num','1.0.0',1);
SaveConfigValue('/PNConfig','Version_Sub','Resolve',1);
SaveConfigValue('/PNConfig','UseCompression',0,0);
SaveConfigValue('/PNConfig','htmlentities',1,0);
SaveConfigValue('/PNConfig','collapseable',1,0);

// Change permissions for 'Mail users' to 'MailUsers' in user permissions
$upcolumn = $pntable['user_perms_column'];
$result = $dbconn->Execute("SELECT $upcolumn[pid],
                                   $upcolumn[component]
                            FROM $pntable[user_perms]");
$foundrecords = !$result->EOF;
while(list($pid, $component) = $result->fields) {
    $result->MoveNext();

    if (preg_match('/Mail users/', $component)) {
        $component = preg_replace('/Mail users/', 'MailUsers', $component);
        $dbconn->Execute("UPDATE $pntable[user_perms]
                          SET $upcolumn[component] = '" . addslashes($component) . "'
                          WHERE $upcolumn[pid] = $pid");
    }
}
if ($foundrecords) {
    $result->Close();
}

$dbconn->Execute("ALTER TABLE $pntable[sections] ADD pn_language VARCHAR(30) NOT NULL AFTER pn_secname");

$dbconn->Execute("ALTER TABLE $pntable[topics] ADD pn_language VARCHAR(30) NOT NULL AFTER pn_topicname");

// Add in reminder to remove the install.php file
$bcolumn = $pntable['blocks_column'];
$dbconn->Execute("INSERT INTO $pntable[blocks]
                    ($bcolumn[bid],
                     $bcolumn[bkey],
                     $bcolumn[title],
                     $bcolumn[content],
                     $bcolumn[url],
                     $bcolumn[mid],
                     $bcolumn[position],
                     $bcolumn[weight],
                     $bcolumn[active],
                     $bcolumn[refresh],
                     $bcolumn[last_update],
                     $bcolumn[language])
                  VALUES
                    (0,
                     'html',
                     'Reminder',
                     'Please remember to remove the following files from your Envolution directory
                     <p>
                     &middot;<b>install.php</b> file
                     <p>
                     &middot;<b>install</b> directory
                     <p>
                     If you do not remove these files then users can obtain the password to your database!',
                     '',
                     0,
                     'l',
                     0.5,
                     1,
                     0,
                     0,
                     '')");


UpdateEncompass();

//
// User Points table
//
if (!CheckTableExists("user_points")) {
  $dbconn->Execute("DROP TABLE ".$prefix."_user_points");
}

// Create User Points table
$result = $dbconn->Execute("CREATE TABLE ".$prefix."_user_points (
  uid int(11) NOT NULL default '0',
  uname varchar(25) NOT NULL default '',
  stories int(11) NOT NULL default '0',
  comments int(11) NOT NULL default '0',
  pollcomm int(11) NOT NULL default '0',
  downloads int(11) NOT NULL default '0',
  dloadvotes int(11) NOT NULL default '0',
  links int(11) NOT NULL default '0',
  linkvotes int(11) NOT NULL default '0',
  reviews int(11) NOT NULL default '0',
  reviewcomm int(11) NOT NULL default '0',
  posts int(11) NOT NULL default '0',
  points int(13) NOT NULL default '0',
  PRIMARY KEY  (uid)
)");

$dbconn->Execute("INSERT INTO ".$prefix."_user_points VALUES ('-1', '0000000000', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)");


// Create User delete request table
$result = $dbconn->Execute("CREATE TABLE ".$prefix."_users_delrequest (
  pn_uid int(11) NOT NULL default '0',
  pn_name varchar(60) NOT NULL default '',
  pn_uname varchar(25) NOT NULL default '',
  pn_email varchar(60) NOT NULL default '',
  pn_pass varchar(40) NOT NULL default '',
  PRIMARY KEY  (pn_uid)
)");

$result = $dbconn->Execute("SELECT MAX(pn_id) FROM ".$prefix."_modules");
list($maxpnid) = $result->fields;

$maxpnid++;

// Update modules
$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='Encompass'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='Encompass'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'Encompass',
                                                                        2,
                                                                        'Encompass',
                                                                        'Encompass Theme Engine',
                                                                        43,
                                                                        'Encompass',
                                                                        '0.926',
                                                                        1,
                                                                        0,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (Encompass)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='Frontpage'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='Frontpage'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'Frontpage',
                                                                        2,
                                                                        'Frontpage',
                                                                        'Encompass FrontPage Module',
                                                                        44,
                                                                        'Frontpage',
                                                                        '0.91-1a',
                                                                        0,
                                                                        1,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (Frontpage)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='News'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='News'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'News',
                                                                        2,
                                                                        'News',
                                                                        'News items',
                                                                        7,
                                                                        'News',
                                                                        '1.5',
                                                                        1,
                                                                        1,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (News)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='User_Points'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='User_Points'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'User_Points',
                                                                        2,
                                                                        'User Points',
                                                                        'Member Points Module',
                                                                        45,
                                                                        'NS-User_Points',
                                                                        '0.22a-1',
                                                                        1,
                                                                        0,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (User_Points)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='Your_Account'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='Your_Account'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'Your_Account',
                                                                        2,
                                                                        'Your Account',
                                                                        'User options',
                                                                        0,
                                                                        'NS-Your_Account',
                                                                        '0.8',
                                                                        0,
                                                                        0,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (Your_Account)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='Past_Nuke'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='Past_Nuke'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'Past_Nuke',
                                                                        1,
                                                                        'Past Nuke',
                                                                        'Old Postnuke Admin compatibility',
                                                                        0,
                                                                        'NS-Past_Nuke',
                                                                        '1.0',
                                                                        1,
                                                                        0,
                                                                        1)")
or die("<b>"._NOTUPDATED.$prefix."_modules (Past_Nuke)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='NewUser'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='NewUser'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'NewUser',
                                                                        1,
                                                                        'NewUser',
                                                                        'New User for Envolution.',
                                                                        21,
                                                                        'NS-NewUser',
                                                                        '0.5',
                                                                        0,
                                                                        0,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (NewUser)</b>");

$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='postbbcode'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='postbbcode'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES ($maxpnid,
                                                                        'postbbcode',
                                                                        1,
                                                                        'postbbcode',
                                                                        'BBcode for use in Envolution.',
                                                                        46,
                                                                        'postbbcode',
                                                                        '0.1',
                                                                        0,
                                                                        1,
                                                                        3)")
or die("<b>"._NOTUPDATED.$prefix."_modules (postbbcode)</b>");


$maxpnid++;

$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='Autolinks'");
$foundrecords = !$result->EOF;

if ($foundrecords) {
        $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='Autolinks'");
}
$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
                                                        VALUES (9,
                                                                        'Autolinks',
                                                                        2,
                                                                        'Autolinks',
                                                                        'Automatically add links to text',
                                                                        11,
                                                                        'Autolinks',
                                                                        '1.0',
                                                                        1,
                                                                        0,
                                                                        3)") or die("<b>"._NOTUPDATED.$prefix."_modules</b>");




$result = $dbconn->Execute("SELECT  pn_tmodule FROM ".$prefix."_hooks where  pn_tmodule='Autolinks'");
$foundrecords = !$result->EOF;

if (!$foundrecords) {
        $result = $dbconn->Execute("INSERT INTO ".$prefix."_hooks VALUES (3, 'item', 'transform', NULL, NULL, 'API', 'Autolinks', 'user', 'transform')") || die("<b>"._NOTUPDATED.$prefix."_hooks</b>");
}

//list($dbconn) = pnDBGetConn();
//$pntable = pnDBGetTables();

// Setup the table and column info
$table = $pntable['module_vars'];
$column = &$pntable['module_vars_column'];

// Get the next available skin id
$id = $dbconn->GenId($table);

echo "Checking existing Autolinks variables ... ";
$result = $dbconn->Execute("Select pn_modname FROM ".$prefix."_module_vars WHERE pnmodname='Autolinks'");
$foundrecords = !$result->EOF;
echo "OK<br>";
echo "";

if($foundrecords) {
        echo "Inserting Autolinks variables ... ";
        $result = $dbconn->Execute("INSERT INTO ".$prefix."_module_vars VALUES($id, 'Autolinks', 'itemsperpage', 20)") || die("<b>"._NOTUPDATED.$prefix."_module_vars</b>");
        $result = $dbconn->Execute("INSERT INTO ".$prefix."_module_vars VALUES($id, 'Autolinks', 'linkfirst', 1)") || die("<b>"._NOTUPDATED.$prefix."_module_vars</b>");
        $result = $dbconn->Execute("INSERT INTO ".$prefix."_module_vars VALUES($id, 'Autolinks', 'invisilinks', 0)") || die("<b>"._NOTUPDATED.$prefix."_module_vars</b>");
        echo "OK<br>";
} else{
        echo "Autolinks variables are up to date already";
}
$maxpnid++;

// Check there is at least 1 story
$result = $dbconn->Execute("SELECT * FROM ".$prefix."_stories");
if ($result->EOF) {
        // Insert at least a new
        $dbconn->Execute("INSERT INTO ".$prefix."_stories
                                VALUES (1,
                                                1,
                                                '1',
                                                '"._ENCOREF8."',
                                                '2002-05-31 09:07:11',
                                                '"._ENCOREF9.".',
                                                '',
                                                0,
                                                0,
                                                1,
                                                '"._VOC60."',
                                                '',
                                                0,
                                                '',
                                                '',
                                                0,
                                                0)");
}
?>