<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Original Author of file:                Envolution Development Team - Brian Lindner
// Purpose of file:                        Install data for a PHP upgrade installation
// ----------------------------------------------------------------------------


include_once("install/Encompass.php");
require("includes/pnAPI.php");

list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

$dbconn->Execute("CREATE TABLE $pntable[autolinks] (
  pn_lid int(11) NOT NULL auto_increment,
  pn_keyword varchar(100) NOT NULL default '',
  pn_title varchar(100) NOT NULL default '',
  pn_url varchar(200) NOT NULL default '',
  pn_comment varchar(200) NOT NULL default '',
  PRIMARY KEY  (pn_lid),
  UNIQUE KEY keyword (pn_keyword)
)");

$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE anid pn_anid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE catid pn_catid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE aid pn_aid varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE title pn_title varchar(80) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE time pn_time varchar(19) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE hometext pn_hometext text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE bodytext pn_bodytext text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE topic pn_topic tinyint(3) DEFAULT '1' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE informant pn_informant varchar(20) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE notes pn_notes text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE ihome pn_ihome tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE alanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] CHANGE acomm pn_withcomm int(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[autonews] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_anid)");

$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE bid pn_bid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE cid pn_cid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE imptotal pn_imptotal int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE impmade pn_impmade int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE clicks pn_clicks int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE imageurl pn_imageurl varchar(255) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE clickurl pn_clickurl varchar(255) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[banner] CHANGE date pn_date datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[banner] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_bid)");

$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE cid pn_cid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE name pn_name varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE contact pn_contact varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE email pn_email varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE login pn_login varchar(10) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE passwd pn_passwd varchar(10) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] CHANGE extrainfo pn_extrainfo text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[bannerclient] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_cid)");

$dbconn->Execute("CREATE TABLE $pntable[bannerfinish] (
  pn_bid int(11) NOT NULL auto_increment,
  pn_cid int(11) NOT NULL default '0',
  pn_impressions int(11) NOT NULL default '0',
  pn_clicks int(11) NOT NULL default '0',
  pn_datestart datetime default NULL,
  pn_dateend datetime default NULL,
  PRIMARY KEY  (pn_bid)
)");

$dbconn->Execute("ALTER TABLE $pntable[blocks] RENAME $pntable[blocks]_old");
$dbconn->Execute("CREATE TABLE $pntable[blocks] (
  pn_bid int(11) unsigned NOT NULL auto_increment,
  pn_bkey varchar(255) NOT NULL default '',
  pn_title varchar(255) NOT NULL default '',
  pn_content text NOT NULL,
  pn_url varchar(255) NOT NULL default '',
  pn_mid int(11) unsigned NOT NULL default '0',
  pn_position char(1) NOT NULL default 'l',
  pn_weight decimal(10,1) NOT NULL default '0.0',
  pn_active tinyint(3) unsigned NOT NULL default '1',
  pn_refresh int(11) unsigned NOT NULL default '0',
  pn_last_update timestamp(14) NOT NULL,
  pn_language varchar(30) NOT NULL default '',
  PRIMARY KEY  (pn_bid)
)");


$dbconn->Execute("CREATE TABLE $pntable[blocks_buttons] (
  pn_id int(11) unsigned NOT NULL auto_increment,
  pn_bid int(11) unsigned NOT NULL default '0',
  pn_title varchar(255) NOT NULL default '',
  pn_url varchar(255) NOT NULL default '',
  pn_images longtext NOT NULL,
  PRIMARY KEY  (pn_id)
)");

$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE tid pn_tid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE pid pn_pid int(11) DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE sid pn_sid int(11) DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE date pn_date datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE name pn_name varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE email pn_email varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE url pn_url varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE host_name pn_host_name varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE subject pn_subject varchar(85) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE comment pn_comment text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE score pn_score tinyint(4) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[comments] CHANGE reason pn_reason tinyint(4) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[comments] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_tid)");

$dbconn->Execute("CREATE TABLE $pntable[counter] (
  pn_type varchar(80) NOT NULL default '',
  pn_var varchar(80) NOT NULL default '',
  pn_count int(11) unsigned NOT NULL default '0'
)");

$dbconn->Execute("ALTER TABLE $pntable[counter] CHANGE type pn_type varchar(80) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[counter] CHANGE var pn_var varchar(80) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[counter] CHANGE count pn_count int(11)  unsigned NOT NULL DEFAULT '0'");


$dbconn->Execute("ALTER TABLE $pntable[downloads_categories] CHANGE cid pn_cid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[downloads_categories] CHANGE title pn_title varchar(50) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_categories] CHANGE cdescription pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_categories] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_cid)");

$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE lid pn_lid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE cid pn_cid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE sid pn_sid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE description pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE date pn_date datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE name pn_name varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE email pn_email varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE hits pn_hits int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE submitter pn_submitter varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE downloadratingsummary pn_ratingsummary double(6,4) DEFAULT '0.0000' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE totalvotes pn_totalvotes int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE totalcomments pn_totalcomments int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE filesize pn_filesize int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE version pn_version varchar(10) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] CHANGE homepage pn_homepage varchar(200) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_downloads] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_lid)");

$dbconn->Execute("ALTER TABLE $pntable[downloads_editorials] CHANGE downloadid pn_id int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_editorials] CHANGE adminid pn_adminid varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_editorials] CHANGE editorialtimestamp pn_timestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_editorials] CHANGE editorialtext pn_text text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_editorials] CHANGE editorialtitle pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_editorials] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");

$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE requestid pn_requestid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE lid pn_lid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE cid pn_cid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE sid pn_sid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE description pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE modifysubmitter pn_modifysubmitter varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE brokendownload pn_brokendownload int(3) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE name pn_name varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE email pn_email varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE filesize pn_filesize int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE version pn_version varchar(10) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] CHANGE homepage pn_homepage varchar(200) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_modrequest] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_requestid)");

$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE lid pn_lid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE cid pn_cid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE sid pn_sid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE description pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE name pn_name varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE email pn_email varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE submitter pn_submitter varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE filesize pn_filesize int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE version pn_version varchar(10) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] CHANGE homepage pn_homepage varchar(200) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_newdownload] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_lid)");

$dbconn->Execute("CREATE TABLE $pntable[downloads_subcategories] (
  pn_sid int(11) NOT NULL auto_increment,
  pn_cid int(11) NOT NULL default '0',
  pn_title varchar(50) NOT NULL default '',
  PRIMARY KEY  (pn_sid)
)");

$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE ratingdbid pn_id int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE ratinglid pn_lid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE ratinguser pn_user varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE rating pn_rating int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE ratinghostname pn_hostname varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE ratingcomments pn_comments text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] CHANGE ratingtimestamp pn_timestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[downloads_votedata] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");

$dbconn->Execute("ALTER TABLE $pntable[ephem] CHANGE eid pn_eid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[ephem] CHANGE did pn_did tinyint(2) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[ephem] CHANGE mid pn_mid tinyint(2) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[ephem] CHANGE yid pn_yid int(4) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[ephem] CHANGE content pn_content text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[ephem] CHANGE elanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[ephem] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_eid)");

$dbconn->Execute("ALTER TABLE $pntable[faqanswer] CHANGE id pn_id tinyint(4) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[faqanswer] CHANGE id_cat pn_id_cat tinyint(4) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[faqanswer] CHANGE question pn_question varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[faqanswer] CHANGE answer pn_answer text");
$dbconn->Execute("ALTER TABLE $pntable[faqanswer] CHANGE submittedby pn_submittedby varchar(250) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[faqanswer] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");

$dbconn->Execute("ALTER TABLE $pntable[faqcategories] CHANGE id_cat pn_id_cat tinyint(3) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[faqcategories] CHANGE categories pn_categories varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[faqcategories] CHANGE flanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[faqcategories] CHANGE parent_id pn_parent_id tinyint(3) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[faqcategories] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id_cat)");

$dbconn->Execute("CREATE TABLE $pntable[group_membership] (
  pn_gid int(11) NOT NULL default '0',
  pn_uid int(11) NOT NULL default '0'
)");

$dbconn->Execute("CREATE TABLE $pntable[group_perms] (
  pn_pid int(11) NOT NULL auto_increment,
  pn_gid int(11) NOT NULL default '0',
  pn_sequence int(11) NOT NULL default '0',
  pn_realm smallint(4) NOT NULL default '0',
  pn_component varchar(255) NOT NULL default '',
  pn_instance varchar(255) NOT NULL default '',
  pn_level smallint(4) NOT NULL default '0',
  pn_bond int(2) NOT NULL default '0',
  PRIMARY KEY  (pn_pid)
)");

$dbconn->Execute("CREATE TABLE $pntable[groups] (
  pn_gid int(11) NOT NULL auto_increment,
  pn_name varchar(255) NOT NULL default '',
  PRIMARY KEY  (pn_gid)
)");


$dbconn->Execute("ALTER TABLE $pntable[headlines] CHANGE hid pn_id int(11) unsigned NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[headlines] CHANGE sitename pn_sitename varchar(255) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[headlines] CHANGE headlinesurl pn_rssurl varchar(255) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[headlines] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");
$dbconn->Execute("ALTER TABLE $pntable[headlines] ADD UNIQUE ('sitename`)");

/*
$dbconn->Execute("DROP TABLE $pntable[headlines]");
$dbconn->Execute("CREATE TABLE $pntable[headlines] (
  pn_id int(11) unsigned NOT NULL auto_increment,
  pn_sitename varchar(255) NOT NULL default '',
  pn_rssuser varchar(10) default NULL,
  pn_rsspasswd varchar(10) default NULL,
  pn_use_proxy tinyint(3) NOT NULL default '0',
  pn_rssurl varchar(255) NOT NULL default '',
  pn_maxrows tinyint(3) NOT NULL default '10',
  pn_siteurl varchar(255) NOT NULL default '',
  pn_options varchar(20) default '',
  PRIMARY KEY  (pn_id)
)");
*/

$dbconn->Execute("CREATE TABLE $pntable[hooks] (
  pn_id int(11) unsigned NOT NULL auto_increment,
  pn_object varchar(64) NOT NULL default '',
  pn_action varchar(64) NOT NULL default '',
  pn_smodule varchar(64) default NULL,
  pn_stype varchar(64) default NULL,
  pn_tarea varchar(64) NOT NULL default '',
  pn_tmodule varchar(64) NOT NULL default '',
  pn_ttype varchar(64) NOT NULL default '',
  pn_tfunc varchar(64) NOT NULL default '',
  PRIMARY KEY  (pn_id)
)");

$dbconn->Execute("CREATE TABLE $pntable[languages_constant] (
  pn_constant varchar(32) NOT NULL default '',
  pn_file varchar(64) NOT NULL default '',
  PRIMARY KEY  (pn_constant)
)");
$dbconn->Execute("CREATE TABLE $pntable[languages_file] (
  pn_target varchar(64) NOT NULL default '',
  pn_source varchar(64) NOT NULL default '',
  PRIMARY KEY  (pn_target,pn_source),
  UNIQUE KEY source (pn_source)
)");

$dbconn->Execute("CREATE TABLE $pntable[languages_translation] (
  pn_language varchar(32) NOT NULL default '',
  pn_constant varchar(32) NOT NULL default '',
  pn_translation longblob NOT NULL,
  pn_level tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (pn_constant,pn_language)
)");

$dbconn->Execute("ALTER TABLE $pntable[links_categories] CHANGE cid pn_cat_id int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[links_categories] CHANGE parentid pn_parent_id int(11) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[links_categories] CHANGE title pn_title varchar(50) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_categories] CHANGE cdescription pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_categories] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_cat_id)");

$dbconn->Execute("ALTER TABLE $pntable[links_editorials] CHANGE linkid pn_linkid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_editorials] CHANGE adminid pn_adminid varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_editorials] CHANGE editorialtimestamp pn_timestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_editorials] CHANGE editorialtext pn_text text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_editorials] CHANGE editorialtitle pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_editorials] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_linkid)");

$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE lid pn_lid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE cid pn_cat_id int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE description pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE date pn_date datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE name pn_name varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE email pn_email varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE hits pn_hits int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE submitter pn_submitter varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE linkratingsummary pn_ratingsummary double(6,4) DEFAULT '0.0000' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE totalvotes pn_totalvotes int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] CHANGE totalcomments pn_totalcomments int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_links] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_lid)");

$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE requestid pn_requestid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE lid pn_lid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE cid pn_cat_id int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE sid pn_sid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE description pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE modifysubmitter pn_modifysubmitter varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] CHANGE brokenlink pn_brokenlink tinyint(3) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_modrequest] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_requestid)");

$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE lid pn_lid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE cid pn_cat_id int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE description pn_description text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE name pn_name varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE email pn_email varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] CHANGE submitter pn_submitter varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_newlink] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_lid)");

$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE ratingdbid pn_id int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE ratinglid pn_lid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE ratinguser pn_user varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE rating pn_rating int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE ratinghostname pn_hostname varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE ratingcomments pn_comments text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] CHANGE ratingtimestamp pn_timestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[links_votedata] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");

$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE mid pn_mid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE title pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE content pn_content text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE date pn_date varchar(14) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE expire pn_expire mediumint(7) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE active pn_active tinyint(4) DEFAULT '1' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE view pn_view tinyint(1) DEFAULT '1' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] CHANGE mlanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[message] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_mid)");

$dbconn->Execute("CREATE TABLE $pntable[module_vars] (
  pn_id int(11) unsigned NOT NULL auto_increment,
  pn_modname varchar(64) NOT NULL default '',
  pn_name varchar(64) NOT NULL default '',
  pn_value longtext,
  PRIMARY KEY  (pn_id),
  KEY pn_modname (pn_modname),
  KEY pn_name (pn_name)
)");

$dbconn->Execute("DROP TABLE $pntable[modules]");

$dbconn->Execute("CREATE TABLE $pntable[modules] (
  pn_id int(11) unsigned NOT NULL auto_increment,
  pn_name varchar(64) NOT NULL default '',
  pn_type int(6) NOT NULL default '0',
  pn_displayname varchar(64) NOT NULL default '',
  pn_description varchar(255) NOT NULL default '',
  pn_regid int(11) unsigned NOT NULL default '0',
  pn_directory varchar(64) NOT NULL default '',
  pn_version varchar(10) NOT NULL default '0',
  pn_admin_capable tinyint(1) NOT NULL default '0',
  pn_user_capable tinyint(1) NOT NULL default '0',
  pn_state tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (pn_id)
)");


$dbconn->Execute("CREATE TABLE $pntable[nomoreblocks] (
  pn_modulo varchar(32) NOT NULL default '',
  pn_blocco varchar(32) NOT NULL default '',
  pn_identi varchar(32) NOT NULL default '',
  pn_pos varchar(4) NOT NULL default '',
  pn_peso decimal(10,1) NOT NULL default '1.0',
  PRIMARY KEY  (pn_blocco,pn_modulo)
)");

$dbconn->Execute("ALTER TABLE $pntable[poll_check] CHANGE ip pn_ip varchar(20) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_check] CHANGE time pn_time varchar(14) DEFAULT '' NOT NULL ");


$dbconn->Execute("ALTER TABLE $pntable[poll_data] CHANGE pollID pn_pollid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_data] CHANGE optionText pn_optiontext char(50) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_data] CHANGE optionCount pn_optioncount int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_data] CHANGE voteID pn_voteid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_data] ADD    pn_optioncolor varchar(7) NOT NULL default '#009900'");

$dbconn->Execute("ALTER TABLE $pntable[poll_desc] CHANGE pollid pn_pollid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] CHANGE pollTitle pn_title varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] CHANGE timestamp pn_timestamp int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] CHANGE voters pn_voters mediumint(9) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] CHANGE planguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] ADD     pn_votesystem char(3) NOT NULL default 'D'");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] ADD     pn_postfull tinyint(1) NOT NULL default '0'");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] ADD     pn_votetracking int(1) NOT NULL default '0'");
$dbconn->Execute("ALTER TABLE $pntable[poll_desc] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_pollid)");

$dbconn->Execute("CREATE TABLE $pntable[poll_voters] (
  pn_pollid int(11) NOT NULL default '0',
  pn_voteid int(11) NOT NULL default '0',
  pn_uid int(11) NOT NULL default '0',
  pn_timestamp int(11) NOT NULL default '0',
  KEY pn_pollid (pn_pollid),
  KEY pn_uid (pn_uid)
)");

$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE tid pn_tid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE pid pn_pid int(11) DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE pollid pn_pollid int(11) DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE date pn_date datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE name pn_name varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE email pn_email varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE url pn_url varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE host_name pn_host_name varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE subject pn_subject varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE comment pn_comment text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE score pn_score tinyint(4) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] CHANGE reason pn_reason tinyint(4) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[pollcomments] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_tid)");

$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE msg_id pn_msg_id int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE msg_image pn_msg_image varchar(100) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE subject pn_subject varchar(100) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE from_userid pn_from_userid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE to_userid pn_to_userid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE msg_time pn_msg_time varchar(20) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE msg_text pn_msg_text text");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] CHANGE read_msg pn_read_msg tinyint(4) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] DROP INDEX to_userid");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_msg_id)");
$dbconn->Execute("ALTER TABLE $pntable[priv_msgs] ADD KEY pn_to_userid (pn_to_userid)");

$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE qid pn_qid smallint(5) unsigned NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE uid pn_uid mediumint(9) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] ADD    pn_arcd tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE uname pn_uname varchar(40) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE subject pn_subject varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE story pn_story text");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE timestamp pn_timestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE topic pn_topic varchar(20) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE alanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[queue] CHANGE storyext pn_bodytext text");
$dbconn->Execute("ALTER TABLE $pntable[queue] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_qid)");

$dbconn->Execute("ALTER TABLE ".$prefix."_quotes CHANGE qid pn_qid int(11) unsigned NOT NULL  auto_increment");
$dbconn->Execute("ALTER TABLE ".$prefix."_quotes CHANGE quote pn_quote text");
$dbconn->Execute("ALTER TABLE ".$prefix."_quotes ADD    pn_author varchar(150) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE ".$prefix."_quotes DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_qid)");

$dbconn->Execute("CREATE TABLE $pntable[realms] (
  pn_rid int(11) NOT NULL auto_increment,
  pn_name varchar(255) NOT NULL default '',
  PRIMARY KEY  (pn_rid)
)");

$dbconn->Execute("ALTER TABLE $pntable[referer] CHANGE rid pn_rid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[referer] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[referer] ADD    pn_frequency int(15) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[referer] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_rid)");

$dbconn->Execute("ALTER TABLE $pntable[related] CHANGE rid pn_rid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[related] CHANGE tid pn_tid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[related] CHANGE name pn_name varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[related] CHANGE url pn_url varchar(200) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[related] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_rid)");

$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE id pn_id int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE date pn_date date DEFAULT '0000-00-00' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE title pn_title varchar(150) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE text pn_text text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE reviewer pn_reviewer varchar(20) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE email pn_email varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE score pn_score int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE cover pn_cover varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE url_title pn_url_title varchar(50) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE hits pn_hits int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] CHANGE rlanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");

$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE id pn_id int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE date pn_date date DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE title pn_title varchar(150) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE text pn_text text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE reviewer pn_reviewer varchar(20) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE email pn_email varchar(60) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE score pn_score int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE url_title pn_url_title varchar(50) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] CHANGE rlanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_add] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_id)");

$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] CHANGE cid pn_cid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] CHANGE rid pn_rid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] CHANGE userid pn_userid varchar(25) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] CHANGE date pn_date datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] CHANGE comments pn_comments text");
$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] CHANGE score pn_score int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[reviews_comments] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_cid)");

$dbconn->Execute("ALTER TABLE $pntable[reviews_main] CHANGE title pn_title varchar(100) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[reviews_main] CHANGE description pn_description text");

$dbconn->Execute("ALTER TABLE $pntable[seccont] CHANGE artid pn_artid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[seccont] CHANGE secid pn_secid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[seccont] CHANGE title pn_title text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[seccont] CHANGE content pn_content text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[seccont] CHANGE counter pn_counter int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[seccont] CHANGE slanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[seccont] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_artid)");

$dbconn->Execute("ALTER TABLE $pntable[sections] CHANGE secid pn_secid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[sections] CHANGE secname pn_secname varchar(40) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[sections] CHANGE image pn_image varchar(50) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[sections] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_secid)");

$dbconn->Execute("DROP TABLE $pntable[session_info]");

$dbconn->Execute("CREATE TABLE $pntable[session_info] (
  pn_sessid varchar(32) NOT NULL default '',
  pn_ipaddr varchar(20) NOT NULL default '',
  pn_firstused int(11) NOT NULL default '0',
  pn_lastused int(11) NOT NULL default '0',
  pn_uid int(11) NOT NULL default '0',
  pn_vars blob,
  PRIMARY KEY  (pn_sessid)
)");

// ==================================================
// STATS tables migrade
// =================================================
$dbconn->Execute("ALTER TABLE $pntable[stats_date] CHANGE date pn_date varchar(80) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stats_date] CHANGE hits pn_hits int(11) unsigned NOT NULL DEFAULT '0'");

$dbconn->Execute("ALTER TABLE $pntable[stats_hour] CHANGE hour pn_hour tinyint(2) unsigned DEFAULT '0' NOT NULL");
$dbconn->Execute("ALTER TABLE $pntable[stats_hour] CHANGE hits pn_hits int(11) unsigned NOT NULL DEFAULT '0' ");

$dbconn->Execute("ALTER TABLE $pntable[stats_month] CHANGE month pn_month tinyint(2) unsigned NOT NULL DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[stats_month] CHANGE hits pn_hits int(11) unsigned NOT NULL DEFAULT '0'");

$dbconn->Execute("ALTER TABLE $pntable[stats_week] CHANGE weekday pn_weekday tinyint(1) unsigned NOT NULL DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[stats_week] CHANGE hits pn_hits int(11) unsigned NOT NULL DEFAULT '0'");




$dbconn->Execute("CREATE TABLE $pntable[stats_week] (
  pn_weekday tinyint(1) unsigned NOT NULL default '0',
  pn_hits int(11) unsigned NOT NULL default '0'
)");

$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE sid pn_sid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE catid pn_catid int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE aid pn_aid varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE title pn_title varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE time pn_time datetime DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE hometext pn_hometext text");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE bodytext pn_bodytext text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE comments pn_comments int(11) DEFAULT '0'");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE counter pn_counter mediumint(8) unsigned NULL");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE topic pn_topic tinyint(3) DEFAULT '1' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE informant pn_informant varchar(20) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE notes pn_notes text NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE ihome pn_ihome tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE themeoverride pn_themeoverride varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE alanguage pn_language varchar(30) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE acomm pn_withcomm tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] CHANGE format_type pn_format_type tinyint(1) unsigned DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_sid)");
$dbconn->Execute("ALTER TABLE $pntable[stories] ADD  pn_format_type tinyint(1) unsigned NOT NULL default '0'");
$dbconn->Execute("ALTER TABLE $pntable[stories] ADD  pn_themeoverride varchar(30) NOT NULL default ''");

$dbconn->Execute("ALTER TABLE $pntable[stories_cat] CHANGE catid pn_catid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[stories_cat] CHANGE title pn_title varchar(40) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories_cat] CHANGE counter pn_counter int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[stories_cat] ADD  pn_themeoverride varchar(30) NOT NULL default ''");
$dbconn->Execute("ALTER TABLE $pntable[stories_cat] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_catid)");

$dbconn->Execute("CREATE TABLE $pntable[theme_config] (
  name varchar(20) NOT NULL default '',
  skin_id int(3) NOT NULL default '1',
  description varchar(60) NOT NULL default '',
  setting varchar(10) NOT NULL default '',
  data varchar(150) NOT NULL default '',
  KEY skin_id (skin_id)
)");

$dbconn->Execute("CREATE TABLE $pntable[theme_layout] (
  skin_id int(3) NOT NULL default '0',
  zone_label varchar(20) NOT NULL default '',
  tpl_file varchar(20) NOT NULL default '',
  KEY skin_id (skin_id)
)");

$dbconn->Execute("CREATE TABLE $pntable[theme_skins] (
  skin_id int(3) NOT NULL auto_increment,
  name varchar(60) NOT NULL default '',
  is_active int(1) NOT NULL default '0',
  is_multicolor int(1) NOT NULL default '0',
  bgcolor1 varchar(12) NOT NULL default '#FFFFFF',
  bgcolor2 varchar(12) NOT NULL default '#FFFFFF',
  bgcolor3 varchar(12) NOT NULL default '#FFFFFF',
  bgcolor4 varchar(12) NOT NULL default '#FFFFFF',
  bgcolor5 varchar(12) NOT NULL default '#FFFFFF',
  bgcolor6 varchar(12) NOT NULL default '#FFFFFF',
  sepcolor varchar(12) NOT NULL default '#000000',
  textcolor1 varchar(12) NOT NULL default '#000000',
  textcolor2 varchar(12) NOT NULL default '#000000',
  PRIMARY KEY  (skin_id)
)");

$dbconn->Execute("CREATE TABLE $pntable[theme_zones] (
  zone_id int(3) NOT NULL auto_increment,
  skin_id int(3) NOT NULL default '1',
  name varchar(40) NOT NULL default 'No Name',
  label varchar(20) NOT NULL default 'addon',
  type int(1) NOT NULL default '1',
  is_active int(1) NOT NULL default '0',
  PRIMARY KEY  (zone_id),
  KEY skin_id (skin_id)
)");

$dbconn->Execute("ALTER TABLE $pntable[topics] CHANGE topicid pn_topicid tinyint(3) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[topics] CHANGE topicname pn_topicname varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[topics] CHANGE topicimage pn_topicimage varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[topics] CHANGE topictext pn_topictext varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[topics] CHANGE counter pn_counter int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[topics] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_topicid)");
$dbconn->Execute("ALTER TABLE $pntable[topics] ADD    pn_language varchar(30) NOT NULL default ''");

$dbconn->Execute("CREATE TABLE $pntable[user_data] (
  pn_uda_id int(11) NOT NULL auto_increment,
  pn_uda_propid int(11) NOT NULL default '0',
  pn_uda_uid int(11) NOT NULL default '0',
  pn_uda_value mediumblob NOT NULL,
  PRIMARY KEY  (pn_uda_id)
)");

$dbconn->Execute("CREATE TABLE $pntable[user_perms] (
  pn_pid int(11) NOT NULL auto_increment,
  pn_uid int(11) NOT NULL default '0',
  pn_sequence int(6) NOT NULL default '0',
  pn_realm int(4) NOT NULL default '0',
  pn_component varchar(255) NOT NULL default '',
  pn_instance varchar(255) NOT NULL default '',
  pn_level int(4) NOT NULL default '0',
  pn_bond int(2) NOT NULL default '0',
  PRIMARY KEY  (pn_pid)
)");

$dbconn->Execute("CREATE TABLE $pntable[user_points] (
  uid int(11) NOT NULL default '0',
  uname varchar(25) NOT NULL default '',
  stories int(11) NOT NULL default '0',
  comments int(11) NOT NULL default '0',
  pollcomm int(11) NOT NULL default '0',
  downloads int(11) NOT NULL default '0',
  dloadvotes int(11) NOT NULL default '0',
  links int(11) NOT NULL default '0',
  linkvotes int(11) NOT NULL default '0',
  reviews int(11) NOT NULL default '0',
  reviewcomm int(11) NOT NULL default '0',
  posts int(11) NOT NULL default '0',
  points int(13) NOT NULL default '0',
  PRIMARY KEY  (uid)
)");

$dbconn->Execute("CREATE TABLE $pntable[user_property] (
  pn_prop_id int(11) NOT NULL auto_increment,
  pn_prop_label varchar(255) NOT NULL default '',
  pn_prop_dtype int(11) NOT NULL default '0',
  pn_prop_length int(11) NOT NULL default '255',
  pn_prop_weight int(11) NOT NULL default '0',
  pn_prop_validation varchar(255) default NULL,
  PRIMARY KEY  (pn_prop_id),
  UNIQUE KEY pn_prop_label (pn_prop_label)
)");

$dbconn->Execute("CREATE TABLE $pntable[userblocks] (
  pn_uid int(11) NOT NULL default '0',
  pn_bid int(11) NOT NULL default '0',
  pn_active tinyint(3) NOT NULL default '1',
  pn_last_update timestamp(14) NOT NULL
)");

$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE uid pn_uid int(11) NOT NULL auto_increment");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE name pn_name varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE uname pn_uname varchar(25) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE email pn_email varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE femail pn_femail varchar(60) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE url pn_url varchar(100) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_avatar pn_user_avatar varchar(30) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_regdate pn_user_regdate varchar(20) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_icq pn_user_icq varchar(15) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_occ pn_user_occ varchar(100) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_from pn_user_from varchar(100) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_intrest pn_user_intrest varchar(150) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_sig pn_user_sig varchar(255) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_viewemail pn_user_viewemail tinyint(2) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_theme pn_user_theme tinyint(3) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_aim pn_user_aim varchar(18) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_yim pn_user_yim varchar(25) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE user_msnm pn_user_msnm varchar(25) DEFAULT NULL");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE pass pn_pass varchar(40) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE storynum pn_storynum tinyint(4) DEFAULT '10' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE umode pn_umode varchar(10) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE uorder pn_uorder tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE thold pn_thold tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE noscore pn_noscore tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE bio pn_bio tinytext NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE ublockon pn_ublockon tinyint(1) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE ublock pn_ublock tinytext NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE theme pn_theme varchar(255) DEFAULT '' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE commentmax pn_commentmax int(11) DEFAULT '4096' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE counter pn_counter int(11) DEFAULT '0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] CHANGE timezone_offset pn_timezone_offset float(3,1) DEFAULT '0.0' NOT NULL ");
$dbconn->Execute("ALTER TABLE $pntable[users] DROP PRIMARY KEY, ADD PRIMARY KEY  (pn_uid)");
$dbconn->Execute("ALTER TABLE $pntable[users] ADD    pn_timezone_offset float(3,1) NOT NULL default '0.0'");
$dbconn->Execute("ALTER TABLE $pntable[users] ADD `pn_message` int(1) NOT NULL default '0'") or die ("error".$dbconn->ErrorMsg());

$dbconn->Execute("CREATE TABLE $pntable[users_delrequest] (
  pn_uid int(11) NOT NULL default '0',
  pn_name varchar(60) NOT NULL default '',
  pn_uname varchar(25) NOT NULL default '',
  pn_email varchar(60) NOT NULL default '',
  pn_pass varchar(40) NOT NULL default '',
  PRIMARY KEY  (pn_uid)
)");


/*=========================
//DROPS??
nuke_access
nuke_authors
nuke_banlist
nuke_bbtopics
nuke_catagories
nuke_config
nuke_contactbook
nuke_disallow
nuke_encyclopedia
nuke_encyclopedia_text
nuke_forum_access
nuke_forum_config
nuke_forum_mods
nuke_forums
nuke_forumtopics
nuke_journal
nuke_journal_comments
nuke_journal_stats
nuke_main
nuke_optimize_gain
nuke_pages
nuke_pages_categories
nuke_popsettings
nuke_posts
nuke_posts_text
nuke_public_messages
nuke_ranks
nuke_smiles
nuke_words


// migration tables
nuke_stats_date
nuke_stats_hour
nuke_stats_month
nuke_stats_year - no equiv

===============*/

?>