<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2004 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------

function atExtendedInit()
{
	return true;
}
	
function atThemeClose()
{    
    $runningconfig = atGetRunningConfig();

    if (!isset($runningconfig['extra'])) {
        return;
    }
    $extra = $runningconfig['extra'];

    foreach ($extra as $name) {
		if (isset($name['themepostprocess'])) {
			$themepostfuncs[] = $name['themepostprocess'];
		}
		if (isset($name['themeclose'])) {
            $func = $name['themeclose'];
            if (function_exists("$func")) {
            	$func($runningconfig);
            }
        }
    }
    if (isset($themepostfuncs)) {
    	atThemePostProcess($themepostfuncs);
    }
    /*if (atGetModStyle() == "new") {
    	ob_start();
    }*/
}

function atThemeAddHeader()
{
    $runningconfig = atGetRunningConfig();
    extract($runningconfig);

    extract($style);
    
    $head .= "\n<!--\n"
    ."******************************************************************\n"
    ."***** AutoTheme - AT-Lite .81 (http://spidean.mckenzies.net) *****\n"
    ."********** for MaxDev - MD-Pro (http://www.maxdev.com) ***********\n"
    ."************************** Header part ***************************\n"
    ."******************************************************************\n"
    ."-->\n\n";
    
    $head .= "\n<link rel=\"stylesheet\" href=\"".$atdir."style/style.css\" type=\"text/css\">\n";

    if (isset($stylesheet)) {
        if (@file_exists($themepath.$stylesheet) && !@is_dir($themepath.$stylesheet)) {
            $head .= "<link rel=\"stylesheet\" href=\"".$themepath.$stylesheet."\" type=\"text/css\">\n";
        }
    }
    if ($striphead) {
		$head .= "</head>\n\n";
	}
	echo $head;
}

function atThemeAddFooter()
{
    $runningconfig = atGetRunningConfig();
    extract($runningconfig);

    $footer = "\n<!--\n"
    ."******************************************************************\n"
    ."***** AutoTheme - AT-Lite .81 (http://spidean.mckenzies.net) *****\n"
    ."********** for MaxDev - MD-Pro (http://www.maxdev.com) ***********\n"
    ."************************** Footer part ***************************\n"
    ."******************************************************************\n"
    ."-->\n";

	echo $footer;
}

?>
