<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2004 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------

function atPlatformThemeInit()
{
    $GLOBALS['postnuke_theme'] = true;

    return array();
}

function atPlatformAPIInit()
{
    return array();
}

function atGetPlatformVersion()
{
    return pnConfigGetVar('version_num');
}

function atGetHomeMod()
{
    return pnConfigGetVar('startpage');
}

function atIsHomePage()
{
    if (eregi("index.php", $_SERVER['PHP_SELF']) && !isset($_GET['module']) && !isset($_GET['name'])) {
        return true;
    }
    else {
        return false;
    }
}

function atIsAdminUser()
{
    if (pnSecAuthAction(0, '::', '::', ACCESS_ADMIN)) {
        return true;
    }
    else {
        return false;
    }
}

function atIsLoggedIn()
{
    if (pnUserLoggedIn()) {
        return true;
    }
    else {
        return false;
    }
}

function atGetUserName()
{
    if (!atIsLoggedIn()) {
        if (defined('_AT_GUEST')) {
            $username = _AT_GUEST;
        }
        else {
            $username = "";
        }
    }
    else {
        $username = pnUserGetVar('uname');
    }
    return $username;
}

function atGetModType()
{
    $type = "";
    
    if (eregi("admin.php", $_SERVER['PHP_SELF'])) {
        $type = "admin";
    }
    elseif (eregi("index.php", $_SERVER['PHP_SELF']) && isset($_GET['type'])) {
        $type = $_GET['type'];
    }
    elseif (eregi("user.php", $_SERVER['PHP_SELF'])) {
        $type = "user";
    }
    return $type;
}

function atGetModStyle()
{
    $modname = atGetModName();
    $modinfo = pnModGetInfo(pnModGetIDFromName($modname));
    $modtype = atGetModType();
// This is not enough. Admin-part of News is newstyle, User-part is old-style. WindMeUp 2004/10/06 
//    if ($modinfo['type'] == 2 && $modname != "News" && $modtype != "user") {
    if ( ($modinfo['type'] == 2 && ($modname == "News" && $modtype == "admin") && $modtype != "user") ||
	     ($modinfo['type'] == 2 && $modname != "News" && $modtype != "user") ) {
        $style = "new";
    } else {
        $style = "old";
    }
    return $style;
}

function atGetModName()
{
    return pnModGetName();
}

function atGetLang()
{
    return pnUserGetLang();
}

function atBlockLoad($location="", $title="")
{
	global $pnconfig;
	$dbtype = $pnconfig['dbtype'];

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $column = &$pntable['blocks_column'];
    $modcol = &$pntable['modules_column'];

    if (pnConfigGetVar('multilingual')) {
        $querylang = "AND ($column[language]='".pnVarPrepForStore(atGetLang())."' OR $column[language]='' OR $column[language] IS NULL)";
    }
    else {
        $querylang = "";
    }
    if ($location) {
   		switch ($dbtype){
			case "oci8":
		        $result = $dbconn->Execute("
		        	SELECT
		        			$column[bid] as bid,
							$column[bkey] as bkey,
							$column[mid] as mid,
							$column[title] as title,
							$column[content] as content,
							$column[url] as url,
							$column[position] as position,
							$column[weight] as weight,
							$column[active] as active,
							$column[refresh] as refresh,
							$column[last_update] AS unix_update,
							$column[language] as language,
							$modcol[name] as modname
					FROM	$pntable[blocks], $pntable[modules]
					WHERE   $modcol[id] = $column[mid] AND
							$column[position]='".pnVarPrepForStore($location)."' AND $column[active]=1 $querylang
					ORDER BY $column[weight]");			
				break;
			default:
		        $result = $dbconn->Execute("
		        	SELECT
		        			$column[bid] as bid,
							$column[bkey] as bkey,
							$column[mid] as mid,
							$column[title] as title,
							$column[content] as content,
							$column[url] as url,
							$column[position] as position,
							$column[weight] as weight,
							$column[active] as active,
							$column[refresh] as refresh,
							$column[last_update] AS unix_update,
							$column[language] as language,
							$modcol[name] as modname
					FROM	$pntable[blocks]
					LEFT JOIN $pntable[modules] ON $modcol[id] = $column[mid]
					WHERE	$column[position]='".pnVarPrepForStore($location)."' AND $column[active]=1 $querylang
					ORDER BY $column[weight]");
				break;
		}
    }
    elseif ($title) {
   		switch ($dbtype){
			case "oci8":
		        $result = $dbconn->Execute("
		        	SELECT
		        			$column[bid] as bid,
							$column[bkey] as bkey,
							$column[mid] as mid,
							$column[title] as title,
							$column[content] as content,
							$column[url] as url,
							$column[position] as position,
							$column[weight] as weight,
							$column[active] as active,
							$column[refresh] as refresh,
							$column[last_update] AS unix_update,
							$column[language] as language,
							$modcol[name] as modname
					FROM	$pntable[blocks], $pntable[modules]
					WHERE   $modcol[id] = $column[mid] AND
							$column[title]='".pnVarPrepForStore($title)."' AND $column[active]=1 $querylang");
				break;
			default:
		        $result = $dbconn->Execute("
		        	SELECT
		        			$column[bid] as bid,
							$column[bkey] as bkey,
							$column[mid] as mid,
							$column[title] as title,
							$column[content] as content,
							$column[url] as url,
							$column[position] as position,
							$column[weight] as weight,
							$column[active] as active,
							$column[refresh] as refresh,
							$column[last_update] AS unix_update,
							$column[language] as language,
							$modcol[name] as modname
					FROM	$pntable[blocks]
					LEFT JOIN $pntable[modules] ON $modcol[id] = $column[mid]
					WHERE	$column[title]='".pnVarPrepForStore($title)."' AND $column[active]=1 $querylang");
				break;
			}
    }
    while (!$result->EOF) {
        $block = $result->GetRowAssoc(false);
        $block['unix_update'] = $result->UnixTimeStamp($block['unix_update']);

        if (!$block['modname']) {
            $block['modname'] = "Core";
        }
        echo pnBlockShow($block['modname'], $block['bkey'], $block);

        $result->MoveNext();
    }
}

function atBlockList()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $blockstable = $pntable['blocks'];
    $blockscolumn = &$pntable['blocks_column'];

    $sql = "SELECT $blockscolumn[title] FROM $blockstable ORDER BY $blockscolumn[title]";
    $result = $dbconn->Execute($sql);

    while (list($title) = $result->fields) {
        $blocklist[] = $title;
        $result->MoveNext();
    }
    return $blocklist;
}

?>
