<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Domenico Pasquini
// Purpose of file: Display banners in a block
// ----------------------------------------------------------------------

$blocks_modules['bannermodules'] = array(
    'func_display' => 'blocks_bannermodules_block',
    'text_type' => 'BannerModules',
    'text_type_long' => 'Banner in a Block',
    'allow_multiple' => false,
    'form_content' => false,
    'form_refresh' => false,
//  'xhtml_support' => false,
    'show_preview' => true
);

// Security
pnSecAddSchema('BannerModulesblock::', 'Block title::');

function blocks_bannermodules_block($row) {

    if (!pnSecAuthAction(0, 'BannerModulesblock::', "$row[title]::", ACCESS_READ)) {
        return;
    }
    // test on config settings
    if (pnConfigGetVar('banners') == 0) return;
    list($dbconn) = pnDBGetConn();

    $pntable = pnDBGetTables();
    if (pnConfigGetVar('banners') != 2) {
      $bresult = $dbconn->Execute("SELECT count(*) AS count FROM $pntable[banner] WHERE pn_type='1'");
    } else {
      $mymodname=$GLOBALS['name'];
      $bresult = $dbconn->Execute("SELECT count(*) AS count FROM $pntable[banner] WHERE (pn_type='1' AND pn_module='$mymodname') OR (pn_type='1' AND pn_module='ALL')");
    }
    list($numrows) = $bresult->fields;
    // we no longer need this, free the resources
    $bresult->Close();

    /* Get a random banner if exist any. */
    /* More efficient random stuff, thanks to Cristian Arroyo from http://www.planetalinux.com.ar */

    if ($numrows>1) {
        $numrows = $numrows-1;
        mt_srand((double)microtime()*1000000);
        $bannum = mt_rand(0, $numrows);
    } else {
        $bannum = 0;
    }

    $column = &$pntable['banner_column'];
    if (pnConfigGetVar('banners') != 2) {
       $bresult2 = $dbconn->Execute("SELECT pn_bid, pn_imageurl, pn_width, pn_height FROM $pntable[banner] WHERE pn_type='1' LIMIT $bannum,1");
    } else {
       $bresult2 = $dbconn->Execute("SELECT pn_bid, pn_imageurl, pn_width, pn_height  FROM $pntable[banner] WHERE (pn_type='1' AND pn_module='$mymodname') OR (pn_type='1' AND pn_module='ALL') LIMIT $bannum,1");
    }
    list($bid, $imageurl, $width, $height) = $bresult2->fields;
    // we no longer need this, free the resources
    $bresult2->Close();

    $myIP = pnConfigGetVar('myIP');

    $myhost = getenv("REMOTE_ADDR");

    if ($myIP == $myhost) {
        // do nothing
    } else {
        $dbconn->Execute("UPDATE $pntable[banner]
                        SET $column[impmade]=$column[impmade]+1
                        WHERE $column[bid]=".pnVarPrepForStore($bid)."");
    }

    if ($numrows > 0) {
        $aborrar = $dbconn->Execute("SELECT $column[cid],$column[imptotal],
                                          $column[impmade], $column[clicks],
                                          $column[date]
                                   FROM $pntable[banner]
                                   WHERE $column[bid]=".pnVarPrepForStore($bid)."");
        list($cid, $imptotal, $impmade, $clicks, $date) = $aborrar->fields;
        $aborrar->Close();

        /* Check if this impression is the last one and print the banner */
        if ($imptotal == $impmade) {

            $dbconn->Execute("DELETE FROM $pntable[banner] WHERE $column[bid]=".pnVarPrepForStore($bid)."");
            $column = &$pntable['bannerfinish_column'];
            $dbconn->Execute("INSERT INTO $pntable[bannerfinish]
                            ( $column[bid], $column[cid], $column[impressions], $column[clicks], $column[datestart], $column[dateend] )
                            VALUES (NULL, '".pnVarPrepForStore($cid)."', '".pnVarPrepForStore($impmade)."', '".pnVarPrepForStore($clicks)."', '".pnVarPrepForStore($date)."', now())");
        }

        $row['content']="<CENTER><a href=\"banners.php?op=click&amp;bid=$bid\" target=\"_blank\"><br>";

        if (strpos($imageurl,"swf")==TRUE) {
            $row['content'] .= "<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\"\n";
            $row['content'] .= "codebase=\"http://active.macromedia.com/flash4/cabs/swflash.cab#version=4,0,0,0\"\n";
            $row['content'] .= "id=\"bannerflash\" width=\"$width\" height=\"$height\">\n";
            $row['content'] .= " <param name=\"movie\" value=\"$imageurl\">\n";
            $row['content'] .= " <param name=\"quality\" value=\"high\">\n";
            $row['content'] .= " <param name=\"bgcolor\" value=\"#FFFFFF\">\n";
            $row['content'] .= " <embed name=\"bannerflash\" src=\"$imageurl\" quality=\"high\" bgcolor=\"#FFFFFF\"\n";
            $row['content'] .= "   width=\"$width\" height=\"$height\"\n";
            $row['content'] .= "   type=\"application/x-shockwave-flash\"\n";
            $row['content'] .= "   pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\">\n";
            $row['content'] .= " </embed>\n";
            $row['content'] .= "</object>\n";
            $row['content'] .= "</a></center>";
        } elseif (strpos($imageurl,"htm")==TRUE) {
            $thefile = fopen("$imageurl", "r");
            $row['content'] .= fread($thefile, filesize("$imageurl"));
            fclose($thefile);
        } else {
            $row['content'] .= "<img src=\"$imageurl\" border=\"1\" alt=\""._CLICK."\"></a></center>";

        }
    }
    return themesideblock($row);
}
?>
