<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: WindMeUp
// Original Author of file: Domenico Pasquini
// Purpose of file: Display banners in a block
// last modified: WindMeUp now a specific module, topic and/or language
//                         can be selected for a banner to be shown.
//                WindMeUp included Flash and HTML-banner support from
//                         Domenico Pasquini (www.vivituscia.com)
// ----------------------------------------------------------------------

$blocks_modules['banners'] = array(
    'func_display'     => 'blocks_banner_block',
    'func_add'         => 'blocks_banner_add',
    'func_update'      => 'blocks_banner_update',
    'func_edit'        => 'blocks_banner_edit',
    'text_type'        => 'banners',
    'text_type_long'   => 'Custom Banner Display',
    'allow_create'     => false,
    'allow_multiple'   => true,
    'allow_delete'     => false,
    'form_content'     => false,
    'form_refresh'     => false,
    'show_preview'     => true
);
// Security
pnSecAddSchema("BannerModulesBlock::", "Block title::");

function blocks_banner_block($row) {

    global $info, $artid, $secid;

    if (!pnSecAuthAction(0, 'BannerModulesBlock::', "$row[title]::", ACCESS_READ)) {
        return;
    }
    // test on config settings
    if (pnConfigGetVar('banners') == 0) return;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the name of the module
    //$qymodule = pnModGetName();
        $qymodule = $GLOBALS['name'];
    // if the module is a News or a Section we need to know the id
    switch($qymodule) {
        case "News":
            $qymodid = $info['tid'];
            $qymodule = 'Topics';
            if (!isset($qymodid)) $qymodid = 0;
            break;

        case "Sections":
            // Articles only propagate their own id and not the id of the section they belong to.
            // To solve that we need to ask the database for a section id
            if ((!isset($secid)) || ($secid == 0)) {
              $bannertable = $pntable['seccont'];
              $bannercolumn = &$pntable['seccont_column'];
              $sql = "SELECT $bannercolumn[secid]
                FROM $bannertable
                WHERE $bannercolumn[artid] = '" . $artid."'";
              //echo $sql."-----<br>";
              $bresult = $dbconn->Execute($sql);
              list($secid) = $bresult->fields;
            }
            $qymodid = $secid;
            if (!isset($qymodid)) $qymodid = 0;
            break;
        default:
            $qymodid = 0;
    }

    // Get the language
    $qylang = pnUserGetLang();

    $bannertable = $pntable['banner'];
    $bannercolumn = &$pntable['banner_column'];

    // First we search for language and module. If no banner exist search for module.
    // If no results then we search for a generic one (language=* and module=*)
    // At least there should be one generic banner

    // Get items
    // we need to do 4 iterations to check all possible conditions
    // 1.- Select module and module_id if false module_id = all
    // 2.- Search for module and module_id = all if no results then module = all
    // 3.- check for a specific language if no results then language = all
    // 4.- Now the query must give us the right result

    for ($i=1; $i<=4; $i++) {
        $sql = "SELECT $bannercolumn[bid]
                FROM $bannertable
                WHERE $bannercolumn[module] = '" . $qymodule."'
                AND $bannercolumn[moduleid] = '".$qymodid."' ";
        if ($i > 2) {
            $sql .= "AND $bannercolumn[lang] = '".$qylang."' ";
        }
                if ($i > 3) {
            if (pnConfigGetVar('banners') != 2) {
                    $sql .= "AND $bannercolumn[type] = '1' ";
                        } else {
                    $sql .= "AND ($bannercolumn[type] = '1' AND $bannercolumn[module]='$qymodule') OR ($bannercolumn[type] = '1' AND $bannercolumn[module]='ALL')";
                        }
                }
        //echo $sql."-----<br>";
        $bresult = $dbconn->Execute($sql);

        // Check for an error with the database code
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }

        // looking for no rows, and if so return
        if ($bresult->EOF) {
           switch ($i) {
               case 1:
                  $qymodid = 0;
                  break;
               case 2:
                  $qymodule = '*';
                  break;
               case 3:
                  $qylang = '*';
                  break;
               case 4:
                  //echo $sql;
                  //return false;
                  break;
           }
        }
    }
    //echo $sql."-----<br>";
    $numrows = $bresult->RecordCount();

    // in $bidarray we get an array of banners than can be shown in this page.
    // The random variable $bannum will tell us which will be the choosen one
    while (!$bresult->EOF){
        $bidarray[] = $bresult->fields[0];
        $bresult->MoveNext();
    }
        $bresult->close();

    /* Get a random banner if exist any. */
    /* More efficient random stuff, thanks to Cristian Arroyo from http://www.planetalinux.com.ar */

    if ($numrows>1) {
        $numrows = $numrows-1;
        mt_srand((double)microtime()*1000000);
        $bannum = mt_rand(0, $numrows);
    } else {
        $bannum = 0;
    }

// neu
    $column = &$pntable['banner_column'];
     if (pnConfigGetVar('banners') != 2) {
        $bresult2 = $dbconn->Execute("SELECT pn_bid, pn_imageurl, pn_width, pn_height
                                                                          FROM $pntable[banner]
                                                                          WHERE pn_type='1'
                                                                          AND pn_bid = '" . $bidarray[$bannum]."'");
     } else {
        $bresult2 = $dbconn->Execute("SELECT pn_bid, pn_imageurl, pn_width, pn_height
                                                                          FROM $pntable[banner]
                                                                          WHERE (pn_type='1' AND pn_module='$qymodule') OR (pn_type='1' AND pn_module='ALL')
                                                                          AND pn_bid = '" . $bidarray[$bannum]."'");
     }
    list($bid, $imageurl, $width, $height) = $bresult2->fields;
// Ende neu


/*********************************************************** alt
    $sql = "SELECT $bannercolumn[bid],
                   $bannercolumn[imageurl]
                FROM $bannertable
                WHERE $bannercolumn[bid] = '" . $bidarray[$bannum]."'";

    //$query = buildSimpleQuery ('banner', array ('bid', 'imageurl'), '', '', 1, $result->fields[$bannum]);
    //echo $sql."--$bannum--------<br>";
    $bresult2 = $dbconn->Execute($sql);
    list($bid, $imageurl) = $bresult2->fields;
****************************************************************/


    // we no longer need this, free the resources
    $bresult2->Close();
//    $bresult->Close();

    $myIP = pnConfigGetVar('myIP');

    $myhost = getenv("REMOTE_ADDR");

    if ($myIP == $myhost) {
        // do nothing
    } else {
        $dbconn->Execute("UPDATE $pntable[banner]
                        SET $column[impmade]=$column[impmade]+1
                        WHERE $column[bid]=".pnVarPrepForStore($bid)."");
    }

    if ($numrows > 0) {
        $aborrar = $dbconn->Execute("SELECT $column[cid],$column[imptotal],
                                          $column[impmade], $column[clicks],
                                          $column[date]
                                   FROM $pntable[banner]
                                   WHERE $column[bid]=".pnVarPrepForStore($bid)."");
        list($cid, $imptotal, $impmade, $clicks, $date) = $aborrar->fields;
        $aborrar->Close();

        /* Check if this impression is the last one and print the banner */
        if ($imptotal == $impmade) {
            $dbconn->Execute("DELETE FROM $pntable[banner] WHERE $column[bid]=".pnVarPrepForStore($bid)."");
            $column = &$pntable['bannerfinish_column'];
            $dbconn->Execute("INSERT INTO $pntable[bannerfinish]
                            ( $column[bid], $column[cid], $column[impressions], $column[clicks], $column[datestart], $column[dateend] )
                            VALUES (NULL, '".pnVarPrepForStore($cid)."', '".pnVarPrepForStore($impmade)."', '".pnVarPrepForStore($clicks)."', '".pnVarPrepForStore($date)."', now())");
        }

        $row['content']="<CENTER><a href=\"banners.php?op=click&amp;bid=$bid\" target=\"_blank\"><br>";

        if (strpos($imageurl,"swf")==TRUE) {
            $row['content'] .= "<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\"\n";
            $row['content'] .= "codebase=\"http://active.macromedia.com/flash4/cabs/swflash.cab#version=4,0,0,0\"\n";
            $row['content'] .= "id=\"bannerflash\" width=\"$width\" height=\"$height\">\n";
            $row['content'] .= " <param name=\"movie\" value=\"$imageurl\">\n";
            $row['content'] .= " <param name=\"quality\" value=\"high\">\n";
            $row['content'] .= " <param name=\"bgcolor\" value=\"#FFFFFF\">\n";
            $row['content'] .= " <embed name=\"bannerflash\" src=\"$imageurl\" quality=\"high\" bgcolor=\"#FFFFFF\"\n";
            $row['content'] .= "   width=\"$width\" height=\"$height\"\n";
            $row['content'] .= "   type=\"application/x-shockwave-flash\"\n";
            $row['content'] .= "   pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\">\n";
            $row['content'] .= " </embed>\n";
            $row['content'] .= "</object>\n";
            $row['content'] .= "</a></center>";
        } elseif (strpos($imageurl,"htm")==TRUE) {
            $thefile = fopen("$imageurl", "r");
            $row['content'] .= fread($thefile, filesize("$imageurl"));
            fclose($thefile);
        } else {
            $row['content'] .= "<img src=\"$imageurl\" border=\"1\" alt=\""._CLICK."\"></a></center>";
        }
    }
    return themesideblock($row);
}
?>
