<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file: Display menu, with lots of options
// ----------------------------------------------------------------------

$blocks_modules['menu'] = array(
    'func_display' => 'blocks_menu_block',
    'func_edit' => 'blocks_menu_select',
    'func_update' => 'blocks_menu_update',
    'text_type' => 'Menu',
    'text_type_long' => 'Generic menu',
    'allow_multiple' => true,
    'form_content' => false,
    'form_refresh' => false,
//  'support_xhtml' => true,
    'show_preview' => true
);

pnSecAddSchema('Menublock::', 'Block title:Link name:');

function blocks_menu_block($row)
{
        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Generic check
    if (!pnSecAuthAction(0, 'Menublock::', "$row[title]::", ACCESS_READ)) {
        return;
    }

    // Break out options from our content field
    $vars = pnBlockVarsFromContent($row['content']);

    // Display style
    // dstyle = 1 - simple list
    // dstyle = 2 - drop-down list

    // Title
    $block['title'] = $row['title'];

    // Styling
    if (empty($vars['dstyle'])) {
        $vars['dstyle'] = 1;
    }
    $block['content'] = startMenuStyle($vars['dstyle']);

    $content = 0;

    // nkame: must start with some blank line, otherwise we're not able to
    // chose the first option in case of a drop-down menu.
    // a better solution would be to detect where we are, and adjust the selected
    // option in the list, and only add a blank line in case of no recognition.
    if($vars['dstyle'] == 2)
        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "", "", "");

    // Content
    if (!empty($vars['content'])) {
        $contentlines = explode("LINESPLIT", $vars['content']);
        foreach ($contentlines as $contentline) {
            list($url, $title, $comment) = explode('|', $contentline);
            if (pnSecAuthAction(0, "Menublock::", "$row[title]:$title:", ACCESS_READ)) {
                $block['content'] .= addMenuStyledUrl($vars['dstyle'], pnVarPrepForDisplay($title), $url, pnVarPrepForDisplay($comment));
                $content = 1;
            }
        }
    }

    // Modules
    if (!empty($vars['displaymodules'])) {
        $mods = pnModGetUserMods();

        // Separate from current content, if any
        if ($content == 1) {
            $block['content'] .= addMenuStyledUrl($vars['dstyle'], "", "", "");
        }

        foreach($mods as $mod) {
// jgm - need to work back ML into modules table somehow
//            if (file_exists("modules/$mod/modname.php")) {
//                include "modules/$mod/modname.php";
//            } else {

            if (pnSecAuthAction(0, "$mod[name]::", "::", ACCESS_OVERVIEW)) {
                if (pnSecAuthAction(0, "Menublock::", "$row[title]:$mod[name]:", ACCESS_READ)) {
                switch($mod['type']) {
                    case 1:
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], pnVarPrepForDisplay($mod['displayname']), "modules.php?op=modload&amp;name=" . pnVarPrepForDisplay($mod['directory']) . "&amp;file=index", pnVarPrepForDisplay($mod['description']));
                        $content = 1;
                        break;
                    case 2:
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'],
                                                              pnVarPrepForDisplay($mod['displayname']),
                                                              pnModURL($mod['name'],
                                                                       'user',
                                                                       'main'),
                                                              pnVarPrepForDisplay($mod['description']));
                        $content = 1;
                        break;
                                        }
                }

            }
        }

    }

    // Waiting content
    if (!empty($vars['displaywaiting'])) {
        // Separate from current content, if any
        if ($content == 1) {
            $block['content'] .= addMenuStyledUrl($vars['dstyle'], "", "", "");
        }


        $header = 0;
        if (pnSecAuthAction(0, "AddStory::", "::", ACCESS_ADD)) {
            $result = $dbconn->Execute("SELECT count(1) FROM $pntable[queue]
                                      WHERE {$pntable['queue_column']['arcd']}=0");
            if ($dbconn->ErrorNo() == 0) {
                list($qnum) = $result->fields;
                $result->Close();
                if ($qnum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], _SUBMISSIONS.": $qnum", "admin.php?module=NS-AddStory&amp;op=submissions", "");
                    $content = 1;
                }
            }
        }

        if (pnSecAuthAction(0, "Reviews::", "::", ACCESS_ADD)) {
            $result = $dbconn->Execute("SELECT count(1) FROM $pntable[reviews_add]");
            if ($dbconn->ErrorNo() == 0) {
                list($rnum) = $result->fields;
                $result->Close();
                if ($rnum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], _WREVIEWS.": $rnum", "admin.php?module=Reviews&amp;op=main", "");
                    $content = 1;
                }
            }
        }

        if (pnSecAuthAction(0, "Web_Links::Link", "::", ACCESS_ADD)) {
            $result = $dbconn->Execute("SELECT count(1) FROM $pntable[links_newlink]");
            if ($dbconn->ErrorNo() == 0) {
                list($lnum) = $result->fields;
                $result->Close();
                if ($lnum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], _WLINKS.": $lnum", "admin.php?module=Web_Links&amp;op=main", "");
                    $content = 1;
                }
            }
        }

        if (pnSecAuthAction(0, "Downloads::Item", "::", ACCESS_ADD)) {
            $result = $dbconn->Execute("SELECT count(1) FROM $pntable[downloads_newdownload]");
            if ($dbconn->ErrorNo() == 0) {
                list($dnum) = $result->fields;
                $result->Close();
                if ($dnum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], _WDOWNLOADS.": $dnum", "admin.php?module=Downloads&amp;op=main", "");
                    $content = 1;
                }
            }
        }

        if (pnSecAuthAction(0, "FAQ::", "::", ACCESS_ADD)) {
            $faqcolumn = &$pntable['faqanswer_column'];
// modified for Oracle compatibility
//                        $result = $dbconn->Execute("SELECT count(1) FROM $pntable[faqanswer] WHERE $faqcolumn[answer]='' OR $faqcolumn[answer] IS NULL");

                    if (strcmp($dbtype,'oci8')== 0) {
                                $query="SELECT count(1) FROM $pntable[faqanswer] WHERE DBMS_LOB.getlength($faqcolumn[answer]) = 0";
                        }else{
                                $query="SELECT count(1) FROM $pntable[faqanswer] WHERE $faqcolumn[answer]='' OR $faqcolumn[answer] IS NULL";
                        }
                        $result = $dbconn->Execute($query);

            if ($dbconn->ErrorNo() == 0) {
                list($fnum) = $result->fields;
                $result->Close();
                if ($fnum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], _FQUESTIONS.": $fnum", "admin.php?module=FAQ&amp;op=FaqCatUnanswered", "");
                    $content = 1;
                }
            }
        }

                /*Added by Chestnut !*/
        if (pnSecAuthAction(0, "Users::", "::", ACCESS_DELETE)) {
            $udelcolumn = &$pntable['users_modrequest_column'];
            $result = $dbconn->Execute("SELECT count(1) FROM $pntable[users_modrequest] WHERE $udelcolumn[udel]='1'");
            if ($dbconn->ErrorNo() == 0) {
                list($unum) = $result->fields;
                $result->Close();
                if ($unum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], ""._UADELREQUEST." : $unum", "admin.php?module=NS-User&op=ListDelRequest", "");
                    $content = 1;
                }
            }
        }

        if (pnSecAuthAction(0, "Users::", "::", ACCESS_ADD)) {
            $uaddcolumn = &$pntable['users_modrequest_column'];
            $result = $dbconn->Execute("SELECT count(1) FROM $pntable[users_modrequest] WHERE $udelcolumn[uadd]='1'");
            if ($dbconn->ErrorNo() == 0) {
                list($unum) = $result->fields;
                $result->Close();
                if ($unum) {
                    if ($header == 0) {
                        $block['content'] .= addMenuStyledUrl($vars['dstyle'], "<strong>" . _WAITINGCONT. "</strong>", "", "");
                        $header = 1;
                    }
                    $block['content'] .= addMenuStyledUrl($vars['dstyle'], ""._UAADDREQUEST." : $unum", "admin.php?module=NS-User&amp;op=ListUAddRequest", "");
                    $content = 1;
                }
            }
        }
        /*End*/
    }

    // Styling
    $block['content'] .= endMenuStyle($vars['dstyle']);

    if ($content) {
        $row['title'] = $block['title'];
        $row['content'] = $block['content'];
        return themesideblock($row);
    }
}


function blocks_menu_select($row)
{
    global $pntheme;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Break out options from our content field
    $vars = pnBlockVarsFromContent($row['content']);
    $row['content'] = "";

    // Defaults
    if (empty($vars['dstyle'])) {
        $vars['dstyle'] = 1;
    }

    // What style of menu
    $output = '<tr><td class="pn-title">'._MENU_FORMAT.'</td><td></td></tr>';

    $output .= '<tr><td class="pn-normal">'._MENU_AS_LIST.':</td><td><input type="radio" name="dstyle" value="1"';
    if ($vars['dstyle'] == 1) {
        $output .= ' checked';
    }
    $output .= ' /></td></tr><tr><td class="pn-normal">'._MENU_AS_DROPDOWN.':</td><td><input type="radio" name="dstyle" value="2"';
    if ($vars['dstyle'] == 2) {
        $output .= ' checked';
    }
    $output .= ' /></td></tr>';

    // What to display
    $output .= '<tr><td class="pn-title">'._DISPLAY.'</td><td></td></tr>';

    $output .= '<tr><td class="pn-normal">'._MENU_MODULES.':</td><td><input type="checkbox" value="1" name="displaymodules"';
    if (!empty($vars['displaymodules'])) {
        $output .= ' checked';
    }

    $output .= ' /></td></tr><tr><td class="pn-normal">'._WAITINGCONT.':</td><td><input type="checkbox" value="1" name="displaywaiting"';
    if (!empty($vars['displaywaiting'])) {
        $output .= ' checked';
    }
    $output .= ' /></td></tr>';

    // Content
    $c=1;
    $output .= "</table><table>";
    $output .= "<tr><td valign=\"top\" class=\"pn-title\">"._MENU_CONTENT
    .":</td><td><table border=\"1\"><tr><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><strong>"
    ._TITLE."</strong></td><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><strong>"
    ._URL."</strong></td><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><b>"
    ._MENU_DESCRIPTION."&nbsp;</strong><span class=\"pn-sub\"><strong>("._OPTIONAL.")</strong></span></td><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><strong>"
    ._DELETE."</strong></td><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><strong>"._INSERT_BLANK_AFTER."</strong></td></tr>";
    if (!empty($vars['content'])) {
        $contentlines = explode("LINESPLIT", $vars['content']);
        foreach ($contentlines as $contentline) {
            $link = explode('|', $contentline);
            $output .= "<tr><td valign=\"top\"><input type=\"text\" name=\"linkname[$c]\" size=\"30\" maxlength=\"255\" value=\"" . pnVarPrepForDisplay($link[1]) . "\" class=\"pn-normal\" /></td><td valign=\"top\"><input type=\"text\" name=\"linkurl[$c]\" size=\"30\" maxlength=\"255\" value=\"" . pnVarPrepForDisplay($link[0]) . "\" class=\"pn-normal\"></td><td valign=\"top\"><input type=\"text\" name=\"linkdesc[$c]\" size=\"30\" maxlength=\"255\" value=\"" . pnVarPrepForDisplay($link[2]) . "\" class=\"pn-normal\" /></td><td valign=\"top\"><input type=\"checkbox\" name=\"linkdelete[$c]\" value=\"1\" class=\"pn-normal\" /></td><td valign=\"top\"><input type=\"checkbox\" name=\"linkinsert[$c]\" value=\"1\" class=\"pn-normal\" /></td></tr>\n";
            $c++;
        }
    }

    $output .= "<tr><td><input type=\"text\" name=\"new_linkname\" size=\"30\" maxlength=\"255\" class=\"pn-normal\" /></td><td><input type=\"text\" name=\"new_linkurl\" size=\"30\" maxlength=\"255\" class=\"pn-normal\" /></td><td class=\"pn-normal\"><input type=\"text\" name=\"new_linkdesc\" size=\"30\" maxlength=\"255\" class=\"pn-normal\" /></td><td class=\"pn-normal\">"._NEWONE."</td><td class=\"pn-normal\"><input type=\"checkbox\" name=\"new_linkinsert\" value=\"1\" class=\"pn-normal\" /></td></tr>\n";
    $output .= '</table></td></tr>';

    return $output;

}

function blocks_menu_update($row)
{
    list($vars['displaymodules'],
         $vars['displaywaiting'],
         $vars['dstyle'])
      = pnVarCleanFromInput('displaymodules',
                            'displaywaiting',
                            'dstyle');

    // Defaults
    if (empty($vars['displaymodules'])) {
        $vars['displaymodules'] = 0;
    }
    if (empty($vars['displaywaiting'])) {
        $vars['displaywaiting'] = 0;
    }
    if (empty($vars['dstyle'])) {
        $vars['dstyle'] = 1;
    }

    // User links
    $content = array();
    $c = 1;
    if (isset($row['linkname'])) {
        list($linkurl, $linkname, $linkdesc) = pnVarCleanFromInput('linkurl', 'linkname', 'linkdesc');
        foreach ($row['linkname'] as $v) {
            if (!isset($row['linkdelete'][$c])) {
                $content[] = "$linkurl[$c]|$linkname[$c]|$linkdesc[$c]";
            }
            if (isset($row['linkinsert'][$c])) {
                $content[] = "||";
            }
            $c++;
        }
    }
    if ($row['new_linkname']) {
       $content[] = pnVarCleanFromInput('new_linkurl').'|'.pnVarCleanFromInput('new_linkname').'|'.pnVarCleanFromInput('new_linkdesc');
    }
    $vars['content'] = implode("LINESPLIT", $content);

    $row['content']=pnBlockVarsToContent($vars);

    return($row);
}

function startMenuStyle($dstyle)
{
    // Nothing to do for dstyle == 1 (bullet list)
    $content = "";
    if ($dstyle == 2) {
        $content = "<br /><div style=\"text-align: center;\"><form method=\"post\" action=\"index.php\"><select class=\"pn-text\" name=\"newlanguage\" onchange=\"top.location.href=this.options[this.selectedIndex].value\">";
    }

    return $content;
}

function endMenuStyle($dstyle)
{
    // Nothing to do for dstyle == 1 (bullet list)
    $content = "";
    if ($dstyle == 2) {
        $content = "</select></form></div>";
    }

    return $content;
}

function addMenuStyledUrl($dstyle, $name, $url, $comment)
{
        $url = trim($url);
    if ($dstyle == 1) {
        // Bullet list
        if (empty($url)) {
            // Separator
            if (empty($name)) {
                $content = "<br />";
            } else {
                $content = "<br /><strong>$name</strong><br />";
            }
        } else {
        switch ($url[0]) // Used to allow support for linking to modules with the use of bracket
        {
            case '[': // old style module link
            {
                $url = explode(':', substr($url, 1,  - 1));
                $url = 'modules.php?op=modload&amp;name='.$url[0].'&amp;file='.((isset($url[1])) ? $url[1]:'index');
                break;
            }
            case '{': // new module link
            {
                $url = explode(':', substr($url, 1,  - 1));
                $url = 'index.php?module='.$url[0].'&amp;func='.((isset($url[1])) ? $url[1]:'main');
                break;
            }
        }  // End Bracket Linking
            $filebase = "themes/".pnConfigGetVar('Default_Theme')."/images/".str_replace(" ","_",strtolower($name));
            $events = '';
            if (file_exists($filebase . "_bg.jpg")) {
                $events = "<img style=\"cursor: pointer; border:0;\" src=\"{$filebase}_bg.jpg\" onclick=\"document.location.href='{$url}'\" onmouseout=\"this.src='{$filebase}_bg.jpg'\"";
                if (file_exists($filebase . "_ov.jpg")) $events .= " onmouseover=\"this.src='{$filebase}_ov.gpg'\"";
                if (file_exists($filebase . "_dn.jpg")) $events .= " onmousedown=\"this.src='{$filebase}_dn.gpg'\"";
                $content = $events . " /><br />";
            } else {
                $content = "<strong><big>&middot;</big></strong>&nbsp;<a class=\"pn-normal\" href=\"$url\" title=\"$comment\">$name</a><br />";
            }
        }
    } else if ($dstyle == 2) {
        // Drop-down lilst
        if (empty($url)) {
            // Separator
            $content = "<option>-----</option>";
            if (!empty($name)) {
                $content .= "<option>$name</option>";
                $content .= "<option>-----</option>";
            }
        } else {

        switch ($url[0])  // Used to allow support for linking to modules with the use of bracket
        {
            case '[': // module link
            {
                $url = explode(':', substr($url, 1,  - 1));
                $url = 'modules.php?op=modload&amp;name='.$url[0].'&amp;file='.((isset($url[1])) ? $url[1]:'index');
                break;
            }
            case '{': // new module link
            {
                $url = explode(':', substr($url, 1,  - 1));
                $url = 'index.php?module='.$url[0].'&amp;func='.((isset($url[1])) ? $url[1]:'main');
                break;
            }
        } // End bracket linking.
            $content = "<option value=\"$url\">$name</option>";
        }
    }

    return $content;
}
?>
