<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
//
//  Poll block with advanced voter functions
//  by Furbo
//  allows for normal polls (ip, one vote per day) OR one vote per user
//
// Requirements:
//  add pntable[poll_voters] and pntable[poll_voter_column] entries to the pntables.php file
//
//                  Original Author of file: Francisco Burzi
//                  Purpose of file:
// ----------------------------------------------------------------------

$blocks_modules['poll'] = array(
    'func_display' => 'blocks_poll_block',
    'func_edit' => 'blocks_poll_select',
    'func_update' => 'blocks_poll_update',
    'text_type' => 'Poll',
    'text_type_long' => 'Display poll',
    'allow_multiple' => true,
    'form_content' => false,
    'form_refresh' => false,
//  'support_xhtml' => true,
    'show_preview' => true
);

// Security
pnSecAddSchema('Pollblock::', 'Block title::');

/**
 * poll functions
 */

function pollMain($pollID, $row)
{
    global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    $content = explode('|', $row['content']);

    // for block vars: should only display results
    $resultsonly = ($content[2] == 1);

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $columnvoter = &$pntable['poll_voters_column'];

    if (!pnSecAuthAction(0, 'Pollblock::', "$row[title]::", ACCESS_READ)) {
        return;
    }

    if(!isset($pollID)) {
        $pollID = 1;
    }

    // get the data
    $column = &$pntable['poll_desc_column'];
        $result = $dbconn->Execute("SELECT $column[polltitle], $column[voters], $column[votesystem], $column[postfull], $column[votetracking]
                                                          FROM $pntable[poll_desc]
                                                          WHERE $column[pollid]='$pollID'");

        if ($result->EOF) {

                return;
        }

        list($pollTitle, $voters, $votesystem, $postfull) = $result->fields;
        $result->Close();

    $url = pnVarCleanFromInput('url');

    if(!isset($url)) {
      if ($postfull)
                $url = sprintf("modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;req=results&amp;pollID=%d", $pollID);
          else
                $url = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER[REQUEST_URI];
                //preg_replace('!^/*!', '', $_SERVER[REQUEST_URI]);
        }
        $boxContent = "<form action=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index\" method=\"post\">";
        $boxContent .= "<input type=\"hidden\" name=\"pollID\" value=\"".$pollID."\" />";
        $boxContent .= "<input type=\"hidden\" name=\"forwarder\" value=\"".$url."\" />";

    // one vote per user
    $peruser = ($votesystem != 'D');


    if (!pnSecAuthAction(0, 'Polls::', "$row[title]::$pollID", ACCESS_OVERVIEW)) {
        return;
    }

    $boxContent .= "<font class=\"pn-normal\"><b>$pollTitle</b></font><br><br>\n";
    $displayOptions = true;

    if ($resultsonly) {
      $boxContent .= pollResultsChart($pollID, true);
    }
    else { // display as normal
                if ($peruser) {
                  // only registered user can vote in a per user or tracking poll... sorry
                  if (pnUserLoggedIn()) {
                          // check to see if person voted before
                          $userid = pnUserGetVar('uid');
                          $sql = "SELECT count(1) FROM $pntable[poll_voters]
                                          WHERE $columnvoter[pollid] = '$pollID' AND $columnvoter[uid] = '$userid' ";
                          $result = $dbconn->Execute($sql);

                          if ($dbconn->ErrorNo() <> 0) {
                                 $row['content'] = $dbconn->ErrorMsg()."<br>$sql";
                                 return themesideblock($row);
                          }

                          list($votecount) = $result->fields;

                          if ($votecount > 0) {
                                $boxContent .= pollResultsChart($pollID, true);
                                $displayOptions = false;
                          }
                   }
                   else { // guest user
                     $boxContent .= _POLLSORRYUSERPOLLONLY;
                     $displayOptions = false;
                   }

                }
                else { // once per day check
                  if (pnSessionGetVar("poll_voted$pollID")) {
                    // user voted
                        $boxContent .= pollResultsChart($pollID, true);
                        $displayOptions = false;
                  }
                }

                if ($displayOptions) {
                      $column = &$pntable['poll_data_column'];

//modified for Oracle compatibility
//                          $result = $dbconn->Execute("SELECT $column[voteid], $column[optiontext] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\") ORDER BY $column[voteid]");
                        if (strcmp($dbtype,'oci8')== 0) {
                                $query="SELECT $column[voteid], $column[optiontext] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] IS NOT NULL) ORDER BY $column[voteid]";
                        }else{
                                $query="SELECT $column[voteid], $column[optiontext] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\") ORDER BY $column[voteid]";
                        }
                        $result = $dbconn->Execute($query);

//modified for Oracle compatibility
//                      while(list($voteid, $optionText) = $result->fields) {
                    while (!$result-> EOF){
                                list($voteid, $optionText) = $result->fields;
                        if (pnSecAuthAction(0, 'Polls::', "$row[title]::$pollID",ACCESS_COMMENT)) {
                            $boxContent .= "<input type=\"radio\" name=\"voteID\" value=\"$voteid\" class=\"r-button\" /> <span class=\"pn-normal\">$optionText</span><br>\n";
                        } else {
                            $boxContent .= "&middot;&nbsp;<span class=\"pn-normal\">$optionText</span><br>\n";
                        }
                        $result->MoveNext();
                      }

                      if (pnSecAuthAction(0, 'Polls::', "$row[title]::$pollID", ACCESS_COMMENT)) {
                        $boxContent .= "<br><p style=\"text-align:center\"><span class=\"pn-normal\"><input class=\"pn-button\" type=\"submit\" value=\""._VOTE."\" /></span></center><br>";
                      }
         }
    }


    $commentoptions = pnUserGetCommentOptions();

    $pollresulturl = "modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;req=results&amp;pollID=$pollID&amp;$commentoptions";

    $column = &$pntable['poll_data_column'];
    $result = $dbconn->Execute("SELECT SUM($column[optioncount]) AS sum
                              FROM $pntable[poll_data]
                              WHERE $column[pollid]=$pollID");
    list($sum) = $result->fields;
    $boxContent .=  '<p style="text-align:center"><span class="pn-normal">[ ';
    if (!$resultsonly && pnSecAuthAction(0, 'Polls::', "$row[title]::$pollID", ACCESS_READ)) {
        $boxContent .= "<a class=\"pn-normal\" href=\"$pollresulturl\"><b>"._RESULTS."</b></a> | ";
        $boxContent .= '<a class="pn-normal" href="modules.php?op=modload&amp;name=NS-Polls&amp;file=index"><b>'._POLLS.'</b></a> ]</span></p>';

        if (pnConfigGetVar('pollcomm') ) {
                    $column = &$pntable['pollcomments_column'];
                        $comres = $dbconn->Execute("SELECT COUNT(*) FROM $pntable[pollcomments] WHERE $column[pollid]=".pnVarPrepForStore($pollID)."");
                        list($numcom) = $comres->fields;
                        $boxContent .= "<p style=\"text-align:center\"><span class=\"pn-normal\">"._NUMVOTES.": <b>$sum</b>";

                        $boxContent .=" | <a class=\"pn-normal\" href=\"$pollresulturl\">"._PCOMMENTS."</a> <b>$numcom</b>";

                        $boxContent .= "</span></p>\n\n";
                } else {
                        $boxContent .= "<p style=\"text-align:center\"><span class=\"pn-normal\">"._NUMVOTES.": <b>$sum</b></span></p>\n\n";
                  }
    }
    else {
      $boxContent .= '<a class="pn-normal" href="modules.php?op=modload&amp;name=NS-Polls&amp;file=index"><b>'._POLLS.'</b></a> ]</span></p>';
      $boxContent .= "<p style=\"text-align:center\"><span class=\"pn-normal\">"._NUMVOTES.": <b>$sum</b>";
      if (pnConfigGetVar('pollcomm')) {
        $column = &$pntable['pollcomments_column'];
                $comres = $dbconn->Execute("SELECT COUNT(*) FROM $pntable[pollcomments] WHERE $column[pollid]=".pnVarPrepForStore($pollID)."");
                list($numcom) = $comres->fields;
        $boxContent .= " | "._PCOMMENTS." <b>$numcom</b>";
      }
      $boxContent .= "</span></p>";
    }

    $boxContent .= "</form>\n\n";

    if (empty($row['position'])) {
        $row['position'] = "c";
    }

    if (empty($row['title'])) {
        $row['title'] = _POLL;
    }
    $row['content'] = $boxContent;
    return themesideblock($row);
}

function pollLatest()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $currentlang = pnUserGetLang();

    if (pnConfigGetVar('multilingual') == 1) {
        $column = &$pntable['poll_desc_column'];
//modified for Oracle compatibility
  //      $querylang = "WHERE ($column[planguage]='".pnVarPrepForStore($currentlang)."' OR $column[planguage]='')";
        $querylang = "WHERE ($column[planguage]='".pnVarPrepForStore($currentlang)."' OR $column[planguage]='' OR $column[planguage] IS NULL)";
    } else {
        $querylang = '';
    }
    $column = &$pntable['poll_desc_column'];
        $sql = "SELECT $column[pollid] FROM $pntable[poll_desc] $querylang ORDER BY $column[pollid] DESC";
    $result = $dbconn->SelectLimit($sql,1);

    $pollID = $result->fields;
    return($pollID[0]);
}

function pollNewest()
{
    $pollID = pollLatest();
    $row = '';
    return pollMain($pollID,$row);
}

function pollCollector($pollID, $voteID, $forwarder)
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $currenttime = time();

    $column = &$pntable['poll_desc_column'];
    $sql = "SELECT $column[votesystem], $column[votetracking] FROM $pntable[poll_desc] WHERE $column[pollid] = '$pollID'";
    $result = $dbconn->Execute($sql);

    list($votesystem, $votetracking) = $result->fields;

    $peruser = ($votesystem != 'D');

    $columnVoter =  &$pntable['poll_voters_column'];

    $userid = pnUserGetVar('uid');

    if (!isset($userid)) // guest
      $userid = 0;

    if ($peruser) {
          $sql = "SELECT $columnVoter[uid] FROM $pntable[poll_voters] WHERE $columnVoter[pollid] = $pollID";
          $result = $dbconn->Execute($sql);
//modified for Oracle compatibility
//          while(list($voterid) = $result->fields) {
    while (!$result-> EOF){
                list($voterid) = $result->fields;
                $userfound = 0;
                $result->MoveNext();
                if ($voterid == $userid ) {
                        $userfound = 1;
                        break;
                }
          }
        }

    // Check that the user hasn't voted for this poll already
    if ($peruser && $userfound == 1) {
        $warn = "You already voted today!";
    }
    elseif (!$peruser && pnSessionGetVar("poll_voted$pollID")) {
      $warn = "You already voted today!";
    }
    else {
        pnSessionSetVar("poll_voted$pollID", 1);
        $column = &$pntable['poll_data_column'];
        $dbconn->Execute("UPDATE $pntable[poll_data] SET $column[optioncount]=$column[optioncount]+1 WHERE ($column[pollid]=".pnVarPrepForStore($pollID).") AND ($column[voteid]=".pnVarPrepForStore($voteID).")");
        $column = &$pntable['poll_desc_column'];
        $dbconn->Execute("UPDATE $pntable[poll_desc] SET $column[voters]=$column[voters]+1 WHERE $column[pollid]=".pnVarPrepForStore($pollID)."");


        if ($votetracking == 1) { // track user votes
            $sql = "INSERT INTO $pntable[poll_voters] ($columnVoter[pollid], $columnVoter[voteid], $columnVoter[uid], $columnVoter[timestamp]) VALUES ($pollID,$voteID,$userid,$currenttime)";
                $dbconn->Execute($sql);
            }
            elseif ($peruser) {
           // just record user voted
            $sql = "INSERT INTO $pntable[poll_voters] ($columnVoter[pollid], $columnVoter[uid], $columnVoter[timestamp]) VALUES ($pollID,$userid,$currenttime)";
                $dbconn->Execute($sql);

            }
    }

    pnRedirect($forwarder);
}

function pollList()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $currentlang = pnUserGetLang();

    if (!pnSecAuthAction(0, 'Polls::', "::", ACCESS_OVERVIEW)) {
        return;
    }

    $commentoptions = pnUserGetCommentOptions();

    if (pnConfigGetVar('multilingual') == 1) {
        $column = &$pntable['poll_desc_column'];
//modified for Oracle compatibility
//           $querylang =  "WHERE ($column[planguage]='".pnVarPrepForStore($currentlang)."' OR $column[planguage]='')";
       $querylang =  "WHERE ($column[planguage]='".pnVarPrepForStore($currentlang)."' OR $column[planguage]='' OR $column[planguage] IS NULL)";
    } else {
        $querylang = "";
    }
    $column = &$pntable['poll_desc_column'];
    $result = $dbconn->Execute("SELECT $column[pollid], $column[polltitle], $column[timestamp], $column[voters] FROM $pntable[poll_desc] $querylang ORDER BY $column[timestamp] DESC");
    OpenTable();
    OpenTable();
    echo "<p style=\"text-align:center\"><span class=\"pn-title\"><b>"._PASTSURVEYS."</b></span></p>";
    CloseTable();

    echo "<table border=\"0\" cellpadding=\"8\"><tr><td>";
    echo "<span class=\"pn-normal\">";
    $counter = 0;
    $resultArray = array();
//modified for Oracle compatibility
//    while($thisresult = $result->fields) {
    while(!$result->EOF){
                $thisresult = $result->fields;

        $result->MoveNext();
        $resultArray[$counter] = $thisresult;
        $counter++;
    }
    for ($count = 0; $count < count($resultArray); $count++) {
        $id = $resultArray[$count][0];
        $pollTitle = $resultArray[$count][1];
        $voters = $resultArray[$count][3];
        $column = &$pntable['poll_data_column'];
        $result2 = $dbconn->Execute("SELECT SUM($column[optioncount]) AS sum FROM $pntable[poll_data] WHERE $column[pollid]=".pnVarPrepForStore($id)."");
        list($sum) = $result2->fields;
        echo "<strong><big>&middot;</big></strong>&nbsp;<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;pollID=$id\">$pollTitle</a> ";
        echo "(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;req=results&amp;pollID=$id&amp;$commentoptions\">"._RESULTS."</a> - $sum "._LVOTES.")<br>\n";
    }
    echo '</td></tr></table>';
    CloseTable();
}

function pollResults($pollID)
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    if(!isset($pollID)) $pollID = 1;
    $column = &$pntable['poll_desc_column'];
    $result = $dbconn->Execute("SELECT $column[polltitle], $column[votesystem] FROM $pntable[poll_desc] WHERE $column[pollid]=".pnVarPrepForStore($pollID)."");
    list($holdtitle, $votesystem) = $result->fields;
    echo "<br><span class=\"pn-normal\"><b>$holdtitle</b></span><br><br>";
    $result->Close();

    echo pollResultsChart($pollID);

    echo "<p style=\"text-align:center\"><span class=\"pn-normal\">";
    echo "<b>"._TOTALVOTES." $sum</b><br>";
    echo "</span><span class=\"pn-sub\">";

    if ($votesystem == 'D')
      echo _ONEPERDAY;
    else
      echo _ONEPERUSER;

    echo "</span><span class=\"pn-normal\"><br><br>";

    $booth = $pollID;
    echo("[ <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;pollID=$booth\">"._VOTING."</a> | ");

    if (pnSecAuthAction(0, 'Polls::', "$holdtitle::$pollID", ACCESS_ADMIN)) {
       $sql = "SELECT $column[votesystem], $column[votetracking] FROM $pntable[poll_desc] WHERE $column[pollid] = '$pollID'";
           $result = $dbconn->Execute($sql);

           list($votesystem, $votetracking) = $result->fields;

       $peruser = ($votesystem != 'D');

       if ($peruser || $votetracking) {
            echo("<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;req=voters&pollID=$booth\">"._VOTERS."</a> | ");
           }
   }

    echo("<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index\">"._OTHERPOLLS."</a> ]</span></p>");
    return(1);
}

// @param $blockstyle    boolean that will tell function to show the standard chart or the smaller block style
function pollResultsChart($pollID, $blockstyle=false) {

   global $pnconfig;
   $dbtype = $pnconfig['dbtype'];

 list($dbconn) = pnDBGetConn();
     $pntable = pnDBGetTables();

   $column = &$pntable['poll_data_column'];
   $result = $dbconn->Execute("SELECT SUM($column[optioncount]) AS sum FROM $pntable[poll_data] WHERE $column[pollid]=".pnVarPrepForStore($pollID)."");
   list($sum) = $result->fields;
   $result->Close();


   $chartdata = "<table border=\"0\" width=\"100%\">";
    /* cycle through all options */
    $column = &$pntable['poll_data_column'];

//modified for Oracle compatibility
//        $result = $dbconn->Execute("SELECT $column[optiontext], $column[optioncolor], $column[optioncount] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\") ORDER BY $column[voteid]");
        if (strcmp($dbtype,'oci8')== 0) {
                $query="SELECT $column[optiontext], $column[optioncolor], $column[optioncount] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] IS NOT NULL) ORDER BY $column[voteid]";
        }else{
                $query="SELECT $column[optiontext], $column[optioncolor], $column[optioncount] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\") ORDER BY $column[voteid]";
        }
        $result = $dbconn->Execute($query);

//modified for Oracle compatibility
//    while(list($optionText, $optionColor, $optionCount) = $result->fields) {
    while (!$result-> EOF){
                list($optionText, $optionColor, $optionCount) = $result->fields;
        if($sum) {
            $percent = 100 * $optionCount / $sum;
        } else {
            $percent = 0;
        }
        $result->MoveNext();

        $percentInt = (int)$percent * 4 * pnConfigGetVar('BarScale');

                $percentVoted = (int)$percent;
                $percentNot   = 100 - $percent;

        $ThemeSel = pnUserGetTheme();

        if ($blockstyle) {

           $chartdata .=  '<TR><TD width="100%" colspan="2">
                          <span class="pn-normal">'.$optionText.'</span>
                          </TD></tr>
                          <TR>
                                          <TD width="100%" vAlign=top align=left colspan="2">
                                            <TABLE width="100%" border=0 cellpading="0" cellspacing="0">
                                              <TBODY>
                                              <TR>';
                        if ($percentVoted == 0)
                          $chartdata .= '<TD width="'.$percentVoted.'" bgColor="'.$optionColor.'"><IMG height=12 src="images/clear.gif"> </TD>';
                        else
                      $chartdata .= '<TD width="'.$percentVoted.'%" bgColor="'.$optionColor.'"><IMG height=12 src="images/clear.gif"> </TD>';

                        $chartdata .=  '<TD width="'.$percentNot.'%">
                                      <FONT size=2 class="pn-normal">&nbsp&nbsp<B>'.$percentVoted.'%</B></FONT>
                                                </TD>
                                               </TR></TBODY>
                                            </TABLE></TD>
                                          </TR>';

          //$chartdata .= sprintf("<span class=pn-normal> %.2f %% (%d)</span>", $percent, $optionCount);
        }
        else {
          $chartdata .=  "<tr><td>";
                  $chartdata .=  "<span class=\"pn-normal\">$optionText</span>";
                  $chartdata .=  "</td>";

           $chartdata .=  "<td NOWRAP>";

          if ($percent > 0) {
            $chartdata .=  "<img src=\"themes/$ThemeSel/images/leftbar.gif\" height=\"15\" width=\"7\" alt=\"$percentVoted %\" />";
            $chartdata .=  "<img src=\"themes/$ThemeSel/images/mainbar.gif\" height=\"15\" width=\"$percentInt\" alt=\"$percentVoted %\" />";
            $chartdata .=  "<img src=\"themes/$ThemeSel/images/rightbar.gif\" height=\"15\" width=\"7\" alt=\"$percentVoted %\" />";
          } else {
            $chartdata .=  "<img src=\"themes/$ThemeSel/images/leftbar.gif\" height=\"15\" width=\"7\" alt=\"$percentVoted %\" />";
            $chartdata .=  "<img src=\"themes/$ThemeSel/images/mainbar.gif\" height=\"15\" width=\"3\" alt=\"$percentVoted %\" />";
            $chartdata .=  "<img src=\"themes/$ThemeSel/images/rightbar.gif\" height=\"15\" width=\"7\" alt=\"$percentVoted %\" />";
          }

          $chartdata .= sprintf("<span class=pn-normal> %.2f %% (%d)</span>", $percent, $optionCount);
        }

        $chartdata .=  "</td></tr>";
    }
    $chartdata .=  "</table><br>";

    return $chartdata;
}

function pollVotersResults($pollID)
{
        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();


    if(!isset($pollID)) $pollID = 1;
    $column = &$pntable['poll_desc_column'];
    $result = $dbconn->Execute("SELECT $column[polltitle] FROM $pntable[poll_desc] WHERE $column[pollid]=".pnVarPrepForStore($pollID)."");
    list($holdtitle) = $result->fields;

    if (!pnSecAuthAction(0, 'Polls::', "$holdtitle::$pollID", ACCESS_ADMIN)) {
      return;
    }

    echo "<br><span class=\"pn-normal\"><b>$holdtitle</b></span><br><br>";
    $result->Close();
    $column = &$pntable['poll_data_column'];
    echo "<table border=\"0\">";

    $column = &$pntable['poll_data_column'];
//modified for Oracle compatibility
//                $result = $dbconn->Execute("SELECT count(1) FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\")");
        if (strcmp($dbtype,'oci8')== 0) {
                $result = $dbconn->Execute("SELECT count(1) FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] IS NOT NULL)");
    }else{
    $result = $dbconn->Execute("SELECT count(1) FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\")");
        }
    list($optioncount) = $result->fields;

    /* cycle through all options */
//modified for Oracle compatibility
//            $result = $dbconn->Execute("SELECT $column[optiontext] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\") ORDER BY $column[voteid]");
        if (strcmp($dbtype,'oci8')== 0) {
            $result = $dbconn->Execute("SELECT $column[optiontext] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] IS NOT NULL) ORDER BY $column[voteid]");
    }else{
    $result = $dbconn->Execute("SELECT $column[optiontext] FROM $pntable[poll_data] WHERE ($column[pollid]=".pnVarPrepForStore($pollID)." AND $column[optiontext] NOT LIKE \"\") ORDER BY $column[voteid]");
        }
    echo "<tr><td>User</td>";
//modified for Oracle compatibility
//    while(list($optionText) = $result->fields) {
     while (!$result-> EOF){
                list($optionText) = $result->fields;

        $result->MoveNext();
        $optionTxt = substr($optionText,0,15);
        echo "<td>";
        echo "<span class=\"pn-normal\"><b>$optionTxt</b></span>";
        echo "</td>";
    }
    echo "</tr>";
//Added for bug correction
        $columvoters = &$pntable['poll_voters_column'];
                $sql=("SELECT $columvoters[uid], $columvoters[voteid] FROM $pntable[poll_voters] WHERE $columvoters[pollid]=".pnVarPrepForStore($pollID)." ORDER BY $columvoters[timestamp]");
                $result = $dbconn->Execute($sql);

//modified for Oracle compatibility
//    while(list($userid,$votedoption) = $result->fields) {
    while (!$result-> EOF){
                list($userid,$votedoption) = $result->fields;

        $result->MoveNext();
        $columnuser = &$pntable['users_column'];
        $result1 = $dbconn->Execute("SELECT $columnuser[uname] FROM $pntable[users] WHERE $columnuser[uid] = '$userid'");
            list($username) = $result1->fields;
            $result1->Close();
        echo "<tr><td>";
        echo "<span class=\"pn-normal\"><a href=\"user.php?op=userinfo&uname=$username\">$username</a></span>";
        echo "</td>";

        if ($votedoption > 0) {
                        //////
                        // place a X below the right option
                        //////
                        // pad left
                        for($i=1;$i<$votedoption;$i++) {
                                echo "<td> </td>";
                        }
                        echo "<td align=\"center\"><b>X</b></td>";
                        // pad right
                        for($i=$votedoption+1;$i<$optioncount;$i++) {
                                echo "<td> </td>";
                        }
                }
                else {
                    // pad right
                        for($i=1;$i<$optioncount;$i++) {
                            echo "<td> </td>";
                        }
                }
                echo "</tr>";
    }
    echo "</table><br>";
    echo "<p style=\"text-align:center\"><span class=\"pn-normal\">";
    $booth = $pollID;
    echo("[ <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;pollID=$booth\">"._VOTING."</a> | ");
    echo("<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index&amp;req=results&amp;pollID=$pollID\"><b>"._RESULTS."</b></a> | ");
    echo("<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=NS-Polls&amp;file=index\">"._OTHERPOLLS."</a> ]</span></p>");
    return(1);
}


function blocks_poll_block($row)
{
// for MSSQL that alwasys have an space
    $row['content'] = trim($row['content']);

    $content = explode('|', $row['content']);

    if (!empty($content[1])) {
        $pollID = $content[1];
    } else {
        $pollID = pollLatest();
    }


    return pollMain($pollID, $row);

}

function blocks_poll_select($row)
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();


    $zerochecked = "";
    $onechecked = "";
    $resultschecked = "";

    $content = explode('|', $row['content']);

    if ($content[0] == 1) {
      $onechecked = "checked";
    }
    else {
          $zerochecked = "checked";
    }

    $pollID = $content[1];

    if ($content[2] == 1)
      $resultschecked = "checked";


    $output = "<tr><td class=\"pn-title\">"._POLL_DISPLAY.":</td></tr>";
    $output .= "<tr><td class=\"pn-normal\">"._POLL_LATEST."</td><td><input type=\"radio\" name=\"polltype\" value=\"0\" $zerochecked></td></tr>";
    $output .= "<tr><td class=\"pn-normal\">"._POLL_SPECIFIC."</td><td><input type=\"radio\" name=\"polltype\" value=\"1\" $onechecked>&nbsp;&nbsp;";

    $output .= "<select name=\"pollid\">";

    // Get list of polls
    $polltable = $pntable['poll_desc'];
    $pollcolumn = $pntable['poll_desc_column'];
    $sql = "SELECT $pollcolumn[polltitle],
                   $pollcolumn[pollid]
            FROM $polltable
            ORDER BY $pollcolumn[polltitle]";
    $result = $dbconn->Execute($sql);
//modified for Oracle compatibility
//    while(list($title, $id) = $result->fields) {
    while (!$result-> EOF){
                list($title, $id) = $result->fields;

        $result->MoveNext();
        $output .= "<option value=\"$id\"";
        if ($pollID == $id) {
           $output .= " selected";
        }
        $output .= ">$title</option>";
    }
    $result->Close();

    $output .= "</select></td></tr>";

    $output .= "<tr><td class=\"pn-normal\">"._POLL_ONLYRESULTS."</td><td><input type=\"checkbox\" name=\"pollonlyresults\" value=\"1\" $resultschecked></td></tr>";

    return $output;
}

function blocks_poll_update($row)
{
/*  if (($row['polltype'] == 1) && (!empty($row['pollid']))) {
        $row['content'] = $row['pollid'];
    } else {
        $row['content'] = "";
    }
*/

  $row['content'] = pnVarPrepForStore($row['polltype']).'|'.pnVarPrepForStore($row['pollid']).'|'.pnVarPrepForStore($row['pollonlyresults']);


  return($row);
}
?>
