<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file: Display titles of stories, with lots of options
// ----------------------------------------------------------------------

$blocks_modules['stories'] = array(
        'func_display' => 'blocks_stories_block',
        'func_edit' => 'blocks_stories_select',
        'func_update' => 'blocks_stories_update',
        'text_type' => 'Stories',
        'text_type_long' => 'Story Titles',
        'allow_multiple' => true,
        'form_content' => false,
        'form_refresh' => false,
        'show_preview' => true
        );

pnSecAddSchema('Storiesblock::', 'Block title::');

function blocks_stories_block($row)
{
	global $pnconfig;
	$dbtype = $pnconfig['dbtype'];

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $currentlang = pnUserGetLang();

    if (!pnSecAuthAction(0, 'Storiesblock::', "$row[title]::", ACCESS_READ)) {
        return;
    }

    // Break out options from our content field
    $vars = pnBlockVarsFromContent($row['content']);

    // Defaults
    if (!isset($vars['storiestype'])) {
        $vars['storiestype'] = 2;
    }
    if (!isset($vars['topic'])) {
        $vars['topic'] = -1;
    }
    if (!isset($vars['topic'])) {
        $vars['topic'] = -1;
    }
    if (!isset($vars['category'])) {
        $vars['category'] = -1;
    }
    if (!isset($vars['limit'])) {
        $vars['limit'] = 10;
    }

    $row['content'] = "";
    $query_started = false;


    // Base query
    $storiescolumn = &$pntable['stories_column'];
    $storiescatcolumn = &$pntable['stories_cat_column'];
    $topicscolumn = $pntable['topics_column'];
//modified for Oracle compatibility
// function selectlimit doesn't work if receive equals name-column from different tables, so we use an alias

    $query = "SELECT $storiescolumn[aid] AS \"aid\",
                    $storiescolumn[catid] AS \"cid\",
                    $storiescatcolumn[title] AS \"cattitle\",
                    $storiescolumn[sid] AS \"sid\",
                    $topicscolumn[topicid] AS \"tid\",
                    $storiescolumn[time] AS \"time\",
                    $storiescolumn[title] AS \"title\",
                    $topicscolumn[topicname] AS \"topicname\"
                        FROM         $pntable[stories]";

	switch ($dbtype){
	    case "oci8":
		    $query .= ", $pntable[stories_cat], $pntable[topics] WHERE $storiescolumn[catid]= $storiescatcolumn[catid](+) AND $storiescolumn[topic]= $topicscolumn[topicid](+)";
			break;
		default:
	        // Assume mysql start
		    $query .= " LEFT JOIN $pntable[stories_cat] ON $storiescolumn[catid] = $storiescatcolumn[catid]
                                LEFT JOIN $pntable[topics] ON $storiescolumn[topic] = $topicscolumn[topicid]";
			// Assume mysql end
			break;
	}



//        $query .= " WHERE";
        $wherearray=array();

        // check language
        if (pnConfigGetVar('multilingual') == 1) {
//                $query_started = true;
//                $query .= " ($storiescolumn[alanguage]='" . pnUserGetLang() . "' OR $storiescolumn[alanguage]='')";
//modified for Oracle compatibility
//				$wherearray[] = " ($storiescolumn[alanguage]='" . pnUserGetLang() . "' OR $storiescolumn[alanguage]='')";
				$wherearray[] = " ($storiescolumn[alanguage]='" . pnUserGetLang() . "' OR $storiescolumn[alanguage]='' OR $storiescolumn[alanguage] IS NULL)";
        }

    // Qualifier for front-page/not front-page news
    // storiestype = 3 - front-page news
    // storiestype = 1 - not front-page news
    // storiestype = 2 - all news


    if ($vars['storiestype']=='1') {
            // where clause already started?
//            if ($query_started == true) {
//                    $query .= " AND";
//            }
//            $query_started = true;
//        $query .= " $storiescolumn[ihome]=1";
                $wherearray[] = " $storiescolumn[ihome]=1";
    }
    if ($vars['storiestype']=='3') {
            // where clause already started?
//            if ($query_started == true) {
//                    $query .= " AND";
//            }
//            $query_started = true;
//        $query .= " $storiescolumn[ihome]=0";
                $wherearray[] = " $storiescolumn[ihome]=0";
    }

    // Qualifier for particular topic
    // topic = -1 - all topics?
    if ($vars['topic'] != -1) {
            // where clause already started?
//            if ($query_started == true) {
//                    $query .= " AND";
//            }
//            $query_started = true;
//        $query .= " $storiescolumn[topic]=" . pnVarPrepForStore($vars['topic']);
                $wherearray[] = " $storiescolumn[topic]=" . pnVarPrepForStore($vars['topic']);
    }

    // Qualifier for particular category
    // category = -1 - all categories
    if ($vars['category'] != -1) {
            // where clause already started?
//            if ($query_started = true) {
//                    $query .= " AND";
//            }
//        $query .= " $storiescolumn[cid]=" . pnVarPrepForStore($vars['category']);
        $wherearray[] = " $storiescolumn[cid]=" . pnVarPrepForStore($vars['category']);
    }

        if ($wherearray) {
				switch ($dbtype){
				    case "oci8":
		                $query .= " AND " . implode(" AND ", $wherearray);
						break;
					default:
		                $query .= " WHERE " . implode(" AND ", $wherearray);
						break;
				}
        }

    // Qualifier for how many stories
    $query .= " ORDER BY $storiescolumn[time] DESC";

        // we can't use a limit query since permissions might take effect...
    //$result = $dbconn->SelectLimit($query, pnVarPrepForStore($vars['limit']));
        $result = $dbconn->Execute($query);

    // Error checking -- jn
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

        $shown_results=0;
        $postmax=$vars['limit'];

    while((list($aid, $cid, $cattitle, $sid, $tid, $time, $title, $topicname) = $result->FetchRow()) && ($shown_results < $postmax) ){
        $time=$result->UnixTimeStamp($time);
        if(!isset($aid)) {
            $aid = '';
        }
                if ($catid == 0) {
                        // Default category
                        $cattitle = ""._ARTICLES."";
                }
        if (pnSecAuthAction(0, 'Stories::Story', "$aid:$cattitle:$sid", ACCESS_READ) && pnSecAuthAction(0, 'Topics::Topic', "$topicname::$tid", ACCESS_READ) ) {
            $row['content'] .=
                "<strong><big>&middot;</big></strong>&nbsp;<a href=\"modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=" . pnVarPrepForDisplay($sid) . "\">" . pnVarPrepForDisplay($title) . "</a>
                (".ml_ftime(_DATEBRIEF,$time).")<br>\n";
                        $shown_results++;
        }
                // removed uncessary MoveNext; FetchRow() from above moves the record set pointer - markwest
                // Credit rembert http://forums.postnuke.com/index.php?name=PNphpBB2&amp;file=viewtopic&t=14182
        // $result->MoveNext();
    }
    if (!empty($row['content'])) {
        return themesideblock($row);
    }
}

function blocks_stories_select($row)
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Break out options from our content field
    $vars = pnBlockVarsFromContent($row['content']);

    // Defaults
    if (empty($vars['storiestype'])) {
        $vars['storiestype'] = 2;
    }
    if (empty($vars['topic'])) {
        $vars['topic'] = -1;
    }
    if (empty($vars['category'])) {
        $vars['category'] = -1;
    }
    if (empty($vars['limit'])) {
        $vars['limit'] = 10;
    }

    $row['content'] = "";

    // Which stories to list
    $output = '<tr><td class="pn-normal">' . _STORIESDISPLAYALL .
              ':</td><td><input type="radio" name="storiestype" value="2"';
    if ($vars['storiestype'] == 2) {
        $output .= ' checked';
    }
    $output .= '></td></tr><tr><td class="pn-normal">' . _STORIESDISPLAYFRONTPAGE .
               ':</td><td><input type="radio" name="storiestype" value="3"';
    if ($vars['storiestype'] == 3) {
        $output .= ' checked';
    }
    $output .= '></td></tr><tr><td class="pn-normal">' . _STORIESDISPLAYNONFRONTPAGE .
               ':</td><td><input type="radio" name="storiestype" value="1"';
    if ($vars['storiestype'] == 1) {
        $output .= ' checked';
    }
    $output .= '></td></tr>';

    // Which topic
    $output .= '<tr><td class="pn-normal">' . _STORIESTOPIC . ':</td><td><select name="topic" size="1">';
    $output .= '<option value="-1\"';
    if ($vars['topic'] == -1) {
        $output .= " selected";
    }
    $output .= '>'._ALL.'</option>';

    $topicscolumn = &$pntable['topics_column'];
    $query = "SELECT $topicscolumn[topicid],
                     $topicscolumn[topicname]
              FROM $pntable[topics]
              ORDER BY $topicscolumn[topicname]";
    $result = $dbconn->Execute($query);
    while(!$result->EOF) {
        list($tid, $tname) = $result->fields;
        $result->MoveNext();
        $output .= "<option value=\"$tid\"";
        if ($vars['topic'] == $tid) {
            $output .= ' selected';
        }
        $output .= '>' . pnVarPrepForDisplay($tname) . '</option>';
    }
    $output .= '</select></td></tr>';

    // Which category
    $output .= '<tr><td class="pn-normal">' . _STORIESCATEGORY . ':</td><td><select name="category" size="1">';
    $output .= "<option value=\"-1\"";
    if ($vars['category'] == -1) {
        $output .= ' selected';
    }
    $output .= '>'._ALL.'</option>';

    $storiescatcolumn = &$pntable['stories_cat_column'];
    $query = "SELECT $storiescatcolumn[catid],
                     $storiescatcolumn[title]
              FROM $pntable[stories_cat]
              ORDER BY $storiescatcolumn[title]";
    $result = $dbconn->Execute($query);
    while(!$result->EOF) {
        list($catid, $cattitle) = $result->fields;
        $result->MoveNext();
        $output .= "<option value=\"$catid\"";
        if ($vars['category'] == $catid) {
            $output .= ' selected';
        }
        $output .= ">" . pnVarPrepForDisplay($cattitle) . "</option>";
    }
    $output .= "</select></td></tr>";

    // Number of stories
    $output .= '<tr><td class="pn-normal">' . _STORIESMAXNUM .
               ':</td><td><input type="text" name="limit" size="2" value="' .
               pnVarPrepForDisplay($vars['limit']) . '"></td></tr>';

    return $output;
}

function blocks_stories_update($row)
{
    list($vars['storiestype'],
         $vars['topic'],
         $vars['category'],
         $vars['limit'])
      = pnVarCleanFromInput('storiestype',
                            'topic',
                            'category',
                            'limit');

    $row['content'] = pnBlockVarsToContent($vars);

    return($row);
}

?>