<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Patrick Kellum
// Purpose of file: Display the recent links added to the WEb Links module
// ----------------------------------------------------------------------

$blocks_modules['weblinks'] = array (
    'func_display' => 'blocks_weblinks_display',
    'func_add' => 'blocks_weblinks_add',
    'func_update' => 'blocks_weblinks_update',
    'func_edit' => 'blocks_weblinks_edit',
    'text_type' => 'Weblinks',
    'text_type_long' => 'Latest Web Links',
    'allow_multiple' => true,
    'form_content' => false,
    'form_refresh' => false,
    'show_preview' => true
);
pnSecAddSchema('Weblinksblock::', 'Block title::');
function blocks_weblinks_display($row)
{
	global $pnconfig;
	$dbtype = $pnconfig['dbtype'];
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    if (!pnSecAuthAction(0, 'Weblinksblock::', "$row[title]::", ACCESS_READ)) {
        return;
    }

    $url = explode('|', $row['url']);
    if (!$url[0])
    {
        $row['content'] = 'You forgot to set the module name!';
        return themesideblock($row);
    }
    if (!$url[1])
    {
        $url[1] = 10;
    }

        $links_col = &$pntable['links_links_column'];
        $linksok = 0;
        $linkcount = 0;
        $result=$dbconn->Execute("SELECT $links_col[cat_id], $links_col[title] FROM $pntable[links_links] ORDER BY $links_col[date] DESC");
//modified for ORacle compatibility
//		while(list($cid, $title)=$result->fields) {
		while(!$result->EOF){
			list($cid, $title)=$result->fields;
            $result->MoveNext();
	        $linkcount++;
		    if (pnSecAuthAction(0, "Web Links::Category", "$title::$cid", ACCESS_READ)) {
                 $linksok++;
			}
	        if ($linksok == $url[1]) {
                 break;
		    }
		}
        $oldurl=$url[1];
    $url[1] = $linkcount;

    $row['content'] = '<span class="pn-normal">';
    $links_col = &$pntable['links_links_column'];
    $cats_col = &$pntable['links_categories_column'];
//modified for ORacle compatibility
	switch ($dbtype){
		case "oci8":
			$sql = "SELECT $links_col[lid] as lid, $links_col[cat_id] as catid, $links_col[title] as title, $links_col[description] as description, $links_col[hits] as hits, $cats_col[title] AS cattitle
               FROM $pntable[links_links], $pntable[links_categories]
               WHERE $cats_col[cat_id](+)=$links_col[cat_id]
               ORDER BY $links_col[date] DESC";
			break;
		default:
			$sql = "SELECT $links_col[lid] as lid, $links_col[cat_id] as catid, $links_col[title] as title, $links_col[description] as description, $links_col[hits] as hits, IF($links_col[cat_id], CONCAT('/', $cats_col[title]), $cats_col[title]) AS cattitle
               FROM $pntable[links_links]
               LEFT JOIN $pntable[links_categories]
               ON $cats_col[cat_id]=$links_col[cat_id]
               ORDER BY $links_col[date] DESC";
			break;
	}
    $result = $dbconn->SelectLimit($sql,$url[1]);

    while(!$result->EOF) {
        $lrow = $result->GetRowAssoc(false);
		
		//modified for ORacle compatibility
		if (strcmp($dbtype,'oci8')== 0) { 
			if($lrow[catid]) {
				$lrow[cattitle]='/'.$lrow[cattitle];
			}
		}

        if (pnSecAuthAction(0, "Web_Links::Category", "$lrow[cattitle]::$lrow[catid]", ACCESS_READ)) {
        $lrow['title'] = pnVarPrepForDisplay($lrow['title']);
        $lrow['description'] = pnVarPrepHTMLDisplay($lrow['description']);
        $lrow['cattitle'] = pnVarPrepForDisplay($lrow['cattitle']);
        $row['content'] .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"modules.php?op=modload&amp;name=$url[0]&amp;file=index&amp;req=visit&lid=$lrow[lid]\" target=\"_blank\" title=\"$lrow[cattitle]:\n$lrow[description]\" class=\"pn-sub\">$lrow[title]</a> ($lrow[hits])<br>\n";
        $result->MoveNext();
                   }
    }
    $row['content'] .= '</span>';
    return themesideblock($row);
}
function blocks_weblinks_add($row)
{
    $row['url'] = 'Web_Links|10';
    return $row;
}
function blocks_weblinks_update($vars)
{
    $vars['url'] = "$vars[weblinks_modname]|$vars[weblinks_total]";
    return $vars;
}
function blocks_weblinks_edit($row)
{
    if (!empty($row['url'])) {
        $url = explode('|', $row['url']);
        $wlmodname = $url[0];
        $wltotal = $url[1];
    } else {
        $wlmodname = 'Web_Links';
        $wltotal = 10;
    }
    $output = '<tr><td valign="top" class="pn-normal">Module Name:</td><td>'
        ."<input type=\"text\" name=\"weblinks_modname\" size=\"30\" maxlength=\"255\" value=\"$wlmodname\" class=\"pn-normal\">"
        ."</td></tr>\n"
    ;
    $output .= '<tr><td valign="top" class="pn-normal">Total Links:</td><td>'
        ."<input type=\"text\" name=\"weblinks_total\" size=\"30\" maxlength=\"255\" value=\"$wltotal\" class=\"pn-normal\">"
        ."</td></tr>\n"
    ;
    return $output;
}
?>
