<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file:
// Purpose of file:
// ----------------------------------------------------------------------

/**
 * CatList
 * Recursivly creates option tags for each sub category of $scat, selects category $sel
 * @usedby search, popular, addlink
 */
function CatList($scat, $sel)
{
	global $ModName;

  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $s="";
  $column = &$pntable['links_categories_column'];
  $result=$dbconn->Execute("SELECT $column[cat_id]
                            FROM $pntable[links_categories]
                            WHERE $column[parent_id]=" . pnVarPrepForStore($scat));
//modified for Oracle compatibility
//  while(list($cid)=$result->fields) {
  while(!$result->EOF){
	  list($cid)=$result->fields;

      $result->MoveNext();
    if ($sel==$cid) {
      $selstr=" selected";
    } else {
      $selstr='';
    }
    $s.="<option value=\"$cid\"$selstr>".CatPath($cid,0,0,0)."</option>";
    $s.=CatList($cid, $sel);
  }
  return $s;
}

/**
 * Catpath
 * Creates the full path for a category title
 * New function by toph, 20/8/2001
 * @usedby search, popular, addlink
 */
function CatPath($cid, $start, $links, $linkmyself) {

    global $ModName, $modurl;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $column = &$pntable['links_categories_column'];
    $result=$dbconn->Execute("SELECT $column[parent_id],
                                     $column[title]
                              FROM $pntable[links_categories]
                              WHERE $column[cat_id]=" . pnVarPrepForStore($cid));
    list($pid, $title)=$result->fields;
    if ($linkmyself) {
        $cpath = "<a href=\"${modurl}&amp;req=viewlink&amp;cid=$cid\">".pnVarPrepForDisplay($title)."</a>";
    } else {
        $cpath = $title;
    }
    while ($pid!=0) {
        $column = &$pntable['links_categories_column'];
        $result=$dbconn->Execute("SELECT $column[cat_id],
                                         $column[parent_id],
                                         $column[title]
                                  FROM $pntable[links_categories]
                                  WHERE $column[cat_id]=" . pnVarPrepForStore($pid));
        list($cid, $pid, $title)=$result->fields;
        if ($links) {
            $cpath = "<a href=\"${modurl}&amp;req=viewlink&amp;cid=$cid\">".pnVarPrepForDisplay($title).'</a> / '.pnVarPrepForDisplay($cpath);
        } else {
            $cpath = $title.' / '.$cpath;
        }
    }
    if ($start) {
      $cpath="<a href=\"${modurl}\">"._START."</a> / ".pnVarPrepForDisplay($cpath);
    }
    return $cpath;
}


function downloads_ItemCIDFromLID($lid) 
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_downloads'];
    $dlcatcolumn = &$pntable['downloads_downloads_column'];

    $query = "SELECT $dlcatcolumn[cid]
              FROM $dlcattable
              WHERE $dlcatcolumn[lid] = " . pnVarPrepForStore($lid);
    $result = $dbconn->Execute($query);
    list($cid) = $result->fields;
    $result->Close();

    return $cid;
}

function downloads_ItemSIDFromLID($lid) 
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_downloads'];
    $dlcatcolumn = &$pntable['downloads_downloads_column'];

    $query = "SELECT $dlcatcolumn[sid]
              FROM $dlcattable
              WHERE $dlcatcolumn[lid] = " . pnVarPrepForStore($lid);
    $result = $dbconn->Execute($query);
    list($sid) = $result->fields;
    $result->Close();
    return $sid;
}

function downloads_SubCatNumItems($sid)
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_downloads'];
    $dlcatcolumn = &$pntable['downloads_downloads_column'];

    $query = "SELECT $dlcatcolumn[sid]
              FROM $dlcattable
              WHERE $dlcatcolumn[sid] = " . pnVarPrepForStore($sid);
    $result = $dbconn->Execute($query);
    $catnumitems = $result->PO_RecordCount();
    $result->Close();

    return $catnumitems;
}


/*
 * Get the sub category name given its SID
 */
function downloads_SubCatNameFromSID($sid)
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_subcategories'];
    $dlcatcolumn = &$pntable['downloads_subcategories_column'];

    $query = "SELECT $dlcatcolumn[title]
              FROM $dlcattable
              WHERE $dlcatcolumn[sid] = " . pnVarPrepForStore($sid);
    $result = $dbconn->Execute($query);
    list($catname) = $result->fields;
    $result->Close();

    return $catname;
}

/*
 * Get the category name given its CID
 */
function downloads_CatNameFromCID($cid)
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_categories'];
    $dlcatcolumn = &$pntable['downloads_categories_column'];

    $query = "SELECT $dlcatcolumn[title]
              FROM $dlcattable
              WHERE $dlcatcolumn[cid] = " . pnVarPrepForStore($cid);

    $result = $dbconn->Execute($query);
    list($catname) = $result->fields;
    $result->Close();

    return $catname;
}

function downloads_ItemNameFromLID($lid)
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_downloads'];
    $dlcatcolumn = &$pntable['downloads_downloads_column'];

    $query = "SELECT $dlcatcolumn[title]
              FROM $dlcattable
              WHERE $dlcatcolumn[lid] = " . pnVarPrepForStore($lid);

    $result = $dbconn->Execute($query);
    list($catname) = $result->fields;
    $result->Close();
    return $catname;


}

function downloads_ItemSubmitterFromLID($lid)
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlcattable = $pntable['downloads_downloads'];
    $dlcatcolumn = &$pntable['downloads_downloads_column'];

    $query = "SELECT $dlcatcolumn[submitter]
              FROM $dlcattable
              WHERE $dlcatcolumn[lid] = " . pnVarPrepForStore($lid);
    $result = $dbconn->Execute($query);
    list($catname) = $result->fields;
    $result->Close();

    return $catname;

}


/*
 * Get the item category given its IID
 */
function downloads_CatNameFromIID($iid)
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $dlitemtable = $pntable['downloads_downloads'];
    $dlitemcolumn = &$pntable['downloads_downloads_column'];

    $query = "SELECT $dlitemcolumn[cid]
              FROM $dlitemtable
              WHERE $dlitemcolumn[lid] = " . pnVarPrepForStore($iid);
    $result = $dbconn->Execute($query);
    list($cid) = $result->fields;
    $result->Close();

    $dlcattable = $pntable['downloads_categories'];
    $dlcatcolumn = &$pntable['downloads_categories_column'];

    $query = "SELECT $dlcatcolumn[title]
              FROM $dlcattable
              WHERE $dlcatcolumn[cid] = " . pnVarPrepForStore($cid);
    $result = $dbconn->Execute($query);
    list($catname) = $result->fields;
    $result->Close();

    return $catname;
}

function downloads_authsubcat($cid, $sid, $actype)
{
	global $ModName;

	$ctitle = downloads_CatNameFromCID($cid);
	$stitle = downloads_SubCatNameFromSID($sid);

	if ((pnSecAuthAction(0, $ModName.'::Category', "$stitle::$sid", $actype)) &&
	    (pnSecAuthAction(0, $ModName.'::Category', "$ctitle::$cid", $actype))) {
		return true;
	} else {
		return false;
	}
}

function downloads_authitem($cid, $sid, $lid, $actype)
{
	global $ModName;

	$ititle = downloads_ItemNameFromLID($lid);

	if ($actype == ACCESS_EDIT) {
		if (pnSecAuthAction(0, $ModName.'::Item', "$ititle::$lid", $actype)) {
			return true;
		} else {
			return false;
		}
	} else {
		$ctitle = downloads_CatNameFromCID($cid);

		if ($sid == 0) {
			$subcatauth = true;
		} else {
			$stitle = downloads_SubCatNameFromSID($sid);
			$subcatauth = (pnSecAuthAction(0, $ModName.'::Category', "$stitle::$sid", $actype));
		}

		if ((pnSecAuthAction(0, $ModName.'::Category', "$ctitle::$cid", $actype)) &&
		    ($subcatauth) &&
	    	(pnSecAuthAction(0, $ModName.'::Item', "$ititle::$lid", $actype)) ) {
			return true;
		} else {
			return false;
		}
	}
}

function DownloadsNewCat() 
{
	global $ModName;

    if (pnSecAuthAction(0, $ModName.'::', '::', ACCESS_ADD)) {
       OpenTable();
       echo "<form method=\"post\" action=\"admin.php\">"
       ."<font class=\"pn-title\"><b>"._ADDMAINCATEGORY."</b></font><br><br>"
			 ."<table>"
       ."<tr><td><font class=\"pn-normal\">"._NAME.": </font></td><td><input type=\"text\" name=\"title\" size=\"30\" maxlength=\"100\"></td></tr>"
       ."<tr><td><font class=\"pn-normal\">"._DESCRIPTION.": </font></td><td><textarea name=\"cdescription\" cols=\"60\" rows=\"10\"></textarea></td></tr>"
       ."<tr><td colspan=\"2\"><input type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
       ."<input type=\"hidden\" name=\"op\" value=\"DownloadsAddCat\">"
       ."<input type=\"hidden\" name=\"authid\" value=\"" . pnSecGenAuthKey() . "\">"
       ."<input type=\"submit\" value=\""._ADD."\"></td></tr>"
			 ."</table>"
       ."</form>";
       CloseTable();
    }
}


/* 	this function adds a new category through the admin-page
	It is checked to work with the upload-feature
 */
function DownloadsAddCat()
{
	global $ModName;
	include("config/dl-config.php");
	list($title,$cdescription) = pnVarCleanFromInput('title','cdescription');

	$title = strtr($title, "\\*?/\"<>|&.!", "___________");

	if (!pnSecConfirmAuthKey())
	{
		include 'header.php';
		echo _BADAUTHKEY;
		include 'footer.php';
		exit;
	}

	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

	if (!pnSecAuthAction(0, $ModName.'::Category', "$title::", ACCESS_ADD)) 
	{
		echo _DOWNLOADSCATADDNOAUTH;
		CloseTable();
		include 'footer.php';
		return;
	}

	$column = &$pntable['downloads_categories_column'];
  $table = $pntable['downloads_categories'];
	$result = $dbconn->Execute("SELECT $column[cid]
                                FROM $table
                                WHERE $column[title]='" . pnVarPrepForStore($title) . "'");
	if (!$result->EOF) 
	{
		include("header.php");
		GraphicAdmin();
		OpenTable();
		echo "<br><center><font class=\"pn-title\">"
		."<b>"._ERRORTHECATEGORY." ".pnVarPrepForDisplay($title)." "._ALREADYEXIST."</b><br><br>"
		.""._GOBACK."<br><br>";
		CloseTable();
		include("footer.php");
	} 
	else
	{
		global $ModName, $pnconfig;
	    $dbtype = $pnconfig['dbtype'];
		$dbname = $pnconfig['prefix'];

		include("config/dl-config.php");
		$foldername = strtr($title, " ", "_");

		/* Check if "store_folder" not exists */
		if(!is_dir($upload_folder))
		{
			/*if "store_folder" is missing tell you need it*/
			include("header.php");
			GraphicAdmin();
			OpenTable();
			echo "<br><center><font class=\"pn-title\">"
			."<b>"._NOSTOREFOLDER."</b><br><br>"
			.""._GOBACK."<br><br>";
			CloseTable();
			include("footer.php");
		}

		/* Check if "store_folder" is writable */
		if(!is_writable($upload_folder))
		{
			include("header.php");
			GraphicAdmin();
			OpenTable();
			echo "<br><center><font class=\"pn-title\">"
			."<b>"._NOSTOREFOLDERPERMS."</b><br><br>"
			.""._GOBACK."<br><br>";
			CloseTable();
			include("footer.php");
		}

		//dir for that catagory already exists
		if(@is_dir($upload_folder."/".$foldername))
		{
			if(!is_file($upload_folder."/".$foldername."/.htaccess") && $secure_download==1)
			{
				copy("modules/$ModName/includes/.htaccess",$upload_folder."/".$foldername."/.htaccess");
			}
			$table = $pntable['downloads_categories'];
//modified for Oracle compatibility
/*			$dbconn->Execute("INSERT INTO $table
						($column[cid],
						$column[title],
						$column[cdescription])
					VALUES
						(NULL,
						'" . pnVarPrepForStore($title) . "',
						'" . pnVarPrepForStore($cdescription) . "')");
*/
			switch ($dbtype){
				case "oci8":
                    $sequence=substr_replace($pntable['downloads_categories'],'',0,strlen($dbname)+1).'_sq';
					$newid = $dbconn->GenId($sequence);
					$dbconn->Execute("INSERT INTO $table
						($column[cid],
						$column[title],
						$column[cdescription])
					VALUES
						($newid, '" . pnVarPrepForStore($title) . "', empty_clob())");
						$dbconn->updateClob($table,$column[cdescription],$cdescription,"$column[cid]=".$newid);
					break;
				default:
			$dbconn->Execute("INSERT INTO $table
						($column[cid],
						$column[title],
						$column[cdescription])
					VALUES
						(NULL,
						'" . pnVarPrepForStore($title) . "',
						'" . pnVarPrepForStore($cdescription) . "')");
					break;
			}
/////
			pnRedirect('admin.php?module='.$ModName.'&op=downloads');
		}

		//dir for that catagory has do be created
		elseif(mkdir($upload_folder."/".$foldername,$folderperms))
		{
			if($secure_download==1)
			{
				copy("modules/$ModName/includes/.htaccess",$upload_folder."/".$foldername."/.htaccess");
			}
			$table = $pntable['downloads_categories'];
			$dbconn->Execute("INSERT INTO $table
						($column[cid],
						$column[title],
						$column[cdescription])
					VALUES
						(NULL,
						'" . pnVarPrepForStore($title) . "',
						'" . pnVarPrepForStore($cdescription) . "')");
			pnRedirect('admin.php?module='.$ModName.'&op=downloads');
		}
		else
                {
			include("header.php");
			GraphicAdmin();
			OpenTable();
			echo "<br><center><font class=\"pn-title\">"
			."<b>"._FORCATEGORY." ".pnVarPrepForDisplay($title)." "._NOFOLDERCREATE."</b><br><br>"
			.""._GOBACK."<br><br>";
			CloseTable();
			include("footer.php");
		}
	}
}

function DownloadsNewSubCat()
{
	global $ModName;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    if (pnSecAuthAction(0, $ModName.'::', '::', ACCESS_ADD)) {
       $column = &$pntable['downloads_categories_column'];
       $table = $pntable['downloads_categories'];
       $result=$dbconn->Execute("SELECT $column[cid],
                                        $column[title]
                                 FROM $table
                                 ORDER BY $column[title]");
        if (!$result->EOF) {
           OpenTable();
           echo "<form method=\"post\" action=\"admin.php\">"
            ."<font class=\"pn-title\"><b>"._ADDSUBCATEGORY."</b></font><br><br>"
            .""._NAME.": <input type=\"text\" name=\"title\" size=\"30\" maxlength=\"100\">&nbsp;"._IN."&nbsp;"
            ."<select name=\"cid\">";

//modified for Oracle compatibility
//            while(list($ccid, $ctitle) = $result->fields) {
            while(!$result->EOF){
				list($ccid, $ctitle) = $result->fields;
               echo "<option value=\"$ccid\">$ctitle</option>";
               $result->MoveNext();
            }
            echo "</select>"
            ."<input type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
            ."<input type=\"hidden\" name=\"op\" value=\"DownloadsAddSubCat\">"
            ."<input type=\"hidden\" name=\"authid\" value=\"" . pnSecGenAuthKey() . "\">"
            ."<input type=\"submit\" value=\""._ADD."\"><br>"
            ."</form>";
            CloseTable();
         }
    }
}

/* 	this function adds a new subcategory through the admin-page
	It is checked to work with the upload-feature
 */
function DownloadsAddSubCat()
{
	global $ModName;
	include("config/dl-config.php");
	include_once("modules/$ModName/dl-util.php");
		
	list($cid,$title) = pnVarCleanFromInput('cid','title');

	$title = strtr($title, "\\*?/\"<>|&.!", "___________");
	if(empty($title)) pnRedirect('admin.php?module='.$ModName.'&op=downloads');

	if (!pnSecConfirmAuthKey())
	{
		include 'header.php';
		echo _BADAUTHKEY;
		include 'footer.php';
		exit;
	}

	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

	if (!pnSecAuthAction(0, $ModName.'::Category', "$title::", ACCESS_ADD))
	{
		echo _DOWNLOADSCATADDNOAUTH;
		CloseTable();
		include 'footer.php';
		return;
	}

	$column = &$pntable['downloads_subcategories_column'];
        $table = $pntable['downloads_subcategories'];
	$result = $dbconn->Execute("SELECT $column[cid]
                                FROM $table
                                WHERE $column[title]='" . pnVarPrepForStore($title) . "'
                                AND $column[cid]='" . pnVarPrepForStore($cid) . "'");
	if (!$result->EOF)
	{
		include("header.php");
		GraphicAdmin();
		OpenTable();
		echo "<br><center>";
		echo "<font class=\"pn-title\">"
		."<b>"._ERRORTHESUBCATEGORY." ".pnVarPrepForDisplay($title)." "._ALREADYEXIST."</b><br><br>"
		.""._GOBACK."<br><br>";
		include("footer.php");
	}
	else
	{
		$foldername = RemoveSpaces($title);
		$cat_column = &$pntable['downloads_categories_column'];
                $table = $pntable['downloads_categories'];
		$cat_result = $dbconn->Execute("SELECT $cat_column[title]
						FROM $table
						WHERE $cat_column[cid]='".$cid."'");
		list($ctitle)=$cat_result->fields;
		$ctitle = RemoveSpaces($ctitle);

                if (!$cat_result->EOF)
		{
			if(@is_dir($upload_folder."/".$ctitle."/".$foldername))
			{
				if(!is_file($upload_folder."/".$ctitle."/".$foldername."/.htaccess") && $secure_download==1)
				{
					copy("modules/$ModName/includes/.htaccess",$upload_folder."/".$ctitle."/".$foldername."/.htaccess");
				}
				
				$table = $pntable['downloads_subcategories'];
				$dbconn->Execute("INSERT INTO $table
						($column[sid],
						$column[cid],
						$column[title])
					VALUES
						(NULL,
						'" . pnVarPrepForStore($cid) . "',
						'" . pnVarPrepForStore($title) . "')");
				pnRedirect('admin.php?module='.$ModName.'&op=downloads');
			}
			elseif(mkdir($upload_folder."/".$ctitle."/".$foldername,$folderperms))
			{
				if($secure_download==1)
				{
					copy("modules/$ModName/includes/.htaccess",$upload_folder."/".$ctitle."/".$foldername."/.htaccess");
				}
				
				$table = $pntable['downloads_subcategories'];
				$dbconn->Execute("INSERT INTO $table
						($column[sid],
						$column[cid],
						$column[title])
					VALUES
						(NULL,
						'" . pnVarPrepForStore($cid) . "',
						'" . pnVarPrepForStore($title) . "')");
				pnRedirect('admin.php?module='.$ModName.'&op=downloads');
			}
			else
			{
				include("header.php");
				GraphicAdmin();
				OpenTable();
				echo "<br><center><font class=\"pn-title\">"
				."<b>"._FORCATEGORY." ".pnVarPrepForDisplay($title)." "._NOFOLDERCREATE."</b><br><br>"
				.""._GOBACK."<br><br>";
				CloseTable();
				include("footer.php");
			}
		}
	}
}


function DownloadsModCat($cat)
{
	global $ModName;

	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

	if (pnSecAuthAction(0, $ModName.'::Category', '::', ACCESS_EDIT)) 
        {
		include ("header.php");
		GraphicAdmin();
		OpenTable();
		echo "<center><font class=\"pn-title\"><b>"._WEBDOWNLOADSADMIN."</b></font></center>";
		CloseTable();

		$cat = explode("-", $cat);
		if (!isset($cat[1])) 
                {
			$cat[1] = 0;
		}
		OpenTable();
		echo "<center><font class=\"pn-title\"><b>"._MODCATEGORY."</b></font></center><br><br>";
		if ($cat[1]==0) 
		{
			$column = &$pntable['downloads_categories_column'];
                        $table = $pntable['downloads_categories'];
			$result=$dbconn->Execute("SELECT $column[title],
							$column[cdescription]
							FROM $table
							WHERE $column[cid]=" . pnVarPrepForStore($cat[0]));

			list($title,$cdescription) = $result->fields;
			$cdescription = stripslashes($cdescription);

			echo "<form action=\"admin.php\" method=\"get\">"
			.""._NAME.": <input type=\"text\" name=\"title\" value=\"$title\" size=\"51\" maxlength=\"50\"><br>"
			.""._DESCRIPTION.":<br><textarea name=\"cdescription\" cols=\"60\" rows=\"10\">".pnVarPrepHTMLDisplay($cdescription)."</textarea><br>"
			."<input type=\"hidden\" name=\"sub\" value=\"0\">"
			."<input type=\"hidden\" name=\"cid\" value=\"$cat[0]\">"
			."<input type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
			."<input type=\"hidden\" name=\"op\" value=\"DownloadsModCatS\">"
			."<input type=\"hidden\" name=\"authid\" value=\"" . pnSecGenAuthKey() . "\">"
			."<table border=\"0\"><tr><td>"
			."<input type=\"submit\" value=\""._SAVECHANGES."\"></form></td><td>"

			."<form action=\"admin.php\" method=\"get\">"
			."<input type=\"hidden\" name=\"sub\" value=\"0\">"
			."<input type=\"hidden\" name=\"cid\" value=\"$cat[0]\">"
			."<input type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
			."<input type=\"hidden\" name=\"op\" value=\"DownloadsDelCat\">"
			."<input type=\"submit\" value=\""._DELETE."\"></form></td></tr></table>";
		}
		else
		{
			$column = &$pntable['downloads_categories_column'];
                        $table = $pntable['downloads_categories'];
			$result=$dbconn->Execute("SELECT $column[title]
						FROM $table
						WHERE $column[cid]=" . pnVarPrepForStore($cat[0]));
			list($ctitle) = $result->fields;

			$column = &$pntable['downloads_subcategories_column'];
			$table = $pntable['downloads_subcategories'];
			$result2=$dbconn->Execute("SELECT $column[title]
						FROM $table
						WHERE $column[sid]=" . pnVarPrepForStore($cat[1]));
			list($stitle) = $result2->fields;

			echo "<form action=\"admin.php\" method=\"get\">"
			.""._CATEGORY.": $ctitle<br>"
			.""._SUBCATEGORY.": <input type=\"text\" name=\"title\" value=\"$stitle\" size=\"51\" maxlength=\"50\"><br>"
			."<input type=\"hidden\" name=\"sub\" value=\"1\">"
			."<input type=\"hidden\" name=\"cid\" value=\"$cat[0]\">"
			."<input type=\"hidden\" name=\"sid\" value=\"$cat[1]\">"
			."<input type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
			."<input type=\"hidden\" name=\"op\" value=\"DownloadsModCatS\">"
			."<input type=\"hidden\" name=\"authid\" value=\"" . pnSecGenAuthKey() . "\">"
			."<table border=\"0\"><tr><td>"
			."<input type=\"submit\" value=\""._SAVECHANGES."\"></form></td><td>"

			."<form action=\"admin.php\" method=\"get\">"
			."<input type=\"hidden\" name=\"sub\" value=\"1\">"
			."<input type=\"hidden\" name=\"cid\" value=\"$cat[0]\">"
			."<input type=\"hidden\" name=\"sid\" value=\"$cat[1]\">"
			."<input type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
			."<input type=\"hidden\" name=\"op\" value=\"DownloadsDelCat\">"
			."<input type=\"submit\" value=\""._DELETE."\"></form></td></tr></table>";
		}
		CloseTable();
		include("footer.php");
	}
}

function DownloadsModCatS()
{
	global $ModName;

	list(	$cid,
		$sid,
		$sub,
		$title,
		$cdescription) = pnVarCleanFromInput(	'cid',
							'sid',
							'sub',
							'title',
							'cdescription');
       
	$title = strtr($title, "\\*?/\"<>|&.!", "___________");

	global $ModName;
	include("config/dl-config.php");
	include_once("modules/$ModName/dl-util.php");
	
	if (!pnSecConfirmAuthKey()) 
	{
		include 'header.php';
		echo _BADAUTHKEY;
		include 'footer.php';
		exit;
	}

	if (!isset($cdescription))
	{
		$cdescription = '';
	}

	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

	$catcolumn = &$pntable['downloads_categories_column'];
	$cattable  = $pntable['downloads_categories'];
	$result    = $dbconn->Execute("SELECT $catcolumn[title]
					FROM $cattable
					WHERE $catcolumn[cid] = " . pnVarPrepForStore($cid));
	list($oldtitle) = $result->fields;
	$result->Close();
        $oldtitle = RemoveSpaces($oldtitle);
        
	if (!pnSecAuthAction(0, $ModName.'::Category', "$oldtitle::$cid", ACCESS_EDIT))
	{
		echo _DOWNLOADSCATEDITNOAUTH;
		CloseTable();
		include 'footer.php';
		return;
	}

	if ($sub==0)
        {
        
        	$clean_title = RemoveSpaces($title);
		rename($upload_folder."/".$oldtitle, $upload_folder."/".$clean_title);

		$file_column = &$pntable['downloads_downloads_column'];

		//// first we get the lid in the file_result
                $table = $pntable['downloads_downloads'];
		$file_result = $dbconn->Execute("SELECT $file_column[url], $file_column[lid]
						FROM $table
						WHERE $file_column[cid]='".$cid."'");

		//// then put it in the propper variable
//modified for Oracle compatibility
//		while(list($url, $lid) = $file_result->fields){
		while(!$file_result->EOF){
			list($url, $lid) = $file_result->fields;
			$file_result->MoveNext();
			$vari = array($upload_folder."/".$oldtitle => $upload_folder."/".$clean_title);
                        $url = strtr($url,$vari);
			$file_column = &$pntable['downloads_downloads_column'];
			//// here you put the lid column in the WHERE clause
                        $table = $pntable['downloads_downloads'];
			$dbconn->Execute("UPDATE $table
						SET
						      $file_column[url]='".$url."'
						WHERE $file_column[lid]='".$lid."'");
		}

		$column = &$pntable['downloads_categories_column'];
                $table = $pntable['downloads_categories'];
		$dbconn->Execute("UPDATE $table
					SET 	$column[title]='" . pnVarPrepForStore($title) . "',
						$column[cdescription]='" . pnVarPrepForStore($cdescription) . "'
					WHERE $column[cid]=" . pnVarPrepForStore($cid));
	}
	else
	{
		$clean_title = RemoveSpaces($title);

		$subcolumn = &$pntable['downloads_subcategories_column'];
		$subtable  = $pntable['downloads_subcategories'];
		$subresult    = $dbconn->Execute("SELECT $subcolumn[title]
							FROM $subtable
							WHERE $subcolumn[sid] = " . pnVarPrepForStore($sid));
		list($oldsubtitle) = $subresult->fields;
		$subresult->Close();
                $oldsubtitle = RemoveSpaces($oldsubtitle);

		rename($upload_folder."/".$oldtitle."/".$oldsubtitle, $upload_folder."/".$oldtitle."/".$clean_title);

		$file_column = &$pntable['downloads_downloads_column'];
                $table = $pntable['downloads_downloads'];
		$file_result = $dbconn->Execute("SELECT $file_column[url],$file_column[lid]
						FROM $table
						WHERE $file_column[sid]='".$sid."'");
//modified for Oracle compatibility
//		while(list($url,$lid) = $file_result->fields){
		while(!$file_result->EOF){
			list($url,$lid) = $file_result->fields;
			$file_result->MoveNext();
			$vari = array($upload_folder."/".$oldtitle."/".$oldsubtitle => $upload_folder."/".$oldtitle."/".$clean_title);
			$url = strtr($url,$vari);
			$file_column = &$pntable['downloads_downloads_column'];
                        $table = $pntable['downloads_downloads'];
			$dbconn->Execute("UPDATE $table
						SET
							$file_column[url]='".$url."'
						WHERE $file_column[lid]='".$lid."'");
		}

		$column = &$pntable['downloads_subcategories_column'];
                $table = $pntable['downloads_subcategories'];
		$dbconn->Execute("UPDATE $table
					SET 	$column[title]='" . pnVarPrepForStore($title) . "'
					WHERE $column[sid]=" . pnVarPrepForStore($sid));
	}
	pnRedirect('admin.php?module='.$ModName.'&op=downloads');
}

function DownloadsDelCat()
{
	global $ModName;

	list(	$cid,
		$sid,
		$sub,
		$ok) = pnVarCleanFromInput(	'cid',
						'sid',
						'sub',
						'ok'  );

	if (!isset($ok)) 
	{
		$ok = 0;
	}

	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

	$catcolumn = &$pntable['downloads_categories_column'];
	$cattable  = $pntable['downloads_categories'];
	$result    = $dbconn->Execute("SELECT $catcolumn[title]
					FROM $cattable
					WHERE $catcolumn[cid] = " . pnVarPrepForStore($cid));
	list($oldtitle) = $result->fields;
	$result->Close();

	if (!pnSecAuthAction(0, $ModName.'::Category', "$oldtitle::$cid", ACCESS_DELETE)) 
	{
		echo _DOWNLOADSCATDELNOAUTH;
		CloseTable();
		include 'footer.php';
		return;
	}
	
	include("config/dl-config.php");
	include_once("modules/$ModName/dl-util.php");
	
	$cat_column = &$pntable['downloads_categories_column'];
        $table = $pntable['downloads_categories'];
	$cat_result = $dbconn->Execute("SELECT $cat_column[title]
					FROM $table
					WHERE $cat_column[cid]='".$cid."'");
	list($ctitle)=$cat_result->fields;
        $ctitle = RemoveSpaces($ctitle);

	$sub_column = &$pntable['downloads_subcategories_column'];
        $table = $pntable['downloads_subcategories'];
	$sub_result = $dbconn->Execute("SELECT $sub_column[title]
					FROM $table
					WHERE $sub_column[sid]='".$sid."'");
	list($stitle) = $sub_result->fields;
        $stitle = RemoveSpaces($stitle);

	if($ok==1) 
	{
		if ($sub>0)
		{
			$folder = dir($upload_folder."/".$ctitle."/".$stitle);
			while($entry=$folder->read())
			{
				if($entry != "." && $entry!= "..")unlink($upload_folder."/".$ctitle."/".$stitle."/".$entry);
			}
			$folder->close();
			$ans = rmdir($upload_folder."/".$ctitle."/".$stitle);

			
			$table1 = $pntable['downloads_subcategories'];
                        $table2 = $pntable['downloads_subcategories_column']['sid'];
                        $dbconn->Execute("DELETE FROM $table1
						WHERE {$table2}=" . pnVarPrepForStore($sid));

			$table1 = $pntable['downloads_downloads'];
                        $table2 = $pntable['downloads_downloads_column']['sid'];
			$dbconn->Execute("DELETE FROM $table1
						WHERE {$table2}=" . pnVarPrepForStore($sid));
		}
		else
		{
			$sub_column = &$pntable['downloads_subcategories_column'];
                        $table = $pntable['downloads_subcategories'];
			$sub_result = $dbconn->Execute("SELECT $sub_column[title]
							FROM $table
							WHERE $sub_column[cid]='".$cid."'");
//modified for Oracle compatibility
//			while(list($stitle) = $sub_result->fields){
			while(!$sub_result->EOF){
				list($stitle) = $sub_result->fields;
				$sub_result->MoveNext();
				$stitle = RemoveSpaces($stitle);
				$folder = dir($upload_folder."/".$ctitle."/".$stitle);
				while($entry=$folder->read())
				{
					if($entry != "." && $entry!= "..")unlink($upload_folder."/".$ctitle."/".$stitle."/".$entry);
				}
				$folder->close();
				$ans = rmdir($upload_folder."/".$ctitle."/".$stitle);

			}
			$folder = dir($upload_folder."/".$ctitle);
			while($entry=$folder->read())
			{
				if($entry != "." && $entry!= "..")unlink($upload_folder."/".$ctitle."/".$entry);
			}
			$folder->close();
			$ans = rmdir($upload_folder."/".$ctitle);

			
			$table1 = $pntable['downloads_categories'];
			$table2 = $pntable['downloads_categories_column']['cid'];
			$dbconn->Execute("DELETE FROM $table1
						WHERE {$table2}=" . pnVarPrepForStore($cid));
                                                
			$table1 = $pntable['downloads_subcategories'];
                        $table2 = $pntable['downloads_subcategories_column']['cid'];
			$dbconn->Execute("DELETE FROM $table1
						WHERE {$table2}=" . pnVarPrepForStore($cid));
                                                
			$table1 = $pntable['downloads_downloads'];
                        $table2 = $pntable['downloads_downloads_column']['cid'];
                        $table3 = $pntable['downloads_downloads_column']['sid'];
			$dbconn->Execute("DELETE FROM $table1
						WHERE {$table2}=" . pnVarPrepForStore($cid) . "
						AND {$table3}=0");
		}
	        pnRedirect('admin.php?module='.$ModName.'&op=downloads');
	}
	else
	{
		include("header.php");
		GraphicAdmin();
		OpenTable();
		echo "<br><center><font class=\"pn-title\">";
		echo "<b>"._DDELCATWARNING."</b><br>";

		if ($sub>0)
		{
			$verz = dir($upload_folder."/".$ctitle."/".$stitle);
		}
		else
		{
			$verz = dir($upload_folder."/".$ctitle);
		}
		echo _FILESTODELIN."  ".$verz->path."<br>";
		while($entry=$verz->read())
		{
			if($entry != "." && $entry!= "..")echo $entry."<br>";
		}
		$verz->close();
                echo "<br><br>";
	}
	echo "\n<form action=\"admin.php\" method=\"post\">"
	."<input   type=\"hidden\" name=\"module\" value=\"".$ModName."\">"
	."\n<input type=\"hidden\" name=\"op\"     value=\"DownloadsDelCat\">"
	."<input   type=\"hidden\" name=\"authid\" value=\"" . pnSecGenAuthKey() . "\">"
	."\n<input type=\"hidden\" name=\"cid\"    value=\"$cid\">"
	."\n<input type=\"hidden\" name=\"sid\"    value=\"$sid\">"
	."\n<input type=\"hidden\" name=\"sub\"    value=\"$sub\">"
	."\n<input type=\"hidden\" name=\"ok\"    value=\"1\">"
	."\n<input type=\"submit\" value=\""._YES."\">"
	."\n<input type=\"reset\" value=\""._NO."\" onClick=\"window.location.href = 'admin.php?module=".$ModName."&amp;op=main'\">"
	."\n<br><br>";
	CloseTable();
	include 'footer.php';
}


function downloads_outputpagelinks($catid, $modurl, $orderby, $totalselecteddownloads, $perpage, $min, $max, $show, $dllinktext, $dlidtext)
{
	global $ModName;

    $orderby = convertorderbyout($orderby);
    /* Calculates how many pages exist.  Which page one should be on, etc... */

    $downloadpagesint = ($totalselecteddownloads / $perpage);
    $downloadpageremainder = ($totalselecteddownloads % $perpage);
    if ($downloadpageremainder != 0) {
        $downloadpages = ceil($downloadpagesint);
        if ($totalselecteddownloads < $perpage) {
            $downloadpageremainder = 0;
        }
    } else {
        $downloadpages = $downloadpagesint;
    }


    /* Page Numbering */
    if ($downloadpages > 1) {
        echo "<br><br>"
        ."<font class=\"pn-normal\">"._SELECTPAGE.":</font> ";
        $prev=$min-$perpage;
        if ($prev>=0) {
            echo "&nbsp;&nbsp;[ <a class=\"pn-normal\" href=\"$modurl&amp;req=$dllinktext&amp;$dlidtext=$catid&amp;min=$prev&amp;orderby=$orderby&amp;show=$show\">"
            ." &lt;&lt; "._PREVIOUS."</a> ] ";
        }
        $counter = 1;
        $currentpage = ($max / $perpage);
        while ($counter<=$downloadpages ) {
            $cpage = $counter;
            $mintemp = ($perpage * $counter) - $perpage;
            if ($counter == $currentpage) {
                echo "<font class=\"pn-normal\">".(int)$counter."</font>&nbsp";
            } else {
                echo "<a class=\"pn-normal\" href=\"$modurl&amp;req=$dllinktext&amp;$dlidtext=$catid&amp;min=$mintemp&amp;orderby=$orderby&amp;show=$show\">".(int)$counter."</a> ";
            }
            $counter++;
        }
        $next=$min+$perpage;
        if ($currentpage < $downloadpages) {
            echo "&nbsp;&nbsp;[ <a class=\"pn-normal\" href=\"$modurl&amp;req=$dllinktext&amp;$dlidtext=$catid&amp;min=$max&amp;orderby=$orderby&amp;show=$show\">"
            ." "._NEXT." &gt;&gt;</a> ] ";
        }
    }
}

function downloads_outputitem ($lid, $url, $title, $image, $description, $time, $hits, $downloadratingsummary, $totalvotes, $totalcomments, $filesize, $version, $homepage, $modurl, $ModName)
{
        global $ModName;
        include("config/dl-config.php");

        if (downloads_authitem((downloads_ItemCIDFromLID($lid)), (downloads_ItemSIDFromLID($lid)), $lid, ACCESS_READ) ) {
            $downloadratingsummary = number_format($downloadratingsummary, pnConfigGetVar('mainvotedecimal'));
            $title = pnVarPrepForDisplay($title); $description = pnVarPrepHTMLDisplay($description);
            $transfertitle = str_replace (" ", "_", $title);

            $dlicon = get_icon($lid);

            if ($displayscreenshot==1) {
                $col_span = 3;
            } else {
                $col_span = 3;
								$image = 'empty.gif';
            }

            echo"<table width=100% border=0>";
            if (downloads_authitem((downloads_ItemCIDFromLID($lid)), (downloads_ItemSIDFromLID($lid)), $lid, ACCESS_EDIT) ) {
                echo "<tr><td colspan=\"$col_span\"><a class=\"pn-normal\" href=\"admin.php?module=$ModName&amp;op=DownloadsModDownload&amp;lid=$lid\"><img src=\"modules/$ModName/images/$dlicon\" border=\"0\" alt=\""._EDIT."\"></a>&nbsp;&nbsp;";
            } else {
                echo "<tr><td colspan=\"$col_span\"><img src=\"modules/$ModName/images/$dlicon\" border=\"0\" alt=\"\">&nbsp;&nbsp;";
            }
            echo "<a class=\"pn-normal\" href=\"$modurl&amp;req=getit&amp;lid=$lid\"><b>$title</b></a>";
            newdownloadgraphic($datetime, $time);
            popgraphic($hits);
            echo "</td></tr>";

        //Description
            /* code for *editor review* insert here */
            detecteditorial($lid, $transfertitle, 1);
            $description = nl2br($description);
            if ($description != "") {
                echo "<tr><td width=\"20%\" valign=\"top\"><font class=\"pn-normal\"><b>"._DESCRIPTION.":</b></font></td><td><font class=\"pn-normal\"> $description</font></td>";
            }

            if ($displayscreenshot==1) {
                echo "<td width = \"". ($screenshotwidth + 30). "\" rowspan = \"5\" valign=\"top\" align=\"middle\" >";
                get_screenshot($image);
                echo "</td>";
            }

            echo "</tr>";

        //Version
            if ($version != "") {
                echo "<tr><td width=\"20%\"><font class=\"pn-normal\"><b>"._VERSION.":</b></font></td><td> <font class=\"pn-normal\">".pnVarPrepForDisplay($version)."</font></td></tr>";
            }

        //Filesize
            echo "<tr><td width=\"20%\"><font class=\"pn-normal\"><b>"._FILESIZE.":</b></font></td><td> <font class=\"pn-normal\">".CoolSize($filesize)."</font></td></tr>";

        //Date and Time
            setlocale (LC_TIME, pnConfigGetVar('locale'));
            ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
            $datetime = ml_ftime(""._LINKSDATESTRING."", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
            $datetime = ucfirst($datetime);
            echo "<tr><td><font class=\"pn-normal\"><b>"._ADDEDON.":</b></font></td><td> <font class=\"pn-normal\">".pnVarPrepForDisplay($datetime)."</font></td></tr>";

        //Downloadcount
            echo "<tr><td width=\"20%\"><font class=\"pn-normal\"><b>"._UDOWNLOADS.":</b></font></td><td><font class=\"pn-normal\"> ".(int)$hits."</font></td></tr>";

            $transfertitle = str_replace (" ", "_", $title);

        //voting & comments stats
            if ($totalvotes == 1) {
                $votestring = _VOTE;
            } else {
                $votestring = _VOTES;
            }
            if ($downloadratingsummary!="0" || $downloadratingsummary!="0.0") {
                echo "<tr><td width=\"20%\"><font class=\"pn-normal\"><b>"._RATING.":</b></font></td><td><font class=\"pn-normal\">".pnVarPrepForDisplay($downloadratingsummary)." (".(int)$totalvotes." ".pnVarPrepForDisplay($votestring).")</font></td></tr>";
            }


        //Categorie
            list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

            $result_cid=$dbconn->Execute("SELECT ".$pntable['downloads_downloads_column']['cid'].
                                                 " FROM ".$pntable['downloads_downloads'].
                                                 " WHERE ".$pntable['downloads_downloads_column']['lid']."=".$lid);
            list($cid) = $result_cid->fields;
            $result_sid=$dbconn->Execute("SELECT ".$pntable['downloads_downloads_column']['sid'].
                                                 " FROM ".$pntable['downloads_downloads'].
                                                 " WHERE ".$pntable['downloads_downloads_column']['lid']."=".$lid);
            list($sid) = $result_sid->fields;

            $result_c=$dbconn->Execute("SELECT ".$pntable['downloads_categories_column']['title'].
                                               " FROM ".$pntable['downloads_categories'].
                                               " WHERE ".$pntable['downloads_categories_column']['cid']."=".$cid);
            list($ctitle) = $result_c->fields;
            echo "<tr><td width=\"20%\"><font class=\"pn-normal\"><b>"._CATEGORY.":</b></font></td><td><font class=\"pn-normal\"> ".pnVarPrepForDisplay($ctitle)."</font>";

            $table = $pntable['downloads_subcategories'];
            $result_s=$dbconn->Execute("SELECT ".$pntable['downloads_subcategories_column']['title'].
                                               " FROM ".$pntable['downloads_subcategories'].
                                               " WHERE ".$pntable['downloads_subcategories_column']['sid']."=".$sid);
            list($stitle) = $result_s->fields;
            if(isset($stitle))
                echo " / $stitle";
            echo "</td></tr>";


        //Homepage
            echo"<tr><td colspan=\"$col_span\" align=\"right\">";
            if ($homepage != "" && $homepage != "http://" ) {
                echo "<a class=\"pn-normal\" href=\"$homepage\" target=\"new\">"._HOMEPAGE."</a> | ";
            }
            
        //Links
            if (downloads_authitem((downloads_ItemCIDFromLID($lid)), (downloads_ItemSIDFromLID($lid)), $lid, ACCESS_COMMENT) ) {
                echo "<a class=\"pn-normal\" href=\"$modurl&amp;req=ratedownload&amp;lid=$lid&amp;ttitle=$transfertitle\">"._RATERESOURCE."</a>";
                echo " | ";
            }
            echo "<a class=\"pn-normal\" href=\"$modurl&amp;req=viewdownloaddetails&amp;lid=$lid&amp;ttitle=$transfertitle\">"._DETAILS."</a>";
            if ($totalcomments != 0) {
                echo " | <a class=\"pn-normal\" href=\"$modurl&amp;req=viewdownloadcomments&amp;lid=$lid&amp;ttitle=$transfertitle\">"._COMMENTS." (".(int)$totalcomments.")</a>";
            }
            detecteditorial($lid, $transfertitle, 0);
            echo "</td></tr><tr height=\"1\" bgcolor=\"#eeeeee\"><td colspan=\"$col_span\"></td></tr></table>";
        }
}

?>