<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Francisco Burzi
// Purpose of file:Download tracker/organizer
// ----------------------------------------------------------------------
// 15/01/2002 - Frank - Image and minor utility
//-----------------------------------------------------------------------
// Upload feature added from:
// Vassilis Stratigakis
// webmaster@tequilastarrise.net

if (!defined("LOADED_AS_MODULE"))
{
    die ("You can't access this file directly...");
}

$ModName = basename( dirname( __FILE__ ) );
$modurl="modules.php?op=modload&amp;name=$ModName&amp;file=index"; //Shorten url text

modules_get_language();

include_once ("modules/$ModName/dl-util.php");
include_once ("modules/$ModName/dl-categories.php");
include_once ("modules/$ModName/dl-navigation.php");

/*
 * If register_globals is off, then extract all HTTP variables into the global
 * namespace.
 */

$register_globals = ini_get("register_globals");
if (empty($register_globals) ||
        !strcasecmp($register_globals, "off") ||
        !strcasecmp($register_globals, "false"))
{
    extract($HTTP_GET_VARS);
    extract($HTTP_POST_VARS);
    extract($HTTP_COOKIE_VARS);

    foreach($HTTP_POST_FILES as $key => $value)
    {
        ${$key."_name"} = $value["name"];
        ${$key."_size"} = $value["size"];
        ${$key."_type"} = $value["type"];
        ${$key} = $value["tmp_name"];
    }
}

/**
 * Switch on $req
 * load the appropriate module, and call the appropriate function.
 */
if(empty($req)) {
        $req = '';
}

switch($req) {

    case "menu":
      menu($maindownload);
    break;

    // Menu downloads
    case "AddDownload":
      include_once ("modules/$ModName/dl-adddownload.php");
      AddDownload();
    break;

    case "NewDownloads":
      include_once ("modules/$ModName/dl-newdownloads.php");

      // E_ALL complains if we pass an empty argument, lets settle on a week for a starter
      // (AV) think this $var should initially come from the config system

      if(!isset($newdownloadshowdays)) {
                                $newdownloadshowdays = 7;
      }
      NewDownloads($newdownloadshowdays);
    break;

    case "NewDownloadsDate":
      include_once ("modules/$ModName/dl-newdownloads.php");
      NewDownloadsDate($selectdate);
    break;

    case "CoolSize":
        CoolSize($size);
    break;

    case "TopRated":
      include_once ("modules/$ModName/dl-toprated.php");

      if(!isset($ratenum)) {
          $ratenum = '';
      }

      if(!isset($ratetype)) {
          $ratetype = '';
      }
      TopRated($ratenum, $ratetype);
    break;

    case "MostPopular":
      include_once ("modules/$ModName/dl-mostpopular.php");

      // E_ALL warnings here again...
      // initial $vars shouldn't be empty, but come from the module or system config
      if(!isset($ratenum)) {
          $ratenum = '';
      }

      if(!isset($ratetype)) {
          $ratetype = '';
      }
      MostPopular($ratenum, $ratetype);
    break;

    // currently not implemented. i just left this in. anyone plug it in?
    case "Randomdownload":
       include_once ("modules/$ModName/dl-randomdownload.php");
       Randomdownload();
    break;

    case "search":
      include_once ("modules/$ModName/dl-search.php");

      if(!isset($min)) {
          $min = 0;
      }

      if(!isset($orderby)) {
          $orderby = 0;
      }

      if(!isset($show)) {
          $show = '';
      }
      search($query, $min, $orderby, $show);
    break;

    //End of navigation Menu downloads
    //Display a download - called from index
    case "viewdownload":
      include_once ("modules/$ModName/dl-viewdownload.php");

      if(!isset($min)) {
          $min = 0;
      }

      if(!isset($orderby)) {
          $orderby = 0;
      }

      if(!isset($show)) {
          $show = '';
      }
      viewdownload($cid, $min, $orderby, $show);
    break;

    case "viewsdownload":
      include_once ("modules/$ModName/dl-viewdownload.php");

      if(!isset($min)) {
          $min = 0;
      }

      if(!isset($orderby)) {
          $orderby = 0;
      }

      if(!isset($show)) {
          $show = '';
      }
      viewsdownload($sid, $min, $orderby, $show);
    break;

    case "brokendownload":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      brokendownload($lid);
    break;

    case "modifydownloadrequest":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      modifydownloadrequest($lid);
    break;

    case "modifydownloadrequestS":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      modifydownloadrequestS($lid, $cat, $title, $url, $image, $description, $modifysubmitter, $aname, $email, $filesize, $version, $homepage);
    break;

    case "brokendownloadS":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      brokendownloadS($lid, $modifysubmitter);
    break;

    case "getit":
        visit($lid);
    break;

    case "Add":
      include_once ("modules/$ModName/dl-adddownload.php");
      Add();
    break;

    case "rateinfo":
      include_once ("modules/$ModName/dl-rating.php");
      rateinfo($lid, $title);
    break;

    case "ratedownload":
      include_once ("modules/$ModName/dl-rating.php");
      ratedownload($lid, $ttitle);
    break;

    case "addrating":
      include_once ("modules/$ModName/dl-rating.php");
      addrating($ratinglid, $ratinguser, $rating, $ratinghost_name, $ratingcomments);
    break;

    case "viewdownloadcomments":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      viewdownloadcomments($lid, $ttitle);
    break;

    case "outsidedownloadsetup":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      outsidedownloadsetup($lid);
    break;

    case "viewdownloaddetails":
      include_once ("modules/$ModName/dl-downloaddetails.php");
      viewdownloaddetails($lid, $ttitle);
    break;

    case "viewdownloadeditorial":
      include_once ("modules/$ModName/dl-downloadeditorial.php");
      viewdownloadeditorial($lid, $ttitle);
    break;

    case "listlastdownloads":
      include_once ("modules/$ModName/dl-listlastdownloads.php");
      listlastdownloads($count);
    break;

    default:
      index();
}
?>
