<?php

class LayersMenuCommon {
	var $prependedUrl;
	var $dirroot;
	var $libjsdir;
	var $imgdir;
	var $imgwww;
	var $tpldir;
	var $menuStructure;
	var $_nodesCount;
	var $tree;
	var $_maxLevel;
	var $_firstLevelCnt;
	var $_firstItem;
	var $_lastItem;
	var $_tmpArray = array();

	function LayersMenuCommon() {
		$this->prependedUrl = "";
		$this->dirroot 	= "./";
                $this->libjsdir         = "modules/MDMenus/libs/";
                $this->imgdir                 = "modules/MDMenus/pnimages/";
                $this->imgwww         = "modules/MDMenus/pnimages/";
                $this->tpldir                 = "modules/MDMenus/templates/";
		$this->menuStructure = "";
		$this->separator 	= "|";
		$this->_nodesCount 	= 0;
		$this->tree 		= array();
		$this->_maxLevel 	= array();
		$this->_firstLevelCnt 	= array();
		$this->_firstItem 	= array();
		$this->_lastItem 	= array();
	}

	function scanTableForMenu($menu_name = "", $parent = 1) {
		$this->_maxLevel[$menu_name] = 0;
		$this->_firstLevelCnt[$menu_name] = 0;
		unset($this->tree[$this->_nodesCount+1]);
		$this->_firstItem[$menu_name] = $this->_nodesCount + 1;
	
                pnModDBInfoLoad('MDMenus');
		list($dbconn) = pnDBGetConn(); 
		$pntable = pnDBGetTables(); 
                $table = $pntable['mdmenus'];
		$column =& $pntable['menus_column']; 
		$result = $dbconn->Execute($s="
				SELECT $column[id], 
					$column[parent_id],
					$column[text], 
					$column[href],
					$column[title], 
					$column[icon],
					$column[target],
					$column[expanded]
			FROM	$table
			WHERE $column[id] <> 1
			ORDER BY $column[orderfield], $column[text] ASC"); 
		$this->_tmpArray = array(); 
		while (!$result->EOF) {
			list($id,$parent_id,$text,$href,$title,$icon,$target,$expanded) = $result->fields;
			$result->MoveNext();
                        if (pnSecAuthAction(0, 'SuperMenus::', ":$text:", ACCESS_READ)) {

			$this->_tmpArray[$id]["id"]			= $id;
			$this->_tmpArray[$id]["parent_id"]	= $parent_id;
			$this->_tmpArray[$id]["text"]		= $text;
			$this->_tmpArray[$id]["href"]		= $href;
			$this->_tmpArray[$id]["title"]		= $title;
			$this->_tmpArray[$id]["icon"]		= $icon;
			$this->_tmpArray[$id]["target"]		= $target;
			$this->_tmpArray[$id]["expanded"]	= $expanded;
                               }
		}
		$this->_depthFirstSearch($this->_tmpArray, $menu_name, $parent, 1);
		$this->_lastItem[$menu_name] = count($this->tree);
		$this->_nodesCount = $this->_lastItem[$menu_name];
		$this->tree[$this->_lastItem[$menu_name]+1]["level"] = 0;
		$this->_postParse($menu_name);
	}

	function _depthFirstSearch($tmpArray, $menu_name, $parent_id=1, $level) {
		reset ($tmpArray);
		while (list($id, $foobar) = each($tmpArray)) {
			if ($foobar["parent_id"] == $parent_id) {
				unset($tmpArray[$id]);
				unset($this->_tmpArray[$id]);
				$cnt = count($this->tree) + 1;
				$this->tree[$cnt]["id"]		= $foobar["id"];
				$this->tree[$cnt]["parent_id"]= $foobar["parent_id"];
				$this->tree[$cnt]["level"] 	= $level;
				$this->tree[$cnt]["text"] 	= $foobar["text"];
				$this->tree[$cnt]["href"] 	= $foobar["href"];
				$this->tree[$cnt]["title"] 	= $foobar["title"];
				$this->tree[$cnt]["icon"] 	= $foobar["icon"];
				$this->tree[$cnt]["target"] = $foobar["target"];
				$this->tree[$cnt]["expanded"]= $foobar["expanded"];
				unset($foobar);
				if ($id != $parent_id) {
					$this->_depthFirstSearch($this->_tmpArray, $menu_name, $id, $level+1);
				}
			}
		}
	}

	function _postParse($menu_name = "") {
		for ($cnt=$this->_firstItem[$menu_name]; $cnt<=$this->_lastItem[$menu_name]; $cnt++) {	// this counter scans all nodes of the new menu
			$this->tree[$cnt]["child_of_root_node"] = ($this->tree[$cnt]["level"] == 1);
			$this->tree[$cnt]["parsed_text"] = stripslashes($this->tree[$cnt]["text"]);
			$this->tree[$cnt]["parsed_href"] = (ereg_replace(" ", "", $this->tree[$cnt]["href"]) == "") ? "#" : $this->prependedUrl . $this->tree[$cnt]["href"];
			$this->tree[$cnt]["parsed_title"] = ($this->tree[$cnt]["title"] == "") ? "" : " title=\"" . addslashes($this->tree[$cnt]["title"]) . "\"";
			$fooimg = $this->imgdir . $this->tree[$cnt]["icon"];
			if ($this->tree[$cnt]["icon"] == "" || !(file_exists($fooimg))) {
				$this->tree[$cnt]["parsed_icon"] = "";
			} else {
				$this->tree[$cnt]["parsed_icon"] = $this->tree[$cnt]["icon"];
				$foobar = getimagesize($fooimg);
				$this->tree[$cnt]["iconwidth"] = $foobar[0];
				$this->tree[$cnt]["iconheight"] = $foobar[1];
			}
			$this->tree[$cnt]["parsed_target"] = ($this->tree[$cnt]["target"] == "") ? "" : " target=\"" . $this->tree[$cnt]["target"] . "\"";
			$this->_maxLevel[$menu_name] = max($this->_maxLevel[$menu_name], $this->tree[$cnt]["level"]);
			if ($this->tree[$cnt]["level"] == 1) {
				$this->_firstLevelCnt[$menu_name]++;
			}
		}
	}
}

?>
