<?php
// $Id: pnadminapi.php,v 1.6 2004/08/17 12:40:59 timax Exp $
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// MD dynamic menu system for MD-Pro
// Original author :  Sergey Alexandrov  http://www.maxdev.com
// based on PHP Layers Menu 3.1.1 Marco Pratesi
// TiMax 05/05/2004 integrated in MD-Pro and add multilanguage

function mdmenus_adminapi_getmenulist() {
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $table = $pntable['mdmenus'];
        $column = &$pntable['menus_column'];
        $items = array();
        $sql = "SELECT $column[id], $column[text] FROM $table WHERE $column[parent_id] = 1 ORDER BY $column[text]";
        $result = $dbconn->Execute($sql);
        if (!$result->EOF) {
                while (!$result->EOF) {
                        list($id, $title) = $result->fields;
                        $result->MoveNext();
                        $items[] = array('id' => $id, 'title' => $title);
                }
        }
        return $items;
}

function mdmenus_adminapi_getmenuinfo($args)
{
	extract($args);
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $table = $pntable['mdmenus'];
    $column = &$pntable['menus_column'];
    $items = array();
    $sql = "SELECT	$column[text],
                    $column[title]
			FROM	$table
			WHERE	$column[id] = ".intval($id);
    $result = $dbconn->Execute($sql);
    if (!$result->EOF) {
        list($text, $title) = $result->fields;
        $items = array('name' => $text, 'data' => unserialize($title));
    }
    return $items;
}

function mdmenus_adminapi_getitemdata($args)
{
        extract($args);
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $table = $pntable['mdmenus'];
        $column = &$pntable['menus_column'];
        $items = array();
        $sql = "SELECT	$column[text],
                        $column[title],
                        $column[target],
                        $column[icon],
                        $column[href],
        				$column[expanded]
				FROM	$table
				WHERE	$column[id] = ".intval($id);
        $result = $dbconn->Execute($sql);
        if (!$result->EOF) {
                list($text, $title, $target, $icon, $href,$expanded) = $result->fields;
                $items = array('text' => $text, 'title' => $title, 'target' => $target, 'icon' => $icon, 'href' => $href, 'expanded' => $expanded);
        }
        return $items;
}

function mdmenus_adminapi_gettopics()
{
        $items = array();
        if (pnModAvailable('Topics')) {
                list($dbconn) = pnDBGetConn();
                $pntable = pnDBGetTables();
                $tab = $pntable['topics'];
                $col =&$pntable['topics_column'];
                $sql = "SELECT $col[topicid], $col[topicname] FROM $tab ORDER BY $col[topicname]";
                $res = $dbconn->Execute($sql);
                while (!$res->EOF) {
                        list($tid, $tname) = $res->fields;
                        $res->MoveNext();
                        $items[] = array('id' => $tid, 'name' => $tname);
                }
        }
        return $items;
}

function mdmenus_adminapi_getarticles($args)
{
        extract($args);
        $items = array();
        if (pnModAvailable('News')) {
                list($dbconn) = pnDBGetConn();
                $pntable = pnDBGetTables();
                $tab = $pntable['stories'];
                $col =&$pntable['stories_column'];
                $sql = "SELECT $col[sid], $col[title] FROM $tab ORDER BY $col[time] DESC LIMIT 0, $num";
                $res = $dbconn->Execute($sql);
                while (!$res->EOF) {
                        list($tid, $tname) = $res->fields;
                        $res->MoveNext();
                        $items[] = array('id' => $tid, 'name' => $tname);
                }
        }
        return $items;
}

function mdmenus_adminapi_gethtmlpages($args)
{
        extract($args);
        $items = array();
        if (pnModAvailable('htmlp')) {
                pnModDBInfoLoad('htmlp');
                list($dbconn) = pnDBGetConn();
                $pntable = pnDBGetTables();
                $tab = $pntable['htmlp'];
                $col =&$pntable['htmlp_column'];
                $sql = "SELECT $col[pid], $col[title] FROM $tab ORDER BY $col[title]";
                $res = $dbconn->Execute($sql);
                while (!$res->EOF) {
                        list($tid, $tname) = $res->fields;
                        $res->MoveNext();
                        $items[] = array('id' => $tid, 'name' => $tname);
                }
        }
        return $items;
}

function mdmenus_adminapi_getmodlist()
{
        $modlist = pnModGetUserMods();
        $mymodlist = array();
        $mymodlist[] = array('id' => 'index.php', 'name' => _HOMEPAGE);
        $mymodlist[] = array('id' => 'user.php', 'name' => _USERPROFILE);
        $mymodlist[] = array('id' => 'user.php?module=NS-User&op=logout', 'name' => _LOGOUT);
        $mymodlist[] = array('id' => 'admin.php', 'name' => _ADMINTITLE);

        foreach ($modlist as $key => $module) {
                $mymodlist[] = array('id' => $module['directory'], 'name' => $module['displayname']);
        }
        return $mymodlist;
}

function mdmenus_adminapi_delete($args) {
        extract($args);
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $table = $pntable['mdmenus'];
        $column = &$pntable['menus_column'];
        $sql = "DELETE FROM        $table WHERE $column[id] = ".intval($id);
        $result = $dbconn->Execute($sql);
        return true;
}
?>