<?php
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jens Henrik Gbbert
// Purpose of file: initialise the UpDown module
// ----------------------------------------------------------------------


/**
 * initialise the module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function MySQL_Tools_init()
{

        define('_CREATETABLEFAILED','Could not create needed database table :-(');

        global $id;

        $ModName = basename( dirname( __FILE__ ) );

        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        $mysqltools_statistics   =  $pntable['statistics'];
        $mysqltools_statistics_column  = &$pntable['statistics_column'];

        $sql = "
                CREATE TABLE $mysqltools_statistics (
                  $mysqltools_statistics_column[gain] decimal(13,3) default NULL,
                  $mysqltools_statistics_column[date] datetime NOT NULL default '0000-00-00 00:00:00'
                ) TYPE=MyISAM;

                ";
        $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0)
        {
                pnSessionSetVar('errormsg', "** 1 ** "._CREATETABLEFAILED);
                return false;
        }

        return true;
}

/**
 * upgrade the module from an old version
 * This function can be called multiple times
 */
function MySQL_Tools_upgrade($oldversion)
{
        global $id;

        // Get module information
        $modinfo = pnModGetInfo($id);
        if (empty($modinfo))
        {
                pnSessionSetVar('errormsg', _MODNOSUCHMOD);
                return false;
        }
        $ModName = $modinfo['name'];


    // Update successful
    return true;
}

/**
 * delete the module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function MySQL_Tools_delete()
{
        global $id;

    $ModName = "MySQL_Tools";

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $mysqltools_statistics   =  $pntable['statistics'];
    $sql = "DROP TABLE IF EXISTS $mysqltools_statistics";
    $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'statistics Table Drop Failed');
        return false;
    }

    // Deletion successful
    return true;
}

?>