<?php

// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file: Display admin messages
// ----------------------------------------------------------------------

function admin_messages_messagesblock_init()

{

    // Security

    pnSecAddSchema('Admin Messages:Messagesblock:', 'Block title::Message ID');

}



/**

 * get information on block

 */

function admin_messages_messagesblock_info()

{

    // Values

    return array('text_type' => 'Messages',

                 'module' => 'Admin Messages',

                 'text_type_long' => 'Show admin messages',

                 'allow_multiple' => true,

                 'form_content' => false,

                 'form_refresh' => false,

                 'show_preview' => true);

}



/**

 * display block

 */

function admin_messages_messagesblock_display($row)
{
		global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

        list($dbconn) = pnDBGetConn();

    $pntable =pnDBGetTables();



    if (!isset($row['title'])) {

        $row['title'] = '';

    }



    if (!pnSecAuthAction(0, 'Admin Messages:Messagesblock:', "$row[title]::", ACCESS_READ)) {

        return;

    }



    $messagestable = $pntable['message'];

    $messagescolumn = &$pntable['message_column'];



    if (pnConfigGetVar('multilingual') == 1) {

        $currentlang = pnUserGetLang();

//modified for Oracle compatibility
//    $querylang = "AND ($messagescolumn[mlanguage]='$currentlang' OR $messagescolumn[mlanguage]='')";
                $querylang = "AND ($messagescolumn[mlanguage]='$currentlang' OR $messagescolumn[mlanguage]='' OR $messagescolumn[mlanguage] IS NULL)";
    } else {

        $querylang = '';

    }

//modified for Oracle compatibility
/*    $sql = "SELECT $messagescolumn[mid],

                   $messagescolumn[title],

                   $messagescolumn[content],

                   $messagescolumn[date],

                   $messagescolumn[view]

            FROM $messagestable

            WHERE $messagescolumn[active] = 1

            AND  ( $messagescolumn[expire] > unix_timestamp(now())

                  OR $messagescolumn[expire] = 0)

            $querylang

            ORDER by $messagescolumn[mid] DESC";

*/

    if (strcmp($dbtype,'oci8')== 0) {
          $ts=time();
          $sql = "SELECT $messagescolumn[mid],
                   $messagescolumn[title],
                   $messagescolumn[content],
                   $messagescolumn[date],
                   $messagescolumn[view]
            FROM $messagestable
            WHERE $messagescolumn[active] = 1
            AND  ( $messagescolumn[expire] > $ts
                  OR $messagescolumn[expire] = 0)
            $querylang
            ORDER by $messagescolumn[mid] DESC";
        }else{
          $sql = "SELECT $messagescolumn[mid],
                   $messagescolumn[title],
                   $messagescolumn[content],
                   $messagescolumn[date],
                   $messagescolumn[view]
            FROM $messagestable
            WHERE $messagescolumn[active] = 1
            AND  ( $messagescolumn[expire] > unix_timestamp(now())
                  OR $messagescolumn[expire] = 0)
            $querylang
            ORDER by $messagescolumn[mid] DESC";
        }

    $result = $dbconn->Execute($sql);

        if ($dbconn->ErrorNo() != 0) {

        return;

    }



    $output = new pnHTML();


//modified for Oracle compatibility
//    while (list($mid, $title, $content, $date, $view) = $result->fields) {

        while (!$result-> EOF){
           list($mid, $title, $content, $date, $view) = $result->fields;
                $result->MoveNext();



        $show = 0;
        if (pnSecAuthAction(0,'Admin Messages:Messagesblock:',"$row[title]::$mid", ACCESS_READ)) { 
        switch($view) {

            case 1:

                // Message for everyone

                $show = 1;

                break;

            case 2:

                // Message for users

                if (pnUserLoggedIn()) {

                    $show = 1;

                }

                break;

            case 3:

                // Messages for non-users

                if (!pnUserLoggedIn()) {

                    $show = 1;

                }

                break;

            case 4:

                // Messages for administrators of any description

                if (pnSecAuthAction(0, '::', '::', ACCESS_ADMIN)) {

                    $show = 1;

                }

                break;

        }
    	}


        if ($show) {

            list($title,

                 $content) = pnModCallHooks('item',

                                            'transform',

                                            '',

                                            array($title,

                                                  $content));

            $output->TableStart('', '', 0);

            $output->SetInputMode(_PNH_VERBATIMINPUT);

            $output->SetOutputMode(_PNH_RETURNOUTPUT);

            $ttitle = $output->Linebreak();

            $ttitle .= $output->Text($title);

            $ttitle .= $output->Linebreak();

            $output->SetOutputMode(_PNH_KEEPOUTPUT);

            $output->TableAddRow(array("<font class=\"pn-title\">" . pnVarPrepHTMLDisplay($ttitle) . "</font>"), 'center');
            $output->TableAddRow(array("<div class=\"pn-normal\">" . pnVarPrepHTMLDisplay($content) . "</div>"), 'left');
            $output->SetInputMode(_PNH_PARSEINPUT);

            $output->TableEnd();

        }

    }



    if($output->output != "")

        {

            // Don't want a title

            $row['title'] = '';

            $row['content'] = $output->GetOutput();

            return themesideblock($row);

        }

}



?>
