<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Filename: User Points		funcs.php
// Original Author of file: Brian K. Virgin (aka 'MADHATter7')
// Purpose of file: User Points System Utility Functions
// ----------------------------------------------------------------------
// Changelog
//  7-04-2002:	Zoom - converted blackadders .713 port and updated plugins
//  11-01-2002: mh7 - initial release
// ----------------------------------------------------------------------


global $score, $calc, $toshow, $forums, $refreshtime;

//////																	  //////
//						Begin Configuration Section							  //
//////																	  //////


//////
// Number of users to display
//////
$toshow = 20;

//////
//							Refresh period:
//	--------------------------------------------------------------
//  3600 = 1 hour		 43200 = 12 hours		  86400 = 24 hours
//604800 = 1 week		907200 = 1/2 month		2592000 = 1 month
//	[ 7 days ]				[ 15 days ]				[ 30 days ]
//////
$refreshtime = 60;		// every minute


//////
// Place your Forums Module name here
// and then place function in the plugins/ directory.
// (XForums, phpBB & Postboard and several others included)
//////
$forums = "phpBB2";


//////
// Setup activity scoring system (what each action is worth)
//////
$score = array(
	"stories" => 4,				// for every Story
	"reviews" => 6,				// for every Review
	"comments" => 2, 			// for Story Comments
	"pollcomm" => 2, 			// for Poll Comments
	"reviewcomm" => 2,			// for Review Comments
	"downloads" => 3,			// for Submited Downloads
	"dloadvotes" => 2,			// for votes on Downloads
	"links" => 3,				// for Web Links
	"linkvotes" => 2,			// for votes on Links
	"posts" => 1				// for Forum Posts
);

//////
// Setup which activities we will be scoring
// Calculate score = 1, ignore = 0
//////
$calc = array(
	"stories" => 1,
	"reviews" => 1,
	"comments" => 1,
	"pollcomm" => 1,
	"reviewcomm" => 1,
	"downloads" => 1,
	"dloadvotes" => 1,
	"links" => 1,
	"linkvotes" => 1,
	"posts" => 1
);

//////																	  //////
//						End Configuration Section							  //
//////																	  //////


//////
// Tabulate the stories
//////
function tabStories($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility
//	$query = "SELECT count(*) FROM $pntable[stories] WHERE pn_time > date_add(now(),interval-31 day) and pn_informant='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[stories] WHERE pn_time > sysdate-31 and pn_informant='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[stories] WHERE pn_time > date_add(now(),interval-31 day) and pn_informant='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate article comments
//////
function tabComments($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[comments] WHERE pn_date > date_add(now(),interval-31 day) and pn_name='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[comments] WHERE pn_date > sysdate-31 and pn_name='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[comments] WHERE pn_date > date_add(now(),interval-31 day) and pn_name='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate poll comments
//////
function tabPollComm($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM  $pntable[pollcomments] WHERE pn_date > date_add(now(),interval-31 day) and pn_name='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM  $pntable[pollcomments] WHERE pn_date > sysdate-31 and pn_name='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM  $pntable[pollcomments] WHERE pn_date > date_add(now(),interval-31 day) and pn_name='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate posted downloads
//////
function tabDownloads($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[downloads_downloads] WHERE pn_date > date_add(now(),interval-31 day) and pn_submitter='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[downloads_downloads] WHERE pn_date > sysdate-31 and pn_submitter='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[downloads_downloads] WHERE pn_date > date_add(now(),interval-31 day) and pn_submitter='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate download votes
//////
function tabDloadVotes($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
	$pntable[downloads_votedata] = $prefix."_downloads_votedata";
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[downloads_votedata] WHERE pn_timestamp > date_add(now(),interval-31 day) and pn_user='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[downloads_votedata] WHERE pn_timestamp > sysdate-31 and pn_user='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[downloads_votedata] WHERE pn_timestamp > date_add(now(),interval-31 day) and pn_user='$uname'";
			break;
	}
	
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result2->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate posted web links
//////
function tabWebLinks($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[links_links] WHERE pn_date > date_add(now(),interval-31 day) and pn_submitter='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[links_links] WHERE pn_date > sysdate-31 and pn_submitter='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[links_links] WHERE pn_date > date_add(now(),interval-31 day) and pn_submitter='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate link votes
//////
function tabLinkVotes($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[links_votedata] WHERE pn_timestamp > date_add(now(),interval-31 day) and pn_user='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[links_votedata] WHERE pn_timestamp > sysdate-31 and pn_user='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[links_votedata] WHERE pn_timestamp > date_add(now(),interval-31 day) and pn_user='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo <> 0) {
		echo"DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate posted reviews
//////
function tabReviews($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[reviews] WHERE pn_date > date_add(now(),interval-31 day) and pn_reviewer='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[reviews] WHERE pn_date > sysdate-31 and pn_reviewer='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[reviews] WHERE pn_date > date_add(now(),interval-31 day) and pn_reviewer='$uname'";
			break;
	}

	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate review comments
//////
function tabReviewComm($uname) {
	global $dbconn, $pntable, $prefix, $pnconfig;
	$dbtype = $pnconfig['dbtype'];
	//$pntable[reviews_comments] = $prefix."_reviews_comments";
//modified for Oracle compatibility;
//	$query = "SELECT count(*) FROM $pntable[reviews_comments] WHERE pn_date > date_add(now(),interval-31 day) and pn_userid='$uname'";
	switch ($dbtype){
		case "oci8":
			$query = "SELECT count(*) FROM $pntable[reviews_comments] WHERE pn_date > sysdate-31 and pn_userid='$uname'";
			break;
		default:
	$query = "SELECT count(*) FROM $pntable[reviews_comments] WHERE pn_date > date_add(now(),interval-31 day) and pn_userid='$uname'";
			break;
	}
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br>";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate forum posts (via plugin)
//////
function tabPosts($uname) {
	global $dbconn, $pntable, $prefix, $ModName, $forums;

	if (isset($forums) && $forums != "none") {
		if (file_exists("modules/$ModName/plugins/$forums.php")) {
			require("modules/$ModName/plugins/$forums.php");
		}
	}
	return $abacus;
}

?>
