<?php
// $Id: pnuserapi.php,v 1.4 2004/09/21 13:44:47 timax Exp $
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Alberto Galanti
// Purpose of file:  News user API functions
// ----------------------------------------------------------------------

/**
 * @author       Alberto Galanti aka AbiBepo
 * @link         http://www.afginformatica.it
 * @author       Stefan Koehler aka WindMeUp
 * @link         http://www.maxdev.de
 * @copyright    (c) 2002-2003 by the MaxDev Development Team (Link: http://www.maxdev.com/); Please READ the Docs/credits.txt file for complete credits list
 * @version      1.5
 * @package      News
 * @subpackage	 Core
 * @license      http://www.gnu.org/copyleft/gpl.html GNU General Public License
*/

/**
 * get infos from category or topic items
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param    int     $args['id']		id of item
 * @param    int     $args['type']		type of item
 * @return   array   array of infos, or false on failure
 */
function news_userapi_getinfos($args) 
{
	
	// extract parameters - id adn type must be set
	extract ($args);
	if (!isset($id)) {
	    return false;
	}
	if (!isset($type)) {
	    return false;
	}

    // Get datbase setup
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

	// define, for every type, table infos and sql query
	switch($type){
		case 'category': 
		    $column = &$pntable['stories_cat_column'];
		    $sql = "SELECT $column[themeoverride],  $column[title], $column[counter]
		            FROM $pntable[stories_cat]
		            WHERE $column[catid]=".pnVarPrepForStore($id)."";
			break;
		case 'topic': 
		    $column = &$pntable['topics_column'];
		    $sql = "SELECT $column[topicid],  $column[topicname], $column[topicimage], $column[topictext]
		            FROM $pntable[topics]
		            WHERE $column[topicid]=".pnVarPrepForStore($id)."";
			break;
		default:
			// not defined type is not allowed
			return false;
	} // switch

    // Get infos
    $result =& $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }

	// build infos array
	switch($type){
		case 'category': 
			$infos = array('themeoverride'	=> $result->fields[0],
						   'title'			=> $result->fields[1],
						   'counter'		=> $result->fields[2]);
			break;
		case 'topic': 
			$infos = array('topicid'	=> $result->fields[0],
						   'topicname'			=> $result->fields[1],
						   'topicimage'			=> $result->fields[2],
						   'topictext'		=> $result->fields[3]);
			break;
		default:
			return false;
	} // switch

	// return infos
	return $infos;
	
}
 
/**
 * update counter for category, topic or story items
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param    int     $args['id']		id of item
 * @param    int     $args['type']		type of item
 * @param	 int	 $args['inc']		increment of counter
 * @return   array   array of infos, or false on failure
 */
function news_userapi_setcounter($args) 
{
	
	// extract parameters - id adn type must be set, inc is optional
	extract ($args);
	if (!isset($id)) {
	    return false;
	}
	if (!isset($type)) {
	    return false;
	}
	if (!isset($inc)) {
	    $inc = 1;
	}
	

    // Get datbase setup
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

	// define, for every type, table infos and sql query
	switch($type){
		case 'category': 
		    $column = &$pntable['stories_cat_column'];
		    $sql = "UPDATE $pntable[stories_cat] 
					SET $column[counter]=$column[counter]+$inc
		            WHERE $column[catid]=".pnVarPrepForStore($id)."";
			$sqlcounter = "SELECT $column[counter]
		            FROM $pntable[stories_cat]
		            WHERE $column[catid]=".pnVarPrepForStore($id)."";
			break;
		case 'topic': 
		    $column = &$pntable['topics_column'];
		    $sql = "UPDATE $pntable[topics] 
					SET $column[counter]=$column[counter]+$inc
		            WHERE $column[topicid]=".pnVarPrepForStore($id)."";
			$sqlcounter = "SELECT $column[counter]
		            FROM $pntable[topics]
		            WHERE $column[topicid]=".pnVarPrepForStore($id)."";
			break;
		case 'story':
		    $column = &$pntable['stories_column'];
		    $sql = "UPDATE $pntable[stories] 
					SET $column[counter]=$column[counter]+$inc
		            WHERE $column[sid]=".pnVarPrepForStore($id)."";
			$sqlcounter = "SELECT $column[counter]
		            FROM $pntable[stories]
		            WHERE $column[sid]=".pnVarPrepForStore($id)."";
			break;
		default:
			// not defined type is not allowed
			return false;
	} // switch

    // Set counter
    $result =& $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }

    // Get counter
    $result =& $dbconn->Execute($sqlcounter);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }

	// return new id
	return $result->fields[0];

}

/**
 * get all items
 * 
 * @author WindMeUp
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param    int     $args['starnum']    (optional) first item to return
 * @param    int     $args['storynum']   (optional) number if items to return
 * @param	 int	 $args['filter']	 (optional) SQL where conditions:
 * 													values are in an array of array
 * 													each array contain 3 values:
 * 													field (of stories table), 
 * 													numeric (a bool), value 
 * @param	 bool	 $args['countonly']	 (optional) return only count of stories
 * @param	 string	 $args['order']		 (optional) SQL order statements
 * @return   array   array of items, or false on failure
 */
function news_userapi_getall($args)
{

    // Get arguments from argument array 
    extract($args);

    // Optional arguments.
    if (!isset($startrow)) {
        $startrow = 0;
    }
    if (!isset($storynum)) {
        $storynum = -1;
    }
    if (!isset($filter)) {
        $filter = '';
    }
    if (!isset($countonly)) {
        $countonly = false;
    }
    if (!isset($order)) {
        $order = '';
    }
    if (!isset($ihome)) {
        $ihome = 1;
    }
    if (!isset($datetime)) {
        $datetime = 0;
    }

	// get user language info
    $currentlang = pnUserGetLang();
	
    // Get database setup
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();
    $storiescolumn = $pntable['stories_column'];
    $storiescatcolumn= $pntable['stories_cat_column'];
    $topicscolumn = $pntable['topics_column'];

	// Compose the SELECT component of query 
	if ($countonly)	{
		$query = "SELECT count(*) FROM $pntable[stories]";
    } else {
		$query = "SELECT $storiescolumn[aid] as \"aid\",
						 $storiescolumn[bodytext] as \"bodytext\",
						 $storiescatcolumn[themeoverride] AS \"catthemeoverride\",
                         $storiescolumn[catid] as \"cid\",
						 $storiescatcolumn[title] AS \"cattitle\",
						 $storiescolumn[comments] as \"comments\",
						 $storiescolumn[counter] as \"counter\",
						 $storiescolumn[hometext] as \"hometext\",
						 $storiescolumn[informant] as \"informant\",
						 $storiescolumn[notes] as \"notes\",
						 $storiescolumn[sid] as \"sid\",
                         $storiescolumn[themeoverride] as \"themeoverride\",
						 $topicscolumn[topicid] AS \"tid\",
                         $storiescolumn[time] as \"time\",
						 $storiescolumn[title] as \"title\",
						 $storiescolumn[image] as \"image\",
						 $storiescolumn[descimage] as \"descimage\",		
						 $topicscolumn[topicname] AS \"topicname\",
						 $topicscolumn[topicimage] AS \"topicimage\",
						 $topicscolumn[topictext] AS \"topictext\",
						 $topicscolumn[counter] AS \"tcounter\",
                         $storiescolumn[time] as \"unixtime\",
                         $storiescolumn[withcomm] as \"withcomm\",
						 $storiescolumn[skins] as \"skins\",
 						 $storiescolumn[published_status] as \"published_status\",
						 $storiescolumn[lastchanged] as \"lastchanged\",
						 $storiescolumn[changedfrom] as \"changedfrom\",
						 $storiescolumn[language] as \"language\",
						 $storiescolumn[ihome] as \"ihome\",
						 $storiescolumn[from] as \"from\",
						 $storiescolumn[to] as \"to\",
						 $storiescolumn[dataeven] as \"dataeven\"
         		FROM $pntable[stories]";
	}

	// Compose filter condition
	$where = '';
	$and = '';
	$today = time();
	foreach ($filter as $cond ) {
		if ($cond['numeric']) {
		    $where .= $and . $storiescolumn[$cond['field']] . '=' . $cond['value'];
		}
		elseif ($cond['list']) {
			$where .= $and . $storiescolumn[$cond['field']] . ' in (' . $cond['value'] . ')';
		}
		else {
			$where .= $and . $storiescolumn[$cond['field']] . '=\'' . $cond['value'] . '\'';
		}
		$and = ' AND ';
	}

	// show only stories if today is between story-from and story-to
	if($datetime) {
		$where .= " AND ( (".$storiescolumn['from']." <= '".date('Y-m-d H:i:s',time())."' OR ".$storiescolumn['from']." = '0000-00-00 00:00:00') 
					AND   (".$storiescolumn['to']." >= '".date('Y-m-d H:i:s',time())."' OR ".$storiescolumn['to']." = '0000-00-00 00:00:00') )";
	}
	
	// show only items between date range. Necessary for _archive.
	if ((isset($from)) && (isset($to))) {
	   $where .= " AND ($storiescolumn[time] >= '" . pnVarPrepForStore($from) . "' AND $storiescolumn[time] <= '" . pnVarPrepForStore($to) . "')";
	}

	// Add the joins, limits, filter and order
	// This part have two different version: one for mysql and one for oracle
    if (strcmp(pnConfigGetVar('dbtype'), 'oci8') == 0) {

		// ORACLE VERSION
		// Add join
		$query .=  " , $pntable[stories_cat], $pntable[topics]
                    WHERE $storiescolumn[catid]=$storiescatcolumn[catid](+)
                    AND $topicscolumn[topicid]=$storiescolumn[topic]";
        
		// Add filter for multilingual user
		if (pnConfigGetVar('multilingual') == 1) {
			$query .= " AND ($storiescolumn[language]='$currentlang' OR $storiescolumn[language]='' OR $storiescolumn[language] IS NULL)";
        }

		// Limit max stories returned
        if (!$storynum == 1) {
            $query .= " AND ROWNUM < $storynum";
        }

		// Add filter conditions
        if (!$filter == '') {
            $query .= " AND $where";
        }

    } else {
	
		// MYSQL VERSION
		
		// Add joins
        $query .= " LEFT JOIN $pntable[stories_cat] ON $storiescolumn[catid] = $storiescatcolumn[catid]
                    LEFT JOIN $pntable[topics] ON $storiescolumn[topic] = $topicscolumn[topicid]";

		// Add filter for multilingual user
		if (pnConfigGetVar('multilingual') == 1) {
            $query .= " WHERE ($storiescolumn[language]='" . pnUserGetLang() . "' OR $storiescolumn[language]='')";
            if (!$filter == '') {
                $query .= " AND $where";
            }
        } else {
            if (!$filter == '') {
                $query .= " WHERE $where";
            }
        }

	}
		// Add order statements
        if (!$order == '') {
            $query .= " ORDER BY $order";
        }
//    }

// echo ("Query: ". $query."<br /><br />StoryNumbers: ".$storynum."<br />");
	// Querying database with or without limits
	//??? why check order and not storynum or startrow ???
//	if (!$order == '') {
		$result =& $dbconn->SelectLimit($query, $storynum, $startrow-1);
//	} else {
//		$result =& $dbconn->Execute($query);
//	}
	//??? why check order and not storynum or startrow ???

	// return dberrors
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED . ": getArticles: " . $dbconn->ErrorNo() . ': ' . $dbconn->ErrorMsg() . '<br />');
        return false;
    }
	
	// Return item count if required
	if ($countonly) {
		$items = $result->fields[0];
	} else {
		// result transformations
		$items = array();
		$num = 0;

		//??? where is used this ???
		//$numstories = $result->PO_RecordCount();
		while(!$result->EOF) {
		    $row = $result->GetRowAssoc(false);
		    $row['unixtime']=$result->UnixTimeStamp($row['unixtime']);
			//??? sure i need so much repeat ???
		    $row['topicid'] = $row['tid'];	
		    $row['topic'] = $row['tid'];
		    $row['catid'] = $row['cid'];
			if ($row['cattitle'] == "") {
				$row['cattitle'] = "". _ARTICLES . ""; 
			}
			$items[$num] = $row;
			$num++;
		    $result->MoveNext();
		}
	}

    // Close db access
    $result->Close();

    // Return the items
    return $items;
}

/**
 * Return a formatted pager
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param	int	$args[hposition]		Horizzontal position of the pager
 * @param	int	$args[pagelinks]		Number of links to show ???
 * @param	int	$args[storynum]			Number of story for page
 * @param	int	$args[num_record]		Total number of news to show
 * @param	int	$args[startrow]			First story to show
 * @param	int	$args[catid]			Category to show
 * @param	int	$args[topic]			topic to show
 * @return	string						pager to display
 * @todo using of pnHTML-pager
 */  
function news_userapi_pagelinks($args)
{
	
	// set default value
	extract($args);
	if (!isset($hposition)) {
	    $hposition = 2;	// center
	}
	if (!isset($pagelinks)) {
	    $pagelinks = 5;
	}
	if (!isset($storynum)) {
	    $hposition = 2;
	}
	if (!isset($num_record)) {
	    $num_record = 5;
	}
	if (!isset($startrow)) {
	    $startrow = 0;
	}
	if (!isset($catid)) {
	    $catid = '';
	}
	if (!isset($topic)) {
	    $topic = '';
	}
	
	// output HTML class object
	$output =& new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

	
switch($hposition)
	{
		// left position		
		case 1:
			$hposition = "left";
		break;
		// center position
		case 2:
			$hposition = "center";
		break;
		// right position
		case 3:
			$hposition = "right";
		break;
		// 0 or NULL -> center
		default:
			$hposition = "center";
		break;
	}

	// Set output
	$output->Text("<div style=\"text-align: ".$hposition.";\">");
	$output->Text(news_userapi_printlinks( $pagelinks, $storynum, $num_record, $startrow, $catid, $topic ));
	$output->Text("</div>\n");

	// return otuput
	return $output->GetOutput();
}

/**
 *	Compose and return pager without formatting
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param	int	$pagelinks		Number of links to show ???
 * @param	int	$storynum		Number of story for page
 * @param	int	$num_record		Total number of news to show
 * @param	int	$startrow		First story to show
 * @param	int	$catid			Category to show
 * @param	int	$topic			topic to show
 * @return	string					pager to display
 * @todo using of pnHTML-pager
 */
function news_userapi_printlinks($pagelinks, $storynum, $num_record, $startrow, $catid ,$topic )
{

	// output HTML class object
	$output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

	// Calculate the total number of pages and stories in the last page
	$pages = intval($num_record / $storynum);
	if ($num_record % $storynum)
	{
		// has left over from division, so add one page
		$pages++;
	}
	$last = ($pages * $storynum) - $storynum;
	
	// begin pager whith total pages
	if( $pages == 1 ) {
		$output->Text("<span class=\"pn-sub\">&nbsp;"._PAGETOTAL." "._PAGETEXT.": <strong>$pages</strong> "._GOTO."</span>");
	}
	else {
		$output->Text("<span class=\"pn-sub\">&nbsp;"._PAGETOTAL." "._PAGETEXTS.": <strong>$pages</strong> "._GOTO."</span>");
	}
	
	// determine the current page and the first page avaiable in links group
	// this is calculate from max links visible
	$cur_page = ceil( $startrow / $storynum ) + 1;
	$check = intval(($cur_page-1) / $pagelinks)*$pagelinks + 1;
	
	// Calculate the previous results, 
	// only print 'Previous' if startrow is not equal to zero and 
	// if we are over the first group of links
	if ($startrow != 0 && ($startrow >= ($storynum * $pagelinks)))
	{
		//$prevrow = $startrow - ($storynum * $links);
		$prevrow = ($check-$pagelinks-1) * $storynum;
		if ($prevrow < 0)
		{
			$prevrow = 0;
		}
		$output->Text("<span class=\"pn-sub\">[ <a class=\"pn-normal\" href=\"index.php?module=News&amp;func=view&amp;catid=$catid&amp;topic=$topic&amp;startrow=0\" title=\""._PAGEBEGIN." "._PAGETEXT."\">"._PAGEBEGIN."</a> ]&nbsp</span>");
		$output->Text("<span class=\"pn-sub\">[ <a class=\"pn-normal\" href=\"index.php?module=News&amp;func=view&amp;catid=$catid&amp;topic=$topic&amp;startrow=$prevrow\" title=\""._PAGEPREVTEXT." $links "._PAGETEXTS."\">"._PAGEPREV."</a> ]&nbsp</span>");
	}
	
	// Print the next pages, first check if there are more pages then 1
	if ($pages >= 1)
	{
		$loop = 0;
		$end_page_links = $check + $pagelinks - 1;
		
		// calculate limits of pages to link
		if ($end_page_links > $pages)
		{
			$loop = $pages;
			$o = $check;
		}
		else
		{
			$loop = $end_page_links;
			$o = $check;
		}

		// loop for show link to pages
		for ($i=$o; $i <= $loop; $i++)
		{ 
			$nextrow = $storynum * ($i - 1);
			//Check for current page - if it is: do not put a link
			if($cur_page == $i)
			{
				$output->Text(" <strong>$i</strong>&nbsp;");
			}
			else
			{
				$title = ucfirst(_PAGETEXT)." $i ";
				$output->Text(" <a class=\"pn-normal\" href=\"index.php?module=News&amp;func=view&amp;catid=$catid&amp;topic=$topic&amp;startrow=$nextrow\" title=\"$title\">$i</a> ");
			}
		}
	}
	//End loop
	
	// Check if we are at the last page, if so, dont print 'Next'
	if ( ($pages > ($check + $pagelinks - 1)) && $pages != 1 && ($num_record > 1))
	{
	// not the last page so print Next $links pages
		$nextrow = $storynum * ($check + $pagelinks - 1);
		$output->Text("<a class=\"pn-normal\" href=\"index.php?module=News&amp;func=view&amp;catid=$catid&amp;topic=$topic&amp;startrow=$nextrow\" title=\""._PAGENEXTTEXT." $links "._PAGETEXTS."\">"._PAGENEXT."</a> &nbsp;");
		$output->Text("<a class=\"pn-normal\" href=\"index.php?module=News&amp;func=view&amp;catid=$catid&amp;topic=$topic&amp;startrow=$last\" title=\""._PAGEEND." "._PAGETEXT."\">"._PAGEEND."</a> &nbsp;");
	}
	$output->Text("<br />");
	
	return $output->GetOutput();
}

/**
 * Return article infos
 * 
 * User the row read with getall function and filter with 
 * system rows like usertime, censoring,multipage links,...
 * 
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param	mixed	$row		Row of stories tables returned by getall
 * @param	int		$pagenum	Page of the story to show
 * 
 * @return	mixed				Array of infos
 */
function news_userapi_genArticleInfo($args) {

	// extract parameters
	//$row, $pagenum=1
	extract ($args);
	if (!isset($pagenum)) {
	    $pagenum = 1;
	}

    //??? bhoo ???
	setlocale(LC_TIME, pnConfigGetVar('locale'));

    $info = $row;
    $info['version'] = 1;
    $info['longdatetime'] = ml_ftime(_DATETIMELONG, GetUserTime($info['unixtime']));
    $info['briefdatetime'] = ml_ftime(_DATETIMEBRIEF, GetUserTime($info['unixtime']));
    $info['longdate'] = ml_ftime(_DATELONG, GetUserTime($info['unixtime']));
    $info['briefdate'] = ml_ftime(_DATEBRIEF, GetUserTime($info['unixtime']));
    $info['brieftime'] = ml_ftime("%H:%M", GetUserTime($info['unixtime']));
    $anonymous = pnConfigGetVar('anonymous');
    if (empty($info['informant'])) {
        $info['informant'] = $anonymous;
    }

    list($info['title'],
         $info['hometext'],
         $info['bodytext'],
         $info['notes']) = pnModCallHooks('item',
                                          'transform',
                                          '',
                                          array($info['title'],
                                                $info['hometext'],
                                                $info['bodytext'],
                                                $info['notes']));

    $info['title'] = preg_replace('/<a\s+.*?>(.*?)<\/a>/i', '\\1', $info['title']);
    $info['title'] = pnVarPrepForDisplay(pnVarCensor($info['title']));
    $info['hometext'] = pnVarPrepHTMLDisplay(pnVarCensor($info['hometext']));
    $info['bodytext'] = pnVarPrepHTMLDisplay(pnVarCensor($info['bodytext']));
    $info['notes'] = pnVarPrepHTMLDisplay(pnVarCensor($info['notes']));
    $info['cattitle'] = pnVarPrepHTMLDisplay(pnVarCensor($info['cattitle']));
    if ($info['catid']) {
        $info['catandtitle'] = $info['cattitle'].": ".$info['title'];
    } else {
        $info['catandtitle'] = $info['title'];
    }

	// add pages links to multipage stories
    $bodytxt = explode( "[pagebreak]", $info['bodytext'] );
    $lastpage = count($bodytxt);
    $commentextra = "mode=thread&amp;order=0&amp;thold=0";
    if ( $pagenum < 1 ) {
        $pagenum = 1;
	}
    if ( $pagenum > $lastpage ) {
        $pagenum = $lastpage;
	}
    if ($lastpage > 1) {
        $info['bodytext'] = $bodytxt[$pagenum - 1]."<br /><span style=\"text-align: center;\"><strong>"._PAGE.":</strong> $pagenum/$lastpage</span><br />";
    }
    if($pagenum >= $lastpage) {
          $next_page = "";
    } else {
        $next_pagenumber = $pagenum + 1;
        $next_page .= "<span class=\"pn-normal\"><a href=\"index.php?module=News&amp;func=display&amp;sid=$info[sid]&amp;pagenum=$next_pagenumber&amp;$commentextra\">"._NEXT." ($next_pagenumber/$lastpage)</a> <a href=\"index.php?module=News&amp;func=display&amp;sid=$info[sid]&amp;pagenum=$next_pagenumber&amp;$commentextra\"><img style=\"border: 0;\" src=\"modules/News/pnimages/right.gif\" alt=\""._NEXT."\" /></a></span>";

    }
    if($pagenum <= 1) {
                $previous_page = "";
        } else {
                $previous_pagenumber = $pagenum - 1;
                $previous_page = "<span class=\"pn-normal\"><a href=\"index.php?module=News&amp;func=display&amp;sid=$info[sid]&amp;pagenum=$previous_pagenumber&amp;$commentextra\"><img style=\"border: 0;\" src=\"modules/News/pnimages/left.gif\" alt=\""._PREVIOUS."\"></a> <a href=\"index.php?module=News&amp;func=display&amp;sid=$info[sid]&amp;pagenum=$previous_pagenumber&amp;$commentextra\">"._PREVIOUS." ($previous_pagenumber/$lastpage)</a></span>";
        }
        if ($lastpage > 1 ) {
                $formatpages = "<div style=\"text-align: center;\"><table width=\"85%\"><tr><td align=\"left\" style=\"width: 50%;\">";
                $formatpages .= $previous_page;
                $formatpages .= "</td><td align=\"right\" style=\"width=: 50%;\">".$next_page."</td></tr></table></div>";
                $info['bodytext'] = $info['bodytext'].$formatpages;
        }

	//??? bho ???
//    $info['hometext'] = news_userapi_genBBcodeDisplay($info['hometext']);
//    $info['bodytext'] = news_userapi_genBBcodeDisplay($info['bodytext']);
//    $info['notes'] = news_userapi_genBBcodeDisplay($info['notes']);

    if ($pagenum <= 1) {
    $info['maintext'] = $info['hometext']."\n".$info['bodytext'];
    } else {
        $info['maintext'] = "$info[bodytext]";
    }
    if (!empty($info['notes'])) {
        $info['fulltext'] = $info['maintext']."\n".$info['notes'];
    } else {
        $info['fulltext'] = $info['maintext'];
    }
    $info['skins'] = $info['skins'];
    return($info);
}

/*
 * Build usefull links to story
 * 
 * Use infos from getnarticleinfo for return links to article pages, topic
 * search, comments, category, printable version, and sending page
 * 
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param	mixed	$args[info]		Array of infos returned by genarticleinfo
 * @param	mixed	$args[links]	Array of infos returned by genarticleinfo
 * 
 * @return	mixed					Array of preformatted text parts
 */
function news_userapi_genArticlePreformat($args) {

	//###Check for correct arguments
	extract ($args);
	
    $component = 'News::';
    $instance = "$info[aid]:$info[cattitle]:$info[sid]";

    if (pnModAvailable("Recommend_Us")) {
        $send = "<a href=\"$links[send]\"><img style=\"border: 0;\" src=\"images/global/friend.gif\" alt=\""._FRIEND."\" /></a>";
    } else {
        $send = "";
    }

    if ($info['image']) {
       $image = "<img src=\"upload/images/".$info['sid'].$info[image]."\" border=0 width=100 height=100>";
    } else {
       $image = "";
    }
    $descimage = $info['descimage'];
    $hometext = $info['hometext'];
    $bodytext = $info['bodytext'];
    $bytesmore = strlen($info['bodytext']);
    $readmore = "";
    $bytesmorelink = "";
    if ($bytesmore > 0) {
        if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
            $readmore = "<a class=\"pn-normal\" href=\"$links[fullarticle]\">"._READMORE."</a>";
        }
        $bytesmorelink = "$bytesmore "._BYTESMORE;
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $title = "<a class=\"pn-title\" href=\"$links[fullarticle]\">$info[title]</a>";
    } else {
        $title = $info['title'];
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $print = "<a class=\"pn-normal\" href=\"$links[print]\"><img style=\"border: 0;\" src=\"images/global/print.gif\" alt=\""._PRINTER."\" /></a>";
    } else {
        $print = '';
    }

    $comment = "";
    if ($info['withcomm'] == 1) {
        if ($info['comments'] == 0) {
            $comment = _COMMENTSQ;
        } else if ($info['comments'] == 1) {
            $comment = "1 " . _COMMENT;
        } else {
            $comment = "$info[comments] "._COMMENTS;
        }
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_COMMENT)) {
        $comment = "<a class=\"pn-normal\" href=\"$links[comment]\">$comment</a>";
    } else if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $comment = "$comment";
    } else {
        $comment = "";
    }

    if (!empty($info['notes'])) {
        $notes = _NOTE." <i>$info[notes]</i>";
    } else {
        $notes = "";
    }

    $dataeven = $info['dataeven'];
    $preformat = array(
                       "bodytext" => $bodytext,
                       "bytesmore" => $bytesmorelink,
                       "category" => "<a href=\"$links[category]\">$info[cattitle]</a>",
                       "comment" => $comment,
                       "hometext" => $hometext,
                       "notes" => $notes,
                       "searchtopic" => "<a href=\"index.php?module=News&amp;func=view&amp;catid=&amp;topic=$info[tid]\"><img style=\"border: 0; float: left; padding: 5px 5px 5px 5px;\" src=\"".pnConfigGetVar('tipath')."$info[topicimage]\" alt=\"$info[topictext]\" /></a>",
                       "image" => $image,
    				   "descimage" => $descimage,
    				   "dataeven" => $dataeven,
                       "print" => $print,
                       "readmore" => $readmore,
                       "send" => $send,
                       "title" => $title,
                       "version" => 1
                       );

    $preformat['more'] = "";
    if ($bytesmore > 0) {
        $preformat['more'] .= "$preformat[readmore] ($preformat[bytesmore]) ";
    }
    $preformat['more'] .= "$preformat[comment] $preformat[send] $preformat[print]";

    if ($info['catid']) {
        $preformat['catandtitle'] = "$preformat[category]: $preformat[title]";
    } else {
        $preformat['catandtitle'] = $preformat['title'];
    }
    $preformat['maintext'] = "$preformat[hometext]<br /><br />$preformat[bodytext]";
    if (!empty($preformat['notes'])) {
        $preformat['fulltext'] = "$preformat[maintext]<br /><br />$preformat[notes]";
    } else {
        $preformat['fulltext'] = "$preformat[maintext]";
    }

    return $preformat;
}


/**
 * Build usefull links to story
 * 
 * Use infos from getnarticleinfo for return links to article pages, topic
 * search, comments, category, printable version, and sending page
 * 
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param	mixed	$args[info]	Array of infos returned by genarticleinfo
 * 
 * @return	mixed				Array of usefull links
 */
function news_userapi_genArticleLinks($args) {

	// extract parameter
	extract($args);
	
	//### security check must be retested ###
    //$component = 'AddStory::';
	$component = 'News::';
    $instance = "$info[aid]:$info[cattitle]:$info[sid]";
    $commentextra = pnUserGetCommentOptions();

	//??? allow comments ???
    if (pnSecAuthAction(0, $component, $instance, ACCESS_COMMENT)) {
        $comment = "index.php?module=News&amp;func=display&amp;sid=$info[sid]&amp;$commentextra";
    } else {
        $comment = "";
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $fullarticle = "index.php?module=News&amp;func=display&amp;sid=$info[sid]&amp;$commentextra";
    } else {
        $fullarticle = "";
    }

    if (!empty($info['tid'])) {
        $searchtopic = "index.php?module=News&amp;func=view&amp;catid=&amp;topic=$info[tid]";
    } else {
        $searchtopic = '';
    }

    $links = array (
                    "category" => "index.php?module=News&amp;func=view&amp;catid=$info[catid]",
                    "comment" => $comment,
                    "fullarticle" => $fullarticle,
                    "searchtopic" => $searchtopic,
                    "print" => "print.php?sid=$info[sid]",
                    "send" => "modules.php?op=modload&amp;name=Recommend_Us&amp;file=index&amp;req=FriendSend&amp;sid=$info[sid]",
                    "version" => 1
                    );

    return $links;
}

/**
 * ???????????????
 * 
 * 
 */
function news_userapi_genBBcodeDisplay($html) {

	if (pnModAvailable('postbbcode')) {
		if (pnModAPILoad('postbbcode', 'user')){
			$html = pnModAPIFunc('postbbcode', 'user', 'bbtohtml', array("bbcode" => $html));
		}
		if (!isset($html)){
		} 
		else {
			$output = $html;
		}
		return $output;
	}
}
 
/**
 * utility function to count the number of items held by this module
 * 
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @return   integer   number of items held by this module
 */
function Example_userapi_countitems()
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you are
    // getting - $table and $column don't cut it in more complex modules
    $exampletable = &$pntable['example'];
    $examplecolumn = &$pntable['example_column'];

    // Get item - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the Execute() command allows for simpler debug operation
    // if it is ever needed
    $sql = "SELECT COUNT(1) FROM $exampletable";
    $result =& $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Obtain the number of items
    list($numitems) = $result->fields;

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Return the number of items
    return $numitems;
}

/**
 * create a new News item
 * @author WindMeUp
 * @author AbiBepo
 * @version $Revision: 1.4 $
 * @param $args['name'] name of the item
 * @param $args['number'] number of the item
 * @returns int
 * @return News item ID on success, false on failure
 */
function news_userapi_create($args)
{

    // Get arguments from argument array - all arguments to this function
    // should be obtained from the $args array, getting them from other
    // places such as the environment is not allowed, as that makes
    // assumptions that will not hold in future versions of PostNuke
    extract($args);

    // Argument check - make sure that all required arguments are present,
    // if not then set an appropriate error message and return
    if ((!isset($title)) ||
        (!isset($hometext))
//        (!isset($hometextcontenttype)) ||
//        (!isset($bodytext)) ||
//        (!isset($bodytextcontenttype)) ||
//        (!isset($notes))
		) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check - important to do this as early on as possible to 
    // avoid potential security holes or just too much wasted processing
	// Stati are: 0 => published, 1 => pending, 2 => archived 3 => rejected
    if (!pnSecAuthAction(0, 'News::Story', "::", ACCESS_COMMENT)) {
        pnSessionSetVar('errormsg', _NEWSNOAUTH);
        return false;
    } else if ( pnSecAuthAction(0, 'News::Story', "::", ACCESS_ADD)) {
	    $status = 0;
		$informant = pnUserGetVar('uname');
    } else {
	    $status = 1;
		$informant = '';
	}

	$lastchanged = 0;
	
	// Set bodytext- and extendedtext-format to HTML FIX
    $hometextcontenttype = 1;
	$bodytextcontenttype = 1;
	
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you
    // are getting - $table and $column don't cut it in more complex
    // modules
    $storiestable = $pntable['stories'];
    $storiescattable= $pntable['stories_cat'];
    $topicstable = $pntable['topics'];
    $storiescolumn = $pntable['stories_column'];
    $storiescatcolumn= $pntable['stories_cat_column'];
    $topicscolumn = $pntable['topics_column'];

    // Get next ID in table - this is required prior to any insert that
    // uses a unique ID, and ensures that the ID generation is carried
    // out in a database-portable fashion
    $nextid = $dbconn->GenId($storiestable);

    // calculate the format type
    $contenttype = ($bodytextcontenttype%4)*4 + $hometextcontenttype%4;

    // check for a permantly published story, or start- and end-time
    if ($startpublish) {
	    $from = $dbconn->DBTimestamp($from);
	} else {
	    $from = 0;
	}
    if ($endpublish) {
	    $to = $dbconn->DBTimestamp($to);
	} else {
	    $to = 0;
	}

	$dataeven = $dbconn->DBTimestamp($dataeven);
	
    // Add item - the formatting here is not mandatory, but it does make
    // the SQL statement relatively easy to read.  Also, separating out
    // the sql statement from the Execute() command allows for simpler
    // debug operation if it is ever needed
    $sql = "INSERT INTO $storiestable (
              $storiescolumn[sid],
              $storiescolumn[catid],
              $storiescolumn[aid],
              $storiescolumn[topic],
              $storiescolumn[title],
              $storiescolumn[time],
              $storiescolumn[hometext],
              $storiescolumn[bodytext],
              $storiescolumn[informant],
              $storiescolumn[notes],
              $storiescolumn[language],
              $storiescolumn[format_type],
              $storiescolumn[ihome],
              $storiescolumn[counter],
			  $storiescolumn[withcomm],
              $storiescolumn[comments],
              $storiescolumn[skins],
              $storiescolumn[themeoverride],
			  $storiescolumn[published_status],
			  $storiescolumn[from],
			  $storiescolumn[to],
			  $storiescolumn[dataeven],
			  $storiescolumn[lastchanged],
			  $storiescolumn[changedfrom],
			  $storiescolumn[gid],
			  $storiescolumn[image],
    		  $storiescolumn[descimage]
			  )
            VALUES (
              $nextid,
              '" . pnvarPrepForStore($catid) . "',
              '" . pnVarPrepForStore(pnUserGetVar('uid')) . "',
              '" . pnvarPrepForStore($topic) . "',
              '" . pnvarPrepForStore($title) . "',
              " . $dbconn->DBTimestamp(time()) . ",
              '" . pnvarPrepForStore($hometext) . "',
              '" . pnvarPrepForStore($bodytext) . "',
              '" . pnVarPrepForStore($informant) . "',
              '" . pnVarPrepForStore($notes) . "',
              '" . pnVarPrepForStore($language) . "',
              '" . pnVarPrepForStore($contenttype) . "',
              " . pnVarPrepForStore($ihome) . ",
              " . pnVarPrepForStore(0) . ",
              " . pnVarPrepForStore($withcomm) . ",
              " . pnVarPrepForStore(0) . ",
              '" . pnVarPrepForStore('') . "',
              '" . pnVarPrepForStore('') . "',
			  " . pnVarPrepForStore($status) . ",
			  " . $from . ",
			  " . $to . ",
			  " . $dataeven . ",
			  " . $lastchanged . ",
			  " . pnVarPrepForStore(0) . ",
			  " . pnVarPrepForStore(0) . ",
    		  '" . pnVarPrepForStore($image['name']) . "',
    		  '" . pnVarPrepForStore($descimage) . "'
			  )";
    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _NEWSCREATEFAILED);
        return false;
    }

    // Get the ID of the item that we inserted.  It is possible, although
    // very unlikely, that this is different from $nextId as obtained
    // above, but it is better to be safe than sorry in this situation
    $sid = $dbconn->PO_Insert_ID($storiestable, $storiescolumn['sid']);

    //ST	==========
	//memorizzazione del file su filesystem
    $cleanName = $image['name'];
	/* ESTENSIONE
    $cleanNameArr = explode(".",$cleanName);
	$estensioneImage = $cleanNameArr[1];
	*/
	$cleanName = "$sid" . "$cleanName";
	$pathimage = pnModGetVar('News', 'pathimage');
	$newfile = $pathimage . $cleanName;
	
	global $_SERVER;
        if (is_uploaded_file($_FILES['image']['tmp_name'])) {
          preg_replace('//[^A-Za-z0-9]+/_/g',$cleanName);
          //$newfile = $_SERVER['DOCUMENT_ROOT'] ."/upload/story/" . $cleanName;
          move_uploaded_file($_FILES['image']['tmp_name'], $newfile) ;
    } else {
         //echo "Impossibile aprire il file ".$image['name'];
			  switch($_FILES['image']['error']){
			   case 0: //no error; possible file attack!
			     echo "There was a problem with your upload uno.";
			     break;
			   case 1: //uploaded file exceeds the upload_max_filesize directive in php.ini
			     echo "The file you are trying to upload is too big.";
			     break;
			   case 2: //uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form
			     echo "The file you are trying to upload is too big.";
			     break;
			   case 3: //uploaded file was only partially uploaded
			     echo "The file you are trying upload was only partially uploaded.";
			     break;

			  }
    }
    
    // Let any hooks know that we have created a new item.  As this is a
    // create hook we're passing 'tid' as the extra info, which is the
    // argument that all of the other functions use to reference this
    // item
    pnModCallHooks('item', 'create', $sid, 'sid');

    // Return the id of the newly created item to the calling process
    return $sid;
}

// *********************  Begin Select Box Code **********************
/**
 *  Returns an array of form data for FormSelectMultiple
 * Input $selectid to determine which item Type to build
 * @author WindMeUp
 * @version $Revision: 1.4 $
 * @param $args['selectid'] number of the item
 * @return array Selectbox for topics
 * @todo move to API functionpool. Useful for other modules too.
 */
function news_userapi_topicsselect($args)
{
	// create the return object to be inserted into the form
    $output = array();
	$tipath = pnConfigGetVar('tipath');

	extract($args);
	if(!isset($selectid)){
		$selectid=0;
	}

	if(!isset($getimage)){
		$getimage=0;
	}

    // Database information
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    // Get items
    $sql = "SELECT $topicscolumn[topicid],
                   $topicscolumn[topicname],
				   $topicscolumn[topicimage]
            FROM $topicstable";
	//pnSessionSetVar('errormsg', $sql);
	//return false;
    $results =& $dbconn->Execute($sql);

	if ($results === false) {
		pnSessionSetVar('errormsg', _PROBLEMSELECTING._TICKETTYPES);
		return false;
	}
	$e = 0;
	if($selectid == 0){
		$output[$e] = array('id'			=> 0,
						  'selected'	=> 1,
						  'name'		=> _SELECTTOPIC,
						  'image'		=> '');
	}
	$e++;
	for (; !$results->EOF; $results->MoveNext()) {
     	list($topicid, $topicname,$topicimage) = $results->fields;
			$selected=0;
			if ($selectid==$topicid){
				$selected=1;
				if($getimage) { return "<img style=\"border: 0;\" src='".$tipath.$topicimage."' />"; }
			}
			$output[$e] = array('id' 		=> $topicid,
                             'selected' => $selected,
                             'name' 	=> $topicname,
							 'image'	=> $tipath.'/'.$topicimage);
		$e++;
	}
    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $results->Close();
	
    // Return the items
    return $output;
}

/**
 *  Returns an array of form data for FormSelectMultiple
 * Input $selectid to determine which item Type to build
 * @author WindMeUp
 * @version $Revision: 1.4 $
 * @param $args['selectid'] number of the item
 * @return array Selectbox for categories
 * @todo move to API functionpool
 */
function news_userapi_categoryselect($args)
{
	// create the return object to be inserted into the form
    $output = array();

	extract($args);
	if(!isset($selectid)){
		$selectid=0;
	}

    // Database information
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $catstable = $pntable['stories_cat'];
    $catscolumn = &$pntable['stories_cat_column'];

    // Get items
    $sql = "SELECT $catscolumn[catid],
                   $catscolumn[title]
            FROM $catstable ORDER BY $catscolumn[title] ASC";
	//pnSessionSetVar('errormsg', $sql);
	//return false;
    $results =& $dbconn->Execute($sql);

	if ($results === false) {
		pnSessionSetVar('errormsg', _PROBLEMSELECTING._TICKETTYPES);
		return false;
	}
	$e = 0;
	if($selectid == 0){
		$output[$e] = array('id'			=> 0,
						  'selected'	=> 1,
						  'name'		=> _SELECTCATEGORY);
	}
	$e++;
	for (; !$results->EOF; $results->MoveNext()) {
     	list($catid, $title) = $results->fields;
			$selected=0;
			if ($selectid==$catid){
				$selected=1;
			}
			$output[$e] = array('id' 		=> $catid,
                             'selected' => $selected,
                             'name' 	=> $title);
		$e++;
	}
    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $results->Close();
	
    // Return the items
    return $output;
}

/**
 *  Returns an array of form data for FormSelectMultiple
 * Input $selectid to determine which item Type to build
 * @author WindMeUp
 * @version $Revision: 1.4 $
 * @param $args['selectid'] number of the item
 * @return array Selectbox for user-groups
 * @todo move to API functionpool
 */
function news_userapi_groupselect($args)
{
	// create the return object to be inserted into the form
    $output = array();

	extract($args);
	if(!isset($selectid)){
		$selectid=0;
	}

    // Database information
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $groupstable = $pntable['groups'];
    $groupscolumn = &$pntable['groups_column'];

    // Get items
    $sql = "SELECT $groupscolumn[gid],
                   $groupscolumn[name]
            FROM $groupstable ORDER BY $groupscolumn[name] ASC";
	//pnSessionSetVar('errormsg', $sql);
	//return false;
    $results =& $dbconn->Execute($sql);

	if ($results === false) {
		pnSessionSetVar('errormsg', _PROBLEMSELECTING._TICKETTYPES);
		return false;
	}
	$e = 0;
	if($selectid == 0){
		$output[$e] = array('id'			=> 0,
						  'selected'	=> 1,
						  'name'		=> _SELECTGROUP);
	}
	$e++;
	for (; !$results->EOF; $results->MoveNext()) {
     	list($gid, $title) = $results->fields;
			$selected=0;
			if ($selectid==$gid){
				$selected=1;
			}
			$output[$e] = array('id' 		=> $gid,
                             'selected' => $selected,
                             'name' 	=> $title);
		$e++;
	}
    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $results->Close();
	
    // Return the items
    return $output;
}

/**
 *  Returns an array of form data for FormSelectMultiple
 * Input $selectid to determine which item Type to build
 * @author WindMeUp
 * @version $Revision: 1.4 $
 * @param bool 'automated' automatic date
 * @param int 'year' default (selected) item
 * @param int 'day' default (selected) item
 * @param int 'month' default (selected) item
 * @param int 'hour' default (selected) item
 * @param int 'min' default (selected) item
 * @param bool 'start' start- or end-date for publishing content
 * @return array Selectboxes for Calendar
 * @todo move to API functionpool
 */
function news_userapi_buildCalendarMenu($automated, &$year, &$day, &$month, &$hour, &$min, $start=1)
{
    $today = getdate();
    $tday = $today['mday'];
    if ($tday < 10){
        $tday = "0$tday";
    }
    $tmonth = $today['month'];
    $ttmon = $today['mon'];
    if ($ttmon < 10){
        $ttmon = "0$ttmon";
    }
    $tyear = $today['year'];
    $thour = $today['hours'];
    if ($thour < 10){
        $thour = "0$thour";
    }
    $tmin = $today['minutes'];
    if ($tmin < 10){
        $tmin = "0$tmin";
    }
    $tsec = $today['seconds'];
    if ($tsec < 10){
        $tsec = "0$tsec";
    }
	if($start) {
		$nDay = 'fromDay';
		$nMonth = 'fromMonth';
		$nYear = 'fromYear';
		$nHour = 'fromHour';
		$nMin = 'fromMinute';
	} else {
		$nDay = 'toDay';
		$nMonth = 'toMonth';
		$nYear = 'toYear';
		$nHour = 'toHour';
		$nMin = 'toMinute';
	}
	if($start == 2) {
		$nDay = 'dEvenDay';
		$nMonth = 'dEvenMonth';
		$nYear = 'dEvenYear';
		$nHour = 'dEvenHour';
		$nMin = 'dEvenMinute';
	}
	$output = '';
    $date = "$tmonth $tday, $tyear @ $thour:$tmin:$tsec"; /* ML get the language from the queue table */
        $formatted_date = ml_ftime(""._DATETIMELONG."", mktime($today['hours'],$today['minutes'],$today['seconds'],$today['mon'],$today['mday'],$today['year']));
        if(!$automated){
			if($start) { $output .= ""._NOWIS.": $formatted_date<br /><br />"; }
                $output .= ""._HOUR.": <select name=\"".$nHour."\" class=\"pn-text\">";
                $hour = 0;
                while ($hour <= 23) {
                        if ($thour==$hour) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        if ($hour < 10) {
                                $hour = "0$hour";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($hour)."</option>";
                        $hour++;
                }
                $output .= "</select>&nbsp;";
                $output .= ": <select name=\"".$nMin."\" class=\"pn-text\">";
                $min = 0;
                while ($min <= 59) {
                        if ($tmin==$min) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        if ($min < 10) {
                                $min = "0$min";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($min)."</option>";
                        $min++;
                }
                $output .= "</select>&nbsp;&nbsp;";
                $day = 1;
                $output .= ""._DAY.": <select name=\"".$nDay."\" class=\"pn-text\">";
                while ($day <= 31) {
                        if ($tday==$day) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($day)."</option>";
                        $day++;
                }
                $output .= "</select>&nbsp;&nbsp;";
                $month = 1;
                $output .= ""._UMONTH.": <select name=\"".$nMonth."\" class=\"pn-text\">";
                while ($month <= 12) {
                        if ($ttmon==$month) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($month)."</option>";
                        $month++;
                }
                $output .= "</select>&nbsp;&nbsp;";
                $date = getdate();
                $formatted_date = ml_ftime(""._DATETIMELONG."", mktime($date['hours'],$date['minutes'],$date['seconds'],$date['mon'],$date['mday'],$date['year']));
                $year = $date['year'];
                $output .= ""._YEAR.": <input type=\"text\" name=\"".$nYear."\" value=\"$year\" size=\"5\" maxlength=\"4\" /><br />";
        } else {
            if($start) { $output .= ""._NOWIS.": $formatted_date<br /><br />"; }
                $output .= ""._HOUR.": <select name=\"".$nHour."\" class=\"pn-text\">";
                $xhour = 0;
                while ($xhour <= 23) {
                        if ($xhour < 10) {
                                $xhour = "0$xhour";
                        }
                        if ($xhour == $hour) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($xhour)."</option>";
                        $xhour++;
                }
                $output .= "</select>&nbsp;";
                $output .= ": <select name=\"".$nMin."\" class=\"pn-text\">";
                $xmin = 0;
                while ($xmin <= 59) {
                        if ($xmin < 10) {
                                $xmin = "0$xmin";
                        }
                        if ($xmin == $min) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($xmin)."</option>";
                        $xmin++;
                }
                $output .= "</select>&nbsp;";
                $xday = 1;
                $output .= ""._DAY.": <select name=\"".$nDay."\" class=\"pn-text\">";
                while ($xday <= 31) {
                        if ($xday == $day) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        $output .= "<option $sel>$xday</option>";
                        $xday++;
                }
                $output .= "</select>&nbsp;";
                $xmonth = 1;
                $output .= ""._UMONTH.": <select name=\"".$nMonth."\" class=\"pn-text\">";
                while ($xmonth <= 12) {
                        if ($xmonth == $month) {
                                $sel = "selected";
                        } else {
                                $sel = "";
                        }
                        $output .= "<option $sel>".pnVarPrepForDisplay($xmonth)."</option>";
                        $xmonth++;
                }
                $output .= "</select>&nbsp;";
                $output .= ""._YEAR.": <input type=\"text\" name=\"".$nYear."\" value=\"$year\" size=\"5\" maxlength=\"4\" /><br /><br />";
                }
    // Return the items
    return $output;
}
?>
