<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: 
// Purpose of file:  init for quotes module
// ----------------------------------------------------------------------

/**
 * init quote module
 */
function quotes_init()
{
    // Get database information
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Create tables
    $quotestable = $pntable['quotes'];
    $quotescolumn = &$pntable['quotes_column'];
    $sql = "CREATE TABLE $quotestable (
            $quotescolumn[qid] int(10) unsigned NOT NULL auto_increment,
            $quotescolumn[quote] text,
            $quotescolumn[author] varchar(150) NOT NULL default '',
            PRIMARY KEY(pn_qid))";
    $dbconn->Execute($sql);

    // Check database result
    if ($dbconn->ErrorNo() != 0) {
        // Report failed initialisation attempt
        return false;
    }

    // Set up module variables
    pnModSetVar('Quotes', 'detail', 0);
    pnModSetVar('Quotes', 'table', 1);

    // Initialisation successful
    return true;
}

/**
 * upgrade
 */
function quotes_upgrade($oldversion)
{
    // Upgrade dependent on old version number
    switch($oldversion) {
        case 1.0:
            // upgrade versions
            break;
        case 2.0:
            // upgrade versions
            break;
        case 2.5:
            // upgrade versions
            break;
    }
}

/**
 * delete the quotes module
 */
function quotes_delete()
{
    // Get database information
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Delete tables
    $sql = "DROP TABLE $pntable[quotes]";
    $dbconn->Execute($sql);

    // Check database result
    if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }

    // Delete module variables
    pnModDelVar('Quotes', 'detail');
    pnModDelVar('Quotes', 'table');

    // Deletion successful
    return true;
}

?>
