<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Stefan Koehler
// Purpose of file:  RteMulti administration display functions
// last change: 2002/10/02  WindMeUp    some more variables,
//                                      create/modify js_config.php automatically,
//                                      for activation TextArea-name is enough
// ----------------------------------------------------------------------

/**
 * the main administration function
 */
function rtemulti_admin_main()
{
    // Create output object
    $output =& new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return the output
    return $output->GetOutput();
}

/**
 * add new item
 */
function rtemulti_admin_new()
{
    // Create output object
    $output =& new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADD)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIADD);

    // Start form
//    $output->FormStart(pnModURL('rtemulti', 'admin', 'create'));
    $output->FormStart(pnModURL('RteMulti', 'admin', 'create'));

    // Add an authorisation ID
    $output->FormHidden('authid', pnSecGenAuthKey());

    $output->TableStart();

    // EditorType
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORTYPE));
    $row[] = $output->FormText('editortype', 'rtemulti', 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Module Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIMODNAME));
    $row[] = $output->FormText('modname', '', 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Variable Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIVARNAME));
    $row[] = $output->FormText('varname', '', 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Keystring (Search string)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIKEYSTRING));
    $row[] = $output->FormTextArea('keystring', '', 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Newstring (...change with)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTINEWSTRING));
    $row[] = $output->FormTextArea('newstring', '', 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Comments
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICOMMENT));
    $row[] = $output->FormText('comment', '', 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();

    // End form
    $output->Linebreak(2);
    $output->FormSubmit(_RTEMULTICREATE);
    $output->FormEnd();

    // Return the output
    return $output->GetOutput();
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by rtemulti_admin_new() to create a new item
 * @param $args['editortype'] which editor for use
 * @param $args['modname'] module-name for activation
 * @param $args['varname'] TEXTAREA-name (or: 'form' for FORM-Tag)
 * @param $args['keystring'] Searchstring (complete beginning FORM- or TEXTAREA-Tag, or any text-string)
 * @param $args['newstring'] New string (not neccassary for FORM- or TEXTAREA-Tag, or replacement of 'keystring')
 * @param $args['comment'] Comments (just for info)
 */
function rtemulti_admin_create($args)
{
    // Get parameters from whatever input we need
    list($rid,
                 $editortype,
                 $modname,
                 $varname,
                 $keystring,
                 $newstring,
                 $comment)= pnVarCleanFromInput('rid',
                                                'editortype',
                                                'modname',
                                                'varname',
                                                'keystring',
                                                'newstring',
                                        'comment');

    extract($args);

    // Confirm authorisation code.
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('RteMulti', 'admin', 'view'));
        return true;
    }

    // Check arguments
    if (empty($modname)) {
        $output =& new pnHTML();
        $output->Text(_RTEMULTIMODNAMEEMPTY);
        return $output->GetOutput();
    }

    // Load API
//	if (!pnModAPILoad('rtemulti', 'admin')) {
	if (!pnModAPILoad('RteMulti', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    // The API function is called
    $lid = pnModAPIFunc('RteMulti',
                        'admin',
                        'create',
                        array('editortype' => $editortype,
                              'modname' => $modname,
                              'varname' => $varname,
                              'keystring' => $keystring,
                              'newstring' => $newstring,
                              'comment' => $comment));

    if ($rid != false) {
        // Success
        pnSessionSetVar('statusmsg', _RTEMULTICREATED);
    }

    pnRedirect(pnModURL('RteMulti', 'admin', 'view'));

    // Return
    return true;
}

/**
 * modify an item
 * @param 'rid' the id of the link to be modified
 */
function rtemulti_admin_modify($args)
{
    // Get parameters from whatever input we need
    list($rid,
                 $editortype,
                 $modname,
                 $varname,
                 $keystring,
                 $newstring,
                 $comment,
         $obid)= pnVarCleanFromInput('rid',
                                     'obid');


    extract($args);

    if (!empty($obid)) {
        $rid = $obid;
    }

    // Create output object
    $output =& new pnHTML();

    // Load API
//	if (!pnModAPILoad('rtemulti', 'user')) {
	if (!pnModAPILoad('RteMulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $link = pnModAPIFunc('RteMulti',
                         'user',
                         'get',
                         array('rid' => $rid));

    if ($link == false) {
        $output->Text(_RTEMULTINOSUCHLINK);
        return $output->GetOutput();
    }

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::Item', "$item[modname]::$rid", ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIEDIT);

    // Start form
    $output->FormStart(pnModURL('RteMulti', 'admin', 'update'));

    // Add an authorisation ID
    $output->FormHidden('authid', pnSecGenAuthKey());

    // Add a hidden variable for the link id
    $output->FormHidden('rid', pnVarPrepForDisplay($rid));

    $output->TableStart();

    // EditorType
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORTYPE));
    $row[] = $output->FormText('editortype', $link['editortype'], 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Module Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIMODNAME));
    $row[] = $output->FormText('modname', $link['modname'], 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Variable Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIVARNAME));
    $row[] = $output->FormText('varname', $link['varname'], 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Keystring (Search string)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIKEYSTRING));
    $row[] = $output->FormTextArea('keystring', $link['keystring'], 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Newstring (...change with)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTINEWSTRING));
    $row[] = $output->FormTextArea('newstring', $link['newstring'], 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Comments
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICOMMENT));
    $row[] = $output->FormText('comment', $link['comment'], 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();

    // End form
    $output->Linebreak(2);
    $output->FormSubmit(_RTEMULTIUPDATE);
    $output->FormEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}


/**
 * This is a standard function that is called with the results of the
 * form supplied by rtemulti_admin_modify() to update a current item
 * @param $args['editortype'] which editor for use
 * @param $args['modname'] module-name for activation
 * @param $args['varname'] TEXTAREA-name (or: 'form' for FORM-Tag)
 * @param $args['keystring'] Searchstring (complete beginning FORM- or TEXTAREA-Tag, or any text-string)
 * @param $args['newstring'] New string (not neccassary for FORM- or TEXTAREA-Tag, or replacement of 'keystring')
 * @param $args['comment'] Comments (just for info)
 */
function rtemulti_admin_update($args)
{
    // Get parameters from whatever input we need
    list($rid,
                 $editortype,
                 $modname,
                 $varname,
                 $keystring,
                 $newstring,
                 $comment)= pnVarCleanFromInput('rid',
                                                                                 'editortype',
                                                                                 'modname',
                                                                                 'varname',
                                                                                 'keystring',
                                                                                 'newstring',
                                        'comment');

    extract($args);

    if (!empty($obid)) {
        $rid = $obid;
    }

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('RteMulti', 'admin', 'view'));
        return true;
    }

    // Check arguments
    if (empty($modname)) {
        $output =& new pnHTML();
        $output->Text(_RTEMULTIMODNAMEEMPTY);
        return $output->GetOutput();
    }

    // Load API
//	if (!pnModAPILoad('rtemulti', 'admin')) {
	if (!pnModAPILoad('RteMulti', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    if(pnModAPIFunc('RteMulti',
                    'admin',
                    'update',
                    array('rid' => $rid,
                          'editortype' => $editortype,
                          'modname' => $modname,
                          'varname' => $varname,
                          'keystring' => $keystring,
                          'newstring' => $newstring,
                          'comment' => $comment))) {
        // Success
        pnSessionSetVar('statusmsg', _RTEMULTIUPDATED);
    }

    pnRedirect(pnModURL('RteMulti', 'admin', 'view'));

    // Return
    return true;
}

/**
 * delete item
 * @param 'rid' the id of the item to be deleted
 * @param 'confirmation' confirmation that this item can be deleted
 */
function rtemulti_admin_delete($args)
{
    // Get parameters from whatever input we need
    list($rid,
         $obid,
         $confirmation) = pnVarCleanFromInput('rid',
                                              'obid',
                                              'confirmation');
    extract($args);

     if (!empty($obid)) {
         $rid = $obid;
     }

    // Load API

//    if (!pnModAPILoad('rtemulti', 'user')) {
    if (!pnModAPILoad('RteMulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called
    $link = pnModAPIFunc('rtemulti',
                         'user',
                         'get',
                         array('rid' => $rid));

    if ($link == false) {
        $output->Text(_RTEMULTINOSUCHITEM);
        return $output->GetOutput();
    }

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::Item', "$item[modname]::$rid", ACCESS_DELETE)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Check for confirmation.
    if (empty($confirmation)) {
        // No confirmation yet

        // Create output object
        $output =& new pnHTML();

        // Add menu to output
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(rtemulti_adminmenu());
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Title
        $output->Title(_RTEMULTIDELETE . " $item[modname] - $item[varname]");

        // Add confirmation to output.
        $output->ConfirmAction(_RTEMULTICONFIRMDELETE,
                               pnModURL('RteMulti',
                                        'admin',
                                        'delete'),
                               _RTEMULTICANCELDELETE,
                               pnModURL('RteMulti',
                                        'admin',
                                        'view'),
                               array('rid' => $rid));

        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    // If we get here it means that the user has confirmed the action

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('RteMulti', 'admin', 'view'));
        return true;
    }

    // Load API
//	if (!pnModAPILoad('rtemulti', 'admin')) {
	if (!pnModAPILoad('RteMulti', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The API function is called
    if (pnModAPIFunc('RteMulti',
                     'admin',
                     'delete',
                     array('rid' => $rid))) {
        // Success
        pnSessionSetVar('statusmsg', _RTEMULTIDELETED);
    }

	pnRedirect(pnModURL('RteMulti', 'admin', 'view'));

    // Return
    return true;
}

/**
 * view items
 */
function rtemulti_admin_view()
{
    // Get parameters from whatever input we need
    $startnum = pnVarCleanFromInput('startnum');

    // Create output object
    $output =& new pnHTML();

    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIVIEW);

    // Load API
//
//	if (!pnModAPILoad('rtemulti', 'user')) {
	if (!pnModAPILoad('RteMulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called
    $links = pnModAPIFunc('RteMulti',
                          'user',
                          'getall',
                          array('rid' => $rid,
                                                                  'editortype' => $editortype,
                                                                'modname' => $modname,
                                                                'varname' => $varname,
                                                                'keystring' => $keystring,
                                                                'newstring' => $newstring,
                                                                'comment' => $comment,
                                'numitems' => pnModGetVar('rtemulti',
                                                          'itemsperpage')));

    if (empty($links)) {
        $output->Text(_RTEMULTINOLINKS);
        return $output->GetOutput();
    }

    // Start output table
    $output->TableStart('',
                        array(_RTEMULTIEDITORTYPE,
                              _RTEMULTIMODNAME,
                              _RTEMULTIVARNAME,
                              _RTEMULTIKEYSTRING,
                              _RTEMULTINEWSTRING,
                              _RTEMULTICOMMENT,
                              _RTEMULTIOPTIONS),
                        3);

    foreach ($links as $link) {

        $row = array();

        if (pnSecAuthAction(0, 'RteMulti::', "$link[modname]::$link[rid]", ACCESS_READ)) {

            $row[] = pnVarPrepForDisplay($link['editortype']);
            $row[] = pnVarPrepForDisplay($link['modname']);
            $row[] = pnVarPrepForDisplay($link['varname']);
            $row[] = pnVarPrepForDisplay(substr($link['keystring'],0,24));
            $row[] = pnVarPrepForDisplay(substr($link['newstring'],0,24));
            if (empty($link['comment'])) {
                $row[] = '&nbsp;';
            } else {
                $row[] = pnVarPrepForDisplay(substr($link['comment'],0,14));
            }

            // Options for the link

            $options = array();
            $output->SetOutputMode(_PNH_RETURNOUTPUT);
            if (pnSecAuthAction(0, 'RteMulti::', "$link[modname]::$link[rid]", ACCESS_EDIT)) {
                $options[] = $output->URL(pnModURL('RteMulti',
                                                   'admin',
                                                   'modify',
                                                   array('rid' => $link['rid'])),
                                          _EDIT);
                if (pnSecAuthAction(0, 'RteMulti::', "$item[modname]::$link[rid]", ACCESS_DELETE)) {
                    $options[] = $output->URL(pnModURL('RteMulti',
                                                       'admin',
                                                       'delete',
                                                       array('rid' => $link['rid'])),
                                              _DELETE);
                }
            }

            $options = join(' | ', $options);
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $row[] = $output->Text($options);
            $output->SetOutputMode(_PNH_KEEPOUTPUT);
            $output->TableAddRow($row);
            $output->SetInputMode(_PNH_PARSEINPUT);
        }
    }
    $output->TableEnd();

    // Display pager
//    $output->Pager($startnum,
//                    pnModAPIFunc('rtemulti', 'user', 'countitems'),
////
    $output->Pager($startnum,
                    pnModAPIFunc('RteMulti', 'user', 'countitems'),
                    pnModURL('RteMulti',
                             'admin',
                             'view',
                            array('startnum' => '%%')),
                    pnModGetVar('rtemulti', 'itemsperpage'));


    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * modify configuration
 */
function rtemulti_admin_modifyconfig()
{
	global $HTTP_SERVER_VARS;
     $root_path = $HTTP_SERVER_VARS['DOCUMENT_ROOT'];
     $servername = $HTTP_SERVER_VARS['SERVER_NAME'];
	 $instdir_url = substr($HTTP_SERVER_VARS['SCRIPT_URL'],0,strpos($HTTP_SERVER_VARS['SCRIPT_URL'],'/index.php'));

	$fullurl =  pnConfigGetVar('fullurl');
	$rootpath = pnConfigGetVar('rootpath');
    $editorpath = pnModGetVar('rtemulti','editorpath');
    $editorrootpath = pnModGetVar('rtemulti','editorrootpath');
    $file_upload_dir = pnModGetVar('rtemulti','file_upload_dir');
    $ignorefolders = pnModGetVar('rtemulti','ignorefolders');
    $homesubfolder = pnModGetVar('rtemulti','homesubfolder');
    $image_accept = pnModGetVar('rtemulti','image_accept');
    $file_accept = pnModGetVar('rtemulti','file_accept');
    $image_filesize = pnModGetVar('rtemulti','image_filesize');
    $file_upload_ext = pnModGetVar('rtemulti','file_upload_ext');
    $uploadsize = pnModGetVar('rtemulti','uploadsize');
    $uploadext = pnModGetVar('rtemulti','uploadext');
    $fm_filedelete = pnModGetVar('rtemulti','fm_filedelete');
    $fm_fileupload = pnModGetVar('rtemulti','fm_fileupload');
    $fm_foldercreate = pnModGetVar('rtemulti','fm_foldercreate');
    $fm_folderdelete = pnModGetVar('rtemulti','fm_folderdelete');
    if ($fullurl == '')			{ $fullurl = 'http://'.$servername.$instdir_url; }
    if ($rootpath == '')		{ $rootpath = $root_path.$instdir_url; }
    if ($editorpath == '')		{ $editorpath = 'modules/RteMulti/pneditor'; }
    if ($editorrootpath == '')	{ $editorrootpath = $rootpath.'/modules/RteMulti/pneditor'; }
    if ($file_upload_dir == '')	{ $file_upload_dir = $rootpath.'/upload/rte'; }
    if ($ignorefolders == '')	{ $ignorefolders = 'temp,tmp'; }
    if ($homesubfolder == '')	{ $homesubfolder = 'upload'; }
    if ($image_accept == '')	{ $image_accept = 'gif,jpg,jpeg,png'; }
    if ($file_accept == '')		{ $file_accept = 'html,htm,txt,phtml,php,inc'; }
    if ($image_filesize == '')	{ $image_filesize = '10240'; }
    if ($file_upload_ext == '')	{ $file_upload_ext = 'gif,jpg,jpeg,png,txt,doc,xls,pdf'; }
    if ($fm_filedelete == '')	{ $fm_filedelete = '1'; }
    if ($fm_fileupload == '')	{ $fm_fileupload = '1'; }
    if ($fm_foldercreate == '')	{ $fm_foldercreate = '1'; }
    if ($fm_folderdelete == '')	{ $fm_folderdelete = '1'; }
//    if ($uploadsize == '')		{ $uploadsize = 1; }
//    if ($uploadext == '')		{ $uploadext = 1; }

    $output =& new pnHTML();

    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADMIN)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

	if (!pnModAPILoad('news', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
		break;
    }	

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->Title(_RTEMULTIMODIFYCONFIG);

    $output->FormStart(pnModURL('RteMulti', 'admin', 'updateconfig'));

    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('groupid', '0');

    $output->HorizontalRule();
    $output->TableStart();


    //$output->TableEnd();
    //$output->Linebreak(1);

    //$output->TableStart();

    // Generell settings (header)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(_RTEMULTIGENERELLSETTING));
    //$row[] = $output->Text(pnVarPrepForDisplay('--'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Set to the full url to access the value you set for $ROOT (rootpath). No trailing slash. 
	// (don't know where I can find a global for that!!!)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_MDPROFULLURL));
    $row[] = $output->FormText('fullurl', $fullurl, 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Set to the full url to home of the RTE kernel-scripts. No trailing slash.
	// (possible: under ContentExpress or anywhere)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORPATH));
    $row[] = $output->FormText('editorpath', $editorpath, 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

	// This is the FULL path to the directory where your website files are 
	// located on your server (Your web root). DO NOT add a trailing slash.
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_MDPROROOT));
    $row[] = $output->FormText('rootpath', $rootpath, 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);
	// This is the FULL path to the directory where the program files
	// are located. 
	// NOTE: If you put it in your "web root" directory, the $ROOT (rootpath) and 
	//       $PATH (editorrootpath) settings will then be the same. DO NOT add a trailing slash.
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORROOTPATH));
    $row[] = $output->FormText('editorrootpath', $editorrootpath, 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

	// Specify a list of folders to ignore when browsing 
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIGNOREFOLDERS));
    $row[] = $output->FormText('ignorefolders', $ignorefolders, 30, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

	// Specify a basefolder for uploader and filemanager 
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIHOMESUBFOLDER));
    $row[] = $rootpath.'/ '.$output->FormText('homesubfolder', $homesubfolder, 30, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

	// What kind of file types should be visible to the users when browsing for
	// images using the WYSIWYG editor?  (The extensions you specify MUST be 
	// for an image filetype or you will get javascript errors.)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEACCEPT));
    $row[] = $output->FormText('image_accept', $image_accept, 30, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

	// What kind of file types should be visible to the users when browsing for
	// links using the WYSIWYG editor? 
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIFILEACCEPT));
    $row[] = $output->FormText('file_accept', $file_accept, 30, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // File upload path (full server path). DO NOT add a trailing slash.
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEUPLOADDIR));
    $row[] = $output->FormText('file_upload_dir', $file_upload_dir, 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Acceptable filesize for uploading files in bytes
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEFILESIZE));
    $row[] = $output->FormText('image_filesize', $image_filesize, 10, 15);
    // Do you want to set a size limit for uploaded files?
    $row[] = $output->FormCheckbox('uploadsize', $uploadsize);
    $row[] = $output->Text(pnVarPrepForDisplay(_WITHSIZE));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // File upload allowed extensions
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTILIMITEXT));
    $row[] = $output->FormText('file_upload_ext', $file_upload_ext, 30, 250);
    // Do you want to limit the acceptable extensions of uploaded file types?
    $row[] = $output->FormCheckbox('uploadext', $uploadext);
    $row[] = $output->Text(pnVarPrepForDisplay(_WITHLIMIT));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // overall activation of RTE
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEENABLE));
    $row[] = $output->FormCheckbox('RteEnable', pnModGetVar('rtemulti', 'RteEnable'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);
    // right-mouse-button dialog-box for RTE-textfields (non-visual)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEVISUALBOX));
    $row[] = $output->FormCheckbox('RteVisualBox', pnModGetVar('rtemulti', 'RteVisualBox'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // RTE-iframe size
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEDIMENSION));
        $row[] = $output->TableStart('','','0');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEHEIGHT));
    $row[] = $output->FormText('RteHeight', pnModGetVar('rtemulti', 'RteHeight'), 6, 6);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEWIDTH));
    $row[] = $output->FormText('RteWidth', pnModGetVar('rtemulti', 'RteWidth'), 6, 6);
        $row[] = $output->TableEnd();
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // if RTE activated, how should it works
        // (-1= only pop-up over right mouse button for activated modules (doesn't work yet)
        // ( 0= only on Klick in TEXAREA with YES/NO-selection (doesn't work yet)
        // ( 2= only for activated TEXTAREAs
        // ( 1= for all TEXTAREAs, without checking which is activated
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEACTIVATE));
        $row[] = $output->TableStart('','','0');
    //$row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('rtemulti', 'RteActivate')=='-1'),'-1','radio','1');
    //$row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEDISABLE));
    //$row[] = $output->Text(pnVarPrepForDisplay('Auf Klick: '));
    //$row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('RteMulti', 'RteActivate')=='0'),'0','radio','2');
    $row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('rtemulti', 'RteActivate')=='2'),'2','radio','3');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEACTIVE));
    $row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('rtemulti', 'RteActivate')=='1'),'1','radio','4');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEOVERALL));
        $row[] = $output->TableEnd();
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    // $output->Linebreak(2);

/**** Not used at moment. WindMeUp
    // activate/deactivate some HTML-tags for security-reason (<object, <iframe, <script, etc.)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTISECURITY));
        $row[] = $output->TableStart('','','0');
    $row[] = $output->FormCheckbox('RteSecurity', pnModGetVar('rtemulti', 'RteSecurity'));
    $row[] = $output->Text(pnVarPrepForDisplay(_RTESECURITY));
        $row[] = $output->TableEnd();
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);
***/

    // Filemanager: Blank line as horizontal rule
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->TextHTML('<hr>');
    $row[] = $output->TextHTML('<hr>');
    $row[] = $output->TextHTML('<hr>');
    $row[] = $output->TextHTML('<hr>');
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Filemanager: Allow delete files
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_FM_FILEDELETE));
    $row[] = $output->FormCheckbox('fm_filedelete', pnModGetVar('rtemulti', 'fm_filedelete'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Filemanager: Allow upload files
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_FM_FILEUPLOAD));
    $row[] = $output->FormCheckbox('fm_fileupload', pnModGetVar('rtemulti', 'fm_fileupload'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Filemanager: Allow create folders
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_FM_FOLDERCREATE));
    $row[] = $output->FormCheckbox('fm_foldercreate', pnModGetVar('rtemulti', 'fm_foldercreate'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Filemanager: Allow delete folders
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_FM_FOLDERDELETE));
    $row[] = $output->FormCheckbox('fm_folderdelete', pnModGetVar('rtemulti', 'fm_folderdelete'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_RTEMULTIUPDATECONFIG);
    $output->FormEnd();

    return $output->GetOutput();
}

/**
 * hide some buttons (different for each group-id)
 * ATTENTION: I use a API function of News module !!!
 */
function rtemulti_admin_hidebuttons()
{
    $output =& new pnHTML();

    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADMIN)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

	if (!pnModAPILoad('news', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
		break;
    }	

	$allgroups = pnModAPIFunc('news','user','groupselect',array('selectid'=>'0'));
	sort($allgroups);
	$groupsettings = pnConfigGetVar('RteHideButtons');

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->Title(_RTEMULTIMODIFYCONFIG);

    $output->HorizontalRule();
    if (empty($allgroups)) {
        $output->Text(_RTEMULTINOSETTINGS);
        return $output->GetOutput();
    }

    $output->TableStart('',
                        array(_RTEGROUPID,
                              _RTEGROUPNAME,
                              _RTEHIDEBUTTONSTRING,
                              _RTEMULTIOPTIONS),
                        3);
    //$output->Linebreak(2);

    foreach ($allgroups as $group) {

        $row = array();

        if ( ($group['id']> 0) && (pnSecAuthAction(0, 'RteMulti::', "$group[name]::$group[id]", ACCESS_READ)) ) {

            $row[] = pnVarPrepForDisplay($group['id']);
            $row[] = pnVarPrepForDisplay($group['name']);
            $row[] = pnVarPrepForDisplay($groupsettings[$group['id']]);

            // Options for the link

            $options = array();
            $output->SetOutputMode(_PNH_RETURNOUTPUT);
            if (pnSecAuthAction(0, 'RteMulti::', "$group[name]::$group[id]", ACCESS_EDIT)) {
                $options[] = $output->URL(pnModURL('RteMulti',
                                                   'admin',
                                                   'modifyhidebuttons',
                                                   array('gid' => $group['id'])),
                                          _EDIT);
                if (pnSecAuthAction(0, 'RteMulti::', "$group[name]::$group[id]", ACCESS_DELETE)) {
                    $options[] = $output->URL(pnModURL('RteMulti',
                                                       'admin',
                                                       'deletehidebuttons',
                                                       array('gid' => $group['id'])),
                                              _DELETE);
                }
            }

            $options = join(' | ', $options);
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $row[] = $output->Text($options);
            $output->SetOutputMode(_PNH_KEEPOUTPUT);
            $output->TableAddRow($row);
            $output->SetInputMode(_PNH_PARSEINPUT);
        }
    }
    $output->TableEnd();

    return $output->GetOutput();
}

/**
 * modify an item
 * @param 'rid' the id of the link to be modified
 */
function rtemulti_admin_modifyhidebuttons($args)
{
    // Get parameters from whatever input we need
    list($gid,
         $obid)= pnVarCleanFromInput('gid',
                                     'obid');

    extract($args);

    if (!empty($obid)) {
        $gid = $obid;
    }

    // Create output object
    $output =& new pnHTML();

    // Load API
//	if (!pnModAPILoad('rtemulti', 'user')) {
	if (!pnModAPILoad('news', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

	$allgifs = array(
				array(	"gif" => "ed_cut.gif",
						"text" => "cut"),
				array(	"gif" => "ed_copy.gif",
						"text" => "copy"),
				array(	"gif" => "ed_paste.gif",
						"text" => "paste"),
				array(	"gif" => "ed_selectall.gif",
						"text" => "selectall"),
				array(	"gif" => "ed_removeformat.gif",
						"text" => "removeformat"),
				array(	"gif" => "ed_ins_table.gif",
						"text" => "inserttable"),
				array(	"gif" => "ed_image.gif",
						"text" => "insertimage"),
				array(	"gif" => "ed_linktofile.gif",
						"text" => "insertfile"),
				array(	"gif" => "ed_link.gif",
						"text" => "createlink"),
				array(	"gif" => "ed_unlink.gif",
						"text" => "unlink"),
				array(	"gif" => "fullscreen_maximize.gif",
						"text" => "popupeditor"),
				array(	"gif" => "ed_format_bold.gif",
						"text" => "bold"),
				array(	"gif" => "ed_format_italic.gif",
						"text" => "italic"),
				array(	"gif" => "ed_format_underline.gif",
						"text" => "underline"),
				array(	"gif" => "ed_format_strike.gif",
						"text" => "strikethrough"),
				array(	"gif" => "ed_format_sub.gif",
						"text" => "subscript"),
				array(	"gif" => "ed_format_sup.gif",
						"text" => "superscript"),
				array(	"gif" => "ed_align_left.gif",
						"text" => "justifyleft"),
				array(	"gif" => "ed_align_center.gif",
						"text" => "justifycenter"),
				array(	"gif" => "ed_align_right.gif",
						"text" => "justifyright"),
 				array(	"gif" => "ed_align_justify.gif",
						"text" => "justifyfull"),
				array(	"gif" => "ed_right_to_left.gif",
						"text" => "righttoleft"),
				array(	"gif" => "ed_template.gif",
						"text" => "template"),
				array(	"gif" => "ed_list_num.gif",
						"text" => "orderedlist"),
				array(	"gif" => "ed_list_bullet.gif",
						"text" => "unorderedlist"),
				array(	"gif" => "ed_indent_less.gif",
						"text" => "outdent"),
				array(	"gif" => "ed_indent_more.gif",
						"text" => "indent"),
				array(	"gif" => "ed_hr.gif",
						"text" => "horizontal"),
				array(	"gif" => "ed_undo.gif",
						"text" => "undo"),
				array(	"gif" => "ed_redo.gif",
						"text" => "redo"),
//				array(	"gif" => "ed_font_format.gif",
				array(	"gif" => "ed_blank.gif",
						"text" => "formatblock"),
//				array(	"gif" => "ed_font_name.gif",
				array(	"gif" => "ed_blank.gif",
						"text" => "fontname"),
//				array(	"gif" => "ed_font_size.gif",
				array(	"gif" => "ed_blank.gif",
						"text" => "fontsize"),
				array(	"gif" => "ed_color_fg.gif",
						"text" => "forecolor"),
				array(	"gif" => "ed_color_bg.gif",
						"text" => "hilitecolor"),
				array(	"gif" => "ed_bgcolor.gif",
						"text" => "bgcolor"),
				array(	"gif" => "ed_bgimage.gif",
						"text" => "bgimage")
				);

	$allgroups = pnModAPIFunc('news','user','groupselect',array('selectid'=>"'".$gid."'"));
	sort($allgroups);
	$groupsettings = pnConfigGetVar('RteHideButtons');
	$selectedgroup = $allgroups[$gid]["name"];

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', "::$gid", ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIEDITHIDEBUTTONS);

    // Start form
    $output->FormStart(pnModURL('RteMulti', 'admin', 'updatehidebuttons'));

    // Add an authorisation ID
    $output->FormHidden('authid', pnSecGenAuthKey());

    // Add a hidden variable for the link id
    $output->FormHidden('gid', pnVarPrepForDisplay($gid));

    $output->TableStart('','',1,'720px');
    // Header for settings table
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(_SELECTEDGROUP).": ".pnVarPrepForDisplay($selectedgroup));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->BoldText(pnVarPrepForDisplay(_HIDEBUTTONS).": ".pnVarPrepForDisplay($groupsettings[$gid]));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->TableEnd();

    $output->TableStart('','',1,'720px');
		$row = array();
		$j = 0;
		foreach($allgifs as $gif) {
			$checked = 0;

			if(ereg($gif['text'],$groupsettings[$gid])) {
				$checked = 1;
			}
		    $output->SetOutputMode(_PNH_RETURNOUTPUT);
			if($i <=4) {
		    $row[] = 	$output->FormCheckbox(pnVarPrepForDisplay($gif['text']),$checked,'1').
						$output->TextHTML("<IMG src='modules/RteMulti/pneditor/images/$gif[gif]'> ".pnVarPrepForDisplay($gif['text']));
			}
			$i++;
			if($i == 5) {
				$i=0;
			    $output->SetOutputMode(_PNH_KEEPOUTPUT);
			    $output->SetInputMode(_PNH_VERBATIMINPUT);
			    $output->TableAddrow($row, 'left');
			    $output->SetInputMode(_PNH_PARSEINPUT);
				$row = array();
			}
		$j++;
		}
		if($i < 5) {
		    $output->SetOutputMode(_PNH_KEEPOUTPUT);
		    $output->SetInputMode(_PNH_VERBATIMINPUT);
		    $output->TableAddrow($row, 'left');
		    $output->SetInputMode(_PNH_PARSEINPUT);
		}
    $output->TableEnd();

    $output->Linebreak(2);
    $output->FormSubmit(_RTEUPDATEHIDEBUTTONS);
    $output->FormEnd();

    return $output->GetOutput();
}

/**
 * modify toolbar configuration
 */
function rtemulti_admin_modifytoolbar()
{
    $output =& new pnHTML();

    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADMIN)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->Title(_RTEMULTIMODIFYCONFIG);

    $output->FormStart(pnModURL('RteMulti', 'admin', 'updatetoolbar'));

    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->HorizontalRule();
    $output->TableStart();

    // Header for configuration
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(_RTEMULTIDEFAULTSETTING));
    $row[] = $output->Text(' ');
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Header for settings table
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(' '));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEBAR_1));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEBAR_2));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEBAR_3));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEBAR_0));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // order the toolbar like you want. Enter numbers for pos in Bar 1-3
        // ( 1= Set Block to Bar 1 )
        // ( 2= Set Block to Bar 2 )
        // ( 3= Set Block to Bar 3 )
        // ( 0= No set             )

	$settings = array();
	$settings = pnConfigGetVar('RteToolbars');
	// Block 1 to 10
	for($blocks=1;$blocks<=10;$blocks++) {
	    $row = array();
	    $output->SetOutputMode(_PNH_RETURNOUTPUT);
	    $row[] = $output->TextHTML("<IMG src=\"modules/RteMulti/images/block".$blocks.".gif\">");
		// order in toolbar 1 to 4
		for($order=1;$order<=4;$order++) {
		    $row[] = $output->FormText('RteBlock'.$blocks.$order,$settings[$blocks][$order], 2, 2);
		}
	    $output->SetOutputMode(_PNH_KEEPOUTPUT);
	    $output->SetInputMode(_PNH_VERBATIMINPUT);
	    $output->TableAddrow($row, 'left');
	    $output->SetInputMode(_PNH_PARSEINPUT);
	}

    $output->TableEnd();
    $output->Linebreak(2);

    $output->FormSubmit(_RTETOOLBARUPDATECONFIG);
    $output->FormEnd();

    return $output->GetOutput();
}

/**
 * update toolbar settings
 */
function rtemulti_admin_updatetoolbar()
{
	$RteBlock = array();
	for($blocks=1;$blocks<=10;$blocks++) {
		for($order=1;$order<=4;$order++) {
			$RteBlock[$blocks][$order] = pnVarCleanFromInput('RteBlock'.$blocks.$order);
		}
	}

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('RteMulti', 'admin', 'view'));
        return true;
    }

    pnConfigSetVar('RteToolbars', $RteBlock);

    pnRedirect(pnModURL('RteMulti', 'admin', 'modifytoolbar'));

    return true;
}

/**
 * update hide buttons for all groups
 */
function rtemulti_admin_updatehidebuttons()
{
		$selected = pnVarCleanFromInput (
			'cut','copy','paste','selectall','removeformat','inserttable','insertimage','insertfile','createlink','unlink','popupeditor',
			'bold','italic','underline','strikethrough','subscript','superscript','justifyleft','justifycenter','justifyright','justifyfull',
			'righttoleft','template','orderedlist','unorderedlist','outdent','indent','horizontal',
			'undo','redo','formatblock','fontname','fontsize','forecolor','hilitecolor','bgcolor','bgimage'
		);
		$sel_name = array(
			'cut','copy','paste','selectall','removeformat','inserttable','insertimage','insertfile','createlink','unlink','popupeditor',
			'bold','italic','underline','strikethrough','subscript','superscript','justifyleft','justifycenter','justifyright','justifyfull',
			'righttoleft','template','orderedlist','unorderedlist','outdent','indent','horizontal',
			'undo','redo','formatblock','fontname','fontsize','forecolor','hilitecolor','bgcolor','bgimage'
		);
	$gid = pnVarCleanFromInput('gid');
	$groupsettings = pnConfigGetVar('RteHideButtons');

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('RteMulti', 'admin', 'view'));
        return true;
    }

	$temp = '';
	for($i=0;$i < count($groupsettings);$i++) {
		if($i == $gid) {
			for($j=0;$j < count($selected);$j++) {
				if($selected[$j] == '1') {
					$temp .= $sel_name[$j]." ";
				}
			}
			$groupsettings[$i] = substr($temp,0,strlen($temp)-1);
			break;
		}
	}

    pnConfigSetVar('RteHideButtons', $groupsettings);

    pnRedirect(pnModURL('RteMulti', 'admin', 'hidebuttons'));

    return true;
}

/**
 * update configuration
 */
function rtemulti_admin_updateconfig()
{
    global $HTTP_SERVER_VARS;
    //$output->Linebreak(2);
	list(
		$fullurl,$editorpath,$rootpath,$editorrootpath,$ignorefolders,$homesubfolder,$image_accept,$file_accept,
		$file_upload_dir,$image_filesize,$uploadsize,$file_upload_ext,$uploadext,$RteEnable,
		$RteVisualBox,$RteHeight,$RteWidth,$RteActivate,
		$fm_filedelete,$fm_fileupload,$fm_foldercreate,$fm_folderdelete
		)
		= pnVarCleanFromInput(
								'fullurl','editorpath','rootpath','editorrootpath','ignorefolders','homesubfolder','image_accept','file_accept',
								'file_upload_dir','image_filesize','uploadsize','file_upload_ext','uploadext','RteEnable',
								'RteVisualBox','RteHeight','RteWidth','RteActivate',
								'fm_filedelete','fm_fileupload','fm_foldercreate','fm_folderdelete'
							);

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('RteMulti', 'admin', 'view'));
        return true;
    }

     $root_path = $HTTP_SERVER_VARS['DOCUMENT_ROOT'];
     $servername = $HTTP_SERVER_VARS['SERVER_NAME'];
	 $instdir_url = substr($HTTP_SERVER_VARS['SCRIPT_URL'],0,strpos($HTTP_SERVER_VARS['SCRIPT_URL'],'/index.php'));

    if (!isset($fullurl))        { $fullurl = 'http://'.$servername.$instdir_url; }
    if (!isset($editorpath))        { $editorpath = 'modules/RteMulti/pneditor'; }
	if($uploadsize == '') $uploadsize=0;
	if($uploadext == '') $uploadext=0;

	if($fm_filedelete == '') $fm_filedelete=0;
	if($fm_fileupload == '') $fm_fileupload=0;
	if($fm_foldercreate == '') $fm_foldercreate=0;
	if($fm_folderdelete == '') $fm_folderdelete=0;
//echo ($file_upload_dir);
//die;
//    if (!isset($RteEnable))         { $RteEnable = 1; }

	pnConfigSetVar('fullurl',$fullurl);
	pnConfigSetVar('rootpath',$rootpath);

    pnModSetVar('rtemulti', 'editorpath', $editorpath);
    pnModSetVar('rtemulti', 'editorrootpath', $editorrootpath);
    pnModSetVar('rtemulti', 'ignorefolders', $ignorefolders);
    pnModSetVar('rtemulti', 'homesubfolder', $homesubfolder);
    pnModSetVar('rtemulti', 'image_accept', $image_accept);
    pnModSetVar('rtemulti', 'file_accept', $file_accept);

    pnModSetVar('rtemulti', 'file_upload_dir', $file_upload_dir);
    pnModSetVar('rtemulti', 'image_filesize', $image_filesize);
    pnModSetVar('rtemulti', 'uploadsize', $uploadsize);
    pnModSetVar('rtemulti', 'file_upload_ext', $file_upload_ext);
    pnModSetVar('rtemulti', 'uploadext', $uploadext);
    pnModSetVar('rtemulti', 'RteEnable', $RteEnable);
    pnModSetVar('rtemulti', 'RteVisualBox', $RteVisualBox);
    pnModSetVar('rtemulti', 'RteHeight', $RteHeight);
    pnModSetVar('rtemulti', 'RteWidth', $RteWidth);
    pnModSetVar('rtemulti', 'RteActivate', $RteActivate);

    pnModSetVar('rtemulti', 'fm_filedelete', $fm_filedelete);
    pnModSetVar('rtemulti', 'fm_fileupload', $fm_fileupload);
    pnModSetVar('rtemulti', 'fm_foldercreate', $fm_foldercreate);
    pnModSetVar('rtemulti', 'fm_folderdelete', $fm_folderdelete);

    pnSessionSetVar('statusmsg', _RTEMULTIUPDATEDCONFIG);

		// valid image file types for inserting
        $aBuffer = explode(',',$image_accept);
        $valid_images = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $valid_images .= '"'.trim($aBuffer[$i]).'",';
        }
        $valid_images = substr($valid_images,0,strlen($valid_images)-1);

		// valid file types for internal linking
        $aBuffer = explode(',',$file_accept);
        $valid_files = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $valid_files .= '"'.trim($aBuffer[$i]).'",';
        }
        $valid_files = substr($valid_files,0,strlen($valid_files)-1);

		// valid file types for uploading
        $aBuffer = explode(',',$file_upload_ext);
        $valid_upload_files = $valid_upload_text = '';
		$counter = count($aBuffer);
        for($i=0; $i < count($aBuffer); $i++)
        {
                $valid_upload_files .= '"'.trim($aBuffer[$i]).'",';
                $valid_upload_text .= '".'.trim($aBuffer[$i]).'",';
        }
        $valid_upload_files = substr($valid_upload_files,0,strlen($valid_upload_files)-1);
        $valid_upload_text  = substr($valid_upload_text,0,strlen($valid_upload_text)-1);

		// ignoring folders
        $aBuffer = explode(',',$ignorefolders);
        $ignore = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $ignore .= '"'.trim($aBuffer[$i]).'",';
        }
        $ignore = substr($ignore,0,strlen($ignore)-1);

		if($uploadsize) {
			$sizelimit = 'yes';
		} else {
			$sizelimit = 'no';
		}
		if($uploadext) {
			$extlimit = 'yes';
		} else {
			$extlimit = 'no';
		}
// Create or modify js_config.php for the image-picker
    $d = ml_ftime(_DATETIMELONG);
    $content = "<?php // Generated: $d\n"
        ."// ----------------------------------------------------------------------\n"
                ."/**\n"
                ."This is the config-file for some defaults to setting up the imagePicker\n"
                ."The imagePicker is an enhancement for the Richtext-Editor\n"
                ."\n"
                ."Name: rte-config.php\n"
                ."Description: DON'T EDIT THIS FILE MANUALLY. IT WILL BE GENERATED AUTOMATICALLY\n"
                ."Author: Stefan Khler (s.koehler@prowings.de)\n"
                ."**/\n"
        ."// ----------------------------------------------------------------------\n\n\n"
				."// This is the FULL path to the directory where the program files\n"
				."// are located. \n"
				."// NOTE: If you put it in your \"web root\" directory, the \$ROOT and \n"
				."//       \$PATH settings will then be the same. DO NOT add a trailing slash.\n"
				."	\$PATH = '$editorrootpath';\n"
				."\n"
				."// This is the FULL path to the directory where your website files are \n"
				."// located on your server (Your web root). DO NOT add a trailing slash.\n"
				."	\$ROOT = '$rootpath';\n"
				."\n"
				."// Set to the full url to access the value you set for \$ROOT. No trailing slash.\n"
				."	\$PREVIEW = '$fullurl';\n"
				."\n"
				."// Set to the full url to access the value you set for \$PATH. \n"
				."	\$URL = '$editorpath';\n"
				."\n"
				."// Specify a list of folders to ignore when browsing \n"
				."	\$IGNORE = array($ignore);\n"
				."\n"
				."// What kind of file types should be visible to the users when browsing for\n"
				."// images using the WYSIWYG editor?  (The extensions you specify MUST be \n"
				."// for an image filetype or you will get javascript errors.)\n"
				."	\$VALID_IMAGE_FILE_TYPES =  array($valid_images);\n"
				."\n"
				."// What kind of file types should be visible to the users when browsing for\n"
				."// links using the WYSIWYG editor? \n"
				."	\$VALID_LINK_FILE_TYPES =  array($valid_files);\n"
				."\n"
				."// To turn off errors from appearing in your email inbox, \n"
				."// set to 0.\n"
				."	\$REPORT = 0;\n"
				."\n"
				."// Set to 1 to enabling printing of WYSIWYG debug messages, otherwise \n"
				."// set to 0 \n"
				."	\$DEBUG = 1;\n"
				."\n"
				."\$absolute_path = '$file_upload_dir'; //Absolute path to where files are uploaded\n"
//				."\$size_limit = '$sizelimit'; //do you want a size limit, yes or no.\n"
//				."\$limit_size = '$image_filesize'; //How big do you want size limit to be in bytes\n"
//				."\$limit_ext = '$extlimit'; //do you want to limit the extensions of files uploaded, yes or no.\n"
				."\$ext_count = '$counter'; //total number of extensions in array below\n"
//				."\$extensions = array($valid_upload_text); //List extensions you want files uploaded to be\n"
				."\n"
				."// Do you want to limit the acceptable extensions of uploaded file types?\n"
				."// To enable set to 1; to disable change to 0.\n"
				."	\$LIMIT_UPLOAD_FILE_TYPES = $uploadext;\n"
				."\n"
				."// If enabled, specify a list of acceptable file types for the upload function.\n"
				."	\$VALID_UPLOAD_FILE_TYPES =  array($valid_upload_files);\n"
				."\n"
				."// Do you want to set a size limit for uploaded files?  \n"
				."// To enable set to 1; to disable change to 0.\n"
				."	\$UPLOAD_FILE_SIZE_LIMIT = $uploadsize;\n"
				."\n"
				."// If enabled, specify the size limit (in bytes) for uploaded files.\n"
				."	\$UPLOAD_FILE_MAX_SIZE = $image_filesize;\n"
				."\n"
				."	define('MAXSIZE', $image_filesize);\n"
				."\n"
				."	/* What is the root of the site? THE LAST '/' IS REQUIRED */\n"
				."	define('ROOTFOLDER', '$rootpath/');\n"
				."	define('SITEROOT', '$fullurl/');\n"
				."\n"
				."	/* What is the base folder for uploader and filemanager? NO trailing slash */\n"
				."	define('HOMEFOLDER', '$homesubfolder');\n"
				."\n"
				."	/* Some sets for additional functions in filemanager */\n"
				."	define('FM_FILEDELETE', '$fm_filedelete');\n"
				."	define('FM_FILEUPLOAD', '$fm_fileupload');\n"
				."	define('FM_FOLDERCREATE', '$fm_foldercreate');\n"
				."	define('FM_FOLDERDELETE', '$fm_folderdelete');\n"
				."\n"
				."	/* Set to 1 to enable the printing of debug messages, otherwise set to 0 */\n"
				."	define('DEBUG', 1);\n\n\n"



        ."// ----------------------------------------------------------------------\n"
        .'?'.'>'
    ;
    // I can't seem to get around the stupid PHP file owner problem :-(
    //$tmpf = tempnam('tmp', 'postnuke_');
    //$fp = fopen("$tmpf.php", w);
    $fp = @fopen('config/rte-config.php', w);
    if (!$fp) die (sprintf(_ERROR_FILE_OPEN,'rte-config.php','rte-config.php'));
    fwrite($fp, $content);
    fclose($fp);

    pnRedirect(pnModURL('RteMulti', 'admin', 'modifyconfig'));

    return true;
}

/**
 * Main administration menu
 */
function rtemulti_adminmenu($title)
{
	global $hlpfile;
    // Create output object 
    $output =& new pnHTML();

	$output->SetOutputMode(_PNH_KEEPOUTPUT);
	$output->SetInputMode(_PNH_VERBATIMINPUT);

	// Some values
	$AdminAccess 	= pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADMIN);
	$enabledimages 	= pnModGetVar('news', 'enableimages');
	$currentlang 	= pnUserGetLang();
	$configlang    = pnConfigGetVar('language');
	if(is_dir('images/buttons/'.pnVarPrepForOS($currentlang))) {
		$imgpath = 'images/buttons/'.pnVarPrepForOS($currentlang);
	} else {
		$imgpath = 'images/buttons/'.pnVarPrepForOS($configlang);
	}

	$filter = array();
	
    // Security check - implemented only base functionality for testing
    if (!$AdminAccess) {
        $output->Text(_RTEMULTI_NOAUTH);
        return $output->GetOutput();
    }

	// Link to main admin menu
	$output->Text('<center><a href="admin.php" class="pn-title"><strong>'._ADMINMENU.'</strong></font></a></center><br />');
//	modules_get_manual();
	if (file_exists($file="modules/RteMulti/pnlang/".pnVarPrepForOS($currentlang)."/manual.html")) {
		$hlpfile = $file;
		$output->TextHTML('<center>[ <a href="javascript:openwindow('.')" class="pn-normal">'._ONLINEMANUAL.'</a> ]</center>'."\n");
	}

    // Display status message if any and clear.
    $output->BoldText(pnGetStatusMsg());
    pnSessionSetVar('errormsg', '');
    $output->Linebreak(2);

    // Menu options. 
//    $output->TableStart(_NEWS_MENU);
    $output->Title(pnVarPrepForDisplay($title));
//	$output->TableRowStart('center');
//	$output->TableColStart();
	if($enabledimages)
	{
		$output->Text('<center>');
		$output->URL(pnModURL('RteMulti', 'admin', 'new'), '<img src="'.$imgpath.'/types.gif" alt="'._ADDACTIVATION.'" border=0>'); 
		$output->Text(' ');
		$output->URL(pnModURL('RteMulti', 'admin', 'view'), '<img src="'.$imgpath.'/viewstory.gif" alt="'._SHOWACTIVATIONS.'" border=0>'); 
		$output->Text(' ');
		$output->URL(pnModURL('RteMulti', 'admin', 'modifyconfig'), '<img src="'.$imgpath.'/genconfig.gif" alt="'._EDITCONFIG.'" border=0>'); 
		$output->Text('<br \>');
		$output->URL(pnModURL('RteMulti', 'admin', 'modifytoolbar'), '<img src="'.$imgpath.'/toolbar.gif" alt="'._EDITTOOLBAR.'" border=0>'); 
		$output->Text(' ');
		$output->URL(pnModURL('RteMulti', 'admin', 'hidebuttons'), '<img src="'.$imgpath.'/hidebuttons.gif" alt="'._HIDEBUTTONS.'" border=0>'); 
		$output->Text('</center>');
		$output->LineBreak(1);
	}else{
		$output->Text('<center>');
		$output->Text('[');
		$output->URL(pnModURL('RteMulti', 'admin', 'new'), _ADDACTIVATION);
		$output->Text('] [');
		$output->URL(pnModURL('RteMulti', 'admin', 'view'), _SHOWACTIVATIONS); 
		$output->Text('] [');
		$output->URL(pnModURL('RteMulti', 'admin', 'modifyconfig'), _EDITCONFIG); 
		$output->Text('] [');
		$output->URL(pnModURL('RteMulti', 'admin', 'modifytoolbar'), _EDITTOOLBAR); 
		$output->Text('] [');
		$output->URL(pnModURL('RteMulti', 'admin', 'hidebuttons'), _HIDEBUTTONS); 
		$output->Text(']');
		$output->Text('</center>');
		$output->Linebreak(1);
	}
//	$output->TableColEnd();
//	$output->TableRowEnd();
//   $output->TableEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

?>
