<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Stefan Koehler
// Purpose of file:  RteMulti administration API
// ----------------------------------------------------------------------

/**
 * create a new RTE activation
 * @param $args['editortype'] which editor for use
 * @param $args['modname'] module-name for activation
 * @param $args['varname'] TEXTAREA-name (or: 'form' for FORM-Tag)
 * @param $args['keystring'] Searchstring (complete beginning FORM- or TEXTAREA-Tag, or any text-string)
 * @param $args['newstring'] New string (not neccassary for FORM- or TEXTAREA-Tag, or replacement of 'keystring')
 * @param $args['comment'] Comments (just for info)
 * @returns int
 * @return rtemulti-ID on success, false on failure
 */
function rtemulti_adminapi_create($args)
{
	global $pnconfig;
/*	$dbtype = $pnconfig['dbtype'];
	$dbname = $pnconfig['prefix']; changed with new function */
	$dbtype = pnConfigGetVar('dbtype');
	$dbname = pnConfigGetVar('prefix');
    // Get arguments from argument array
    extract($args);

    // Optional arguments
    if (!isset($comment)) {
        $comment = '';
    }

    // Argument check - make sure that all required arguments are present,
    // if not then set an appropriate error message and return
    if (!isset($modname)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', "$modname::", ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _RTEMULTINOAUTH);
        return false;
    }

    // Get datbase setup
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

    $rtemultitable = $pntable['rtemulti'];
    $rtemulticolumn = &$pntable['rtemulti_column'];

//modified for Oracle compatibility
/*    // Get next ID in table
    $nextId = $dbconn->GenId($rtemultitable);

    // Add item
    $sql = "INSERT INTO $rtemultitable (
              $rtemulticolumn[rid],
              $rtemulticolumn[editortype],
              $rtemulticolumn[modname],
              $rtemulticolumn[varname],
              $rtemulticolumn[keystring],
              $rtemulticolumn[newstring],
              $rtemulticolumn[comment])
            VALUES (
              $nextId,
              '" . pnVarPrepForStore($editortype) . "',
              '" . pnVarPrepForStore($modname) . "',
              '" . pnVarPrepForStore($varname) . "',
              '" . pnVarPrepForStore($keystring) . "',
              '" . pnVarPrepForStore($newstring) . "',
              '" . pnVarPrepForStore($comment) . "')";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _RTEMULTILINKCREATEFAILED);
        return false;
    }
*/
	switch ($dbtype){
		case "oci8":
	    	$sequence=substr_replace($rtemultitable,'',0,strlen($dbname)+1).'_sq';
			$nextId = $dbconn->GenId($sequence);
			$sql = "INSERT INTO $rtemultitable (
			      $rtemulticolumn[rid],
				  $rtemulticolumn[editortype],
	              $rtemulticolumn[modname],
		          $rtemulticolumn[varname],
			      $rtemulticolumn[keystring],
	              $rtemulticolumn[newstring],
		          $rtemulticolumn[comment])
			    VALUES (
	              $nextId,
		          '" . pnVarPrepForStore($editortype) . "',
			      '" . pnVarPrepForStore($modname) . "',
	              '" . pnVarPrepForStore($varname) . "',
		          empty_clob(),
			      empty_clob(),
	              '" . pnVarPrepForStore($comment) . "')";
			$dbconn->Execute($sql);

		    if ($dbconn->ErrorNo() != 0) {
		        pnSessionSetVar('errormsg', _RTEMULTILINKCREATEFAILED);
		        return false;
			}
			$dbconn->updateClob($rtemultitable,$rtemulticolumn[keystring],pnVarPrepForStore($keystring),$rtemulticolumn[rid].'='.$nextId);
			$dbconn->updateClob($rtemultitable,$rtemulticolumn[newstring],pnVarPrepForStore($newstring),$rtemulticolumn[rid].'='.$nextId);
			break;
		default:
		    $nextId = $dbconn->GenId($rtemultitable);
			$sql = "INSERT INTO $rtemultitable (
			      $rtemulticolumn[rid],
				  $rtemulticolumn[editortype],
	              $rtemulticolumn[modname],
		          $rtemulticolumn[varname],
			      $rtemulticolumn[keystring],
	              $rtemulticolumn[newstring],
		          $rtemulticolumn[comment])
			    VALUES (
	              $nextId,
		          '" . pnVarPrepForStore($editortype) . "',
			      '" . pnVarPrepForStore($modname) . "',
	              '" . pnVarPrepForStore($varname) . "',
		          '" . pnVarPrepForStore($keystring) . "',
			      '" . pnVarPrepForStore($newstring) . "',
	              '" . pnVarPrepForStore($comment) . "')";
			$dbconn->Execute($sql);

		    if ($dbconn->ErrorNo() != 0) {
		        pnSessionSetVar('errormsg', _RTEMULTILINKCREATEFAILED);
		        return false;
			}
			break;
	}

    // Get the ID of the item that we inserted
    $rid = $dbconn->PO_Insert_ID($rtemultitable, $rtemulticolumn['rid']);

    // Let any hooks know that we have created a new link
    pnModCallHooks('item', 'create', $rid, 'rid');

    // Return the id of the newly created link to the calling process
    return $rid;
}

/**
 * delete an RTE activation
 * @param $args['rid'] ID of the link
 * @returns bool
 * @return true on success, false on failure
 */
function rtemulti_adminapi_delete($args)
{
    // Get arguments from argument array
    extract($args);

    // Argument check
    if (!isset($rid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Load API
//    if (!pnModAPILoad('rtemulti', 'user')) {
    if (!pnModAPILoad('RteMulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called
//    $link = pnModAPIFunc('rtemulti',
    $link = pnModAPIFunc('RteMulti',
                         'user',
                         'get',
                         array('rid' => $rid));

    if ($link == false) {
        $output->Text(_RTEMULTINOSUCHLINK);
        return $output->GetOutput();
    }

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', "$link[modname]::$rid", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _RTEMULTINOAUTH);
        return false;
    }

    // Get datbase setup
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

    $rtemultitable = $pntable['rtemulti'];
    $rtemulticolumn = &$pntable['rtemulti_column'];

    // Delete the item
    $sql = "DELETE FROM $rtemultitable
            WHERE $rtemulticolumn[rid] = " . pnVarPrepForStore($rid);
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _RTEMULTIDELETEFAILED);
        return false;
    }

    // Let any hooks know that we have deleted a link
    pnModCallHooks('item', 'delete', $rid, '');

    // Let the calling process know that we have finished successfully
    return true;
}

/**
 * update an RTE activation
 * @param $args['editortype'] which editor for use
 * @param $args['modname'] module-name for activation
 * @param $args['varname'] TEXTAREA-name (or: 'form' for FORM-Tag)
 * @param $args['keystring'] Searchstring (complete beginning FORM- or TEXTAREA-Tag, or any text-string)
 * @param $args['newstring'] New string (not neccassary for FORM- or TEXTAREA-Tag, or replacement of 'keystring')
 * @param $args['comment'] Comments (just for info)
 * @returns bool
 * @return true on success, false on failure
 */
function rtemulti_adminapi_update($args)
{
	global $pnconfig;
//	$dbtype = $pnconfig['dbtype']; changed with new function
	$dbtype = pnConfigGetVar('dbtype');
    // Get arguments from argument array
    extract($args);

    if (!isset($comment)) {
        $comment = '';
    }
    // Argument check
    if ((!isset($rid)) ||
        (!isset($modname))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Load API
//    if (!pnModAPILoad('rtemulti', 'user')) {
    if (!pnModAPILoad('RteMulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called
//    $link = pnModAPIFunc('rtemulti',
    $link = pnModAPIFunc('RteMulti',
                         'user',
                         'get',
                         array('rid' => $rid));

    if ($link == false) {
        $output->Text(_RTEMULTINOSUCHLINK);
        return $output->GetOutput();
    }

    if (!pnSecAuthAction(0, 'RteMulti::', "$link[modname]::$rid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _RTEMULTINOAUTH);
        return false;
    }
    if (!pnSecAuthAction(0, 'RteMulti::', "$modname::$rid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _RTEMULTINOAUTH);
        return false;
    }

    // Get database setup
    $dbconn =& pnDBGetConn(true);
    $pntable = pnDBGetTables();

    $rtemultitable = $pntable['rtemulti'];
    $rtemulticolumn = &$pntable['rtemulti_column'];

    // Update the link

//modified for Oracle compatibility
/*	$sql = "UPDATE $rtemultitable
            SET $rtemulticolumn[editortype] = '" . pnVarPrepForStore($editortype) . "',
                $rtemulticolumn[modname] = '" . pnVarPrepForStore($modname) . "',
                $rtemulticolumn[varname] = '" . pnVarPrepForStore($varname) . "',
                $rtemulticolumn[keystring] = '" . pnVarPrepForStore($keystring) . "',
                $rtemulticolumn[newstring] = '" . pnVarPrepForStore($newstring) . "',
                $rtemulticolumn[comment] = '" . pnVarPrepForStore($comment) . "'
            WHERE $rtemulticolumn[rid] = " . pnVarPrepForStore($rid);
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _RTEMULTIUPDATEFAILED);
        return false;
    }
*/
	switch ($dbtype){
		case "oci8":	
			$sql = "UPDATE $rtemultitable
	            SET $rtemulticolumn[editortype] = '" . pnVarPrepForStore($editortype) . "',
		            $rtemulticolumn[modname] = '" . pnVarPrepForStore($modname) . "',
			        $rtemulticolumn[varname] = '" . pnVarPrepForStore($varname) . "',
				    $rtemulticolumn[keystring] = empty_clob(),
	                $rtemulticolumn[newstring] = empty_clob(),
		            $rtemulticolumn[comment] = '" . pnVarPrepForStore($comment) . "'
				    WHERE $rtemulticolumn[rid] = " . pnVarPrepForStore($rid);
		    $dbconn->Execute($sql);

		    if ($dbconn->ErrorNo() != 0) {
				pnSessionSetVar('errormsg', _RTEMULTIUPDATEFAILED);
		        return false;
		    }
			$dbconn->updateClob($rtemultitable,$rtemulticolumn[keystring],pnVarPrepForStore($keystring),$rtemulticolumn[rid].'='.pnVarPrepForStore($rid));

			$dbconn->updateClob($rtemultitable,$rtemulticolumn[newstring],pnVarPrepForStore($newstring),$rtemulticolumn[rid].'='.pnVarPrepForStore($rid));
			break;
		default:
    $sql = "UPDATE $rtemultitable
            SET $rtemulticolumn[editortype] = '" . pnVarPrepForStore($editortype) . "',
                $rtemulticolumn[modname] = '" . pnVarPrepForStore($modname) . "',
                $rtemulticolumn[varname] = '" . pnVarPrepForStore($varname) . "',
                $rtemulticolumn[keystring] = '" . pnVarPrepForStore($keystring) . "',
                $rtemulticolumn[newstring] = '" . pnVarPrepForStore($newstring) . "',
                $rtemulticolumn[comment] = '" . pnVarPrepForStore($comment) . "'
            WHERE $rtemulticolumn[rid] = " . pnVarPrepForStore($rid);
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _RTEMULTIUPDATEFAILED);
        return false;
    }
			break;
	}

    // Let the calling process know that we have finished successfully
    return true;
}
?>
