<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Filename: modules/Search/index.php
// Original Author of file: Patrick Kellum
// Purpose of file: Search reviews/users/stories/topics/faqs
//
// Last change:  WindMeUp 2003/01/27
// modification: new switch: action = q_search, is called from RTE to search&insert contents-URL
// ----------------------------------------------------------------------
// sjah: 03-10-2004 removed tables for css layout

if (!defined("LOADED_AS_MODULE")) {
         die ("You can't access this file directly...");
     }

/*
Credits to Edgar Miller -- http://www.bosna.de/ from his post on PHP-Nuke ( http://phpnuke.org/article.php?sid=2010&mode=nested&order=0&thold=0 )
Further Credits go to Djordjevic Nebojsa (nesh) for the fix for the fix */

$ModName = basename(dirname(__FILE__));

modules_get_language();

/*
 * load all available search modules
 */

$search_modules = '';
$d = opendir('includes/search/');

while($f = readdir($d)) {
    if(substr($f, -3, 3) == 'php') {
        include 'includes/search/' . $f;
    }
}
closedir($d);

$vars = array_merge($HTTP_POST_VARS,$HTTP_GET_VARS);

if(!isset($vars['action']))
{
	$vars['action'] = 'form';
}

switch($vars['action']) {

    default:
    case 'form':
        include 'header.php';
        OpenTable();
        search_form($vars);
        CloseTable();
        include 'footer.php';
        break;

    case 'search':
        include 'header.php';
        OpenTable();
        echo "<font class=\"pn-normal\">";
        foreach($search_modules as $mods) {
            echo "<BR>";
            echo $mods['func_search']($vars);
        }
        echo "</font>";
        CloseTable();
        include 'footer.php';
        break;

// For Quick-search from RTE we need no formats, only output. WindMeUp 2003/01/27
    case 'q_search':
//        include 'header.php';
//        OpenTable();
//        echo "<font class=\"pn-normal\">";
        foreach($search_modules as $mods) {
//            echo "<BR>";
			echo $mods['func_search']($vars);
        }
//        echo "</font>";
//        CloseTable();
//        include 'footer.php';
        break;
}

/*
 * splits the query string into words suitable for a mysql query
 */
function search_split_query($q) {
    if (!isset($q)) {
        return;
    }

    $w = array();
    $stripped = pnVarPrepForStore($q);
    $qwords = explode(' ', $stripped);
    foreach($qwords as $word) {
        $w[] = '%' . $word . '%';
    }
    return $w;
}

function search_form($vars) {
	$search_modules = &$GLOBALS['search_modules'];
	$bgcolor1 = &$GLOBALS['bgcolor1'];
	$bgcolor2 = &$GLOBALS['bgcolor2'];
	$bgcolor3 = &$GLOBALS['bgcolor3'];
	$textcolor1 = &$GLOBALS['textcolor1'];
	$textcolor2 = &$GLOBALS['textcolor2'];
	$ModName = $GLOBALS['ModName'];
  /*  global
        $search_modules,
        $bgcolor1,
        $bgcolor2,
        $bgcolor3,
        $textcolor1,
        $textcolor2,
        $ModName
    ;   */

    if(!isset($vars['bool']) || $vars['bool'] == '') {
        $vars['bool'] = 'AND';
    }

	$bool_select = array('AND' => '', 'OR' => '');
    $bool_select[$vars['bool']] = ' selected';

    echo "<div style=\"text-align: center; background: $bgcolor1;  border-bottom:1px solid $tblcolor3;\"><br /><br />\n";
    //echo "    <br /><br /><img src=\"modules/Search/images/admin.gif\" style=\"border: 0px;\" alt=\"\"><br />\n";
    echo "    <form method=\"post\" action=\"modules.php\">\n"
        ."        <input type=\"hidden\" name=\"op\" value=\"modload\">\n"
        ."        <input type=\"hidden\" name=\"name\" value=\"$ModName\">\n"
        ."        <input type=\"hidden\" name=\"file\" value=\"index\">\n"
        ."        <input type=\"hidden\" name=\"action\" value=\"search\">\n"
        ."        <input type=\"hidden\" name=\"overview\" value=\"1\">\n";
    echo "        "._SEARCH."&nbsp;"._FOR.":&nbsp;&nbsp;\n"
        ."        <input type=\"text\" name=\"q\" id=\"q\" size=\"20\" maxlength=\"255\" value=\"" . (isset($vars['q']) ? htmlspecialchars($vars['q']) : '') . "\">&nbsp;&nbsp;\n"
        ."        <input type=\"submit\" value=\""._SEARCH."\"><br /><br />"
        .'<select name="bool" size="1">'
        .'<option value="AND"'.$bool_select['AND'].'>'._ALLWORDS.'</option>'
        .'<option value="OR"'.$bool_select['OR'].'>'._ANYWORDS.'</option>'
        .'</select>';
    echo "</div>\n";

    foreach($search_modules as $mods) {
        echo $mods['func_opt']($vars);
    }
	echo "    </form><br />\n";
}
?>