<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// This release: Bas van den Bosch
// Purpose of file:  Topics administration display functions
// ----------------------------------------------------------------------

/**
 * the main administration function
 * This function is the default function, and is called whenever the
 * module is initiated without defining arguments.  As such it can
 * be used for a number of things, but most commonly it either just
 * shows the module menu and returns or calls whatever the module
 * designer feels should be the default function (often this is the
 * view() function)
 */
function topics_admin_main()
{

    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'Topics::Topic', '::', ACCESS_EDIT)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }


//    pnRedirect(pnModURL('topics', 'admin', 'view'));
    pnRedirect(pnModURL('Topics', 'admin', 'view'));
    return $output->GetOutput();
}


function topics_admin_new()
{
    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'Topics::Topic', '::', ACCESS_ADD)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
//    if (!pnModAPILoad('topics', 'visual')) {
    if (!pnModAPILoad('Topics', 'visual')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(topics_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(
        pnModAPIFunc('topics',
                     'visual',
                     'newtopic',
                     array
                     (
                      'return_url' =>  pnModURL(pnModGetName(), 'admin', 'view')
                     )
                    )
                  );
    $output->SetInputMode(_PNH_PARSEINPUT);


     return $output->GetOutput();

}

function topics_admin_create($args)
{
    list($topicnametag,
             $topictext,
             $topicexttext,
             $topicimage,
         $topicparent,
         $topicname) = pnVarCleanFromInput('topicnametag',
                                                                           'topictext',
                                                                           'topicexttext',
                                                                           'topicimage',
                                          'topicparent',
                                          'topicname');
    extract($args);


    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'view'));
        pnRedirect(pnModURL('Topics', 'admin', 'view'));
        return true;
    }


    if (!pnModAPILoad('Topics', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    $topicid = pnModAPIFunc('topics',
                        'admin',
                        'create',
                        array('topicnametag' => $topicnametag,
                                  'topictext' => $topictext,
                                  'topicexttext' => $topicexttext,
                                  'topicimage' => $topicimage,
                              'topicparent' => $topicparent,
                              'topicname' => $topicname));

    if ($topicid != false) {
        pnSessionSetVar('statusmsg', _TOPICSCREATED);
    }

//    pnRedirect(pnModURL('topics', 'admin', 'view'));
    pnRedirect(pnModURL('Topics', 'admin', 'view'));

    return true;
}


function topics_admin_modify($args)
{

    list($topicid,
         $objectid)= pnVarCleanFromInput('topicid',
                                         'objectid');

    extract($args);

    if (!empty($objectid)) {
        $topicid = $objectid;
    }

    $output = new pnHTML();


//    if (!pnModAPILoad('topics', 'visual')) {
    if (!pnModAPILoad('Topics', 'visual')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    if (!pnSecAuthAction(0, 'Topics::Topic', "$topicnametag::$topicid", ACCESS_EDIT)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(topics_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(
        pnModAPIFunc('topics',
                     'visual',
                     'modifytopic',
                     array
                     (
                      'return_url' =>  pnModURL(pnModGetName(), 'admin', 'view'),
                      'topicid' => $topicid
                     )
                    )
                  );
    $output->SetInputMode(_PNH_PARSEINPUT);
    return $output->GetOutput();
}

function topics_admin_modifyrelated($args)
{

    list($rid,
         $objectid,
         $topicid)= pnVarCleanFromInput('rid',
                                    'objectid',
                                    'topicid');

    extract($args);

    if (!empty($objectid)) {
        $rid = $objectid;
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                         'user',
                         'getrelatedlink',
                         array('rid' => $rid));

    if ($item == false) {
        $output = new pnHTML();
    $output->Text('no related item');
        return $output->GetOutput();
    }

    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'Topics::Related', "$topicid::", ACCESS_EDIT)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(topics_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

        $output->Title('');
        $output->Title(_RELATEDMOD);
        $output->FormStart(pnModURL(pnModGetName(), 'admin', 'updaterelated'));
    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('topicid', $item['tid']);
    $output->FormHidden('rid', pnVarPrepForDisplay($item['rid']));
    $output->TableStart();

    // Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RELATEDNAME));
    $row[] = $output->FormText('name',pnVarPrepForDisplay($item['name']), 70, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // URL
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RELATEDURL));
    $row[] = $output->FormText('url',$item['url'], 70, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_UPDATERELATED);
    $output->FormEnd();

    return $output->GetOutput();

}


function topics_admin_updaterelated($args)
{

    list($rid,
         $name,
         $url,
         $topicid) = pnVarCleanFromInput('rid',
                                     'name',
                                     'url',
                                     'topicid');

    extract($args);

    if (!empty($objectid)) {
        $topicid = $objectid;
    }

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'view'));
        pnRedirect(pnModURL('Topics', 'admin', 'view'));
        return true;
    }

//    if (!pnModAPILoad('topics', 'admin')) {
    if (!pnModAPILoad('Topics', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    if(pnModAPIFunc('topics',
                    'admin',
                    'updaterelated',
                    array('rid' => $rid,
                          'name' => $name,
                          'url' => $url,
                          'topicid' => $topicid))) {
                pnSessionSetVar('statusmsg', _RELATEDUPDATED);
    } else {    pnSessionSetVar('statusmsg', _RELATEDMISLUKT);}

//    pnRedirect(pnModURL('topics', 'admin', 'modify', array('topicid' => $topicid)));
    pnRedirect(pnModURL('Topics', 'admin', 'modify', array('topicid' => $topicid)));

    return true;
}


function topics_admin_update($args)
{

    list($topicid,
         $objectid,
         $topicnametag,
         $topictext,
         $topicexttext,
         $topicimage,
         $topicparent) = pnVarCleanFromInput('topicid',
                                        'objectid',
                                        'topicnametag',
                                        'topictext',
                                        'topicexttext',
                                        'topicimage',
                                        'topicparent');

    extract($args);

    if (!empty($objectid)) {
        $topicid = $objectid;
    }


    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'view'));
        pnRedirect(pnModURL('Topics', 'admin', 'view'));
        return true;
    }


//    if (!pnModAPILoad('topics', 'admin')) {
    if (!pnModAPILoad('Topics', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    if(pnModAPIFunc('topics',
                    'admin',
                    'update',
                    array('topicid' => $topicid,
                          'topicnametag' => $topicnametag,
                          'topictext' => $topictext,
                          'topicexttext' => $topicexttext,
                          'topicimage' => $topicimage,
                          'topicparent' => $topicparent,
                          'topicname' => $topicname))) {
        // Success
        pnSessionSetVar('statusmsg', _TOPICSUPDATED);
    }

//    pnRedirect(pnModURL('topics', 'admin', 'view'));
    pnRedirect(pnModURL('Topics', 'admin', 'view'));

    // Return
    return true;
}

function topics_admin_delete($args)
{
    list($topicid,
         $objectid,
         $confirmation) = pnVarCleanFromInput('topicid',
                                              'objectid',
                                              'confirmation');
    extract($args);

     if (!empty($objectid)) {
         $topicid = $objectid;
     }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
                $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                         'user',
                         'get',
                         array('topicid' => $topicid));

    if ($item == false) {
        $output->Text(_TOPICSNOSUCHITEM);
        return $output->GetOutput();
    }

    if (!pnSecAuthAction(0, 'Topics::Item', "$topicnametag::$topicid", ACCESS_DELETE)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    if (empty($confirmation)) {
        $output = new pnHTML();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(topics_adminmenu());
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->Title(_DELETETOPICS);
/*        $output->ConfirmAction(_CONFIRMTOPICSDELETE,
                               pnModURL('topics',
                                        'admin',
                                        'delete'),
                               _CANCELTOPICSDELETE,
                               pnModURL('topics',
                                        'admin',
                                        'view'),
                               array('topicid' => $topicid));
*/
                $output->ConfirmAction(_CONFIRMTOPICSDELETE,
                               pnModURL('Topics',
                                        'admin',
                                        'delete'),
                               _CANCELTOPICSDELETE,
                               pnModURL('Topics',
                                        'admin',
                                        'view'),
                               array('topicid' => $topicid));
        return $output->GetOutput();
    }

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'view'));
        pnRedirect(pnModURL('Topics', 'admin', 'view'));
        return true;
    }

//    if (!pnModAPILoad('topics', 'admin')) {
    if (!pnModAPILoad('Topics', 'admin')) {
                $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    if (pnModAPIFunc('topics',
                     'admin',
                     'delete',
                     array('topicid' => $topicid))) {
        // Success
        pnSessionSetVar('statusmsg', _TOPICSDELETED);
    }

//    pnRedirect(pnModURL('topics', 'admin', 'view'));
    pnRedirect(pnModURL('Topics', 'admin', 'view'));

    return true;
}

function topics_admin_createrelated($args)
{

    list($topicid,
             $name,
             $url) = pnVarCleanFromInput('topicid',
                                                                  'name',
                                                                  'url');
    extract($args);

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'view'));
        pnRedirect(pnModURL('Topics', 'admin', 'view'));
        return true;
    }

//    if (!pnModAPILoad('topics', 'admin')) {
    if (!pnModAPILoad('Topics', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }


    $rid = pnModAPIFunc('topics',
                        'admin',
                        'createrelated',
                        array('topicid' => $topicid,
                                  'name' => $name,
                                  'url' => $url));

    if ($rid != false) {
        pnSessionSetVar('statusmsg', _RELATEDCREATED);
    }

//    pnRedirect(pnModURL('topics', 'admin', 'modify', array('topicid' => $topicid)));
    pnRedirect(pnModURL('Topics', 'admin', 'modify', array('topicid' => $topicid)));

    return true;
}

function topics_admin_deleterelated($args)
{
    list($rid,
         $topicid,
         $objectid,
         $confirmation) = pnVarCleanFromInput('rid',
                                              'topicid',
                                              'objectid',
                                              'confirmation');

    extract($args);
    if (!empty($objectid)) {
         $rid = $objectid;
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                         'user',
                         'getrelatedlink',
                         array('rid' => $rid));

    if ($item == false) {
        $output = new pnHTML();
    $output->Text('no related item');
        return $output->GetOutput();
    }

    if (!pnSecAuthAction(0, 'Topics::Related', "$item[tid]::", ACCESS_DELETE)) {
        $output = new pnHTML();
            $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    if (empty($confirmation)) {
        $output = new pnHTML();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(topics_adminmenu());
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->Title(_DELETEtopics);
/*        $output->ConfirmAction(_CONFIRMtopicsDELETE,
                               pnModURL('topics',
                                        'admin',
                                        'deleterelated',
                                        array('rid' => $rid)),
                               _CANCELtopicsDELETE,
                               pnModURL('topics',
                                        'admin',
                                        'modify',
                                                       array('topicid' => $topicid)));
*/
        $output->ConfirmAction(_CONFIRMtopicsDELETE,
                               pnModURL('Topics',
                                        'admin',
                                        'deleterelated',
                                        array('rid' => $rid)),
                               _CANCELtopicsDELETE,
                               pnModURL('Topics',
                                        'admin',
                                        'modify',
                                                       array('topicid' => $topicid)));
        return $output->GetOutput();
    }

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'modify', array ('topicid' => $topicid)));
        pnRedirect(pnModURL('Topics', 'admin', 'modify', array ('topicid' => $topicid)));
        return true;
    }

//    if (!pnModAPILoad('topics', 'admin')) {
    if (!pnModAPILoad('Topics', 'admin')) {
                $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    if (pnModAPIFunc('topics',
                     'admin',
                     'deleterelated',
                     array('rid' => $rid))) {
        pnSessionSetVar('statusmsg', _RELATEDDELETED);
    }
//    pnRedirect(pnModURL('topics',
    pnRedirect(pnModURL('Topics',
                                        'admin',
                                        'modify',
                                                       array('topicid' => $topicid)));

    return true;
}


function topics_admin_view()
{

    $startnum = pnVarCleanFromInput('startnum');

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text('<center>');
    
    $output->adminmenu(); // TiMax add administration link
  	

    if (!pnSecAuthAction(0, 'Topics::Topic', '::', ACCESS_EDIT)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }


    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(topics_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->Title(_VIEWTOPICS);

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
                $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
    $itemsperpage=pnModGetVar('topics', 'itemsperrow')*pnModGetVar('topics', 'rowsperpage');

    $items = pnModAPIFunc('topics',
                          'user',
                          'getall',
                          array('startnum' => $startnum,
                                'numitems' => $itemsperpage,
                                'getall'   => 'yes'));


    $output->TableStart('','',0);
    $limith=pnModGetVar('topics', 'itemsperrow');
    $counth=0;
    $countv=0;

    $row = array();
    foreach ($items as $item) {
                $catnum=$item['topicid'];
                $imagelink='';
                $imagepath=pnModAPIFunc('topics',
                                                  'user',
                                                  'getimageurl',
                                                  array('imagename' => $item['topicimage']));
                 $imagelink .= '<image name="plaatje" src="'.$imagepath.'">';
            $imagelink .= '<BR><b>'.$item['topicname'].'</b><br><br>';
               $options = array();
               $output->SetOutputMode(_PNH_RETURNOUTPUT);
               if (pnSecAuthAction(0, 'Topics::Item', "$item[topicnametag]::$item[topicid]", ACCESS_EDIT)) {
//                   $options[] = $output->URL(pnModURL('topics',
                   $options[] = $output->URL(pnModURL('Topics',
                                                      'admin',
                                                      'modify',
                                                      array('topicid' => $item['topicid'])),
                                             _EDIT);
               if (pnSecAuthAction(0, 'Topics::Item', "$item[topicnametag]::$item[topicid]", ACCESS_DELETE)) {
//                    $options[] = $output->URL(pnModURL('topics',
                    $options[] = $output->URL(pnModURL('Topics',
                                                       'admin',
                                                       'delete',
                                                       array('topicid' => $item['topicid'])),
                                              _DELETE);
                }
            }
            $options = join(' | ', $options);
            $imagelink.=$options;
            $counth=$counth+1;
            $row[] = $imagelink;
            if ($counth>=$limith) {
                  $output->SetInputMode(_PNH_VERBATIMINPUT);
              $output->SetOutputMode(_PNH_KEEPOUTPUT);
              $output->TableAddRow($row);
              $output->SetInputMode(_PNH_PARSEINPUT);
              $counth=0;
              $row = array();
            }
       }


            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->SetOutputMode(_PNH_KEEPOUTPUT);
            $output->TableAddRow($row);
            $output->SetInputMode(_PNH_PARSEINPUT);


    $output->TableEnd();

        $itemsperpage=pnModGetVar('topics', 'rowsperpage')*pnModGetVar('topics', 'itemsperrow');
//    $output->Pager($startnum,
//                    pnModAPIFunc('topics', 'user', 'countitems'),
//                    pnModURL('topics',
    $output->Pager($startnum,
                    pnModAPIFunc('topics', 'user', 'countitems'),
                    pnModURL('Topics',
                             'admin',
                             'view',
                            array('startnum' => '%%')),
                    $itemsperpage);

    return $output->GetOutput();
}


function topics_admin_modifyconfig()
{
    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'Topics::Item', '::', ACCESS_ADMIN)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(topics_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->Title(_TOPICSMODIFYCONFIG);

//    $output->FormStart(pnModURL('topics', 'admin', 'updateconfig'));
    $output->FormStart(pnModURL('Topics', 'admin', 'updateconfig'));

    $output->FormHidden('authid', pnSecGenAuthKey());

    $output->TableStart();

    // tipath
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSIMAGEPATH));
    $row[] = $output->FormText('tipath', pnConfigGetVar('tipath'), 30, 60);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    // use subtopics
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSUSESUBTOPICS));
    $row[] = $output->FormCheckbox('usesubtopics', pnModGetVar('topics', 'usesubtopics'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    // use themedependant images
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSUSETHEMEDEPENDANT));
    $row[] = $output->FormCheckbox('themedependantimages', pnModGetVar('topics', 'themedependantimages'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    // use languagedependant images
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSUSELANGUAGEDEPENDANT));
    $row[] = $output->FormCheckbox('languagedependantimages', pnModGetVar('topics', 'languagedependantimages'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    // number of items per row
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSITEMSPERROW));
    $row[] = $output->FormText('itemsperrow', pnModGetVar('topics', 'itemsperrow'), 3, 3);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    // Number of rows per page
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSROWSPERPAGE));
    $row[] = $output->FormText('rowsperpage', pnModGetVar('topics', 'rowsperpage'), 3, 3);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    // Main Topics Description
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_MAINTOPICSDESC));
    $row[] = $output->FormTextArea('maintopictext', pnModGetVar('topics', 'maintopictext'), 5, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);

    $output->TableEnd();

    // End form
    $output->Linebreak(2);
    $output->FormSubmit(_TOPICSUPDATE);
    $output->FormEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * This is a standard function to update the configuration parameters of the
 * module given the information passed back by the modification form
 */
function topics_admin_updateconfig()
{
    $usesubtopics = pnVarCleanFromInput('usesubtopics');
    $themedependantimages = pnVarCleanFromInput('themedependantimages');
    $languagedependantimages = pnVarCleanFromInput('languagedependantimages');
    $rowsperpage = pnVarCleanFromInput('rowsperpage');
    $itemsperrow = pnVarCleanFromInput('itemsperrow');
    $tipath= pnVarCleanFromInput('tipath');
    $maintopictext = pnVarCleanFromInput('maintopictext');

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
//        pnRedirect(pnModURL('topics', 'admin', 'view'));
        pnRedirect(pnModURL('Topics', 'admin', 'view'));
        return true;
    }

    if (!isset($usesubtopics)) {
        $usesubtopics = false;
    }
    pnModSetVar('topics', 'usesubtopics', $usesubtopics);

    if (!isset($themedependantimages)) {
        $themedependantimages = false;
    }
    pnModSetVar('topics', 'themedependantimages', $themedependantimages);

    if (!isset($languagedependantimages)) {
        $languagedependantimages = false;
    }
    pnModSetVar('topics', 'languagedependantimages', $languagedependantimages);

    if (!isset($rowsperpage)) {
        $rowsperpage = 2;
    }
    pnModSetVar('topics', 'rowsperpage', $rowsperpage);

    if (!isset($itemsperrow)) {
        $itemsperrow = 5;
    }
    pnModSetVar('topics', 'itemsperrow', $itemsperrow);

    if(isset($tipath)) {pnConfigSetVar('tipath',$tipath);}

    if(isset($maintopictext)) {pnModSetVar('topics', 'maintopictext', $maintopictext);}

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
//    pnRedirect(pnModURL('topics', 'admin', 'view'));
    pnRedirect(pnModURL('Topics', 'admin', 'view'));

    // Return
    return true;
}
/**
 * Main administration menu
 */
function topics_adminmenu()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Display status message if any.  Note that in future this functionality
    // will probably be in the theme rather than in this menu, but this is the
    // best place to keep it for now
    $output->Text(pnGetStatusMsg());
    $output->Linebreak(2);

    // Start options menu
    $output->TableStart(_TOPICS);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);

    // Menu options.  These options are all added in a single row, to add
    // multiple rows of options the code below would just be repeated
    $columns = array();
//    $columns[] = $output->URL(pnModURL('topics',
    $columns[] = $output->URL(pnModURL('Topics',
                                        'admin',
                                        'new'),
                              _NEWTOPICS);
//    $columns[] = $output->URL(pnModURL('topics',
    $columns[] = $output->URL(pnModURL('Topics',
                                        'admin',
                                        'view'),
                              _VIEWTOPICS);
//    $columns[] = $output->URL(pnModURL('topics',
    $columns[] = $output->URL(pnModURL('Topics',
                                        'admin',
                                        'modifyconfig'),
                              _EDITTOPICSCONFIG);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->TableEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}



?>