<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// this release: Bas van den Bosch
// Purpose of file:  Topics administration API
// ----------------------------------------------------------------------


function topics_adminapi_create($args)
{

    extract($args);
        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];
        $dbname = $pnconfig['prefix'];

    if ((!isset($topicnametag)) ||
            (!isset($topictext)) ||
            (!isset($topicexttext)) ||
            (!isset($topicimage))  ||
        (!isset($topicparent))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }


    if (!pnSecAuthAction(0, 'Topics::Topic', "::$topicid", ACCESS_ADD)) {
       pnSessionSetVar('errormsg', _TOPICSNOAUTH);
        return false;
   }
//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

//modified for Oracle compatibility
//    $nextId = $dbconn->GenId(nuke_topics);

    if ($topicparent!=0) {
    $fullname = pnModAPIFunc('topics',
                             'user',
                             'getpath',
                             array('topicid' => $topicparent));
    $fullname .= " / ".$topicnametag;
        } else {
        $fullname = $topicnametag;
        }

//modified for Oracle compatibility
        switch ($dbtype){
                case "oci8":
                        $sequence=substr_replace($pntable['topics'],'',0,strlen($dbname)+1).'_sq';

                        $nextId = $dbconn->GenId($sequence);

                        $sql = "INSERT INTO $topicstable ($topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topictext], $topicscolumn[topicexttext], $topicscolumn[topicimage], $topicscolumn[topicparent], $topicscolumn[topicname])
                                VALUES ($nextId,'$topicnametag','$topictext',empty_clob(),'$topicimage','$topicparent','$fullname')";

                    $dbconn->Execute($sql);
                    if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _CREATEFAILED);
                        return false;
                        }
                        $dbconn->updateClob($pntable[topics],$topicscolumn[topicexttext],$topicexttext,$topicscolumn[topicid].'='.$nextId);


                        break;
                default:
                    $nextId = $dbconn->GenId($pntable['topics']);
                        $sql = "INSERT INTO $topicstable ($topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topictext], $topicscolumn[topicexttext], $topicscolumn[topicimage], $topicscolumn[topicparent], $topicscolumn[topicname])
                                VALUES ($nextId,'$topicnametag','$topictext','$topicexttext','$topicimage','$topicparent','$fullname')";
                    $dbconn->Execute($sql);
                    if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _CREATEFAILED);
                        return false;
                        }
                        break;
        }


    $topicid = $dbconn->PO_Insert_ID($topicstable, $topicscolumn['topicid']);

    pnModCallHooks('item', 'create', $topicid, 'topicid');

    return $topicid;
}


function topics_adminapi_delete($args)
{

    extract($args);

        if (!isset($topicid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
            'user',
            'get',
            array('topicid' => $topicid));

    if ($item == false) {
        $output->Text(_TOPICSNOSUCHITEM);
        return $output->GetOutput();
    }

    if (!pnSecAuthAction(0, 'Topics::Topic', "$topicnametag::$topicid", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _TOPICSNOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    $sql = "DELETE FROM $topicstable
            WHERE $topicscolumn[topicid] = $topicid";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DELETEFAILED);
        return false;
    }

    return true;
}

function topics_adminapi_createrelated($args)
{

    extract($args);

        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];
        $dbname = $pnconfig['prefix'];

    if ((!isset($topicid)) ||
            (!isset($name)) ||
            (!isset($url))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }


    if (!pnSecAuthAction(0, 'Topics::Related', "$topicid::", ACCESS_ADD)) {
       pnSessionSetVar('errormsg', _TOPICSNOAUTH);
        return false;
   }
//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }


    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $relatedtable = $pntable['related'];
    $relatedcolumn = &$pntable['related_column'];

//modified for Oracle compatibility
        switch ($dbtype){
                case "oci8":
                        $sequence=substr_replace($pntable['related'],'',0,strlen($dbname)+1).'_sq';
                        $nextId = $dbconn->GenId($sequence);
                        break;
                default:
//                        $nextId = $dbconn->GenId(nuke_related);
                        $nextId = $dbconn->GenId($pntable['related']);
                        break;
        }
    $sql = "INSERT INTO $relatedtable ($relatedcolumn[rid], $relatedcolumn[name], $relatedcolumn[url], $relatedcolumn[tid])
                            VALUES ($nextId,'$name','$url','$topicid')";

        $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATEFAILED);
        return false;
    }

    $rid = $dbconn->PO_Insert_ID($topicstable, $topicscolumn['rid']);

    return $rid;
}

function topics_adminapi_deleterelated($args)
{

    extract($args);

    if (!isset($rid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                                     'user',
                                     'getrelatedlink',
                                     array('rid' => $rid));

    if ($item == false) {
        $output->Text(_TOPICSNOSUCHITEM);
        return $output->GetOutput();
    }


    if (!pnSecAuthAction(0, 'Topics::Related', "$rid::", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _TOPICSNOAUTH);
        return false;
    }


    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $relatedtable = $pntable['related'];
    $relatedcolumn = &$pntable['related_column'];

    $sql = "DELETE FROM $relatedtable
            WHERE $relatedcolumn[rid] = $rid";
    $dbconn->Execute($sql);


    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DELETERELATEDFAILED);
        return false;
    }

    return true;
}


function topics_adminapi_update($args)
{
        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];
    list($topicid,
         $objectid,
         $topicnametag,
         $topictext,
         $topicimage,
         $topicparent) = pnVarCleanFromInput('topicid',
                                        'objectid',
                                        'topicnametag',
                                        'topictext',
                                        'topicimage',
                                        'topicparent');

        extract($args);


    if ((!isset($topicid)) ||
        (!isset($topicnametag)) ||
        (!isset($topictext)) ||
        (!isset($topicexttext)) ||
        (!isset($topicimage)) ||
        (!isset($topicparent))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }


    $item = pnModAPIFunc('topics',
            'user',
            'get',
            array('topicid' => $topicid));

    if ($item == false) {
        $output->Text(_TOPICSNOSUCHITEM);
        return $output->GetOutput();
    }


   if (!pnSecAuthAction(0, 'Topics::Topic', "$item[topicnametag]::$topicid", ACCESS_EDIT)) {
       pnSessionSetVar('errormsg', _TOPICSNOAUTH);
       return false;
   }
   if (!pnSecAuthAction(0, 'Topics::Item', "$topicnametag::$topicid", ACCESS_EDIT)) {
       pnSessionSetVar('errormsg', _TOPICSNOAUTH);
      return false;
   }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    if ($topicparent!=0) {
    $fullname = pnModAPIFunc('topics',
                             'user',
                             'getpath',
                             array('topicid' => $topicparent));
    $fullname .= " / ".$topicnametag;
        } else {
        $fullname = $topicnametag;
        }

//modified for Oracle compatibility
        switch ($dbtype){
                case "oci8":
                        $sql = "UPDATE $topicstable
                            SET $topicscolumn[topicnametag] = '".pnVarPrepForStore($topicnametag)."',
                                    $topicscolumn[topictext] = '".pnVarPrepForStore($topictext)."',
                                        $topicscolumn[topicexttext] = empty_clob(),
                        $topicscolumn[topicimage] = '".pnVarPrepForStore($topicimage)."',
                            $topicscolumn[topicparent] = '".pnVarPrepForStore($topicparent)."',
                                $topicscolumn[topicname] = '".pnVarPrepForStore($fullname)."'
                                WHERE $topicscolumn[topicid] = '".pnVarPrepForStore($topicid)."'";
                    $dbconn->Execute($sql);

                    if ($dbconn->ErrorNo() != 0) {
                        pnSessionSetVar('errormsg', _EDITFAILED);
                                return false;
                    }

                        $dbconn->updateClob($pntable[topics],$topicscolumn[topicexttext],pnVarPrepForStore($topicexttext),$topicscolumn[topicid].'='.pnVarPrepForStore($topicid));
                        break;
                default:
                        $sql = "UPDATE $topicstable
                            SET $topicscolumn[topicnametag] = '".pnVarPrepForStore($topicnametag)."',
                                    $topicscolumn[topictext] = '".pnVarPrepForStore($topictext)."',
                                        $topicscolumn[topicexttext] = '".pnVarPrepForStore($topicexttext)."',
                        $topicscolumn[topicimage] = '".pnVarPrepForStore($topicimage)."',
                            $topicscolumn[topicparent] = '".pnVarPrepForStore($topicparent)."',
                                $topicscolumn[topicname] = '".pnVarPrepForStore($fullname)."'
                                WHERE $topicscolumn[topicid] = '".pnVarPrepForStore($topicid)."'";
                    $dbconn->Execute($sql);

                    if ($dbconn->ErrorNo() != 0) {
                        pnSessionSetVar('errormsg', _EDITFAILED);
                                return false;
                    }
                        break;
        }

   pnModAPIFunc('topics',
               'admin',
             'updatepaths');


     return true;
}

function topics_adminapi_updaterelated($args)
{

    list($rid,
         $topicid,
         $name,
         $url) = pnVarCleanFromInput('rid',
                                     'topicid',
                                     'name',
                                     'url');

        extract($args);


    if ((!isset($rid)) ||
        (!isset($name)) ||
        (!isset($url)) ||
        (!isset($topicid))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }


//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                                     'user',
                                     'getrelatedlink',
            array('rid' => $rid));

    if ($item == false) {
        $output->Text(_TOPICSNOSUCHITEM);
        return $output->GetOutput();
    }


   if (!pnSecAuthAction(0, 'Topics::Related', "$topicid::", ACCESS_EDIT)) {
       pnSessionSetVar('errormsg', _TOPICSNOAUTH);
       return false;
   }


    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $relatedtable = $pntable['related'];
    $relatedcolumn = &$pntable['related_column'];


    $sql = "UPDATE $relatedtable
            SET $relatedcolumn[name] ='".pnVarPrepForStore($name)."',
                $relatedcolumn[url] = '".pnVarPrepForStore($url)."',
                $relatedcolumn[tid] = '".pnVarPrepForStore($topicid)."'
            WHERE $relatedcolumn[rid] = '".pnVarPrepForStore($rid)."'";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _UPDATEFAILED);
        return false;
    }

    return true;
}

function topics_adminapi_updatepaths()
{

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
                $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

        $sql = "SELECT $topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topicparent] FROM $topicstable ORDER BY $topicscolumn[topicparent]";
    $result = $dbconn->Execute($sql);

//modified for Oracle compatibility
//   for (; !$result->EOF; $result->MoveNext()) {
   while(!$result->EOF){
        list($topicid, $topicnametag, $topicparent) = $result->fields;
        $items[] = array('topicid' => $topicid,
                                         'topicnametag' => $topicnametag,
                                         'topicparent' => $topicparent);
                $result->MoveNext();
   }

foreach ($items as $item) {

        if ($item['topicparent']!=0) {
    $fullname = pnModAPIFunc('topics',
                             'user',
                             'getpath',
                             array('topicid' => $item['topicparent']));
    $fullname .= " / ".$item['topicnametag'];
        } else {
        $fullname = $item['topicnametag'];
        }
        $num=$item['topicid'];

    $sql = "UPDATE $topicstable
            SET $topicscolumn[topicname] = '$fullname'
            WHERE $topicscolumn[topicid] = '$num'";

    $result = $dbconn->Execute($sql);
    }

    return;
}

function topics_adminapi_getlist($args)
{
    list($sel) = pnVarCleanFromInput('sel');
        extract($args);


    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
     $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

        $sql="SELECT $topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topicparent], $topicscolumn[topicname]
          FROM $topicstable
          ORDER BY $topicscolumn[topicname]";
    $result=$dbconn->Execute($sql);

    $data[]=array('id' => '0',
                              'name' => _ISMAINTOPIC);

//modified for Oracle compatibility
//        while(list($topicid, $topicnametag, $topicparent, $topicname) = $result->fields) {
        while(!$result->EOF){
                list($topicid, $topicnametag, $topicparent, $topicname) = $result->fields;

                   $ok='yes';
                   if ($sel==$topicid) {$ok='no';}
                      $parent=$topicparent;
                      while (($ok=='yes') AND ($parent<>'0')) {

                       if ($parent==$sel) {$ok='no';}
                               $item=pnModAPIFunc('topics',
                                           'user',
                                                'get',
                                    array('topicid' => $parent));
                               $parent=$item['topicparent'];
                              }

                              if ($ok=='yes') {
                     $fullname = pnModAPIFunc('topics',
                                                       'user',
                                                   'getpath',
                                        array('topicid' => $topicid));
                            $data[] = array ('id' => $topicid,
                                                       'name' => $fullname);
                        }
        $result->MoveNext();
        }

    return $data;

}



function topics_adminapi_countitems()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    $sql = "SELECT COUNT(1)
            FROM $topicstable";
    $result = $dbconn->Execute($sql);


    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    list($numitems) = $result->fields;


    $result->Close();


    return $numitems;
}

?>