<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// this release: Bas van den Bosch
// Purpose of file:  topics user display functions
// ----------------------------------------------------------------------

/**
 * the main user function
 * This function is the default function, and is called whenever the module is
 * initiated without defining arguments.  As such it can be used for a number
 * of things, but most commonly it either just shows the module menu and
 * returns or calls whatever the module designer feels should be the default
 * function (often this is the view() function)
 */
function topics_user_main()
{

    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'Topics::Topic', '::', ACCESS_READ)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

//    pnRedirect(pnModURL('topics', 'user', 'view'));
    pnRedirect(pnModURL('Topics', 'user', 'view'));

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

function topics_user_view($args)
{
    list($getall,$topicid,$startnum) = pnVarCleanFromInput('getall','topicid','startnum');

    extract($args);

//    if (pnModGetVar('Topics', 'usesubtopics')==false) {
    if (pnModGetVar('topics', 'usesubtopics')==false) {
            $getall='yes';}

        if ($getall<>'yes') { $getall='no'; }

        if (!isset($topicid)) {$topicid=0;}

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
    $tipath=pnConfigGetVar('tipath');
        $output = new pnHTML();

        if ($topicid==0) {
    $output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();

    $columns[] = $output->BoldText(_TOPICS);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();
    }
    else {
    $item = pnModAPIFunc('topics',
                         'user',
                         'get',
                         array('topicid' => $topicid));
    $itemtext=$item['topicexttext'];
    $parent = pnModAPIFunc('topics',
                           'user',
                           'get',
                           array('topicid' => $item['topicparent']));
    $output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();

    if ($item['topicparent']==0){
          $link='<< '._MAINTOPICS;
    } else {
      $link="<< ".$parent['topicname'];
    }

//                $columns[] = $output->URL(pnModURL('topics',
                $columns[] = $output->URL(pnModURL('Topics',
                           'user',
                           'view',
                           array('topicid' => $item['topicparent'])),$link);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $imagepath=pnModAPIFunc('topics',
                                          'user',
                                           'getimageurl',
                                           array('imagename' => $item['topicimage']));
    $image = '<image name="plaatje" src="'.$imagepath.'"BORDER="0" VALIGN="top" ALT="'.$item['topictext'].'">';
//probably the 2 next url are wrong.  catid????
    $columns[] = $output->URL('modules.php?op=modload&name=News&file=index&catid=&topic='.$item['topicid'], $image);
    $columns[] = $output->BoldText($item['topicname']);
    $columns[] = $output->URL('modules.php?op=modload&name=News&file=index&catid=&topic='.$item['topicid'], _NEWS);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns,'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();
        }

    if (!pnSecAuthAction(0, 'Topics::Topic', '::', ACCESS_OVERVIEW)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    $itemsperpage=pnModGetVar('topics', 'itemsperrow')*pnModGetVar('topics', 'rowsperpage');
    $items = pnModAPIFunc('topics',
                          'user',
                          'getall',
                          array('startnum' => $startnum,
                                'numitems' => $itemsperpage,
                                'getall'   => $getall,
                                'topicid'  => $topicid));

//     if ($items == false) {
//        $output->Text(_TOPICSITEMFAILED);
//     }
     $output->Linebreak(2);
     $output->TableStart('','',0);

         $row = array();
         $counth=0;
         $limith=pnModGetVar('topics', 'itemsperrow');


         foreach ($items as $item) {
        if (pnSecAuthAction(0,'Topics::Topic',"::$item[topicid]",ACCESS_OVERVIEW)) {
                        $imagepath=pnModAPIFunc('topics',
                                                  'user',
                                                  'getimageurl',
                                                  array('imagename' => $item['topicimage']));
                $output->SetOutputMode(_PNH_RETURNOUTPUT);
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $image = '<image name="plaatje" src="'.$imagepath.'" BORDER="0" VALIGN="top" ALT="'.$item['topictext'].'"><BR><BR>'.$item['topicname'];
                            $hassubtopics = pnModAPIFunc('topics',
                                             'user',
                                             'countchilditems',
                                             array('topicid'  => $item['topicid']));
                if (($getall=='no') && (!$hassubtopics==0)) {
//                            $row[]=$output -> URL(pnModURL('topics',
                            $row[]=$output -> URL(pnModURL('Topics',
                                                           'user',
                                               'view',
                                               array('topicid' => $item['topicid'])), $image);
                                               } else {
//                            $row[]=$output -> URL(pnModURL('topics',
                            $row[]=$output -> URL(pnModURL('Topics',
                                                           'user',
                                               'display',
                                               array('topicid' => $item['topicid'])), $image);
                                }
                               $counth++;
                }

        if($counth>=$limith) {
                $counth=0;
                    $output->SetInputMode(_PNH_VERBATIMINPUT);
                    $output->SetOutputMode(_PNH_KEEPOUTPUT);
                    $output->TableAddRow($row,'middle');
                    $output->SetInputMode(_PNH_PARSEINPUT);
                $output->SetOutputMode(_PNH_RETURNOUTPUT);
                    $row = array();
                }
       }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->TableAddRow($row,'middle');
    $output->SetInputMode(_PNH_PARSEINPUT);


        $output->TableEnd();

        if ($getall=='yes') {$totalnumberofitems=pnModAPIFunc('topics', 'user', 'countitems');} else {
                                 $totalnumberofitems=pnModAPIFunc('topics', 'user', 'countchilditems', array('topicid' => $topicid));}

        $itemsperpage=pnModGetVar('topics', 'rowsperpage')*pnModGetVar('topics', 'itemsperrow');

//    $output->Pager($startnum,
//                   $totalnumberofitems,
//                   pnModURL('topics',
    $output->Pager($startnum,
                   $totalnumberofitems,
                   pnModURL('Topics',
                            'user',
                            'view',
                            array('startnum' => '%%',
                                      'getall' => $getall,
                                  'topicid' => $topicid)),
                                  $itemsperpage);

    $output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();

    if ($topicid==0) {
       $columns[] =  pnVarPrepHTMLDisplay(pnModGetVar('topics','maintopictext'));
       } else {
       $columns[] = pnVarPrepHTMLDisplay($itemtext);
       }

    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();
    return $output->GetOutput();
}


function topics_user_display($args)
{
    list($topicid,
         $objectid) = pnVarCleanFromInput('topicid',
                                          'objectid');
    extract($args);
    if (!empty($objectid)) {
        $topicid = $objectid;
    }

    $output = new pnHTML();

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
    /*
    $hassubtopics = pnModAPIFunc('topics',
                                 'user',
                                 'countchilditems',
                                 array('topicid'  => $topicid));

    if(!$hassubtopics==0) {
        pnRedirect(pnModURL('topics',
                        'user',
                        'view',
                        array('topicid' => $item['topicid'])));}
*/
    if (!pnSecAuthAction(0, 'Topics::Topic', '::', ACCESS_OVERVIEW)) {
        $output->Text(_TOPICSNOAUTH);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                         'user',
                         'get',
                         array('topicid' => $topicid));
    $itemtext=$item['topicexttext'];
    $parent = pnModAPIFunc('topics',
                           'user',
                           'get',
                           array('topicid' => $item['topicparent']));
    $output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();
    $tipath=pnConfigGetVar('tipath');
    if ($item['topicparent']==0){
          $link='<< '._MAINTOPICS;
    } else {
      $link="<< ".$parent['topicname'];
    }

//    $columns[] = $output->URL(pnModURL('topics',
    $columns[] = $output->URL(pnModURL('Topics',
                           'user',
                           'view',
                           array('topicid' => $item['topicparent'])),$link);
    $imagepath=pnModAPIFunc('topics',
                                'user',
                                  'getimageurl',
                                  array('imagename' => $item['topicimage']));
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $image = '<image name="plaatje" src="'.$imagepath.'" BORDER="0" VALIGN="top" ALT="'.$item['topictext'].'">';
    $columns[] = $output->URL('index.php?module=News&catid=&topic='.$item['topicid'], $image);
    $columns[] = $output->BoldText($item['topicname']);
    $columns[] = $output->URL('index.php?module=News&catid=&topic='.$item['topicid'], _NEWS);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns,'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();


    $output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();
    $columns[] = pnVarPrepHTMLDisplay($itemtext);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();

    return $output->GetOutput();
}

/**
 * generate menu fragment
 */
function topics_usermenu()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Display status message if any.  Note that in future this functionality
    // will probably be in the theme rather than in this menu, but this is the
    // best place to keep it for now

    // Start options menu
    $output->Text(pnGetStatusMsg());
    $output->Linebreak(2);

    // Menu options.  These options are all added in a single row, to add
    // multiple rows of options the code below would just be repeated
    $output->TableStart(_TOPICS);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();
//    $columns[] = $output->URL(pnModURL('topics',
    $columns[] = $output->URL(pnModURL('Topics',
                                       'user',
                                       'view'),
                              _TOPICSVIEW);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

?>