<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// this release: Bas van den Bosch
// Purpose of file:  topics user API
// ----------------------------------------------------------------------

function topics_userapi_getimageurl ($args)
{
        list($imagename) = pnVarCleanFromInput('imagename');
    extract($args);

        $imagepath=pnConfigGetVar('tipath');
        $imagepath.='/';

        if(pnModGetVar('topics','themedependantimages')) {
        $imagepath .= pnUserGetTheme();
        $imagepath.='/';
        }

        if(pnModGetVar('topics','languagedependantimages')) {
        $imagepath .= pnUserGetLang();
        $imagepath.='/';
        }

        $imagepath .= $imagename;

        return $imagepath;

}

function topics_userapi_getall($args)
{
    list($getall,$topicid,$startnum,$numitems) = pnVarCleanFromInput('getall','topicid','startnum','numitems');
    extract($args);

    // Optional arguments.
    if (!isset($startnum)) {
        $startnum = 1;
    }
    if (!isset($numitems)) {
        $numitems = -1;
    }

    $items = array();

    // Security check - important to do this as early on as possible to
    // avoid potential security holes or just too much wasted processing
    if (!pnSecAuthAction(0, 'Topics::Item', '::', ACCESS_READ)) {
        return $items;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];
        if($getall<>'yes') {
        $sql = "SELECT $topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topictext], $topicscolumn[topicexttext], $topicscolumn[topicimage], $topicscolumn[topicparent], $topicscolumn[topicname] FROM $topicstable";
    $sql.=" WHERE $topicscolumn[topicparent]=".$topicid;
        $sql.= " ORDER BY $topicscolumn[topicname]";
        } else {
        $sql = "SELECT $topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topictext], $topicscolumn[topicexttext], $topicscolumn[topicimage], $topicscolumn[topicparent], $topicscolumn[topicname] FROM $topicstable";
    $sql.= " ORDER BY $topicscolumn[topicname]";
        }

    $result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }

    //teller op nul
    //voor elk item dat gelezen mag worden teller 1 ophogen tot numitems
    //zolang teller<startnum niet aan array toevoegen
    //doorgaan tot teller > startnum+numitems

    $counter=0;

//modified for Oracle compatibility
//        for (; !$result->EOF; $result->MoveNext()) {
        while(!$result->EOF){
        list($topicid, $topicnametag, $topictext, $topicexttext, $topicimage, $topicparent, $topicname) = $result->fields;
        if (pnSecAuthAction(0, 'Topics::Topic', "::$topicid", ACCESS_OVERVIEW)) {
                $counter++;
                if (($counter>$startnum-1) && ($counter<($startnum+$numitems))){
            $items[] = array('topicid' => $topicid,
                                             'topicnametag' => $topicnametag,
                                             'topictext' => $topictext,
                                             'topicexttext' => $topicexttext,
                                             'topicimage' => $topicimage,
                             'topicparent' => $topicparent,
                             'topicname' => $topicname);}
        }

                $result->MoveNext();
    }
    $result->Close();
    return $items;
}

function topics_userapi_getrelated($args)
{
    list($topicid) = pnVarCleanFromInput('topicid');
    extract($args);

    $items = array();

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
        $relatedtable=$pntable['related'];
    $column = &$pntable['related_column'];

        $sql = "SELECT $column[rid], $column[name], $column[url] FROM $pntable[related] WHERE $column[tid]=".pnVarPrepForStore($topicid);
    $result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }

//modified for Oracle compatibility
//    for (; !$result->EOF; $result->MoveNext()) {
    while(!$result->EOF){
        list($rid, $name, $url) = $result->fields;
//        if (pnSecAuthAction(0, 'topics::Item', "$topicnametag::$topicid", ACCESS_READ)) {
            $items[] = array('rid' => $rid,
                                             'rname' => $name,
                                             'rurl' => $url);
//        }
                $result->MoveNext();
    }
    $result->Close();
    return $items;
}

function topics_userapi_getitems($args)
{
    //
    extract($args);

    // Optional arguments.
    if (!isset($startnum)) {
        $startnum = 1;
    }
    if (!isset($numitems)) {
        $numitems = -1;
    }

    if (!isset($topicid)) {
        $topicid = 0;
    }

    if ((!isset($startnum)) ||
        (!isset($numitems))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    $items = array();

    // Security check - important to do this as early on as possible to
    // avoid potential security holes or just too much wasted processing
    if (!pnSecAuthAction(0, 'topics::Item', '::', ACCESS_READ)) {
        return $items;
    }

    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $articlestable = $pntable['topics'];
    $articlescolumn = &$pntable['topics_column'];

    // Get items - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the SelectLimit() command allows for simpler debug
    // operation if it is ever needed
    $sql = "SELECT $topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topictext], $topicscolumn[topicexttext], $topicscolumn[topicimage], $topicscolumn[topicparent], $topicscolumn[topicname] FROM $topicstable";
        $sql .= " WHERE $topicscolumn[topicparent]=$topicid";
    $sql .= " ORDER BY $topicscolumn[topicname]";

        $result = $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
 if ($dbconn->ErrorNo() != 0) {
    pnSessionSetVar('errormsg', _GETFAILED);
     return false;
  }

//modified for Oracle compatibility
//     for (; !$result->EOF; $result->MoveNext()) {
     while(!$result->EOF){
        list($topicid, $topicnametag, $topictext, $topicimage, $topicparent, $topicname) = $result->fields;
        if (pnSecAuthAction(0, 'topics::Item', "$topicnametag::$topicid", ACCESS_READ)) {
            $items[] = array('topicid' => $topicid,
                                             'topicnametag' => $topicnametag,
                                             'topictext' => $topictext,
                                             'topicexttext' => $topicexttext,
                                             'topicimage' => $topicimage,
                             'topicparent' => $topicparent,
                             'topicname' => $topicname);
        }
                $result->MoveNext();
    }
    $result->Close();
    return $items;
}

/**
 * get a specific item
 * @param $args['tid'] id of example item to get
 * @returns array
 * @return item array, or false on failure
 */

function topics_userapi_get($args)
{
    // Get arguments from argument array - all arguments to this function
    // should be obtained from the $args array, getting them from other places
    // such as the environment is not allowed, as that makes assumptions that
    // will not hold in future versions of PostNuke
    list($topicid) = pnVarCleanFromInput('topicid');
    extract($args);

    // Argument check - make sure that all required arguments are present, if
    // not then set an appropriate error message and return
    if (!isset($topicid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
       return false;
    }

    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you are
    // getting - $table and $column don't cut it in more complex modules
    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    // Get item - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the Execute() command allows for simpler debug operation
    // if it is ever needed
    $sql = "SELECT $topicscolumn[topicnametag],
                   $topicscolumn[topictext],
                   $topicscolumn[topicexttext],
                   $topicscolumn[topicimage],
                   $topicscolumn[topicparent],
                   $topicscolumn[topicname]
            FROM $topicstable
            WHERE $topicscolumn[topicid] = $topicid";
        $result = $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Check for no rows found, and if so return
    if ($result->EOF) {
        return false;
    }

    // Obtain the item information from the result set
    list($topicnametag, $topictext, $topicexttext, $topicimage, $topicparent,$topicname) = $result->fields;

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Security check - important to do this as early on as possible to avoid
    // potential security holes or just too much wasted processing.  Although
    // this one is a bit late in the function it is as early as we can do it as
    // this is the first time we have the relevant information
    if (!pnSecAuthAction(0, 'Topics::Topic', "::$topicid", ACCESS_READ)) {
       return false;
   }


    // Create the item array
    $item = array('topicid' => $topicid,
                  'topicnametag' => $topicnametag,
                  'topictext' => $topictext,
                  'topicexttext' => $topicexttext,
                  'topicimage' => $topicimage,
                  'topicparent' => $topicparent,
                  'topicname' => $topicname);

    // Return the item array
    return $item;
}

function topics_userapi_getrelatedlink($args)
{
   list($rid) = pnVarCleanFromInput('rid');
    extract($args);

    // Argument check - make sure that all required arguments are present, if
    // not then set an appropriate error message and return
    if (!isset($rid)) {
       pnSessionSetVar('errormsg', _MODARGSERROR);
       return false;
    }

    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you are
    // getting - $table and $column don't cut it in more complex modules
    $relatedtable = $pntable['related'];
    $column = &$pntable['related_column'];

    // Get item - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the Execute() command allows for simpler debug operation
    // if it is ever needed
        $sql = "SELECT $column[rid], $column[name], $column[url], $column[tid] FROM $relatedtable WHERE $column[rid]=$rid";
    $result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    if ($result->EOF) {
        return false;
    }

    list($rid, $name, $url, $tid) = $result->fields;

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Security check - important to do this as early on as possible to avoid
    // potential security holes or just too much wasted processing.  Although
    // this one is a bit late in the function it is as early as we can do it as
    // this is the first time we have the relevant information
    if (!pnSecAuthAction(0, 'Topics::Related', "$tid::", ACCESS_READ)) {
       return false;
   }


    // Create the item array
    $item = array('rid' => $rid,
                    'name' => $name,
                    'url' => $url,
                    'tid' => $tid);

    // Return the item array
    return $item;
}

function topics_userapi_getchilds()
{
    list($sel) = pnVarCleanFromInput('sel');
        extract($args);

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $topicstable = $pntable['topics'];

        $sql="SELECT $topicscolumn[topicid], $topicscolumn[topicnametag], $topicscolumn[topicparent], $topicscolumn[topicname]
          FROM $topicstable
          ORDER BY $topicscolumn[topicnametag]";
    $result=$dbconn->Execute($sql);

//modified for Oracle compatibility
//    while(list($topicid, $topicnametag, $topicparent, $topicname) = $result->fields) {
    while(!$result->EOF){
                list($topicid, $topicnametag, $topicparent, $topicname) = $result->fields;
                   $ok='no';
                   if (($sel==$topicid) OR ($sel==$topicparent)) {$ok='yes';}
                   $parent=$topicparent;
                      while (($ok=='no') AND ($parent<>'0')) {
                                       $item=pnModAPIFunc('topics',
                                            'user',
                                                   'get',
                                        array('topicid' => $parent));
                                       $parent=$item['topicparent'];
                                if ($parent==$sel) {$ok='yes';}
                      }

                      if ($ok=='yes') {
                       $fullname = pnModAPIFunc('topics',
                                            'user',
                                                   'getpath',
                                        array('topicid' => $topicid));
                                  $data[] = array ('id' => $topicid,
                                                       'name' => $fullname);
        }
        $result->MoveNext();
        }

    return $data;

}

function topics_userapi_createwherestatementforchilditems()
{
    list($topicid) = pnVarCleanFromInput('topicid');
        extract($args);
        if ((isset($topicid))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

        $statement=' WHERE $topicscolumn[topicid]=$topicid';
        $data= pnModAPIFunc('topics',
                               'user',
                                    'getchilds',
                        array('sel' => $topicid));
foreach ($data as $item) {
        $statement=$statement+" OR "+$topicscolumn[topicid]+"="+$item['topicid'];
    }

    return $statement;
}




function topics_userapi_countitems()
{
         list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    $sql = "SELECT COUNT(1) FROM $topicstable";

    $result = $dbconn->Execute($sql);


    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Obtain the number of items
    list($numitems) = $result->fields;

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Return the number of items
    return $numitems;
}

function topics_userapi_countchilditems($args)
{
    list($topicid) = pnVarCleanFromInput('topicid');
        extract($args);

    if (!isset($topicid)) {
        $topicid = 0;
    }

        list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

    $sql = "SELECT COUNT(1)
            FROM $topicstable WHERE $topicscolumn[topicparent]=$topicid";
    $result = $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Obtain the number of items
    list($numitems) = $result->fields;

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Return the number of items
    return $numitems;
}



//getlist returns an array of arrays with topicid,fullname in an option-statement
//todo add access readlist
function topics_userapi_getlist($args)
{
    extract($args);

    if (!isset($sel)) {
        $sel=0;
    }


    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $topicstable = $pntable['topics'];

/*   $topicscolumn = &$pntable['topics_column'];
    $sql="SELECT $topicscolumn[topicid], $topicscolumn[topicnametag]
          FROM $topicstable
          ORDER BY $topicscolumn[topicnametag]";
*/

        $sql="SELECT $topicscolumn[topicid], $topicscolumn[topicnametag]
          FROM $topicstable
          ORDER BY $topicscolumn[topicnametag]";

    $result=$dbconn->Execute($sql);

    $data[]=array('id' => '0',
                              'name' => 'is main topics');
//modified for Oracle compatibility
//        while(list($topicid, $topicnametag) = $result->fields) {
        while(!$result->EOF){
                list($topicid, $topicnametag) = $result->fields;
                       $fullname = pnModAPIFunc('topics',
                                            'user',
                                                   'getpath',
                                        array('topicid' => $topicid));
               $data[] = array ('id' => $topicid,
                                                   'name' => $fullname);
        $result->MoveNext();
        }

    return $data;

}


//get the full pathname of the topics
function topics_userapi_getpath($args)
{

    extract($args);

    if (!isset($topicid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
       return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

        $result=$dbconn->Execute("SELECT $topicscolumn[topicparent],
                                     $topicscolumn[topicnametag]
                              FROM $topicstable
                              WHERE $topicscolumn[topicid]=$topicid");
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    if ($result->EOF) {
        return false;
    }

    list($topicparent, $topicnametag)=$result->fields;
    $fullpath=$topicnametag;

    while ($topicparent!=0) {
        $result=$dbconn->Execute("SELECT $topicscolumn[topicparent],
                                         $topicscolumn[topicnametag]
                                  FROM $topicstable
                                  WHERE $topicscolumn[topicid]=$topicparent");
        if ($dbconn->ErrorNo() != 0) {
        return false;
        }
            if ($result->EOF) {
        return $fullpath;
    }
                list($topicparent, $topicnametag)=$result->fields;
                $fullpath = $topicnametag.' / '.$fullpath;
        }

    return $fullpath;
}

function topics_userapi_haschilds($args)
{
    list($topicid) = pnVarCleanFromInput('topicid');
        extract($args);
        if (isset($topicid)) {
        $topicid='0';
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $topicstable = $pntable['topics'];
    $topicscolumn = &$pntable['topics_column'];

        $result=$dbconn->Execute("SELECT $topicscolumn[topicparent]
                              FROM $topicstable
                              WHERE $topicscolumn[topicparent]=$topicid");

    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    if ($result->EOF) {
    return false;
    } else { return true;}
}


?>