<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// This release: Bas van den Bosch
// Purpose of file:  visualisation of admin Topics - to be put to admin/adminapi
// ----------------------------------------------------------------------

function topics_visualapi_findimages ()
{

        $dir_path = pnConfigGetVar('tipath');

        if(pnModGetVar('topics','themedependantimages')) {
        $dir_path .= '/';
        $dir_path .= pnUserGetTheme();
        }

        if(pnModGetVar('topics','languagedependantimages')) {
        $dir_path .= '/';
        $dir_path .= PnUserGetLang();
        }

   $image_array = Array ();
   $image_array[] = '';

   // We need appropriate Error Check here... Or else it just hangs there...
   $dir = @opendir($dir_path);
   if (!$dir)
   {
   //   pnExceptionSet(PN_SYSTEM_EXCEPTION, 'DIRECTORY_INEXISTENT',
   //                  new SystemException(__FILE__.'('.__LINE__.'): An error occured trying to access the categories images directory '.$dir_path));
      return $image_array;
   }
   while (($file = readdir($dir)) !== false) {
      // Should be put somewhere else?
      // Conf vars?
      $extension_array = Array('.png', '.gif', '.jpg');
      $is_image = false;
      foreach ($extension_array as $extension)
      {
         if (ereg("$extension\$", $file)) {$is_image = true;}
      }
      if ($is_image)
      {
         $image_array[] = $file;
      }
   }
   closedir($dir);
   return $image_array;
}

/**
 * Visual Menu to add a new topics
 */
function topics_visualapi_newtopic($args)
{
    extract($args);

    // Create output object
    $output = new pnHTML();

    if (!isset($topicid)) {$topicid = false;}
    if (!isset($eid)) {$eid = false;}
    if (!isset($return_url)) {
        $output->Text(_NOURLTORETURN);
        return $output->GetOutput();
    }
//        if (!pnModAPILoad('topics', 'user')) {
        if (!pnModAPILoad('Topics', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
//        if (!pnModAPILoad('topics', 'admin')) {
        if (!pnModAPILoad('Topics', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
    // Title
    $output->Title(_ADDTOPICS);


    // Start form
    $output->FormStart(pnModURL(pnModGetName(), 'admin', 'create'));
    $output->FormHidden('authid', pnSecGenAuthKey());

    $output->FormHidden('return_url', $return_url);

    // Start Table
    $output->TableStart();

    // Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSNAME));
    $row[] = $output->FormText('topicnametag', '', 50, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Topictext
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSTEXT));
    $row[] = $output->FormText('topictext', '', 50, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Topic extended text
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepHtmlDisplay(_TOPICSEXTTEXT));
    $row[] = $output->FormTextArea('topicexttext', '', 5, 45);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Image
    // Make a Select from images/categories
    // Does this work in IIS ?? _SERVER["PATH_TRANSLATED"]???
    // Need to change the delimiter depending on Win/Unix filesystem
    $image_array = topics_visualapi_findimages ();

    $dir_path = pnConfigGetVar('tipath');
        if(pnModGetVar('topics','themedependantimages')) {
        $dir_path .= pnUserGetTheme();
        }
        if(pnModGetVar('topics','languagedependantimages')) {
        $dir_path .= PnUserGetLang();
        }

    $select = '<image name="plaatje" src="'.$dir_path.'//empty.gif">';
    $select .= "<BR><br><select name=\"topicimage\" size=\"1\" onChange=\"document.plaatje.src='$dir_path//'+this.options[this.selectedIndex].value;\">";
    foreach ($image_array as $image)
    {
            $select .= '<option value="'.$image.'">'.$image.'</option>';
    }

    $select .= '</select>';

    //Image
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSIMAGE));
    $row[] = $select;
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    //parent
    $data = pnModAPIFunc('topics',
                         'admin',
                         'getlist',
                         array('sel' => $item['topicid']));

    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSPAR));
    $row[] = $output->FormSelectMultiple('topicparent', $data, 0, 1);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // End form
    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_TOPICSADD);
    $output->FormEnd();


    // Return output
    return $output->GetOutput();
}


/**
 * Visual Menu to modify a topics
 *
*/
function topics_visualapi_modifytopic($args)
{
    extract($args);

    if (!isset($topicid)) {
        $output->Text(_NOURLTORETURN);
        return $output->GetOutput();
    }

    if (!isset($return_url)) {
        $output->Text(_NOURLTORETURN);
        return $output->GetOutput();
    }

//    if (!pnModAPILoad('topics', 'user')) {
    if (!pnModAPILoad('Topics', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

//    if (!pnModAPILoad('topics', 'admin')) {
    if (!pnModAPILoad('Topics', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $item = pnModAPIFunc('topics',
                         'user',
                         'get',
                         array('topicid' => $topicid));

    if ($item == false) {
                $output = new pnHTML();
        $output->Text(_TOPICSNOSUCHITEM);
        return $output->GetOutput();
    }

    // Create output object
    $output = new pnHTML();

    // Title
    $output->Title(_EDITTOPICS);

    // Start form
    $output->FormStart(pnModURL(pnModGetName(), 'admin', 'update'));
    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('topicid', pnVarPrepForDisplay($topicid));
    $output->FormHidden('return_url', $return_url);

    $output->TableStart();

    // Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSNAME));
    $row[] = $output->FormText('topicnametag', pnVarPrepForDisplay($item['topicnametag']), 45, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Topic text
    $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSTEXT));
    $row[] = $output->FormText('topictext', pnVarPrepForDisplay($item['topictext']), 45, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Topic Extended text
    $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSEXTTEXT));
    $row[] = $output->FormTextArea('topicexttext', pnVarPrepHtmlDisplay($item['topicexttext']), 5, 50);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);


    $image_array = topics_visualapi_findimages ();

    $dir_path = pnConfigGetVar('tipath');
        if(pnModGetVar('topics','themedependantimages')) {
        $dir_path .= pnUserGetTheme();
        }
        if(pnModGetVar('topics','languagedependantimages')) {
        $dir_path .= PnUserGetLang();
        }

    $select = '<image name="plaatje" src="'.$dir_path.'/'.$item['topicimage'].'">';
    $select .= "<br><select name=\"topicimage\" size=\"1\" onChange=\"document.plaatje.src='".$dir_path."/'+this.options[this.selectedIndex].value;\">";
    foreach ($image_array as $image)
    {
       $select .= '<option value="'.$image.'"';
       $select .= ($item['topicimage']==$image)?' selected':' ';
       $select .= '>'.$image.'</option>';
    }

    $select .= '</select>';

    //Image
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSIMAGE));
    $row[] = $select;
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $data = pnModAPIFunc('topics',
                         'admin',
                         'getlist',
                         array('sel' => $item['topicid']));
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_TOPICSPAR));
    $row[] = $output->FormSelectMultiple('topicparent', $data, 0, 1, $item['topicparent']);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);


    // End form
    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_TOPICSUPDATE);
    $output->FormEnd();

    $cat=$item['topicid'];

// related......
        $items = pnModAPIFunc('topics',
                          'user',
                          'getrelated',
                          array('topicid' => $cat));

        $output->Title('');
        $output->Title(_RELATEDLINKS);
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
         $output->SetInputMode(_PNH_PARSEINPUT);

    foreach ($items as $item) {
        if (pnSecAuthAction(0,
                            'Topics::Related',
                            "$cat::",
                            ACCESS_READ)) {
                                $row = array();
                                $options = array();
                                $row[] = $output->Text(pnVarPrepForDisplay($item['rname']));
                $row[] = $output->Text(pnVarPrepForDisplay($item['rurl']));
                if (pnSecAuthAction(0, 'Topics::Related', "$cat::", ACCESS_EDIT)) {
//                    $options[] = $output->URL(pnModURL('topics',
                    $options[] = $output->URL(pnModURL('Topics',
                                                       'admin',
                                                       'modifyrelated',
                                                       array('rid' => $item['rid'],
                                                                        'topicid' => $cat)),
                                             _EDIT);
                if (pnSecAuthAction(0, 'Topics::Related', "$cat::", ACCESS_DELETE)) {
//                    $options[] = $output->URL(pnModURL('topics',
                    $options[] = $output->URL(pnModURL('Topics',
                                                        'admin',
                                                        'deleterelated',
                                                        array('rid' => $item['rid'],
                                                              'topicid' => $cat)),
                                              _DELETE);
                        }
                    }
                    $options = join(' | ', $options);
                    $row[] = $options;

                                   $output->SetOutputMode(_PNH_KEEPOUTPUT);
                            $output->SetInputMode(_PNH_VERBATIMINPUT);
                            $output->TableAddrow($row, 'left');
                            $output->SetOutputMode(_PNH_RETURNOUTPUT);
                            $output->SetInputMode(_PNH_PARSEINPUT);
                    }
    }


            $output->SetOutputMode(_PNH_KEEPOUTPUT);
            $output->TableEnd();

        $output->Title('');
        $output->Title(_ADDRELATED);
        $output->FormStart(pnModURL(pnModGetName(), 'admin', 'createrelated'));
    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('topicid', $cat);
    $output->TableStart();

    // Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RELATEDNAME));
    $row[] = $output->FormText('name','', 70, 70);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // URL
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RELATEDURL));
    $row[] = $output->FormText('url','', 70, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_ADDRELATED);
    $output->FormEnd();

    return $output->GetOutput();
}

?>