<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file:  Initialisation functions for Wiki encoding
// ----------------------------------------------------------------------

/**
 * initialise the Wiki module
 */
function wiki_init()
{
    // Set up module variables
// these are the authorised links.
    pnModSetVar('Wiki', 'AllowedProtocols', 'http|https|mailto|ftp|news|gopher');
// an image may be one of these.
    pnModSetVar('Wiki', 'InlineImages', 'png|jpg|gif');
// if a link is http://something, it can be directed in a new window, or in the same one.
    pnModSetVar('Wiki', 'ExtlinkNewWindow', true);
    pnModSetVar('Wiki', 'IntlinkNewWindow', false);
// dont touch this one.
    pnModSetVar('Wiki', 'FieldSeparator', "\263");

    // Set up module hooks
    if (!pnModRegisterHook('item',
                           'transform',
                           'API',
                           'Wiki',
                           'user',
                           'transform')) {
        pnSessionSetVar('errormsg', _WIKICOULDNOTREGISTER);
        return false;
    }

    // Initialisation successful
    return true;
}

/**
 * upgrade the wiki module from an old version
 */
function wiki_upgrade($oldversion)
{
    return true;
}

/**
 * delete the wiki_ module
 */
function wiki_delete()
{
    // Remove module hooks
    if (!pnModUnregisterHook('item',
                             'transform',
                             'API',
                             'Wiki',
                             'user',
                             'transform')) {
        pnSessionSetVar('errormsg', _WIKICOULDNOTUNREGISTER);
        return false;
    }

    // Remove module variables
    pnModDelVar('Wiki', 'FieldSeparator');
    pnModDelVar('Wiki', 'IntlinkNewWindow');
    pnModDelVar('Wiki', 'ExtlinkNewWindow');
    pnModDelVar('Wiki', 'AllowedProtocols');
    pnModDelVar('Wiki', 'InlineImages');

    // Deletion successful
    return true;
}

?>
