<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------

/**
 * initialise block
 */
function daily_archive_newscalendarblock_init()
{
    // Security
    pnSecAddSchema('daily_archive:newscalendarblock:', 'Block title::');
}

/**
 * get information on block
 */
function daily_archive_newscalendarblock_info()
{
    // Values
    return array('text_type' => 'newscalendar',
                 'module' => 'daily_archive',
                 'text_type_long' => 'News calendar',
                 'allow_multiple' => false,
                 'form_content' => false,
                 'form_refresh' => false,
                 'show_preview' => false);
}



function daily_archive_newscalendarblock_newcalendar ($month, $year, $prev_last=1, $width="0", $border="1", $showmore="1") {

    //    API
    if (!pnModAPILoad('daily_archive', 'user')) return _ARCH_NOAUTH;
            //    API

        $offset_min= pnModAPIFunc('daily_archive', 'user', 'getoffset');

        $month_text=pnModAPIFunc('daily_archive', 'user', 'month_num2text', array('num'=>$month));
        $month_row="<b>" . $month_text . " " . $year . "</b>";
        $currmonth_row="";
        $url_prev="";
        $url_next="";

        if ($width=="1") $width="width=\"100%\"";
        else $width="";

        if ($border=="1") $border="border=\"1\"";
        else $border="";

        if ($showmore=="1") {
                $url_more=pnVarPrepForDisplay(pnModURL('daily_archive', 'user','display',
                        array ('req'=>'get', 'year'=>$year, 'month'=>$month)));
                $more_row="<div align=right><br><a href=\"".$url_more."\"><b>" . _ARCH_LASTBLOCK_MORE . "</b></a>&nbsp;</div>";
        }

        if (date("Y-m")!=$year."-".$month) {
                $url_curr = pnVarPrepForDisplay(pnModURL('daily_archive', 'user', 'redirect',
                                                array('month' => date("m",mktime(0,0,0,date("m"),date("d"),date("Y"))),
                                                          'year' => date("Y",mktime(0,0,0,date("m"),date("d"),date("Y"))))));

                $currmonth_row="<div align=\"center\"><br><a href=".$url_curr.">" . _ARCH_LASTBLOCK_CURR . "</a></div>";
        }

        if ($prev_last==1) {
                $url_prev = pnVarPrepForDisplay(pnModURL('daily_archive', 'user', 'redirect',
                                                        array('month' => date("m", mktime(0,0,0,$month-1,1,$year)),
                                                                        'year' => date("Y", mktime(0,0,0,$month-1,1,$year)))));

                $url_next = pnVarPrepForDisplay(pnModURL('daily_archive', 'user', 'redirect',
                                                        array('month' => date("m", mktime(0,0,0,$month+1,1,$year)),
                                                                        'year' => date("Y", mktime(0,0,0,$month+1,1,$year)))));

                $month_row="<table " . $width ." " . $border . " cellspacing=\"0\" cellpadding=\"0\" align=\"center\"><tr><td><a href=\"".$url_prev."\">" . _ARCH_LASTBLOCK_PREV . "</a></td><td width=\"100%\" align=\"center\">" . $month_row . "</td><td><a href=\"".$url_next."\">" . _ARCH_LASTBLOCK_NEXT . "</a></td></table>";
        }



        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $tbl=$pntable['stories_column'];
        $where_text=pnModAPIFunc('daily_archive', 'user', 'getwhere',
                                                                array('nummon'=>$month, 'numyear'=>$year));

        $calendar_table="<br><table " . $width . " " . $border
                . " cellspacing=\"0\" cellpadding=\"0\" "
                . " align=\"center\"><tr><td colspan=\"7\">" . $month_row . "</td></tr>";

        $sql="SELECT ".$tbl['time']." FROM ".$pntable['stories'] . $where_text ." ORDER by ".$tbl['time'];

        $result = $dbconn->Execute($sql);
        if($dbconn->ErrorNo() != 0) {
       $calendar_table="DB Error: Daily Archive block: "
                       . $dbconn->ErrorNo().": ".$dbconn->ErrorMsg()
                       . "<br>Query:</b><br>" . $sql;
        } else {

                $weekday=1;
                $day=0;
                $lastday=0;
                $calendar_table.="<tr>";
                $week_1stday=date ("w", mktime(0,0,0,$month,1,$year))+1;
                if ($week_1stday==1) $week_1stday=8;

                for($i=1;$i<$week_1stday-1;$i++) {
                        $calendar_table .= "<td></td>";
                        $weekday++;
                }

                while(!$result->EOF) {
                        list($time) = $result->fields;
                        ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $dt);

                        $year=date("Y",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
                        $month=date("m",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
                        $day=date("d",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));

                        if ($day!=$lastday) {

                                for($i=$lastday+1;$i<$day;$i++) {
                                        if ($weekday==1) $calendar_table .= "</tr><tr>";
                                        $calendar_table .= "<td align=\"center\">".$i."</td>";

                                        if ($weekday==7) $weekday=1;
                                        else $weekday++;
                                }

                                $day+=0;
                                if ( ($weekday==1) AND ($day!=1) ) $calendar_table .= "</tr><tr>";

                                $link = pnVarPrepForDisplay(pnModURL('daily_archive','user', 'display',
                                                        array('req'=>'get',         'year'=>$year,'month'=>$month,'day'=>$day)));
                                $calendar_table .= "<td align=\"center\"><a href=\"" . $link . "\"><b>".$day."</b></a></td>";
                                if ($weekday==7) { $weekday=1; $calendar_table.="</tr><tr>";}
                                else $weekday++;
                        }

                        $lastday=$day;
                        $result->MoveNext();

                }

                for($i=$day+1;$i<32;$i++) {
                        if (!checkdate($month, $i, $year)) {
                                if ($weekday!=1) {
                                        for($j=$weekday;$j<7;$j++) {
                                                $calendar_table .= "<td></td>";
                                        }
                                }
                                break;
                        }

                        if ($weekday==1) $calendar_table .= "</tr><tr>";
                        $calendar_table .= "<td align=\"center\">".$i."</td>";
                        if ($weekday==7) $weekday=1;
                        else $weekday++;
                }

                $result->Close();
                $calendar_table .= "</tr></table>" . $currmonth_row . $more_row;
        }
/*debugging*/// $calendar_table=$offset_min. "<br>".$where_text."<br>".$calendar_table;
        return $calendar_table;
}

/**
 * display block
 */
function daily_archive_newscalendarblock_display($blockinfo)
{
    // Security check
    if (!pnSecAuthAction(0,
                         'daily_archive:newscalendarblock:',
                         "$blockinfo[title]::",
                         ACCESS_READ)) {
        return;
    }

    // Get variables from content block

    $vars = pnBlockVarsFromContent($blockinfo['content']);
/*
        if (!isset($vars['lstblk_width'])) {$vars['lstblk_width']=0;}
        if (!isset($vars['lstblk_border'])) {$vars['lstblk_border']=1;}
        if (!isset($vars['lstblk_showmore'])) {$vars['lstblk_showmore']=1;}
*/
        // Create output object
    $output = new pnHTML();
        $output->SetInputMode(_PNH_VERBATIMINPUT);

        $curr_year=date("Y");
        $curr_month=date("m");
        $curr_day=date("d");


        $prev_last=0;
        $curr_lang=pnUserGetLang();

        if (true) {
                $prev_last=1;
                $sess_month=pnSessionGetVar('lstblk_sess_month');
                $sess_year=pnSessionGetVar('lstblk_sess_year');
                $sess_calendar=pnSessionGetVar('lstblk_sess_calendar');
                $sess_language=pnSessionGetVar('lstblk_sess_language');
                $sess_date=pnSessionGetVar('lstblk_sess_date');
        }

        if ( (!isset($sess_month)) OR ($sess_month==false) ) $sess_month=$curr_month;
        if ( (!isset($sess_year)) OR ($sess_year==false) ) $sess_year=$curr_year;
        if ( (!isset($sess_language)) OR ($sess_language==false) ) {
                $sess_language=$curr_lang;
                $sess_calendar=false;
        }
        if ( (!isset($sess_date)) OR ($sess_date==false) ) {
                $sess_date=$curr_year . "-" . $curr_month . "-" . $curr_day;
                $sess_calendar=false;
        }
        if (!isset($sess_calendar)) {$sess_calendar=false;}

        if ($sess_date!=$curr_year . "-" . $curr_month . "-" . $curr_day) {
                $sess_month=$curr_month;
                $sess_year=$curr_year;
                $sess_calendar=false;
        }

        if ($sess_language!=$curr_lang)  {        $sess_calendar=false; }

        if ($sess_calendar==false) {
                $sess_calendar=daily_archive_newscalendarblock_newcalendar($sess_month, $sess_year, $prev_last, $vars['lstblk_width'], $vars['lstblk_border'], $vars['lstblk_showmore']);

/*debugging*/// $sess_calendar=date("Y-m-d H:i:s") . "<br>" . $sess_calendar;

//                pnSessionSetup();
                pnSessionSetVar('lstblk_sess_month', $sess_month);
                pnSessionSetVar('lstblk_sess_year', $sess_year);
                pnSessionSetVar('lstblk_sess_calendar', $sess_calendar);
                pnSessionSetVar('lstblk_sess_language', $curr_lang);
                pnSessionSetVar('lstblk_sess_date', $curr_year . "-" . $curr_month . "-" . $curr_day);
        }

        $output->Text($sess_calendar);


    // Populate block info and pass to theme
    $blockinfo['content'] = $output->GetOutput();

    return themesideblock($blockinfo);
}


/**
 * modify block settings
 */
function daily_archive_newscalendarblock_modify($blockinfo)
{
     // Create output object
    $output = new pnHTML();

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);
/*
        if (empty($vars['lstblk_width'])) {$vars['lstblk_width'] = 0;}
        if (empty($vars['lstblk_border'])) {$vars['lstblk_border'] = 0;}
        if (empty($vars['lstblk_showmore'])) {$vars['lstblk_showmore'] = 0;}
*/
        // lstblk_width
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_ARCH_LASTBLOCK_WIDTH));
    $row[] = $output->FormCheckbox('lstblk_width', $vars['lstblk_width']);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

        // lstblk_border
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_ARCH_LASTBLOCK_BORDER));
    $row[] = $output->FormCheckbox('lstblk_border', $vars['lstblk_border']);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

        // lstblk_showmore
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_ARCH_LASTBLOCK_SHOWMORE));
    $row[] = $output->FormCheckbox('lstblk_showmore', $vars['lstblk_showmore']);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

        // Return output
    return $output->GetOutput();

}

/**
 * update block settings
 */
function daily_archive_newscalendarblock_update($blockinfo)
{
    $vars['lstblk_width'] = pnVarCleanFromInput('lstblk_width');
    $vars['lstblk_border'] = pnVarCleanFromInput('lstblk_border');
    $vars['lstblk_showmore'] = pnVarCleanFromInput('lstblk_showmore');

        $blockinfo['content'] = pnBlockVarsToContent($vars);

        return $blockinfo;
}

?>
