<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------

function daily_archive_userapi_getoffset() {

	if ( (pnModGetVar('daily_archive', 'news_local_time')==1) AND (pnUserLoggedIn()) ) {
		$offset_hour=pnUserGetVar('timezone_offset')-pnConfigGetVar('timezone_offset');
		$offset_min=60*$offset_hour;
	}
	else $offset_min=0;
	
	return $offset_min;
}

function daily_archive_userapi_getwhere($args="") {

	extract($args);

    if (!isset($nummon))  $nummon = 0;
    if (!isset($numyear)) $numyear = 0;
    if ((!isset($numday)) OR ($numday=="00")) $numday = 0;

	$offset_min= daily_archive_userapi_getoffset();

	if ($nummon>0) $news_month_limit=0;
	else {
		$news_month_limit=pnModGetVar('daily_archive', 'news_month_limit');
		if (   (!isset($news_month_limit)) 
			OR ($news_month_limit==false) 
			OR ($nummon<0) ) $news_month_limit=0;
	}

	$sel_language=pnModGetVar('daily_archive', 'sel_language');
	if (!isset($sel_language)) $sel_language=1;


	$where_text="";
	$where_lang_text="";
	$where_month_text="";
	
	$pntable = $GLOBALS['pntable'];
	$tbl=$pntable['stories_column'];

	if ($sel_language==1) {
		$lang=pnUserGetLang();
//modified for Oracle compatibilirty
//		$where_lang_text=$tbl['language']."='$lang' OR ".$tbl['language']."=''";
		$where_lang_text=$tbl['language']."='$lang' OR ".$tbl['language']."='' OR ".$tbl['language']." IS NULL";
	}
	
	if (($news_month_limit > 0) AND ($nummon >= 0)){
		$wheredate = 
			date("Y-m-d H:i:s", mktime(0,-$offset_min,0,date("m")-$news_month_limit+1,date("d"),date("Y")));
		$where_month_text=$tbl['time']." > '$wheredate'";

	} else if ($nummon > 0) {
		if ($numday > 0) {
			$whereprevdate = date("Y-m-d H:i:s", mktime(0,-$offset_min,0,$nummon,$numday,$numyear));
			$wherenextdate = date("Y-m-d H:i:s", mktime(0,-$offset_min,0,$nummon,$numday+1,$numyear));
		} else {
			$whereprevdate = date("Y-m-d H:i:s", mktime(0,-$offset_min,0,$nummon,1,$numyear));
			$wherenextdate = date("Y-m-d H:i:s", mktime(0,-$offset_min,0,$nummon+1,1,$numyear));
		}
		$where_month_text="(".$tbl['time']." >= '$whereprevdate' AND "
							.$tbl['time']." < '$wherenextdate')";
	}

	if (($where_lang_text!="") OR ($where_month_text!="")) {
		$where_text=" WHERE ";
		if ($where_month_text=="") { $where_text.= " " . $where_lang_text; }
		else {	
			if ($where_lang_text=="") { $where_text.= " " . $where_month_text; }
			else { $where_text.= " " . $where_month_text . " AND (" . $where_lang_text . ")"; }
		}
	}
    return $where_text;
}

	
function daily_archive_userapi_celendar_lang($args) {
	extract($args);
	
	$calendar_html=pnModGetVar('daily_archive', 'calendar_html');
	
	$search_arr= array(	"/<!---(..)--->/e", 
						"/<!---_YEARAFTER_--->/");
						
	$replay_arr= array(	"daily_archive_userapi_month_num2text(array('num'=>'\\1', 'flag'=>0))",
						_YEARAFTER);
	
	
	$calendar_html=preg_replace($search_arr, $replay_arr, $calendar_html);
			
	return $calendar_html;

	
}

function daily_archive_userapi_month_num2text($args) {

	extract($args);

    if (!isset($num)) return "";
    if (!isset($flag)) $flag = "0";
	
	switch($num) { 
		case "01": $month_text_ = _JANUARY_; $month_text = _JANUARY; break;
		case "02": $month_text_ = _FEBRUARY_; $month_text = _FEBRUARY; break;
		case "03": $month_text_ = _MARCH_; $month_text = _MARCH; break;
		case "04": $month_text_ = _APRIL_; $month_text = _APRIL; break;
		case "05": $month_text_ = _MAY_ ; $month_text = _MAY; break;
		case "06": $month_text_ = _JUNE_; $month_text = _JUNE; break;
		case "07": $month_text_ = _JULY_; $month_text = _JULY; break;
		case "08": $month_text_ = _AUGUST_; $month_text = _AUGUST; break;
		case "09": $month_text_ = _SEPTEMBER_; $month_text = _SEPTEMBER; break;
		case "10": $month_text_ = _OCTOBER_; $month_text = _OCTOBER; break;
		case "11": $month_text_ = _NOVEMBER_; $month_text = _NOVEMBER; break;
		case "12": $month_text_ = _DECEMBER_; $month_text = _DECEMBER; break;
	}

	if ($flag=="0") return $month_text . _MONTHAFTERSYMBOL;
	else return $month_text_ . _MONTHAFTERSYMBOL;
}

function daily_archive_userapi_date_suffix($args) {

	extract($args);

	if ((!isset($number)) OR ($number > 3) ) return _ARCH_DATE_4SUFFIX;
	if ($number==3) return  _ARCH_DATE_3SUFFIX;
	if ($number==2) return  _ARCH_DATE_2SUFFIX;
	if ($number==1) return  _ARCH_DATE_1SUFFIX;
}

function MonthsTables($day, $mon, $year) {

	$str_day=$day;
	if ($GLOBALS["lastday"]=="00") $GLOBALS["lastday"]=0; 
	for($i=$GLOBALS["lastday"]+1;$i<$day;$i++) {
		if ($GLOBALS["weekday"]==1) $GLOBALS["table_curr"] .= "</tr><tr>";
		
		if ($GLOBALS["show_empty_days"] > 0){	$GLOBALS["table_curr"] .= "<td align=\"center\">".$i."</td>";}
		else { $GLOBALS["table_curr"] .= "<td align=\"center\">&nbsp;&nbsp;&nbsp;&nbsp;</td>"; }
		
		if ($GLOBALS["weekday"]==7) {$GLOBALS["weekday"]=1;} else {$GLOBALS["weekday"]++;}
	}
	
	$day+=0;
	if ($GLOBALS["weekday"]==1) { if ($day!=1) $GLOBALS["table_curr"] .= "</tr><tr>"; }

	$link = pnVarPrepForDisplay(pnModURL('daily_archive','user', 'display'));
	$GLOBALS["table_curr"] .= "<td align=\"center\"><a href=\"" . $link . "&amp;req=get&amp;year=$year&amp;month=$mon&amp;day=".$str_day."\"><b>".$day."</b></a></td>";
	if ($GLOBALS["weekday"]==7) {$GLOBALS["weekday"]=1;} else {$GLOBALS["weekday"]++;}

}

function openMonthsTables($day, $mon, $year, $flag=1) {

	$GLOBALS["weekday"]=1;
	$week_1stday=date ("w", mktime(0,0,0,$mon,1,$year))+1;
	if ($week_1stday==1) $week_1stday=8;

	
	$GLOBALS["table_curr"] = "";
//	$month_text=pnModAPIFunc('daily_archive', 'user', 'month_num2text', array('num'=>$mon));
	$month_text="<!---".$mon."--->";
	$link = pnVarPrepForDisplay(pnModURL('daily_archive','user', 'display'));

	if ($flag > 0) {
		$GLOBALS["table_curr"] .= "<table border=\"1\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"$bgcolor1\" align=\"center\"><tr><td class=\"pn-normal\" colspan=\"7\" align=\"center\">";
		if ($flag==1) 
			$GLOBALS["table_curr"] .= "<a href=\"" . $link . "&amp;req=get&amp;year=$year&amp;month=$mon\"><b>";
		$GLOBALS["table_curr"] .= $month_text . "&nbsp;" . $year . "<!---_YEARAFTER_--->";
		if ($flag==1)  $GLOBALS["table_curr"] .= "</b>";
		$GLOBALS["table_curr"] .= "</a></td></tr><tr>";
	}
	if ($flag > 0) {
		for($i=1;$i<$week_1stday-1;$i++) {
			$GLOBALS["table_curr"] .= "<td></td>";
			$GLOBALS["weekday"]++;
		}
	} else {
		if ($flag==0) {
			$GLOBALS["table_curr"] .= $month_text . "&nbsp;" . $year . "<!---_YEARAFTER_--->";
			if ($GLOBALS["show_empty_inform"]) $GLOBALS["table_curr"] .= _NEWSNOTFOUND;
			$GLOBALS["table_curr"] .= "</td></tr><tr><td>";
			if ($GLOBALS["sort_months_desc"]) {
				$GLOBALS["table_res"] = $GLOBALS["table_curr"] . $GLOBALS["tbl_row"] . $GLOBALS["table_res"]; 
			} else {
				$GLOBALS["table_res"] .= $GLOBALS["tbl_row"] . $GLOBALS["table_curr"]; 
			}
		} else {
			$GLOBALS["table_curr"] .="<a href=\"" . $link . "&amp;req=get&amp;year=$year&amp;month=$mon\"><b>" .  $month_text . "&nbsp;" . $year . "<!---_YEARAFTER_--->" . "</b></a></td></tr><tr><td>";
			if ($GLOBALS["sort_months_desc"]) {
				$GLOBALS["table_res"] = $GLOBALS["table_curr"] . $GLOBALS["tbl_row"] . $GLOBALS["table_res"]; 
			} else {
				$GLOBALS["table_res"] .= $GLOBALS["tbl_row"] . $GLOBALS["table_curr"]; 
			}
		}
		$GLOBALS["last_table"]=0;
	}
}

function closeMonthsTables($day, $mon, $year) {

	for($i=$day+1;$i<32;$i++) {
		if (!checkdate($mon, $i, $year)) {
			if ($GLOBALS["weekday"]!=1) {
				for($j=$GLOBALS["weekday"];$j<7;$j++) {
					$GLOBALS["table_curr"] .= "<td align=\"center\"></td>";
				}
			}
			break;
		}
		if ($GLOBALS["weekday"]==1) $GLOBALS["table_curr"] .= "</tr><tr>";

		if ($GLOBALS["show_empty_days"] > 0){	$GLOBALS["table_curr"] .= "<td align=\"center\">".$i."</td>";}
		else { $GLOBALS["table_curr"] .= "<td align=\"center\">&nbsp;&nbsp;&nbsp;&nbsp;</td>"; }

		if ($GLOBALS["weekday"]==7) {$GLOBALS["weekday"]=1;} else {$GLOBALS["weekday"]++;}
	}
	$GLOBALS["table_curr"] .= "</tr></table></td></tr><tr><td>";
	if ($GLOBALS["sort_months_desc"]) {
		$GLOBALS["table_res"] = $GLOBALS["table_curr"] . $GLOBALS["tbl_row"] .$GLOBALS["table_res"]; 
	} else {
		if ($GLOBALS["table_res"]!="") 
			$GLOBALS["table_curr"] = $GLOBALS["tbl_row"] . $GLOBALS["table_curr"];
		$GLOBALS["table_res"] .= $GLOBALS["table_curr"]; 
	}
	$GLOBALS["last_table"]=1;
}

function daily_archive_userapi_rebuilder($args="") {

	extract($args);
	
	$news_local_time=pnModGetVar('daily_archive', 'news_local_time');
	$GLOBALS["show_empty_inform"]=pnModGetVar('daily_archive', 'show_empty_inform');
	$GLOBALS["sort_months_desc"]=pnModGetVar('daily_archive', 'sort_months_desc');
	$news_month_limit=pnModGetVar('daily_archive', 'news_month_limit');
	$show_empty_months=pnModGetVar('daily_archive', 'show_empty_months');
	$GLOBALS["show_empty_days"]=pnModGetVar('daily_archive', 'show_empty_days');
	$show_calendar=pnModGetVar('daily_archive', 'show_calendar');
		
	if (($show_calendar=="1") OR ($show_empty_months=="2")) {
		$GLOBALS["tbl_row"]="<br></td></tr><tr><td>";
	} else {$GLOBALS["tbl_row"]="";}

	$GLOBALS["last_table"]=0;

	list($dbconn) = pnDBGetConn();
	$pntable = $GLOBALS['pntable'];
	$tbl=$pntable['stories_column'];
	
	
	$offset_min= pnModAPIFunc('daily_archive', 'user', 'getoffset');

	$count = 0;
	$altbg = 0;
	$fromyear = "0000";
	$frommonth = "00";
	$fromday= "00";
	$GLOBALS["lastday"] = "00";
	$last_year_month="000000";

	$GLOBALS["table_curr"]="";
	$GLOBALS["table_res"]="";
	$newsrow_curr="";
	$newsrow_res="";

	$where_text=pnModAPIFunc('daily_archive', 'user', 'getwhere');
	$GLOBALS["weekday"]=1;
	
		$sql= "SELECT ".$tbl['sid']
			. ", ".$tbl['time']
			." FROM ".$pntable['stories'] . " " 
			. $where_text 
			." ORDER by ".$tbl['time'] ;

	$result = $dbconn->Execute($sql);	
	
	if($dbconn->ErrorNo() != 0) {
       return "DB Error: Daily Archive: " . "<br><b>SQL:</b><br>". $sql ."<br><br>" 
       			.$dbconn->ErrorNo() . ": " . $dbconn->ErrorMsg() . "<br>";
	}

	while(!$result->EOF) {
		list($s_sid, $time) = $result->fields;
        ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $dt);

		$datetime[1]=date("Y",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
		$datetime[2]=date("m",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
		$datetime[3]=date("d",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
		$datetime[4]=date("H",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
		$datetime[5]=date("i",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
		$datetime[6]=date("s",mktime($dt[4],$offset_min+$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));

		$year_month=$datetime[1].$datetime[2];
		if ($year_month!=$lastyear.$lastmonth) {
			if ($last_year_month!="000000") {
				if ($show_calendar)
					closeMonthsTables($GLOBALS["lastday"], $lastmonth, $lastyear);
				$GLOBALS["lastday"] = "00"; 
				if ($show_empty_months != "0") {
					while ($year_month!=$lastyear.$lastmonth) {
						$lastyear_curr=date("Y", mktime(0,0,0,$lastmonth+1,1,$lastyear));
						$lastmonth_curr=date("m", mktime(0,0,0,$lastmonth+1,1,$lastyear));
						$lastyear=$lastyear_curr;
						$lastmonth=$lastmonth_curr;
						if ($year_month!=$lastyear.$lastmonth) {
							if ($show_empty_months=="2") {
								openMonthsTables(1, $lastmonth, $lastyear, 2);
								closeMonthsTables(0, $lastmonth, $lastyear);
							} else { openMonthsTables(1, $lastmonth, $lastyear, 0);}
						}
					}
				}
			}
			if ($show_calendar) { openMonthsTables($datetime[3], $datetime[2], $datetime[1]);}
			else { openMonthsTables($datetime[3], $datetime[2], $datetime[1], -1);}
		}
		if ($GLOBALS["lastday"]!=$datetime[3]) { 
			MonthsTables($datetime[3], $datetime[2], $datetime[1]);
			$GLOBALS["lastday"] = $datetime[3]; 
		}

		$lastyear = $datetime[1];
		$lastmonth = $datetime[2];
		$last_year_month=$lastyear.$lastmonth;
        $result->MoveNext();
	}
	if ($show_calendar) 
		closeMonthsTables($GLOBALS["lastday"], $lastmonth, $lastyear);
		
	$result->Close();
	
	pnModSetVar('daily_archive', 'calendar_html', $GLOBALS["table_res"]);
	pnModSetVar('daily_archive', 'calendar_date', date("U"));
	
	return true;

}	
?>