<?php // $Id: pninit.php,v 1.4 2004/09/21 13:44:47 timax Exp $
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Filename: modules/ew_filemanager/pninit.php
// Original Author of file: EasyWeb Team (EWT)
// Support:        Russian - http://www.postnuke.ru
//                        English - http://home.postnuke.ru
// Purpose of file:  Initialisation functions for ew_filemanager module
// ----------------------------------------------------------------------

function ew_filemanager_init()
{
        // Get database setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
        global $pnconfig;
        $dbtype = $pnconfig['dbtype'];

    $column = $pntable['ew_filemanager_column'];

//modified for Oracle compatibility
    // Create the table
/*    $sql = "CREATE TABLE $pntable[ew_filemanager] (
            $column[uid] int(11) NOT NULL,
            $column[path] varchar(255) NOT NULL default 'slash/ended/path/to/files/',
            PRIMARY KEY(uid))";
*/
        switch ($dbtype){
                case "oci8":
                    $sql = "CREATE TABLE $pntable[ew_filemanager] (
                            pn_uid integer NOT NULL,
                                pn_path varchar2 (255) default '''slash/ended/path/to/files/''',
                                CONSTRAINT EW_FILEMANAGER_PK
                                PRIMARY KEY (pn_uid) ) ";
                        break;
                default:
                    $sql = "CREATE TABLE $pntable[ew_filemanager] (
                            $column[pn_uid] int(11) NOT NULL,
                                $column[pn_path] varchar(255) NOT NULL default 'slash/ended/path/to/files/',
                                PRIMARY KEY(pn_uid))";
                        break;
        }

    $dbconn->Execute($sql);

    // Check for an error, and if so set an appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: "
                               . $dbconn->ErrorNo().": ".$dbconn->ErrorMsg()
                               . "<br>Query:</b><br>" . $sql);
        return false;
    }

    // Set up an initial value for a module variable.
        pnModSetVar('ew_filemanager', 'wysiwygeditor', 0);
        pnModSetVar('ew_filemanager', 'maxfilesize', 100000000);
        pnModSetVar('ew_filemanager', 'hddspace', 1000000000);
        pnModSetVar('ew_filemanager', 'hiddenfiles', '.htaccess');
        pnModSetVar('ew_filemanager', 'hiddendirs', '');
        pnModSetVar('ew_filemanager', 'editextensions', 'htm,html,txt');
        pnModSetVar('ew_filemanager', 'imageextensions', 'jpg,jpeg,png,bmp,gif');
        pnModSetVar('ew_filemanager', 'pagespath', 'upload/rte/');
        pnModSetVar('ew_filemanager', 'textareawidth', 80);
        pnModSetVar('ew_filemanager', 'textareaheight', 20);

    return true;
}

function ew_filemanager_upgrade($oldversion) {
    return true;
}

function ew_filemanager_delete()
{
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

    $sql = "DROP TABLE $pntable[ew_filemanager]";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: "
                               . $dbconn->ErrorNo().": ".$dbconn->ErrorMsg()
                               . "<br>Query:</b><br>" . $sql);
        return false;
    }
    // Delete any module variables
        pnModDelVar('ew_filemanager', 'wysiwygeditor');
        pnModDelVar('ew_filemanager', 'maxfilesize');
        pnModDelVar('ew_filemanager', 'hddspace');
        pnModDelVar('ew_filemanager', 'hiddenfiles');
        pnModDelVar('ew_filemanager', 'hiddendirs');
        pnModDelVar('ew_filemanager', 'editextensions');
        pnModDelVar('ew_filemanager', 'imageextensions');
        pnModDelVar('ew_filemanager', 'pagespath');
        pnModDelVar('ew_filemanager', 'textareawidth');
        pnModDelVar('ew_filemanager', 'textareaheight');


    return true;
}
?>
