<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
/**
* postbbcode - BBCode Module for PostNuke 0.7+
*
* schup@users.sourceforge.net
* autor: Peter Schbl
* first release: 03.08.2002
*
* BBCode is based on various implementations of BBCode found on the net
* - Extra GBOOKv11 by Jeroen Vader - bbcode regex
* - XForum (http://trollix.com)    - javascript
*
*/
function postbbcode_user_main()
{
   $output = new pnHTML();

   if (!pnSecAuthAction(0, 'postbbcode::', '::', ACCESS_READ))
   {
        $output->Text(_postbbcodeNOAUTH);
        return $output->GetOutput();
   }

   $output->SetInputMode(_PNH_VERBATIMINPUT);
   $output->Text(postbbcode_user_view());
   $output->SetInputMode(_PNH_PARSEINPUT);

   return $output->GetOutput();
}

/**
* default -user view => help
*
*/
function postbbcode_user_view()
{
  if (!pnSecAuthAction(0, 'postbbcode::', '::', ACCESS_OVERVIEW))
    {
        $output->Text(_postbbcodeNOAUTH);
        return $output->GetOutput();
    }

    if (!pnModAPILoad('postbbcode', 'user'))
    {
        die('Failed to load postbbcode User API');
    }

    $output = new pnHTML();
    $output->Title("BBCodes");
    $output->TableStart();
      $output->TableRowStart();
        $output->TableColStart(1,'left');
        $output->Text(_PBC_DESCRIPTION);
        $output->TableColEnd();
      $output->TableRowEnd();
    $output->TableEnd();

    $output->LineBreak(2);

    $bbcodes = postbbcode_userapi_getall(array());

    // \todo: Help-Text
    /*
    $output->TableStart('BBCodes', array('BBCode', 'Regular Expression', 'replace'),1,null);
    $row = array();
    foreach ($bbcodes as $name => $regex_array)
    {
      $output->SetOutputMode(_PNH_RETURNOUTPUT);
      //$output->TableColStart(1,'left');
      $row[0]['content']  = "$name";
      $row[0]['align']    = 'left';
      //$output->TableColStart(2,'left');
      $row[1]['content']  = $regex_array[0];
      $row[1]['align']    = 'left';
      //$output->TableColStart(3,'left');
      $row[2]['content']  = $regex_array[1];
      $row[2]['align']    = 'left';
      $row[2]['valign']   = 'middle';

      $output->SetOutputMode(_PNH_KEEPOUTPUT);
      $output->TableAddRow($row);
    }
    $output->TableEnd();
    */

    return $output->GetOutput();
}

/**
 * default view
 */
function postbbcode_user_view_test()
{
    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing
    if (!pnSecAuthAction(0, 'postbbcode::', '::', ACCESS_OVERVIEW))
    {
        $output->Text(_postbbcodeNOAUTH);
        return $output->GetOutput();
    }

    if (!pnModAPILoad('postbbcode', 'user'))
    {
        die('Failed to load postbbcode User API');
    }
    $bbcodes = postbbcode_userapi_getall(array());

    // start output
    $output = new pnHTML();
    $output->Title("BBCodes");
    $output->TableStart();
      $output->TableRowStart();
        $output->TableColStart(1,'left');

    $output->TableStart('BBCodes', array('BBCode', 'Regular Expression', 'replace'),1,null);
    $row = array();
    //foreach ($bbcodes as $name => $regex_array)
    foreach ($bbcodes as $regex_array)
    {
      $output->SetOutputMode(_PNH_RETURNOUTPUT);
      //$output->TableColStart(1,'left');
      //$row[0]['content']  = "$name";
      //$row[0]['align']    = 'left';
      //$output->TableColStart(2,'left');
      $row[0]['content']  = $regex_array[0];
      $row[0]['align']    = 'left';
      //$output->TableColStart(3,'left');
      $row[1]['content']  = $regex_array[1];
      $row[1]['align']    = 'left';
      $row[1]['valign']   = 'middle';

      $output->SetOutputMode(_PNH_KEEPOUTPUT);
      $output->TableAddRow($row);
    }
    $output->TableEnd();

        $output->TableColEnd();
      $output->TableRowEnd();
    $output->TableEnd();

    $output->Linebreak(2);
    $output->Title("Test");

    $html = "[b]fett[/b] [i]kursiv[/i] [u]underlined[/u]";
    $html .= "[h3]h3[/h3] [s]strike[/s] [ot]ot[/ot] [img]modules/postbbcode/images/ico_edit.gif[/img]";

    $output->TableStart("Test", null, 1, null);
      $output->TableRowStart();
        $output->TableColStart(1,'left');

        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->Text(postbbcode_userapi_bbtohtml($html));
        $output->SetInputMode(_PNH_VERBATIMINPUT);

        $output->TableColEnd();
      $output->TableRowEnd();
      $output->TableRowStart();
        $output->TableColStart(1,'left');

          $output->SetInputMode(_PNH_VERBATIMINPUT);
          $output->Text(postbbcode_userapi_bbtohtml(array("bbcode" => $html)));

        $output->TableColEnd();
      $output->TableRowEnd();

    $output->TableEnd();

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(postbbcode_footer());
    $output->SetInputMode(_PNH_PARSEINPUT);


    return $output->GetOutput();
}


function postbbcode_footer()
{
    // lets get the module's information
    //$modinfo = pnModGetInfo(pnModGetIDFromName('postbbcode'));

    $footer = '<p align="center">postbbcode experiment</p>';
    return $footer;
}


?>
