<?php

// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Jaroslaw Gilewski (http://www.yagi.com.pl)
// Purpose of file: Display subjects manu block
// ----------------------------------------------------------------------



/**

 * initialise block

 */

function subjects_subjectsblockblock_init()

{

    // Security

	pnSecAddSchema('subjects:subjectsblock:', 'Block title::');

}



/**

 * get information on block

 */

function subjects_subjectsblockblock_info()

{

    // Values

    return array('text_type' => 'subjectsblock',

                 'module' => 'subjects',

                 'text_type_long' => 'Subjects Menu',

                 'allow_multiple' => true,

                 'form_content' => false,

                 'form_refresh' => false,

                 'show_preview' => false);

}



function subjects_subjectsblockblock_display($blockinfo)

{
	global $pnconfig;
	$dbtype = $pnconfig['dbtype'];

    if (!pnSecAuthAction(0, 'subjects:subjectsblock:', "$blockinfo[title]::", ACCESS_READ)) return;

    if (!pnModAPILoad('subjects', 'user')) return;



	$currentlang = pnUserGetLang();

    $vars = pnBlockVarsFromContent($blockinfo['content']);



    $pagesamount = $vars['pagesamount'];

    $pagesdesc = $vars['pagesdesc'];

    $pagesshort = $vars['pagesshort'];

    $reviewsamount = $vars['reviewsamount'];



	if (empty($pagesamount)) $pagesamount = 0;

	if (empty($reviewsamount)) $reviewsamount = 0;



	$content="";

    $colwidth = 50;

	$first_br="";

    

	pnModDBInfoLoad('subjects'); 

	list($dbconn) = pnDBGetConn();

	$pntable = pnDBGetTables();



    $column = $pntable['subjects_column'];

    $column2 = $pntable['subcategories_column'];



    if (pnConfigGetVar('multilingual') == 1) 
//modified for Oracle compatibility
		$querylang = "AND ($column[sublanguage]='$currentlang' OR $column[sublanguage]='' OR $column[sublanguage] IS NULL)"; 
    else 

        $querylang = "";
//modified for Oracle compatibility
	switch ($dbtype){
		case "oci8":
			$sql="SELECT $column[subid], $column2[catid], 
                              $column2[catname], $column[subname]
                              FROM $pntable[subjects], $pntable[subcategories]
                              WHERE $column[catid]=$column2[catid](+)
                              AND $column[subactive] = 1 $querylang 
	                        ORDER BY nvl($column2[catorder],0), $column[suborder]";
			break;
		default:
	$sql="SELECT $column[subid], $column2[catid], 

                              $column2[catname], $column[subname]

                              FROM $pntable[subjects] 

                              LEFT JOIN $pntable[subcategories]

                              ON $column[catid]=$column2[catid]

                              WHERE $column[subactive] = 1 $querylang 

							  ORDER BY $column2[catorder], $column[suborder]";
			break;
	}
    $result = $dbconn->Execute($sql);	

	if($dbconn->ErrorNo() != 0) return;

                              

    $content .= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>";

    $content .= "<td valign=\"top\">";

    if ( (!$result->EOF) &&

		 ($vars['subjectslast'] > 0) ) {

        $currcatid = 0;
//modified for Oracle compatibility
//		while(list($subid, $catid, $catname, $subname) = $result->fields) {
		while(!$result->EOF){
			list($subid, $catid, $catname, $subname) = $result->fields;
            $now = date("Y-m-d H:i:00");

			$last = date ("Y-m-d 00:00:00", mktime (0,0,0,date("m"),date("d")-$vars['subjectslast'],date("Y")));



            $column = &$pntable['subpages_column'];

            $result2 = $dbconn->Execute("SELECT COUNT(*)

                                       FROM $pntable[subpages] 

                                       WHERE $column[subid]=$subid 

									   AND $column[parentpageid]=0 

									   AND $column[pagedatetime] < '$now'

									   AND $column[pagedatetime] >= '$last' ");

            list($pagesattached) = $result2->fields;							   

            $result2->Close();

            if ( ($currcatid != $catid) &&

				 ($pagesattached > 0) ) {

				

				if(strlen($catname) > $vars['subjectsdesc']) 

					$ptitle = substr(strip_tags($catname),0,$vars['subjectsshort'])."&hellip;";

				else $ptitle=strip_tags($catname);



                $content .= $first_br."<a title=\"". ereg_replace('"', "'", $catname)."\" href=\""

					.pnModURL('subjects','user','listcat', array('catid'=>"$catid"))

					."\"><b>".$ptitle."</b></a><br>";

				$first_br="<br>";

                $currcatid = $catid;

            }

      

			if (	(pnModAPIFunc('subjects', 'user','auth', 

						array('perm'=>ACCESS_READ, 'catid'=>$catid, 'subid'=>$subid))) &&

					($pagesattached > 0) ) {

				if(strlen($subname) > $vars['subjectsdesc']) 

					$ptitle = substr(strip_tags($subname),0,$vars['subjectsshort'])."&hellip;";

				else $ptitle=strip_tags($subname);



                $content .= "<img src=\"modules/subjects/pnimages/subject.gif\" align=\"absmiddle\" "

				. "border=\"0\">&nbsp;<a title=\"". ereg_replace('"', "'", $subname)."\" href=\""

				. pnModURL('subjects','user','listpages', array('subid'=>"$subid"))

				."\">".$ptitle."</a>\n";



                $now = date("Y-m-d H:i:00");

				$last = date ("Y-m-d 00:00:00", mktime (0,0,0,date("m"),date("d")-$vars['subjectslast'],date("Y")));



                $column = &$pntable['subpages_column'];

                $result2 = $dbconn->SelectLimit("SELECT $column[pagedatetime]

                                          FROM $pntable[subpages]

                                          WHERE $column[subid] = $subid AND 

                                          $column[pageactive] = 1 AND $column[parentpageid] = 0 AND

                                          $column[pagedatetime] < '$now' AND

										  $column[pagedatetime] >= '$last' 

                                          ORDER BY $column[pagedatetime] DESC", 1);



                if(!$result2->EOF){

                    list($datetime)=$result2->fields;

                    setlocale (LC_TIME, pnConfigGetVar('locale'));

                    ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $datetime, $dt);

                    $dt = ml_ftime(""._LINKSDATESTRING."", mktime($dt[4],$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));

                    $dt = ucfirst($dt);

                    $startdate = time();

                    $count = 0;

                    while ($count <= 7) {

                        $daysold = ml_ftime(""._LINKSDATESTRING."", $startdate);

                        if ("$daysold" == "$dt") {

                            if ($count<=1)

                                $content .= "<img src=\"modules/subjects/pnimages/new_1.gif\" align=\"absmiddle\" alt=\""._NEWTODAY."\">&nbsp;";

                            if ($count<=3 && $count>1)

                                $content .= "<img src=\"modules/subjects/pnimages/new_3.gif\" align=\"absmiddle\" alt=\""._NEWLAST3DAYS."\">&nbsp;";

                            if ($count<=7 && $count>3)

                                $content .= "<img src=\"modules/subjects/pnimages/new_7.gif\" align=\"absmiddle\" alt=\""._NEWTHISWEEK."\">&nbsp;";

                        }

                        $count++;

                        $startdate = (time()-(86400 * $count));

                    }

                }

                $result2->Close();

                $content .= "<br>"; 

            }

            $result->MoveNext();

        }

	} 

    $result->Close();

    $content .= "</td>";



    if($pagesamount > 0){

        if($blockinfo['position'] != 'c')

            $content .= "</tr><tr><td>&nbsp;</TD></tr><tr>";

        $content .= "<td valign=\"top\">";

        $now = date("Y-m-d H:i:00");

        $column = &$pntable['subjects_column'];

        $column2 = &$pntable['subpages_column'];

        $result = $dbconn->SelectLimit("SELECT $column[subid], $column[subname], 

                                  $column2[pageid], $column2[pagetitle],

                                  $column2[pagetext], $column2[pagedatetime], 

                                  $column2[pagecounter], $column[catid]

                                  FROM $pntable[subjects], $pntable[subpages] 

                                  WHERE $column[subid] = $column2[subid] AND

                                  $column[subactive] = 1 $querylang AND

                                  $column2[pageactive] = 1 AND $column2[parentpageid] = 0 AND

                                  $column2[pagedatetime] < '$now' 

    							  ORDER BY $column2[pagedatetime] DESC", $pagesamount);

        if (!$result->EOF) {

            $content .= "<b>$pagesamount "._SB_LASTSUBPAGES."</B><br>";
//modified for Oracle compatibility
//			while(list($subid, $subname, $pageid, $pagetitle, $pagetext, $pagedatetime, $pagecounter, $catid) = $result->fields) {
			while(!$result->EOF){
				list($subid, $subname, $pageid, $pagetitle, $pagetext, $pagedatetime, $pagecounter, $catid) = $result->fields;
				if (pnModAPIFunc('subjects', 'user','auth', 

						array('perm'=>ACCESS_READ, 'catid'=>$catid, 'subid'=>$subid, 'pageid'=>$pageid)))  {

                    setlocale (LC_TIME, pnConfigGetVar('locale'));

                    ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $pagedatetime, $datetime);

                    $datetime = ml_ftime(_DATEBRIEF, (GetUserTime(mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]))));

                    $datetime = ucfirst($datetime);

                    if(strlen($pagetitle) > $pagesdesc) 

						 $ptitle = substr(strip_tags($pagetitle),0,$pagesshort)."&hellip;";

                    else $ptitle=strip_tags($pagetitle);

		

					$descr= ereg_replace('"', "'", 		

									 $pagetitle."\n\n"

									.$subname."\n"

									."(".$datetime."     "

									._SB_SUBPAGESVISITS.":".$pagecounter.")");



                    $content .= "<img src=\"modules/subjects/pnimages/subpage.gif\" align=\"absmiddle\" border=\"0\">&nbsp;<a title=\"".$descr."\" href=\""

						. pnModURL('subjects','user','viewpage', array('pageid'=>"$pageid"))

						. "\">".$ptitle."</a><br>";

                }

                $result->MoveNext();

            }

        }	

        $result->Close();

        $content .= "</td>";

    }



    if($reviewsamount > 0){

        if($blockinfo['position'] != 'c')

            $content .= "</tr><tr><td>&nbsp;</TD></tr><tr>";

        $content .= "<td valign=\"top\">";

        $now = date("Y-m-d H:i:00");

        $column = &$pntable['subreviews_column'];

        $column2 = &$pntable['subpages_column'];

        $column3 = &$pntable['subjects_column'];

        if (pnConfigGetVar('multilingual') == 1) {
//modified for Oracle compatibility
			$querylang = "AND ($column3[sublanguage]='$currentlang' OR $column3[sublanguage]='' OR $column3[sublanguage] IS NULL)"; 
        } else 

            $querylang = "";

        $result = $dbconn->SelectLimit("SELECT $column[reviewid], $column[reviewtitle], $column[reviewuser], 

                           $column[reviewdatetime], $column[reviewscore],

                           $column2[pageid], $column2[pagetitle],

                           $column3[subid], $column3[subname]

                           FROM $pntable[subreviews], $pntable[subpages], $pntable[subjects] 

                           WHERE $column[pageid] = $column2[pageid] AND

                                 $column2[subid] = $column3[subid] AND

                                 $column2[pageactive] = 1 AND $column2[parentpageid] = 0 AND

                                 $column3[subactive] = 1 $querylang AND

                                 $column[reviewdatetime] < '$now' 

    						  ORDER BY $column[reviewdatetime] DESC", $reviewsamount);

        if (!$result->EOF) {

            $content .= "<b>$reviewsamount "._SB_LASTREVIEWS."</B><br>";
//modified for Oracle compatibility
//			while(list($reviewid, $reviewtitle, $reviewuser, $reviewdatetime, $reviewscore,                       $pageid, $pagetitle, $subid, $subname) = $result->fields) {
			while(!$result->EOF){
				list($reviewid, $reviewtitle, $reviewuser, $reviewdatetime, $reviewscore,
                       $pageid, $pagetitle, $subid, $subname) = $result->fields;
                if (pnSecAuthAction(0, 'subjects::subject', "$subname::$subid", ACCESS_READ) &&

                    pnSecAuthAction(0, 'subjects::page', "$pagetitle:$subname:$pageid", ACCESS_READ)) {

                    setlocale (LC_TIME, pnConfigGetVar('locale'));

                    ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $reviewdatetime, $datetime);

                    $datetime = ml_ftime(_DATEBRIEF, (GetUserTime(mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]))));

                    $datetime = ucfirst($datetime);



					if(strlen($reviewtitle) > $pagesdesc) 

						 $ptitle = substr(strip_tags($reviewtitle),0,$pagesshort)."&hellip;";

                    else $ptitle=strip_tags($reviewtitle);

		

					$descr= ereg_replace('"', "'", 		

									 $reviewtitle."\n\n"

									.$subname." -> ".$pagetitle."\n"

									."(".$datetime."     "

									._SB_REVIEWSCORE.":".$reviewscore.")");



                    $content .= "<img src=\"modules/subjects/pnimages/review.gif\" align=\"absmiddle\" border=\"0\">&nbsp;<a title=\"".$descr."\" href=\""

						. pnModURL('subjects','user','pagereview', array('pageid'=>"$pageid"))

						. "\">".$ptitle."</a><br>";

                }

                $result->MoveNext();

            }

        }	

        $result->Close();

        $content .= "</td>";

    }

	

	$content .= "</tr></table>";



//Start Subjects Waiting Content

	if ( (pnModAPIFunc('subjects', 'user','auth', array('perm'=>ACCESS_ADD))) &&

		 ($vars['waitingcont']==1) ) { 



		$subpages_tbl = $pntable['subpages'];

		$subpages_tbl_col = &$pntable['subpages_column'];

		$sql="SELECT $subpages_tbl_col[subid], count(1) 

				FROM $subpages_tbl

				WHERE $subpages_tbl_col[pageactive]=0

				GROUP BY $subpages_tbl_col[subid]";



		$html_string = "";

		$result = $dbconn->Execute($sql); 

		if ($dbconn->ErrorNo() == 0) {

//modified for Oracle compatibility
//			for (; !$result->EOF; $result->MoveNext()) {
			while(!$result->EOF){
				list($subid, $count) = $result->fields;



				$subjects_tbl = $pntable['subjects'];

				$subjects_tbl_col = &$pntable['subjects_column'];



				$sql2="SELECT $subjects_tbl_col[subname], $subjects_tbl_col[subtext]

						FROM $subjects_tbl

						WHERE $subjects_tbl_col[subid]=$subid";

				$result2 = $dbconn->Execute($sql2);



				if ($dbconn->ErrorNo() == 0) {

					list($subname, $subtext) = $result2->fields;

					$html_string.="<br><strong><big>&middot;</big></strong>&nbsp;"

						. "<a title=\"".ereg_replace('"', "'",$subtext)."\" href=\""

						. pnModURL('subjects','admin','pagesadmin', array('subid'=>"$subid"))

						. "\">" . $subname . "</a>:&nbsp;".$count;

				}

				$result2->Close(); 
				$result->MoveNext();
			}

			$result->Close(); 

			

			if (!empty($html_string)) {

				$content .= "<br><span class=\"pn-title\"><b>" . _SB_WAITINGCONT. "</b></span>" . $html_string . "</td>";

			}

		}

	}

//End Subjects Waiting Content





	$blockinfo['content'] = $content;

    return themesideblock($blockinfo);

}



function subjects_subjectsblockblock_modify($blockinfo)

{

    // Get current content

    $vars = pnBlockVarsFromContent($blockinfo['content']);

	if (!isset($vars['pagesamount'])) $vars['pagesamount'] = 5;

	if (empty($vars['pagesdesc'])) $vars['pagesdesc'] = 20;

	if (empty($vars['pagesshort'])) $vars['pagesshort'] = 18;

	if (!isset($vars['reviewsamount'])) $vars['reviewsamount'] = 5;

    if (!isset($vars['subjectslast'])) $vars['subjectslast'] = 10000;

    if (empty($vars['subjectsdesc'])) $vars['subjectsdesc'] = 50;

    if (empty($vars['subjectsshort'])) $vars['subjectsshort'] = 35;

    if (!isset($vars['waitingcont'])) $vars['waitingcont'] = 1;



	if ($vars['waitingcont']==1) $waitingcont_checked=" checked";

	else $waitingcont_checked="";



	$content = ""

		. "<tr><td colspan=\"2\"><br></td></tr>"



		. "<tr>"

			. "<td>"

				. _SB_SHOWSUBJECTSLAST

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"subjectslast\" size=\"3\" maxlength=\"6\" "

					. "value=\"".$vars['subjectslast']."\" class=\"pn-normal\"> "

				. _SB_SHOWSUBJECTSLASTDAYS

			. "</td>"

		. "</tr>"



		. "<tr>"

			. "<td align=\"right\">"

				. _SB_IFSUBJLONGER . " "

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"subjectsdesc\" size=\"3\" maxlength=\"255\" "

					. "value=\"".$vars['subjectsdesc']."\"class=\"pn-normal\"> "._SB_CHARACTER." "

			. "</td>"

		. "</tr>"

		

		. "<tr>"

			. "<td align=\"right\">"

				. _SB_SHORTENTO . " "

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"subjectsshort\" size=\"3\" maxlength=\"255\" "

					. "value=\"".$vars['subjectsshort']."\" class=\"pn-normal\"> "._SB_CHARACTER

			. "</td>"

		. "</tr>"



		. "<tr><td colspan=\"2\"><br></td></tr>"

	

		. "<tr>"

			. "<td>"

				. _SB_SUBPAGESAMOUNT

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"pagesamount\" size=\"3\" maxlength=\"3\" "

					. "value=\"".$vars['pagesamount']."\" class=\"pn-normal\">"

			. "</td>"

		. "</tr>"

	

		. "<tr>"

			. "<td>"

				._SB_REVIEWSAMOUNT

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"reviewsamount\" size=\"3\" maxlength=\"3\" "

					. "value=\"".$vars['reviewsamount']."\" class=\"pn-normal\">"

			. "</td>"

		. "</tr>"



		. "<tr>"

			. "<td align=\"right\">"

				. _SB_IFLONGER . " "

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"pagesdesc\" size=\"3\" maxlength=\"255\" "

					. "value=\"".$vars['pagesdesc']."\"class=\"pn-normal\"> "._SB_CHARACTER." "

			. "</td>"

		. "</tr>"

		

		. "<tr>"

			. "<td align=\"right\">"

				. _SB_SHORTENTO . " "

			. "</td>"

			. "<td>"

				. "<input type=\"text\" name=\"pagesshort\" size=\"3\" maxlength=\"255\" "

					. "value=\"".$vars['pagesshort']."\" class=\"pn-normal\"> "._SB_CHARACTER

			. "</td>"

		. "</tr>"

		

		. "<tr><td colspan=\"2\"><br></td></tr>"



		. "<tr>"

			. "<td>"

				. _SB_SHOWWAITINGCONT

			. "</td>"

			. "<td>"

				. "<input type=\"checkbox\" name=\"waitingcont\" " . $waitingcont_checked . " value=\"1\">"

			. "</td>"

		. "</tr>"

		

		. "<tr><td colspan=\"2\"><br></td></tr>\n";



	// Return output

    $output = new pnHTML();

	$output->SetInputMode(_PNH_VERBATIMINPUT);

	$output->Text($content);

    return $output->GetOutput();



}





function subjects_subjectsblockblock_update($blockinfo)

{   

    $vars['pagesamount'] = pnVarCleanFromInput('pagesamount');

    $vars['pagesdesc'] = pnVarCleanFromInput('pagesdesc');

    $vars['pagesshort'] = pnVarCleanFromInput('pagesshort');

    $vars['reviewsamount'] = pnVarCleanFromInput('reviewsamount');

    $vars['subjectslast'] = pnVarCleanFromInput('subjectslast');

    $vars['subjectsdesc'] = pnVarCleanFromInput('subjectsdesc');

    $vars['subjectsshort'] = pnVarCleanFromInput('subjectsshort');

    $vars['waitingcont'] = pnVarCleanFromInput('waitingcont');



	if ($vars['waitingcont']!=1) $vars['waitingcont']=0;

	

	$blockinfo['content'] = pnBlockVarsToContent($vars);



	return $blockinfo;

}

?>
