<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// http://www.maxdev.com/
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Filename: modules/subjects/pninit.php
// Original Author of file: EasyWeb Team (EWT)
// Support:        Russian - http://www.postnuke.ru
//                        English - http://home.postnuke.ru
//       Polish - http://www.yagi.com.pl
// Purpose of file:  Initialisation functions for subjects module
// ----------------------------------------------------------------------

// initialise the subjects module
function subjects_init()
{
    global $pnconfig;
	$dbtype = $pnconfig['dbtype'];

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Create subjects table
        $subjectstable = $pntable['subjects'];
    $subjectscolumn = &$pntable['subjects_column'];

	switch ($dbtype){
		case "oci8":
			$sql1 = " CREATE TABLE $subjectstable ( ".
				substr_replace($subjectscolumn[subid],'',0,strlen($subjectstable)+1)." INTEGER NOT NULL,".
				substr_replace($subjectscolumn[catid],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[subname],'',0,strlen($subjectstable)+1)." VARCHAR2 (50) DEFAULT '', ".
				substr_replace($subjectscolumn[subtext],'',0,strlen($subjectstable)+1)." CLOB  NOT NULL, ".
				substr_replace($subjectscolumn[subimage],'',0,strlen($subjectstable)+1)." VARCHAR2 (255) DEFAULT '', ".
				substr_replace($subjectscolumn[subactive],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[suborder],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[subcounter],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[keywords],'',0,strlen($subjectstable)+1)." VARCHAR2 (255) DEFAULT '', ".
				substr_replace($subjectscolumn[sublanguage],'',0,strlen($subjectstable)+1)." VARCHAR2 (30)  DEFAULT '' ,
  			    CONSTRAINT SUBJECTS_PK
				PRIMARY KEY ( SUBID ) )"; 

			$dbconn->Execute($sql1);
			if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql1);
                return false;
			}
			
			$sql2='CREATE SEQUENCE SUBJECTS_SQ INCREMENT BY 1 START WITH 1 NOCYCLE CACHE 20 NOORDER';
			$dbconn->Execute($sql2);

			$sql3="CREATE OR REPLACE TRIGGER subjects_tr BEFORE INSERT ON $subjectstable FOR EACH ROW WHEN  (NEW.subid IS NULL OR NEW.subid = 0) BEGIN  SELECT subjects_sq.NEXTVAL INTO :NEW.subid FROM dual; END; ";
			$dbconn->Execute($sql3);

			break;
		default:
    $sql = "CREATE TABLE $subjectstable (
                        $subjectscolumn[subid] int(11) NOT NULL auto_increment,
                        $subjectscolumn[catid] int(11) NOT NULL default '0',
                        $subjectscolumn[subname] varchar(50) NOT NULL,
                        $subjectscolumn[subtext] text NOT NULL default '',
                        $subjectscolumn[subimage] varchar(255) NOT NULL default '',
                        $subjectscolumn[subactive] int(1) NOT NULL default '0',
                        $subjectscolumn[suborder] int(3) NOT NULL default '0',
                        $subjectscolumn[subcounter] int(11) NOT NULL default '0',
                        $subjectscolumn[keywords] varchar(255) NOT NULL default '',
                        $subjectscolumn[sublanguage] varchar(30) NOT NULL default '',
                        PRIMARY KEY  (subid))";

        $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
    }
			break;
	}

        // Create subpages table
        $subjectstable = $pntable['subpages'];
    $subjectscolumn = &$pntable['subpages_column'];

	switch ($dbtype){
		case "oci8":
			$sql1 = " CREATE TABLE $subjectstable ( ".
				substr_replace($subjectscolumn[pageid],'',0,strlen($subjectstable)+1)." INTEGER NOT NULL,".
				substr_replace($subjectscolumn[subid],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[parentpageid],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[pagetitle],'',0,strlen($subjectstable)+1)." VARCHAR2 (100)  DEFAULT '', ".
				substr_replace($subjectscolumn[pagetext],'',0,strlen($subjectstable)+1)." CLOB NOT NULL, ".
				substr_replace($subjectscolumn[pagecontent],'',0,strlen($subjectstable)+1)." CLOB NOT NULL, ".
				substr_replace($subjectscolumn[pagefile],'',0,strlen($subjectstable)+1)." VARCHAR2 (255) DEFAULT '', ".
				substr_replace($subjectscolumn[pageimage],'',0,strlen($subjectstable)+1)." VARCHAR2 (255) DEFAULT '', ".
				substr_replace($subjectscolumn[pageauthor],'',0,strlen($subjectstable)+1)." VARCHAR2 (50) DEFAULT '', ".
				substr_replace($subjectscolumn[pageauthoremail],'',0,strlen($subjectstable)+1)." VARCHAR2 (50) DEFAULT '', ".
				substr_replace($subjectscolumn[pageauthorurl],'',0,strlen($subjectstable)+1)." VARCHAR2 (100) DEFAULT '', ".
				substr_replace($subjectscolumn[pageactive],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[pageorder],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[pagedatetime],'',0,strlen($subjectstable)+1)." DATE DEFAULT '0001-01-01 00:00:00', ".
				substr_replace($subjectscolumn[pagecounter],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[reviewscount],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[reviewsscore],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[reviewactive],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0', ".
				substr_replace($subjectscolumn[keywords],'',0,strlen($subjectstable)+1)." VARCHAR2 (255)  DEFAULT '', ".
				substr_replace($subjectscolumn[username],'',0,strlen($subjectstable)+1)." VARCHAR2 (255)  DEFAULT '', 
			    CONSTRAINT SUBPAGES_PK
			    PRIMARY KEY ( PAGEID ) )"; 
			$dbconn->Execute($sql1);
			if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql1);
                return false;
			}

			$sql2='CREATE SEQUENCE SUBPAGES_SQ INCREMENT BY 1 START WITH 1 NOCYCLE CACHE 20 NOORDER';
			$dbconn->Execute($sql2);
			
			$sql3="CREATE OR REPLACE TRIGGER subpages_tr BEFORE INSERT ON $subjectstable FOR EACH ROW WHEN (NEW.pageid IS NULL OR NEW.pageid = 0) BEGIN    SELECT subpages_sq.NEXTVAL INTO :NEW.pageid FROM dual; END; ";
			$dbconn->Execute($sql3);
			
			$sql4="CREATE INDEX SUBPAGES_1_idx ON $subjectscolumn[pagecontent] indextype IS  ctxsys.context";
			$dbconn->Execute($sql4);

			$sql5="CREATE INDEX SUBPAGES_2_idx ON $subjectscolumn[pagetext] indextype IS  ctxsys.context";
			$dbconn->Execute($sql5);

			break;
		default:
    $sql = "CREATE TABLE $subjectstable (
                        $subjectscolumn[pageid] int(11) NOT NULL auto_increment,
                        $subjectscolumn[subid] int(11) NOT NULL default '0',
                        $subjectscolumn[parentpageid] int(11) NOT NULL default '0',
                        $subjectscolumn[pagetitle] varchar(100) NOT NULL,
                        $subjectscolumn[pagetext] text NOT NULL default '',
                        $subjectscolumn[pagecontent] mediumtext NOT NULL default '',
                        $subjectscolumn[pagefile] varchar(255) NOT NULL default '',
                        $subjectscolumn[pageimage] varchar(255) NOT NULL default '',
                        $subjectscolumn[pageauthor] varchar(50) NOT NULL default '',
                        $subjectscolumn[pageauthoremail] varchar(50) NOT NULL default '',
                        $subjectscolumn[pageauthorurl] varchar(100) NOT NULL default '',
                        $subjectscolumn[pageactive] int(1) NOT NULL default '0',
                        $subjectscolumn[pageorder] int(3) default '0',
                        $subjectscolumn[pagedatetime] datetime NOT NULL default '0000-00-00 00:00:00',
                        $subjectscolumn[pagecounter] int(11) NOT NULL default '0',
                        $subjectscolumn[reviewscount] int(4) NOT NULL default '0',
                        $subjectscolumn[reviewsscore] int(5) NOT NULL default '0',
                        $subjectscolumn[reviewactive] int(1) NOT NULL default '0',
                        $subjectscolumn[keywords] varchar(255) NOT NULL default '',
                        $subjectscolumn[username] varchar(255) NOT NULL default '',
                        PRIMARY KEY  (pageid))";

        $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
        return false;
    }
			break;
	}

        // Create subreviews table
        $subjectstable = $pntable['subreviews'];
    $subjectscolumn = &$pntable['subreviews_column'];
	switch ($dbtype){
		case "oci8":
			$sql1 = "CREATE TABLE $subjectstable ( ".
				substr_replace($subjectscolumn[reviewid],'',0,strlen($subjectstable)+1)." INTEGER NOT NULL,".		
				substr_replace($subjectscolumn[pageid],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0',".		
				substr_replace($subjectscolumn[reviewtitle],'',0,strlen($subjectstable)+1)." VARCHAR2 (50)  DEFAULT '',".
				substr_replace($subjectscolumn[reviewcomments],'',0,strlen($subjectstable)+1)." CLOB NOT NULL,".		
				substr_replace($subjectscolumn[reviewscore],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0',".		
				substr_replace($subjectscolumn[reviewuser],'',0,strlen($subjectstable)+1)." VARCHAR2 (25) DEFAULT '',".	
				substr_replace($subjectscolumn[reviewhostip],'',0,strlen($subjectstable)+1)." VARCHAR2 (15) DEFAULT '',".
				substr_replace($subjectscolumn[reviewdatetime],'',0,strlen($subjectstable)+1)." DATE DEFAULT '0001-01-01 00:00:00',
				  CONSTRAINT SUBREVIEWS_PK
				  PRIMARY KEY ( REVIEWID ) )"; 
			$dbconn->Execute($sql1);
			if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql1);
                return false;
			}

			$sql2='CREATE SEQUENCE SUBREVIEWS_SQ INCREMENT BY 1 START WITH 1 NOCYCLE CACHE 20 NOORDER';
			$dbconn->Execute($sql2);

			$sql3="CREATE OR REPLACE TRIGGER subreviews_tr BEFORE INSERT ON $subjectstable FOR EACH ROW WHEN (NEW.reviewid IS NULL OR NEW.reviewid = 0) BEGIN SELECT subreviews_sq.NEXTVAL INTO :NEW.reviewid FROM dual; END; ";
			$dbconn->Execute($sql3);
			break;
		default:
    $sql = "CREATE TABLE $subjectstable (
                        $subjectscolumn[reviewid] int(11) NOT NULL auto_increment,
                        $subjectscolumn[pageid] int(11) NOT NULL default '0',
                        $subjectscolumn[reviewtitle] varchar(50) NOT NULL,
                        $subjectscolumn[reviewcomments] text NOT NULL default '',
                        $subjectscolumn[reviewscore] int(1) NOT NULL default '0',
                        $subjectscolumn[reviewuser] varchar(25) NOT NULL default '',
                        $subjectscolumn[reviewhostip] varchar(15) NOT NULL default '',
                        $subjectscolumn[reviewdatetime] datetime NOT NULL default '0000-00-00 00:00:00',
                        PRIMARY KEY  (reviewid))";

        $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
    }
			break;
	}

        // Create subcategories table
        $subjectstable = $pntable['subcategories'];
    $subjectscolumn = &$pntable['subcategories_column'];
	switch ($dbtype){
		case "oci8":
			$sql1 = "CREATE TABLE $subjectstable ( ".
				substr_replace($subjectscolumn[catid],'',0,strlen($subjectstable)+1)." INTEGER NOT NULL,".
				substr_replace($subjectscolumn[catname],'',0,strlen($subjectstable)+1)." VARCHAR2 (50) DEFAULT '',".
				substr_replace($subjectscolumn[cattext],'',0,strlen($subjectstable)+1)." CLOB NOT NULL,".
				substr_replace($subjectscolumn[keywords],'',0,strlen($subjectstable)+1)." VARCHAR2 (255) DEFAULT '',".
				substr_replace($subjectscolumn[catorder],'',0,strlen($subjectstable)+1)." INTEGER DEFAULT '0',
				  CONSTRAINT SUBCATEGORIES_PK
				  PRIMARY KEY ( CATID ) )"; 
			$dbconn->Execute($sql1);
			if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql1);
                return false;
			}

			$sql2='CREATE SEQUENCE SUBCATEGORIES_SQ INCREMENT BY 1 START WITH 1 NOCYCLE CACHE 20 NOORDER';
			$dbconn->Execute($sql2);

			$sql3="CREATE OR REPLACE TRIGGER subcategories_tr BEFORE INSERT ON $subjectstable FOR EACH ROW WHEN (NEW.catid IS NULL OR NEW.catid = 0) BEGIN SELECT subcategories_sq.NEXTVAL INTO :NEW.catid FROM dual; END; ";
			$dbconn->Execute($sql3);
			break;
		default:
    $sql = "CREATE TABLE $subjectstable (
                        $subjectscolumn[catid] int(11) NOT NULL auto_increment,
                        $subjectscolumn[catname] varchar(50) NOT NULL,
                        $subjectscolumn[cattext] text NOT NULL default '',
                        $subjectscolumn[keywords] varchar(255) NOT NULL default '',
                        $subjectscolumn[catorder] int(3) NOT NULL default '0',
                        PRIMARY KEY  (catid))";

        $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
    return false;
    }
			break;
	}

    // Set up an initial value for a module variable.
        pnModSetVar('subjects', 'wysiwygeditor', 0);
        pnModSetVar('subjects', 'pagesperlistview', 10);
        pnModSetVar('subjects', 'sortbypanel', 1);
        pnModSetVar('subjects', 'textareawidth', 96);
        pnModSetVar('subjects', 'textareaheight', 20);
        pnModSetVar('subjects', 'pagespath', 'upload/sub');
	pnModSetVar('subjects','showReturnFooter',1);
    return true;
}

// upgrade the subjects module from an old version
function subjects_upgrade($oldversion)
{
    // Upgrade dependent on old version number
    switch($oldversion) {
        case "1.0b":

                        list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

                        // Create subreviews table
                        $subjectstable = $pntable['subreviews'];
                    $subjectscolumn = &$pntable['subreviews_column'];
                    $sql = "CREATE TABLE $subjectstable (
                                        $subjectscolumn[reviewid] int(11) NOT NULL auto_increment,
                                        $subjectscolumn[pageid] int(11) NOT NULL default '0',
                                        $subjectscolumn[reviewtitle] varchar(50) NOT NULL,
                                        $subjectscolumn[reviewcomments] text NOT NULL default '',
                                        $subjectscolumn[reviewscore] int(1) NOT NULL default '0',
                                        $subjectscolumn[reviewuser] varchar(25) NOT NULL default '',
                                        $subjectscolumn[reviewhostip] varchar(15) NOT NULL default '',
                                        $subjectscolumn[reviewdatetime] datetime NOT NULL default '0000-00-00 00:00:00',
                                        PRIMARY KEY  (reviewid))";
                        $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                        return false;
                    }

                        // Create _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                    $sql = "CREATE TABLE $subjectstable (
                                        $subjectscolumn[catid] int(11) NOT NULL auto_increment,
                                        $subjectscolumn[catname] varchar(50) NOT NULL,
                                        $subjectscolumn[cattext] text NOT NULL default '',
                                        $subjectscolumn[catorder] int(3) NOT NULL default '0',
                                        PRIMARY KEY  (catid))";
                        $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                        return false;
                    }

                        // Add coloumns to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[reviewscount] int(4) NOT NULL default '0'";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[reviewsscore] int(5) NOT NULL default '0'";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[reviewactive] int(1) NOT NULL default '0'";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[pageimage] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[username] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add coloumns to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[catid] int(11) NOT NULL default '0'";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    CHANGE $subjectscolumn[subimage] $subjectscolumn[subimage] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add KEYWORDS to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                    // Set up an initial value for a module variable.
        pnModSetVar('subjects', 'wysiwygeditor', 0);
        pnModSetVar('subjects', 'pagesperlistview', 10);
        pnModSetVar('subjects', 'sortbypanel', 1);
        pnModSetVar('subjects', 'textareawidth', 96);
        pnModSetVar('subjects', 'textareaheight', 20);
         pnModSetVar('subjects', 'pagespath', 'upload/sub');

                        break;
        case "1.2":

                        list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

                        // Create _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];

                    $sql = "CREATE TABLE $subjectstable (
                                        $subjectscolumn[catid] int(11) NOT NULL auto_increment,
                                        $subjectscolumn[catname] varchar(50) NOT NULL,
                                        $subjectscolumn[cattext] text NOT NULL default '',
                                        $subjectscolumn[catorder] int(3) NOT NULL default '0',
                                        PRIMARY KEY  (catid))";
                        $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                        return false;
                    }

                        // Add coloumns to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[catid] int(11) NOT NULL default '0'";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    CHANGE $subjectscolumn[subimage] $subjectscolumn[subimage] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add coloumns to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[pageimage] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[username] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add KEYWORDS to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Set up an initial value for a module variable.
        pnModSetVar('subjects', 'wysiwygeditor', 0);
        pnModSetVar('subjects', 'pagesperlistview', 10);
        pnModSetVar('subjects', 'sortbypanel', 1);
        pnModSetVar('subjects', 'textareawidth', 96);
        pnModSetVar('subjects', 'textareaheight', 20);
         pnModSetVar('subjects', 'pagespath', 'upload/sub');

                        break;
        case "1.3":

                        list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

                        // Create _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];

                    $sql = "CREATE TABLE $subjectstable (
                                        $subjectscolumn[catid] int(11) NOT NULL auto_increment,
                                        $subjectscolumn[catname] varchar(50) NOT NULL,
                                        $subjectscolumn[cattext] text NOT NULL default '',
                                        $subjectscolumn[catorder] int(3) NOT NULL default '0',
                                        PRIMARY KEY  (catid))";
                        $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                        return false;
                    }

                        // Add coloumns to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[catid] int(11) NOT NULL default '0'";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    CHANGE $subjectscolumn[subimage] $subjectscolumn[subimage] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add coloumns to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[pageimage] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[username] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add KEYWORDS to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Set up an initial value for a module variable.
        pnModSetVar('subjects', 'wysiwygeditor', 0);
        pnModSetVar('subjects', 'pagesperlistview', 10);
        pnModSetVar('subjects', 'sortbypanel', 1);
        pnModSetVar('subjects', 'textareawidth', 96);
        pnModSetVar('subjects', 'textareaheight', 20);
        pnModSetVar('subjects', 'pagespath', 'upload/sub');
	pnModSetVar('subjects','showReturnFooter',1);
	
                        break;
        case "1.4":
                        list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

                        // Add coloumn to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[username] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add KEYWORDS to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Set up an initial value for a module variable.
        pnModSetVar('subjects', 'wysiwygeditor', 0);
        pnModSetVar('subjects', 'pagesperlistview', 10);
        pnModSetVar('subjects', 'sortbypanel', 1);
        pnModSetVar('subjects', 'textareawidth', 96);
        pnModSetVar('subjects', 'textareaheight', 20);
        pnModSetVar('subjects', 'pagespath', 'upload/sub');
	pnModSetVar('subjects','showReturnFooter',1);
	
                        break;
        case "1.5":
                        list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

                        // Add coloumn to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[username] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Add KEYWORDS to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }

                        // Set up an initial value for a module variable.
        pnModSetVar('subjects', 'wysiwygeditor', 0);
        pnModSetVar('subjects', 'pagesperlistview', 10);
        pnModSetVar('subjects', 'sortbypanel', 1);
        pnModSetVar('subjects', 'textareawidth', 96);
        pnModSetVar('subjects', 'textareaheight', 20);
        pnModSetVar('subjects', 'pagespath', 'upload/sub');
        pnModSetVar('subjects','showReturnFooter',1);

                        break;

        case "2.0 RC1":
                        list($dbconn) = pnDBGetConn();
            $pntable = pnDBGetTables();

                        // Add KEYWORDS to the _subpages table
                        $subjectstable = $pntable['subpages'];
                    $subjectscolumn = &$pntable['subpages_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subjects table
                        $subjectstable = $pntable['subjects'];
                    $subjectscolumn = &$pntable['subjects_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
                        // Add KEYWORDS to the _subcategories table
                        $subjectstable = $pntable['subcategories'];
                    $subjectscolumn = &$pntable['subcategories_column'];
                        $sql = "ALTER TABLE $subjectstable
                    ADD $subjectscolumn[keywords] varchar(255) NOT NULL default ''";
            $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo() != 0) {
                                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
                return false;
            }
            pnModSetVar('subjects','showReturnFooter',1);

                        break;
	case "2.0.1":
		pnModSetVar('subjects','showReturnFooter',1);
		
		break;

    }
    // Update successful
    return true;
}

// Delete the subjects module
function subjects_delete()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Drop the table subjects
    $sql = "DROP TABLE $pntable[subjects]";
    $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
        return false;
    }

    // Drop the table subpages
    $sql = "DROP TABLE $pntable[subpages]";
    $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
        return false;
    }
    // Drop the table subreviews
    $sql = "DROP TABLE $pntable[subreviews]";
    $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
        return false;
    }
    // Drop the table subcategories
    $sql = "DROP TABLE $pntable[subcategories]";
    $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _DBSELECTERROR . ": " .$sql);
        return false;
    }

    // Delete any module variables
        pnModDelVar('subjects', 'wysiwygeditor');
        pnModDelVar('subjects', 'pagesperlistview');
        pnModDelVar('subjects', 'sortbypanel');
        pnModDelVar('subjects', 'textareawidth');
        pnModDelVar('subjects', 'textareaheight');
        pnModDelVar('subjects', 'pagespath');
	pnModDelVar('subjects','showReturnFooter');

    // Deletion successful
    return true;
}
?>
