<?php
// ----------------------------------------------------------------------
// MD-Pro Content Management System
// Copyright (C) 2003 by the MaxDev Development Team.
// (Link: http://www.maxdev.com/)http://www.maxdev.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - http://www.postnuke.com 
// PHP-NUKE Web Portal System - http://www.phpnuke.org 
// Thatware - http://www.thatware.org
//----------------------------------------------------------------------
// Portions of this code were developed by members of the MaxDev Development Team for:
// Envolution 1.25 FLS - http://www.envolution.com.
// ----------------------------------------------------------------------
// LICENSE and CREDITS
// This program is free software and it's released under the terms of the
// GNU General Public License(GPL) - (Link: http://www.gnu.org/licenses/gpl.html)http://www.gnu.org/licenses/gpl.html
// Please READ carefully the Docs/License.txt file for further details
// Please READ the Docs/credits.txt file for complete credits list
// ----------------------------------------------------------------------
// Original Author of file: Francisco Burzi
// Purpose of file: Displays a printer friendly (story) page
// ----------------------------------------------------------------------

include 'includes/pnAPI.php';
pnInit();
include 'includes/legacy.php';
// eugenio themeover 20020413
// pnThemeLoad();

global $link_arr;

$sid = pnVarCleanFromInput('sid');

if(!isset($sid)  || !is_numeric($sid)) {
        include 'header.php';
        echo _MODARGSERROR;
        include 'footer.php';
        exit;
    }

if (!pnLocalReferer() && pnConfigGetVar('refereronprint')) {
    pnRedirect("modules.php?op=modload&amp;name=News&amp;file=article&sid=$sid");
    exit;
}

function Link_Callback($arr)
{
   global $link_arr;
   $link_arr[] = $arr[1];
   return "<strong><em>".$arr[2]."</em> [".count($link_arr)."]</strong>";
}

function ReplaceLinks(&$text)
{
   // (eregi("<a [^>]*href=\"{0,1}([^>\"]*)\"{0,1}[^>]*>([^<]*)</a>",$text,$result));
    $text = preg_replace_callback("/<a [^>]*href\s*=\s*\"?([^>\"]*)\"?[^>]*>(.*?)<\/a.*?>/i","Link_Callback",$text);
}

function GetLinks()
{
    global $link_arr;

    // access database for conversion of internal links
    $dbconn =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();
    $linkscolumn = &$pntable['links_links_column'];
    $downloadscolumn = &$pntable['downloads_downloads_column'];

    // loop through array
    if (count($link_arr))
    {
        $text = "<br /><br />\n<strong>"._LINKSINTHIS."</strong><br />\n";
        for($i=0;$i<count($link_arr);$i++)
        {
            // convert internal link to real URL
            if (preg_match("/^modules\.php.*?Web_Links.*?visit.*?lid=(.*?)$/i",$link_arr[$i],$intern)) {
                $linkquery = buildSimpleQuery('links_links', array('url'), " $linkscolumn[lid] = $intern[1]");
        $linkresult =& $dbconn->Execute($linkquery);
        list($link_arr[$i]) = $linkresult->fields;
            }
            // convert download link to real URL
            if (preg_match("/^modules\.php.*?Downloads.*?getit.*?lid=(.*?)$/i",$link_arr[$i],$intern)) {
                $downloadquery = buildSimpleQuery('downloads_downloads', array('url'), " $downloadscolumn[lid] = $intern[1]");
        $downloadresult =& $dbconn->Execute($downloadquery);
        list($link_arr[$i]) = $downloadresult->fields;
            }
            // append base URL for local links (not web links)
            if (!preg_match("/^http:\/\//i",$link_arr[$i]))
            {
               $link_arr[$i] = pnGetBaseURL().$link_arr[$i];
            }
            // output link
            $text .= "&nbsp;&nbsp;[".($i+1)."] <a class=\"print-normal\" href=\"".pnVarPrepHTMLDisplay($link_arr[$i])."\">".pnVarprepHTMLDisplay($link_arr[$i])."</a><br>";
        }
        return $text;
    }
    return "";
}



function PrintPage($sid) {
    $link_arr = array();
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    // grab the actual story from the database
    $column = &$pntable['stories_column'];
    $result = $dbconn->Execute("SELECT $column[title],
                                     $column[time],
                                     $column[hometext],
                                     $column[bodytext],
                                     $column[topic],
                                     $column[notes],
                                     $column[cid],
                                     $column[aid],
                                     $column[informant]
                              FROM $pntable[stories] where $column[sid] = '".pnVarPrepForStore($sid)."'");
    list($title, $time, $hometext, $bodytext, $topic, $notes, $cid, $aid,$informant) = $result->fields;

        if (!isset($title) || $title == '') {
        include 'header.php';
        echo _DBSELECTERROR;
        include 'footer.php';
        exit;
    }

    if ($dbconn->ErrorNo() != 0) {
        include 'header.php';
        echo _DBSELECTERROR;
        include 'footer.php';
        exit;
    }

    // Get data for "autorise check"
    // Just a temp. solution;
    // Print.php needs completely redesign by using getArticles() and genArticleInfo()
        // fix for Stories::Story, Topics::Topic [larsneo]

        // find out the cattitle
        if ($cid == 0) {
                // Default category
                $cattitle = ""._ARTICLES."";
        } else {
                $catcolumn = &$pntable['stories_cat_column'];
                $catquery = buildSimpleQuery('stories_cat', array('title'), "$catcolumn[catid] = $cid");
                $catresult = $dbconn->Execute($catquery);
                list($cattitle) = $catresult->fields;
        }

        // find out the topictext
        $topicscolumn = &$pntable['topics_column'];
        $topicquery = buildSimpleQuery('topics', array('topictext', 'topicname'), "$topicscolumn[topicid] = $topic");
        $topicresult = $dbconn->Execute($topicquery);
        list($topictext, $topicname) = $topicresult->fields;

        if ((pnSecAuthAction(0, 'AddStory::Story', "$aid:$cattitle:$sid", ACCESS_READ)) && (pnSecAuthAction(0, 'Topics::Topic', "$topicname::$topic", ACCESS_READ))) {
        // user is authorised to view Stories::Story and Topics::Topic
    // Increment the read counter
    $column = &$pntable['stories_column'];
    $dbconn->Execute("UPDATE $pntable[stories] SET $column[counter]=$column[counter]+1 WHERE $column[sid]='".pnVarPrepForStore($sid)."'");


        $time=$result->UnixTimeStamp($time);

    $cWhereIsPerso = WHERE_IS_PERSO;

    if (!empty($cWhereIsPerso)) {
        include("modules/NS-Multisites/print.inc.php");
    } else {
        $themesarein = "";

        $ThemeSel = pnUserGetTheme();
    }

    /* with this code there's no output if wiki is removed [larsneo]
    pnModAPILoad('Wiki', 'user');
    list($title,
         $hometext,
         $bodytext,
         $notes) = pnModAPIFunc('wiki',
                                'user',
                                'transform',
                                array('objectid' => $sid,
                                      'extrainfo' => array($title,
                                                           $hometext,
                                                           $bodytext,
                                                           $notes)));
        */

        // call hooks
        list($title,
         $hometext,
         $bodytext,
         $notes) = pnModCallHooks('item', 'transform', '', array($title,
                                                                           $hometext,
                                                                           $bodytext,
                                                                           $notes));
        ReplaceLinks($hometext);
        ReplaceLinks($bodytext);
        ReplaceLinks($notes);

    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n"
        ."<html>\n"
        ."<head><title>" . pnConfigGetVar('sitename') . "</title>\n";

    if (defined("_CHARSET") && _CHARSET != "") {
        echo "<META HTTP-EQUIV=\"Content-Type\" ".
            "CONTENT=\"text/html; charset="._CHARSET."\">\n";
    }

        //changed to local stylesheet
    //echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".$themesarein."themes/$ThemeSel/style/style.css\">";
    echo "<style type=\"text/css\">\n"
        ."<!--\n"
                .".print-title {\n"
                ."background-color: transparent;\n"
                ."color: #990000;\n"
                ."font-family: Verdana, Arial, sans-serif;\n"
                ."font-size: 14px;\n"
                ."font-weight: bold;\n"
                ."text-decoration: none;\n"
                ."}\n"
                .".print-sub {\n"
                ."background-color: transparent;\n"
                ."color: #000000;\n"
                ."font-family: Verdana, Arial, sans-serif;\n"
                ."font-size: 11px;\n"
                ."font-weight: normal;\n"
                ."text-decoration: none;\n"
                ."}\n"
                .".print-normal {\n"
                ."background-color: transparent;\n"
                ."color: #000000;\n"
                ."font-family: Verdana, Arial, sans-serif;\n"
                ."font-size: 12px;\n"
                ."font-weight: normal;\n"
                ."text-decoration: none;\n"
                ."}\n"
        .".print {\n"
        ."color: #000000;\n"
        ."background-color: #FFFFFF;\n"
        ."}\n"
        ."-->\n"
        ."</style>\n";

    echo "</head>\n"
        ."<body class=\"print\">\n"
        ."\n<table border=\"0\" width=\"85%\" cellpadding=\"0\" cellspacing=\"1\">\n"
        ."<tr><td>\n"
        ."<table border=\"0\" width=\"100%\" cellpadding=\"5\" cellspacing=\"1\">\n"
        ."<tr><td>\n"
        ."<img src=\"".WHERE_IS_PERSO."images/print_" . pnConfigGetVar('site_logo') . "\" alt=\"".pnConfigGetVar('sitename')."\">\n"
        ."<br /><br />\n"
        ."<strong><span class=\"print-title\">" . pnVarPrepHTMLDisplay(pnVarCensor($title)) . "</span></strong><br /><br />\n"
        ."<span class=\"print-sub\">".pnVarPrepHTMLDisplay($cattitle)." / ".pnVarPrepHTMLDisplay($topictext)."<br />\n"
        .""._POSTEDBY." ".$informant." "._ON." ".ml_ftime(_DATETIMEBRIEF,$time)."</span>\n" ."<hr /></td></tr>\n"
        ."<tr><td>\n"
        ."<span class=\"print-normal\">"
        . pnVarPrepHTMLDisplay(pnVarCensor($hometext)) . "<br />\n";

        if (!empty($bodytext)) {
            echo "<br />".pnVarPrepHTMLDisplay(pnVarCensor($bodytext)) . "<br />\n";
        }
        if (!empty($notes)) {
            echo "<br />".pnVarPrepHTMLDisplay(pnVarCensor($notes)) . "<br />\n";
        } else {
            //echo "<br />\n";
        }

    echo "</span>\n"
        ."</td></tr>\n"
        ."<tr><td>\n"
        ."<hr /><span class=\"print-normal\">\n"
        ."<strong>"._COMESFROM." " . pnConfigGetVar('sitename') . "</strong><br />\n"
        ."&nbsp;&nbsp;<a class=\"print-normal\" href=\"" . pnGetBaseURL() . "\">"
        .pnGetBaseURL()
        ."</a>\n"
        ."<br /><br />\n"
        ."<strong>"._THEURL."</strong>"
        ."<br />\n"
        ."&nbsp;&nbsp;<a class=\"print-normal\" href=\"" . pnGetBaseURL() . "modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$sid\">"
        . pnGetBaseURL() . "modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$sid"
        ."</a>\n"
    .GetLinks()
        ."</span>\n"
        ."</td></tr>\n"
        ."</table>\n</td></tr>\n</table>\n"
        ."</body>\n"
        ."</html>\n";
    } else {
        // user is not authorised to view Stories::Story and Topics::Topic
        include 'header.php';
        echo _BADAUTHKEY;
        include 'footer.php';
        exit;
    }

}

PrintPage($sid);

?>
